rem -------------------------------------------------
rem Benchmark.bas -- Test MiniBasic speed
rem -------------------------------------------------

Dim C As Long:Dim G As Double
Dim Count As Long
Dim B As Long
Dim D As String
Dim I As Long:Dim J As Long
Dim SORTARRAY(1000) As Long
Dim TempSort As Long

? "Testing 500000 floating points operations..."+Chr(10)
	C=0:G=0
	Count=Ticks
	For B=1 To 500000
		G=G+10.0/123.44*10
	Next &B
? "Result: ";(Ticks-Count)/1000;" seconds (value: ";G;")"+Chr(10)

? "Testing 500000 floating points functions..."+Chr(10)
	Count=Ticks
	For B=1 To 500000
		G=Atn(10.23)+Sin(2)*Cos(2.5)
	Next &B
? "Result: ";(Ticks-Count)/1000;" seconds (value: ";G;")"+Chr(10)

? "Testing 500000 integer operations..."+Chr(10)
	Count=Ticks
	For B=1 To 500000
		C=0
		C=C+4*4\2+C*2+(8+123+C)
	Next &B
? "Result: ";(Ticks-Count)/1000;" seconds (value: ";C;")"+Chr(10)

? "Testing 500000 integer functions..."+Chr(10)
	C=0
	Count=Ticks
	For B=1 To 500000
		C=Abs(-100)+Sgn(C)*C
	Next &B
? "Result: ";(Ticks-Count)/1000;" seconds (value: ";C;")"+Chr(10)

? "Testing 500000 string functions..."+Chr(10)
	Count=Ticks
	For B=1 To 500000
		D=UCase("this is a test")
	Next &B
? "Result: ";(Ticks-Count)/1000;" seconds (value: ";D;")"+Chr(10)

	B=1000 ' amount of numbers to sort
? "Creating ";B;" random numbers from 1 to 100..."+Chr(10)
	For I=1 To B
		SORTARRAY(I)=Rnd(100)
	Next &I
? "Sorting..."+Chr(10)
	Count=Ticks
	For I=1 To B-1
		For J=I+1 To B
			If SORTARRAY(J)<SORTARRAY(I) Then 
				Swap &SORTARRAY(I),&SORTARRAY(J)
			End If
		Next &J
	Next &I
? "Result: ";(Ticks-Count)/1000;" seconds"+Chr(10)

End
