;-----------------------------------------------------------------------------------------------
; MBasic v1.8
; Copyleft Sylvain Bizoirre 2001.
; Copyright Franck Charlet 2002-2003.
; Please report any questions, bugs, enhancements at:
;
; hitchhikr@australia.edu
;
; New versions can be obtained here:
;
; http://perso.wanadoo.fr/franck.charlet/index.htm
;
;-----------------------------------------------------------------------------------------------
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
;-----------------------------------------------------------------------------------------------
; See Changes.txt for hot news...

;-----------------------------------------------------------------------------------------------
; (Requires MASM32 V8 + Chrome distribution to assemble)
; buildblock RELEASE
; 	CAPT [BINDIR]\ml.exe /c /coff /I"[INCLUDEDIR]" "%2"
; 	CAPT [BINDIR]\Link.exe /MERGE:.data=.text /MERGE:.rdata=.text /LIBPATH:"[LIBDIR]" /SECTION:.text,ERW /IGNORE:4078 /SUBSYSTEM:CONSOLE "%1.obj"
; buildblockend

; buildblock DEBUG
; 	CAPT [BINDIR]\ml.exe /Zd /Zi /c /coff /I"[INCLUDEDIR]" "%2"
;	CAPT [BINDIR]\Link.exe /DEBUG /DEBUGTYPE:CV /MERGE:.data=.text /MERGE:.rdata=.text /LIBPATH:"[LIBDIR]" /SECTION:.text,ERW /IGNORE:4078 /SUBSYSTEM:CONSOLE "%1.obj"
; buildblockend

;-----------------------------------------------------------------------------------------------
; Program model
			.586					; Required for RDTSC instruction
			.model	flat,stdcall
			option	casemap:none			; Case sensitive

;-----------------------------------------------------------------------------------------------
; External includes
			include	windows.inc
			include	kernel32.inc
			include	user32.inc
			include	winmm.inc
			include	masm32.inc

;-----------------------------------------------------------------------------------------------
; Static libraries
			includelib kernel32.lib
			includelib user32.lib
			includelib winmm.lib
			includelib masm32.lib

;-----------------------------------------------------------------------------------------------
; Some functions declarations
StringToDouble		proto	:dword,:ptr qword
DoubleToString		proto	:qword,:dword,:dword
PushOperStack		proto	:dword
PokeOperStack		proto	:dword
FillMem			proto	:dword,:dword,:dword
PutTabPointer		proto	:dword,:dword
PushIfStack		proto	:dword
PokeIfStack		proto	:dword
AddWrapOperator		proto	:byte
AddWrapInteger		proto	:dword
AddWrapFp		proto	:qword
AddWrapFnc		proto	:dword
AddWrapVar		proto	:dword
AddWrapArray		proto	:dword
AddWrapMinusSign	proto
AddWrapOpenBracket	proto
AddWrapCloseBracket	proto
AddWrapString		proto	:dword
AddWrapStringPadding	proto
AddWrapArrayAddress	proto	:dword
AddWrapVarAddress	proto	:dword
AddWrapLabel		proto	:dword
CONHandler		proto	:dword
GetFileLineAddress	proto	:dword,:dword
GetLineLen		proto	:dword

;-----------------------------------------------------------------------------------------------
; Macro to register a command
; .l: command len
; .b: command name
CMD			macro	CmdName:REQ
_CmdName		TEXTEQU	@SubStr(CmdName,2,@SizeStr(CmdName)-2)
			dd	@SizeStr(CmdName)-2
			ifnb	_CmdName
_CmdName		TEXTEQU	@CatStr(<!">,%_CmdName,<!">)
			db	_CmdName
			endif
			endm

; Macro to register a function
; .l: function len
; .b: function name
; .l: function proc
FNC			macro	FncName:REQ,FncProc:REQ
_FncName		TEXTEQU	@SubStr(FncName,2,@SizeStr(FncName)-2)
			dd	@SizeStr(FncName)-2
			ifnb	_FncName
_FncName		TEXTEQU	@CatStr(<!">,%_FncName,<!">)
			db	_FncName
			endif
			dd	offset FncProc
			endm

; Functions table terminator
FNCEND			macro	FncProc:REQ
			dd	0
			db	128
			dd	offset FncProc
			endm

; Misc. macros
PEEKOPERSTACKCOMP	macro
			mov	eax,OperStackPtr
			mov	eax,[eax-4]			; Peek from previous value
			endm

POPOPERSTACKCOMP	macro
			lea	eax,OperStackPtr
			sub	dword ptr [eax],4		; Decrement
			mov	eax,[eax]
			mov	eax,[eax]
			endm

NORMALIZEOPERSTACKCOMP	macro	StackStep:REQ
			lea	eax,OperStackPtr
			sub	dword ptr [eax],StackStep*4
			endm

POKEOPERSTACKDOUBLECOMP	macro
			mov	eax,OperStackPtr
			mov	dword ptr [eax-4],VAR_DOUBLE
			endm

POKEOPERSTACKINTCOMP	macro
			mov	eax,OperStackPtr
			mov	dword ptr [eax-4],VAR_INTEGER
			endm

POKEOPERSTACKSTRCOMP	macro
			mov	eax,OperStackPtr
			mov	dword ptr [eax-4],VAR_STRING
			endm

POKEOPERSTACKCOMP	macro
			mov	eax,OperStackPtr
			push	ExprFinalResult
			pop	dword ptr [eax-4]
			endm

PUSHOPERSTACKCOMP	macro
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4		; Increment
			mov	ecx,ExprFinalResult
			mov	[eax],ecx			; Write type
			endm

; Store a temporary string address in stack
; Need address of string in ebx
PUSHTMPSTRSTACKCOMP	macro
			lea	ecx,TmpStringsStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4		; Increment
			mov	[eax],ebx			; Write address of str
			endm

PUSHOPERSTACKSTRCOMP	macro
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4		; Increment
			mov	dword ptr [eax],VAR_STRING	; Write type
			endm

;-----------------------------------------------------------------------------------------------
; Constants
			.const

; Global constants to define MBasic capabilities
MEMSIZE			equ	020000h				; Size of memory allocated for Basic progs (here 128kb)
MEMDATSIZE		equ	020000h				; Size of datas memory (128kb)
MEMSTRINGSIZE		equ	020000h				; Size of literal strings memory (128kb)
MEMCOMSIZE		equ	020000h				; Size of precompiled commands (128kb)
MEMEXPRSIZE		equ	020000h				; Size of precompiled expressions (128kb)
MEMVARSYMBOLS		equ	020000h				; Memory reserved for symbols (128kb)
MAXVARNAME		equ	64				; 64 chars / variable name. MUST be a multiple of 4 !!!!
FORNEXTLEVELS		equ	16				; FOR..NEXT levels
WHILEWENDLEVELS		equ	16				; WHILE..WEND levels
GOSUBLEVELS		equ	16				; GOSUB
MEMLABELSYMBOLS		equ	020000h				; Memory reserved for labels (128kb)

; Don't modify
VARDATSIZE		equ	32				; Size of a variable/array slot

; Note: if new types are to be added they must use even values
; (order can't be changed in anyway without modifying the sourcecode)
VAR_INTEGER		equ	0				; Integer MUST be 0
VAR_DOUBLE		equ	1				; FP MUST be 1
VAR_STRING		equ	2

VAR_NOFNCARG		equ	3				; Empty expression

DAT_VARIABLE		equ	0
DAT_ARRAY		equ	1
DAT_DYNARRAY		equ	2				; (Not used yet)

FP_EQUALTO		equ	40h

; Variables/Arrays records
VARDAT_DATASPTR		equ	0
VARDAT_RESERVED		equ	4
VARDAT_TYPE		equ	8
VARDAT_NAME		equ	12
VARDAT_VARARR		equ	16
VARDAT_ARRLBOUND	equ	20
VARDAT_ARRUBOUND	equ	24

; Wrapped expressions tags
; Determine the nature of the following datas
WRAP_MINUSSIGN		equ	1				; Inverted result
WRAP_EXPREND		equ	2
WRAP_OPENBRACKET	equ	3
WRAP_CLOSEBRACKET	equ	4
WRAP_FNC		equ	5
WRAP_VAR		equ	6
WRAP_ARRAY		equ	7
WRAP_STRING		equ	8
WRAP_VARADDRESS		equ	9
WRAP_ARRAYADDRESS	equ	0ah
WRAP_FP			equ	0bh
WRAP_INT		equ	0ch

; Determine the operation to perform with the datas
WRAP_PLUS		equ	0dh
WRAP_MINUS		equ	0eh
WRAP_DIV		equ	0fh
WRAP_INTDIV		equ	010h
WRAP_MUL		equ	011h
WRAP_MOD		equ	012h

; MUST be the last operators in list
WRAP_EQU		equ	013h
WRAP_LOWER		equ	014h
WRAP_GREATER		equ	015h
WRAP_LOWEREQU		equ	016h
WRAP_GREATEREQU		equ	017h
WRAP_NOTEQU		equ	018h

; (Used by PRINT)
WRAP_STRPADDING		equ	019h

; Logical operators
WRAP_OR			equ	01ah
WRAP_XOR		equ	01bh
WRAP_AND		equ	01ch
WRAP_SHL		equ	01dh
WRAP_SHR		equ	01eh
WRAP_ROL		equ	01fh
WRAP_ROR		equ	020h
WRAP_IMP		equ	021h
WRAP_EQV		equ	022h
WRAP_NOR		equ	023h
WRAP_NAND		equ	024h
WRAP_NXOR		equ	025h

WRAP_LABEL		equ	026h

; Ordinal positions of functions
WRAP_FNC_ABS		equ	0
WRAP_FNC_ACOSEC		equ	1
WRAP_FNC_ACOS		equ	2
WRAP_FNC_ACOTAN		equ	3
WRAP_FNC_ASC		equ	4
WRAP_FNC_ASEC		equ	5
WRAP_FNC_ASIN		equ	6
WRAP_FNC_ATN		equ	7
WRAP_FNC_BINB		equ	8
WRAP_FNC_BIND		equ	9
WRAP_FNC_BINW		equ	0ah
WRAP_FNC_BIN		equ	0bh
WRAP_FNC_BITCOUNT	equ	0ch
WRAP_FNC_BITTST		equ	0dh
WRAP_FNC_BSWAP		equ	0eh
WRAP_FNC_CARETX		equ	0fh
WRAP_FNC_CARETY		equ	010h
WRAP_FNC_CHR		equ	011h
WRAP_FNC_CINT		equ	012h
WRAP_FNC_COSEC		equ	013h
WRAP_FNC_COS		equ	014h
WRAP_FNC_COTAN		equ	015h
WRAP_FNC_CSTR		equ	016h
WRAP_FNC_DATE		equ	017h
WRAP_FNC_EXP		equ	018h
WRAP_FNC_E		equ	019h
WRAP_FNC_FALSE		equ	01ah
WRAP_FNC_FCLOSE		equ	01bh
WRAP_FNC_FCREATE	equ	01ch
WRAP_FNC_FEOF		equ	01dh
WRAP_FNC_FIX		equ	01eh
WRAP_FNC_FLEN		equ	01fh
WRAP_FNC_FLOAD		equ	020h
WRAP_FNC_FLOC		equ	021h
WRAP_FNC_FLOF		equ	022h
WRAP_FNC_FOPENR		equ	023h
WRAP_FNC_FOPENW		equ	024h
WRAP_FNC_FRAC		equ	025h
WRAP_FNC_FREAD		equ	026h
WRAP_FNC_FSAVE		equ	027h
WRAP_FNC_FSEEK		equ	028h
WRAP_FNC_FWRITE		equ	029h
WRAP_FNC_FWRITELN	equ	02ah
WRAP_FNC_GETCONTITLE	equ	02bh
WRAP_FNC_HACOSEC	equ	02ch
WRAP_FNC_HACOS		equ	02dh
WRAP_FNC_HASEC		equ	02eh
WRAP_FNC_HASIN		equ	02fh
WRAP_FNC_HATN		equ	030h
WRAP_FNC_HCOATN		equ	031h
WRAP_FNC_HCOSEC		equ	032h
WRAP_FNC_HCOS		equ	033h
WRAP_FNC_HCOTAN		equ	034h
WRAP_FNC_HEXB		equ	035h
WRAP_FNC_HEXD		equ	036h
WRAP_FNC_HEXW		equ	037h
WRAP_FNC_HEX		equ	038h
WRAP_FNC_HIBYTE		equ	039h
WRAP_FNC_HIWORD		equ	03ah
WRAP_FNC_HSEC		equ	03bh
WRAP_FNC_HSIN		equ	03ch
WRAP_FNC_HTAN		equ	03dh
WRAP_FNC_HTICKS		equ	03eh
WRAP_FNC_IIF		equ	03fh
WRAP_FNC_INKEY		equ	040h
WRAP_FNC_INSTR		equ	041h
WRAP_FNC_INT		equ	042h
WRAP_FNC_ISDOUBLE	equ	043h
WRAP_FNC_ISINTEGER	equ	044h
WRAP_FNC_ISSTRING	equ	045h
WRAP_FNC_LBOUND		equ	046h
WRAP_FNC_LCASE		equ	047h
WRAP_FNC_LEFT		equ	048h
WRAP_FNC_LEN		equ	049h
WRAP_FNC_LINE		equ	04ah
WRAP_FNC_LOBYTE		equ	04bh
WRAP_FNC_LOGN		equ	04ch
WRAP_FNC_LOG		equ	04dh
WRAP_FNC_LOWORD		equ	04eh
WRAP_FNC_LTRIM		equ	04fh
WRAP_FNC_LTRIM2		equ	050h
WRAP_FNC_MALLOC		equ	051h
WRAP_FNC_MFREE		equ	052h
WRAP_FNC_MID		equ	053h
WRAP_FNC_MREAD		equ	054h
WRAP_FNC_MREADD		equ	055h
WRAP_FNC_MREADW		equ	056h
WRAP_FNC_NOT		equ	057h
WRAP_FNC_NOW		equ	058h
WRAP_FNC_PEEK		equ	059h
WRAP_FNC_PEEKD		equ	05ah
WRAP_FNC_PEEKW		equ	05bh
WRAP_FNC_PI		equ	05ch
WRAP_FNC_RIGHT		equ	05dh
WRAP_FNC_RND		equ	05eh
WRAP_FNC_RTRIM		equ	05fh
WRAP_FNC_RTRIM2		equ	060h
WRAP_FNC_SEC		equ	061h
WRAP_FNC_SGN		equ	062h
WRAP_FNC_SIN		equ	063h
WRAP_FNC_SIZE		equ	064h
WRAP_FNC_SIZEOF		equ	065h
WRAP_FNC_SPACE		equ	066h
WRAP_FNC_SQRT		equ	067h
WRAP_FNC_STR		equ	068h
WRAP_FNC_STRCMP		equ	069h
WRAP_FNC_STRING		equ	06ah
WRAP_FNC_STRLINES	equ	06bh
WRAP_FNC_STRPAD		equ	06ch
WRAP_FNC_STRPADL	equ	06dh
WRAP_FNC_STRPADR	equ	06eh
WRAP_FNC_STRREVERSE	equ	06fh
WRAP_FNC_STRROTATEL	equ	070h
WRAP_FNC_STRROTATER	equ	071h
WRAP_FNC_STRSTOT	equ	072h
WRAP_FNC_STRTTOS	equ	073h
WRAP_FNC_TAN		equ	074h
WRAP_FNC_TCASE		equ	075h
WRAP_FNC_TICKS		equ	076h
WRAP_FNC_TIME		equ	077h
WRAP_FNC_TRIM		equ	078h
WRAP_FNC_TRIM2		equ	079h
WRAP_FNC_TRUE		equ	07ah
WRAP_FNC_UBOUND		equ	07bh
WRAP_FNC_UCASE		equ	07ch
WRAP_FNC_WSWAP		equ	07dh

; Ordinal positions of commands
; (These constants are not used yet but shall remain)
WRAP_CMD_REM1		equ	0
WRAP_CMD_PRINT1		equ	1
WRAP_CMD_BEEP		equ	2
WRAP_CMD_BITCLR		equ	3
WRAP_CMD_BITINV		equ	4
WRAP_CMD_BITSET		equ	5
WRAP_CMD_CLS		equ	6
WRAP_CMD_COLOR		equ	7
WRAP_CMD_DIM		equ	8
WRAP_CMD_DOEVENTS	equ	9
WRAP_CMD_ELSE		equ	0ah
WRAP_CMD_ENDIF		equ	0bh
WRAP_CMD_END		equ	0ch
WRAP_CMD_EXITFOR	equ	0dh
WRAP_CMD_FCLOSE		equ	0eh
WRAP_CMD_FCOPY		equ	0fh
WRAP_CMD_FKILL		equ	010h
WRAP_CMD_FMKDIR		equ	011h
WRAP_CMD_FNAME		equ	012h
WRAP_CMD_FOR		equ	013h
WRAP_CMD_FRMDIR		equ	014h
WRAP_CMD_FSAVE		equ	015h
WRAP_CMD_FSEEK		equ	016h
WRAP_CMD_FWRITE		equ	017h
WRAP_CMD_FWRITELN	equ	018h
WRAP_CMD_GET		equ	019h
WRAP_CMD_GOSUB		equ	01ah
WRAP_CMD_GOTO		equ	01bh
WRAP_CMD_HWAIT		equ	01ch
WRAP_CMD_IF		equ	01dh
WRAP_CMD_INPUT		equ	01eh
WRAP_CMD_LET		equ	01fh
WRAP_CMD_LOCATE		equ	020h
WRAP_CMD_MCOPY		equ	021h
WRAP_CMD_MFILL		equ	022h
WRAP_CMD_MFREE		equ	023h
WRAP_CMD_MROTATEL	equ	024h
WRAP_CMD_MROTATER	equ	025h
WRAP_CMD_MWRITED	equ	026h
WRAP_CMD_MWRITEW	equ	027h
WRAP_CMD_MWRITE		equ	028h
WRAP_CMD_NEXT		equ	029h
WRAP_CMD_POKED		equ	02ah
WRAP_CMD_POKEW		equ	02bh
WRAP_CMD_POKE		equ	02ch
WRAP_CMD_PRINT		equ	02dh
WRAP_CMD_REM		equ	02eh
WRAP_CMD_RETURN		equ	02fh
WRAP_CMD_SETCONTITLE	equ	030h
WRAP_CMD_STOP		equ	031h
WRAP_CMD_SWAPGT		equ	032h
WRAP_CMD_SWAPLW		equ	033h
WRAP_CMD_SWAP		equ	034h
WRAP_CMD_VARTOINT	equ	035h
WRAP_CMD_VARTOSTR	equ	036h
WRAP_CMD_WAIT		equ	037h
WRAP_CMD_WEND		equ	038h
WRAP_CMD_WHILE		equ	039h
WRAP_CMD_WINDOW		equ	03ah

;-----------------------------------------------------------------------------------------------
			.data
EditColors		dd	0
			align	16
EditSizeX		dw	0
			align	16
EditSizeY		dw	0
			align	16
FKILLDat		WIN32_FIND_DATA <>
DOEVENTSMsg		MSG <>
			align	16
dtemp1			dd	4 dup (0)			; Temporary 32 bits Variables
								; (Also used for int->str conversion)
			align	16
dtemp2			dd	0
			align	16
wtemp1			dw	0				; Temporary 16 bits Variables
wtemp2			dw	0				; (sometimes work together)
			align	16
wtemp3			dw	0
			align	16
btemp1			db	0				; Temporary 8 bits variable 
			align	16
btemp2			db	0
			align	16
GosLineNum		dd	0				; Line number of previous GOSUB or 0 if not
			align	16
GosPtrTxt		dd	0				; Text pointer of previous GOSUB or 0
			align	16
GosStackPtr		dd	0				; GOSUB Stack pointer
			align	16
ForStackPtr		dd	0				; FOR..NEXT Stack pointer
			align	16
ForAdrVar		dd	0				; Address of FOR loop variable
			align	16
ForLimit		dd	0				; Higher value of FOR variable
			align	16
ForIncrement		dd	0				; STEP increment or 1
			align	16
ForTested		dd	0
			align	16
ForLine			dd	0				; Line to go back with NEXT
			align	16
ForPtrTxt		dd	0				; Address to go back with NEXT
			align	16
CursorShape		CONSOLE_CURSOR_INFO <>
;Csbi_CharX		dw	0
;Csbi_CharY		dw	0
;Csbi_CharPosX		dw	0
;Csbi_CharPosY		dw	0
;Csbi_WriteReg		SMALL_RECT <>
			align	16
OldConBuffer		CONSOLE_SCREEN_BUFFER_INFO <>
ConBuffer		CONSOLE_SCREEN_BUFFER_INFO <>
			align	16
SysDt			SYSTEMTIME <>
			align	16
; CONSOLE_SCREEN_BUFFER_INFO (used in various API)
Csbi_SizeX		dw	0				; Size of screen buffer (Width X, Hight Y)
Csbi_SizeY		dw	0
Csbi_CursorPositionX	dw	0				; Cursor position (Column X, row Y)
Csbi_CursorPositionY	dw	0
Csbi_Attributes		dw	0				; Colors attributes for foreground and background
Csbi_WindowLeft		dw	0				; Console screen coordinates in Console Screen Buffer
Csbi_WindowTop		dw	0				; (Structure SMALL_RECT)
Csbi_WindowRight	dw	0
Csbi_WindowBottom	dw	0
Csbi_MaximumWindowSizeX	dw	0
Csbi_MaximumWindowSizeY	dw	0
			align	16
			dd	0
ColorsCurrent		dd	0				; Current color used
			align	16
NbrBlock		db	12 dup (0)			; Used to store numbers from API errors
			align	16
EventBuffer		db	16 dup (0)			; Informations area for keyboard inputs 
			align	16
FileHandle		dd	0				; Given by CreateFile API (LOAD, SAVE)
			align	16
FileName		dd	0				; Filename block
			align	16
FilePath		dd	0
			align	16
FilePathName		dd	0
			align	16
CmdLine			dd	0
			align	16
hStdIn			dd	0				; Standard input and output handles given by Windows
			align	16
hStdOut			dd	0
			align	16
ExprFinalResult		dd	0				; Final decision over an expression type
			align	16
PtrTblFnc		dd	0				; Functions table
			align	16
LineLen			dd	0				; Input Line Length
			align	16
LineMaxLen		dd	0				; Maximum input line length allowed
			align	16
LineMaxLenUsr		dd	0
			align	16
LineNumber		dd	0				; Current used line number
			align	16
LinePtr			dd	0				; Input line ptr
			align	16
ConsoleCharNbr		dd	0				; Number of char. in current console screen
			align	16
RequiredSpace		db	0
			align	16
InsertMode		db	0				; Insert key flag in line editor (1 = Insert, 0 = Normal)
			align	16
WasDouble		db	0				; Last checked number was a floating point ?
			align	16
			db	0
ClearInput		db	10 dup (" ")			; Fill input area with spaces
			db	0
			align	16
SMALL_RECT_Left		dw	0				; Coordinates of console screen in Console Screen Buffer
SMALL_RECT_Top		dw	0
SMALL_RECT_Right	dw	0
SMALL_RECT_Bottom	dw	0
			align	16
WindowCmdParms2Pos	dd	0
			align	16
DblTemp			db	24 dup (0)
			align	16
szTemp			db	18 dup (0)
			align	16
ExpFPUState1		dw	0				; Used to handle FPU control word
			align	16
ExpFPUState2		dw	0
			align	16
FpIntLoad		dd	0
			align	16
EConst			dq	2.7182818284590452		; Hardcoded constant (shouldn't change)
			align	16
TenInt			dd	10

; --- Virtual memory Pointers
			align	16
PrintBuffer		dd	0				; Print buffer
			align	16
ForNextStack		dd	0				; FOR..NEXT stack (5 Dwords * 16 FOR..NEXT levels)
			align	16
ForNextStackEnd		dd	0				; FOR..NEXT stack (5 Dwords * 16 FOR..NEXT levels)
			align	16
GosubStack		dd	0				; GOSUB stack (2 Dwords * 16 GOSUB levels)
			align	16
GosubStackEnd		dd	0				; GOSUB stack end
			align	16
TxtStart		dd	0				; Basic text area
			align	16
TxtEnd			dd	0				; End of Basic Text pointer
			align	16
DatStart		dd	0				; Datas area
			align	16
DatEnd			dd	0				; End of datas area
			align	16
CompStart		dd	0				; Running text area
			align	16
CompEnd			dd	0				; End of Running Text pointer
			align	16
CompExpr		dd	0
			align	16
CompExprEnd		dd	0
			align	16
CompExprPtr		dd	0
			align	16
SaveCompExprPtr		dd	0
			align	16
CompPtr			dd	0				; Running text area position
			align	16
CompIFExpr		dd	0
			align	16
CompIFExprEnd		dd	0
			align	16
PreCompLine		dd	0
			align	16
PreCompLen		dw	0
			align	16
PreCompNbr		dw	0
			align	16
IfStack			dd	0				; Stack for if commands
			align	16
IfStackPtr		dd	0
			align	16
LitStack		dd	0				; Stack for literal expressions optimizations
			align	16
LitStackPtr		dd	0
			align	16
LineNum			dd	0				; 2 bytes before ASCII LineBuffer to save space for binary line number (4 bytes)
			align	16
LineBuffer		dd	0				; Input line buffer (must be after text area)
			align	16
DblString		dd	0				; Floating points temporary storage
			align	16
Dbl1			dq	1.0				; Some spaces for floating points
			align	16
Dbl2			dq	2.0				; operations
			align	16
DblGarb			dq	0.0
			align	16
DblGarb2		dq	0.0
			align	16
DblGarb3		dq	0.0
			align	16
DblGarb4		dq	0.0
			align	16
DblGarbSgn		dq	0.0
			align	16
DblVal			dq	0.0
			align	16
DblTerm1		dq	0.0
			align	16
DblTerm2		dq	0.0
			align	16
TmpStringsStack		dd	0				; temporary strings stack
			align	16
TmpStringsStackPtr	dd	0
			align	16
OperStack		dd	0				; expressions stack
			align	16
OperStackPtr		dd	0
			align	16
LitStrings		dd	0				; 128k reserved for literal strings
			align	16
LitStringsPtr		dd	0
			align	16
LitStringsEnd		dd	0
			align	16
DblFromInt		dd	0
			align	16
DblToInt		dd	0
			align	16
VarSymb			dd	0
			align	16
VarNbr			dd	0				; Number of variables
			align	16
LabelSymb		dd	0
			align	16
ReadAmount		dd	0
			align	16
ReadAmountCrLf		dd	0
			align	16
LabelNbr		dd	0				; Number of labels
			align	16
WasArrayName		db	0
			align	16
WasLabelName		db	0
			align	16
VarDeclareAllowed	db	0
			align	16
VarLabelAllowed		db	0
			align	16
VarLabelReferenced	db	0
			align	16
DeclaredVarAddress	dd	0
			align	16
DeclaredVarName		dd	0
			align	16
DeclaredVarSize		dd	0
			align	16
ReferencedVarAddress	dd	0
			align	16
VarToLoadType		dd	0
			align	16
InputVarType		dd	0
			align	16
WhileWendStack		dd	0
			align	16
WhileWendStackEnd	dd	0
			align	16
WhilePreviousFlag	dd	0
			align	16
WhilePtrTxt		dd	0
			align	16
WhileStackPtr		dd	0
			align	16
WhileLine		dd	0
			align	16
WhileExecTable		dd	0
			align	16
NbrPadding		db	0
			align	16
HTimer			dd	0
			align	16
HTimerV			LARGE_INTEGER	<>
			align	16
HTimerFREQ		dd	0
			align	16
HTimerTPMS		dd	0
			align	16
ASCIIFileMem		dd	0
			align	16
ASCIIFileSize		dd	0
			align	16
ASCIILineNumber		dd	0
; Hex numbers conversion table (for 256 chars -1 = invalid value)
			align	16
HEXTab			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	000h,001h,002h,003h,004h,005h,006h,007h,008h,009h,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,00ah,00bh,00ch,00dh,00eh,00fh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,00ah,00bh,00ch,00dh,00eh,00fh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
; Bin numbers conversion table (for 256 chars -1 = invalid value)
; (Only 0 (30h) and 1 (31h) are valids here)
			align	16
BINTab			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	000h,001h,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
			db	0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh,0ffh
; UCASE conversion table
			align	16
CharTableUpper		db	000h,001h,002h,003h,004h,005h,006h,007h,008h,009h,00ah,00bh,00ch,00dh,00eh,00fh
			db	010h,011h,012h,013h,014h,015h,016h,017h,018h,019h,01ah,01bh,01ch,01dh,01eh,01fh
			db	020h,021h,022h,023h,024h,025h,026h,027h,028h,029h,02ah,02bh,02ch,02dh,02eh,02fh
			db	030h,031h,032h,033h,034h,035h,036h,037h,038h,039h,03ah,03bh,03ch,03dh,03eh,03fh
			db	040h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,05bh,05ch,05dh,05eh,05fh
			db	060h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,07bh,07ch,07dh,07eh,07fh
			db	080h,081h,082h,083h,084h,085h,086h,087h,088h,089h,08ah,08bh,08ch,08dh,08eh,08fh
			db	090h,091h,092h,093h,094h,095h,096h,097h,098h,099h,09ah,09bh,09ch,09dh,09eh,09fh
			db	0a0h,0a1h,0a2h,0a3h,0a4h,0a5h,0a6h,0a7h,0a8h,0a9h,0aah,0abh,0ach,0adh,0aeh,0afh
			db	0b0h,0b1h,0b2h,0b3h,0b4h,0b5h,0b6h,0b7h,0b8h,0b9h,0bah,0bbh,0bch,0bdh,0beh,0bfh
			db	0c0h,0c1h,0c2h,0c3h,0c4h,0c5h,0c6h,0c7h,0c8h,0c9h,0cah,0cbh,0cch,0cdh,0ceh,0cfh
			db	0d0h,0d1h,0d2h,0d3h,0d4h,0d5h,0d6h,0d7h,0d8h,0d9h,0dah,0dbh,0dch,0ddh,0deh,0dfh
			db	0e0h,0e1h,0e2h,0e3h,0e4h,0e5h,0e6h,0e7h,0e8h,0e9h,0eah,0ebh,0ech,0edh,0eeh,0efh
			db	0f0h,0f1h,0f2h,0f3h,0f4h,0f5h,0f6h,0f7h,0f8h,0f9h,0fah,0fbh,0fch,0fdh,0feh,0ffh
; LCASE conversion table
			align	16
CharTableLower		db	000h,001h,002h,003h,004h,005h,006h,007h,008h,009h,00ah,00bh,00ch,00dh,00eh,00fh
			db	010h,011h,012h,013h,014h,015h,016h,017h,018h,019h,01ah,01bh,01ch,01dh,01eh,01fh
			db	020h,021h,022h,023h,024h,025h,026h,027h,028h,029h,02ah,02bh,02ch,02dh,02eh,02fh
			db	030h,031h,032h,033h,034h,035h,036h,037h,038h,039h,03ah,03bh,03ch,03dh,03eh,03fh
			db	040h,061h,062h,063h,064h,065h,066h,067h,068h,069h,06ah,06bh,06ch,06dh,06eh,06fh
			db	070h,071h,072h,073h,074h,075h,076h,077h,078h,079h,07ah,05bh,05ch,05dh,05eh,05fh
			db	060h,061h,062h,063h,064h,065h,066h,067h,068h,069h,06ah,06bh,06ch,06dh,06eh,06fh
			db	070h,071h,072h,073h,074h,075h,076h,077h,078h,079h,07ah,07bh,07ch,07dh,07eh,07fh
			db	080h,081h,082h,083h,084h,085h,086h,087h,088h,089h,08ah,08bh,08ch,08dh,08eh,08fh
			db	090h,091h,092h,093h,094h,095h,096h,097h,098h,099h,09ah,09bh,09ch,09dh,09eh,09fh
			db	0a0h,0a1h,0a2h,0a3h,0a4h,0a5h,0a6h,0a7h,0a8h,0a9h,0aah,0abh,0ach,0adh,0aeh,0afh
			db	0b0h,0b1h,0b2h,0b3h,0b4h,0b5h,0b6h,0b7h,0b8h,0b9h,0bah,0bbh,0bch,0bdh,0beh,0bfh
			db	0c0h,0c1h,0c2h,0c3h,0c4h,0c5h,0c6h,0c7h,0c8h,0c9h,0cah,0cbh,0cch,0cdh,0ceh,0cfh
			db	0d0h,0d1h,0d2h,0d3h,0d4h,0d5h,0d6h,0d7h,0d8h,0d9h,0dah,0dbh,0dch,0ddh,0deh,0dfh
			db	0e0h,0e1h,0e2h,0e3h,0e4h,0e5h,0e6h,0e7h,0e8h,0e9h,0eah,0ebh,0ech,0edh,0eeh,0efh
			db	0f0h,0f1h,0f2h,0f3h,0f4h,0f5h,0f6h,0f7h,0f8h,0f9h,0fah,0fbh,0fch,0fdh,0feh,0ffh
; TCASE conversion table
			align	16
CharTableToggle		db	000h,001h,002h,003h,004h,005h,006h,007h,008h,009h,00ah,00bh,00ch,00dh,00eh,00fh
			db	010h,011h,012h,013h,014h,015h,016h,017h,018h,019h,01ah,01bh,01ch,01dh,01eh,01fh
			db	020h,021h,022h,023h,024h,025h,026h,027h,028h,029h,02ah,02bh,02ch,02dh,02eh,02fh
			db	030h,031h,032h,033h,034h,035h,036h,037h,038h,039h,03ah,03bh,03ch,03dh,03eh,03fh
			db	040h,061h,062h,063h,064h,065h,066h,067h,068h,069h,06ah,06bh,06ch,06dh,06eh,06fh
			db	070h,071h,072h,073h,074h,075h,076h,077h,078h,079h,07ah,05bh,05ch,05dh,05eh,05fh
			db	060h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,07bh,07ch,07dh,07eh,07fh
			db	080h,081h,082h,083h,084h,085h,086h,087h,088h,089h,08ah,08bh,08ch,08dh,08eh,08fh
			db	090h,091h,092h,093h,094h,095h,096h,097h,098h,099h,09ah,09bh,09ch,09dh,09eh,09fh
			db	0a0h,0a1h,0a2h,0a3h,0a4h,0a5h,0a6h,0a7h,0a8h,0a9h,0aah,0abh,0ach,0adh,0aeh,0afh
			db	0b0h,0b1h,0b2h,0b3h,0b4h,0b5h,0b6h,0b7h,0b8h,0b9h,0bah,0bbh,0bch,0bdh,0beh,0bfh
			db	0c0h,0c1h,0c2h,0c3h,0c4h,0c5h,0c6h,0c7h,0c8h,0c9h,0cah,0cbh,0cch,0cdh,0ceh,0cfh
			db	0d0h,0d1h,0d2h,0d3h,0d4h,0d5h,0d6h,0d7h,0d8h,0d9h,0dah,0dbh,0dch,0ddh,0deh,0dfh
			db	0e0h,0e1h,0e2h,0e3h,0e4h,0e5h,0e6h,0e7h,0e8h,0e9h,0eah,0ebh,0ech,0edh,0eeh,0efh
			db	0f0h,0f1h,0f2h,0f3h,0f4h,0f5h,0f6h,0f7h,0f8h,0f9h,0fah,0fbh,0fch,0fdh,0feh,0ffh
; STRTTOS conversion table
			align	16
CharTableTTOS		db	000h,001h,002h,003h,004h,005h,006h,007h,008h,020h,00ah,00bh,00ch,00dh,00eh,00fh
			db	010h,011h,012h,013h,014h,015h,016h,017h,018h,019h,01ah,01bh,01ch,01dh,01eh,01fh
			db	020h,021h,022h,023h,024h,025h,026h,027h,028h,029h,02ah,02bh,02ch,02dh,02eh,02fh
			db	030h,031h,032h,033h,034h,035h,036h,037h,038h,039h,03ah,03bh,03ch,03dh,03eh,03fh
			db	040h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,05bh,05ch,05dh,05eh,05fh
			db	060h,061h,062h,063h,064h,065h,066h,067h,068h,069h,06ah,06bh,06ch,06dh,06eh,06fh
			db	070h,071h,072h,073h,074h,075h,076h,077h,078h,079h,07ah,07bh,07ch,07dh,07eh,07fh
			db	080h,081h,082h,083h,084h,085h,086h,087h,088h,089h,08ah,08bh,08ch,08dh,08eh,08fh
			db	090h,091h,092h,093h,094h,095h,096h,097h,098h,099h,09ah,09bh,09ch,09dh,09eh,09fh
			db	0a0h,0a1h,0a2h,0a3h,0a4h,0a5h,0a6h,0a7h,0a8h,0a9h,0aah,0abh,0ach,0adh,0aeh,0afh
			db	0b0h,0b1h,0b2h,0b3h,0b4h,0b5h,0b6h,0b7h,0b8h,0b9h,0bah,0bbh,0bch,0bdh,0beh,0bfh
			db	0c0h,0c1h,0c2h,0c3h,0c4h,0c5h,0c6h,0c7h,0c8h,0c9h,0cah,0cbh,0cch,0cdh,0ceh,0cfh
			db	0d0h,0d1h,0d2h,0d3h,0d4h,0d5h,0d6h,0d7h,0d8h,0d9h,0dah,0dbh,0dch,0ddh,0deh,0dfh
			db	0e0h,0e1h,0e2h,0e3h,0e4h,0e5h,0e6h,0e7h,0e8h,0e9h,0eah,0ebh,0ech,0edh,0eeh,0efh
			db	0f0h,0f1h,0f2h,0f3h,0f4h,0f5h,0f6h,0f7h,0f8h,0f9h,0fah,0fbh,0fch,0fdh,0feh,0ffh
; STRSTOT conversion table
			align	16
CharTableSTOT		db	000h,001h,002h,003h,004h,005h,006h,007h,008h,009h,00ah,00bh,00ch,00dh,00eh,00fh
			db	010h,011h,012h,013h,014h,015h,016h,017h,018h,019h,01ah,01bh,01ch,01dh,01eh,01fh
			db	009h,021h,022h,023h,024h,025h,026h,027h,028h,029h,02ah,02bh,02ch,02dh,02eh,02fh
			db	030h,031h,032h,033h,034h,035h,036h,037h,038h,039h,03ah,03bh,03ch,03dh,03eh,03fh
			db	040h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,05bh,05ch,05dh,05eh,05fh
			db	060h,061h,062h,063h,064h,065h,066h,067h,068h,069h,06ah,06bh,06ch,06dh,06eh,06fh
			db	070h,071h,072h,073h,074h,075h,076h,077h,078h,079h,07ah,07bh,07ch,07dh,07eh,07fh
			db	080h,081h,082h,083h,084h,085h,086h,087h,088h,089h,08ah,08bh,08ch,08dh,08eh,08fh
			db	090h,091h,092h,093h,094h,095h,096h,097h,098h,099h,09ah,09bh,09ch,09dh,09eh,09fh
			db	0a0h,0a1h,0a2h,0a3h,0a4h,0a5h,0a6h,0a7h,0a8h,0a9h,0aah,0abh,0ach,0adh,0aeh,0afh
			db	0b0h,0b1h,0b2h,0b3h,0b4h,0b5h,0b6h,0b7h,0b8h,0b9h,0bah,0bbh,0bch,0bdh,0beh,0bfh
			db	0c0h,0c1h,0c2h,0c3h,0c4h,0c5h,0c6h,0c7h,0c8h,0c9h,0cah,0cbh,0cch,0cdh,0ceh,0cfh
			db	0d0h,0d1h,0d2h,0d3h,0d4h,0d5h,0d6h,0d7h,0d8h,0d9h,0dah,0dbh,0dch,0ddh,0deh,0dfh
			db	0e0h,0e1h,0e2h,0e3h,0e4h,0e5h,0e6h,0e7h,0e8h,0e9h,0eah,0ebh,0ech,0edh,0eeh,0efh
			db	0f0h,0f1h,0f2h,0f3h,0f4h,0f5h,0f6h,0f7h,0f8h,0f9h,0fah,0fbh,0fch,0fdh,0feh,0ffh
; Variables names decision table
; a-z A-Z 0-9 _ 
; Invalid chars = 0
; ( = 1
; : = 2
			align	16
VarNameTable		db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,001h,000h,000h,000h,000h,000h,000h,000h
			db	030h,031h,032h,033h,034h,035h,036h,037h,038h,039h,002h,000h,000h,000h,000h,000h
			db	000h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,000h,000h,000h,000h,05fh
			db	000h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
; Variables names first char decision table
			align	16
VarNameTableFirst	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,026h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,000h,000h,000h,000h,000h
			db	000h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			align	16
VarNameTableFnc		db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	030h,031h,032h,033h,034h,035h,036h,037h,038h,039h,000h,000h,000h,000h,000h,000h
			db	000h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,000h,000h,000h,000h,05fh
			db	000h,041h,042h,043h,044h,045h,046h,047h,048h,049h,04ah,04bh,04ch,04dh,04eh,04fh
			db	050h,051h,052h,053h,054h,055h,056h,057h,058h,059h,05ah,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
			db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
; IMP truth table
; 0  0  -> 1
; 0  1  -> 1
; 1  0  -> 0
; 1  1  -> 1
			align	16
LOGIC_IMP_MaskTable	dd	000000001b,000000000b
			dd	000000001b,000000001b
; EQV truth table
; 0  0  -> 1
; 0  1  -> 0
; 1  0  -> 0
; 1  1  -> 1
			align	16
LOGIC_EQV_MaskTable	dd	000000001b,000000000b
			dd	000000000b,000000001b
; Bits manipulations table
			align	16
Bits_MaskTable		dd	000000000000000000000000000000001b
			dd	000000000000000000000000000000010b
			dd	000000000000000000000000000000100b
			dd	000000000000000000000000000001000b
			dd	000000000000000000000000000010000b
			dd	000000000000000000000000000100000b
			dd	000000000000000000000000001000000b
			dd	000000000000000000000000010000000b
			dd	000000000000000000000000100000000b
			dd	000000000000000000000001000000000b
			dd	000000000000000000000010000000000b
			dd	000000000000000000000100000000000b
			dd	000000000000000000001000000000000b
			dd	000000000000000000010000000000000b
			dd	000000000000000000100000000000000b
			dd	000000000000000001000000000000000b
			dd	000000000000000010000000000000000b
			dd	000000000000000100000000000000000b
			dd	000000000000001000000000000000000b
			dd	000000000000010000000000000000000b
			dd	000000000000100000000000000000000b
			dd	000000000001000000000000000000000b
			dd	000000000010000000000000000000000b
			dd	000000000100000000000000000000000b
			dd	000000001000000000000000000000000b
			dd	000000010000000000000000000000000b
			dd	000000100000000000000000000000000b
			dd	000001000000000000000000000000000b
			dd	000010000000000000000000000000000b
			dd	000100000000000000000000000000000b
			dd	001000000000000000000000000000000b
			dd	010000000000000000000000000000000b
; Table to correct sizes of datas in arrays
			align	16
TypeLenTable		dd	offset TypeLenInteger
			dd	offset TypeLenDouble
			dd	offset TypeLenString
; --- Strings
; (Barbarian way to do it but fast)
			align	16
HEXTabASCII		db	"000102030405060708090A0B0C0D0E0F"
			db	"101112131415161718191A1B1C1D1E1F"
			db	"202122232425262728292A2B2C2D2E2F"
			db	"303132333435363738393A3B3C3D3E3F"
			db	"404142434445464748494A4B4C4D4E4F"
			db	"505152535455565758595A5B5C5D5E5F"
			db	"606162636465666768696A6B6C6D6E6F"
			db	"707172737475767778797A7B7C7D7E7F"
			db	"808182838485868788898A8B8C8D8E8F"
			db	"909192939495969798999A9B9C9D9E9F"
			db	"A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
			db	"B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
			db	"C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
			db	"D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
			db	"E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
			db	"F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"
			align	16
BINTabASCII		db	"0000","0001"
			db	"0010","0011"
			db	"0100","0101"
			db	"0110","0111"
			db	"1000","1001"
			db	"1010","1011"
			db	"1100","1101"
			db	"1110","1111"
			align	16
HEXTabASCII2		db	"0123456789ABCDEF"
			align	16
TempHEXNumber		db	8 dup ("0")
			db	0,0
			align	16
TempBINNumber		db	32 dup ("0")
			db	0,0
			align	16
APIText			db	0dh,0ah,"*** WINDOWS API FATALITY #",0
APIText2		db	" ***",0dh,0ah,0
BasicCredits		db	"Copyright (C) 2002-2003 Franck Charlet.",0ah,0
BasicUsage		db	"Usage: MBasic <program.mbi> or <program[.bas]>",0
BasicTitle		db	"MBasic v1.8",0ah,0
WinTitle		db	"MBasic v1.8",0
			align	16
FileExt			db	".BAS",0			; File extension automagically added
			align	16
Disp1Char		db	" ",0				; Only 1 char to display
			align	16
ReadyTxt		db	"Ready.",0
			align	16
CrLfTxt			db	13
LfTxt			db	10,0

; --- Errors strings
			align	16
Colon			db	":",0
Err1			db	"Syntax error",0
Err2			db	"Invalid Line number",0
Err3			db	"Numeric value overflow",0
Err4			db	"Subscript out of array range",0
Err5			db	"Out of memory",0
Err6			db	"TO expected after FOR statement",0
Err7			db	"Division by zero",0
Err8			db	"Unexpected variable type",0
Err9			db	"Keyword or variable expected",0
Err10			db	"'=' statement expected",0
Err11			db	"Label not found",0
Err12			db	"Available GOSUB levels exhausted",0
Err13			db	"RETURN without GOSUB",0
Err14			db	"Duplicate FOR..NEXT variable",0
Err15			db	"Available FOR..NEXT levels exhausted",0
Err16			db	"NEXT without FOR",0
Err17			db	"NEXT variable doesn't match corresponding FOR",0
Err18			db	"',' statement expected",0
Err19			db	"Invalid argument",0
Err20			db	"Variable expected",0
Err21			db	"File not found",0
Err22			db	"File too large",0
Err23			db	"Not a MBasic file",0
Err24			db	"Label already defined",0
Err25			db	"Invalid floating point number",0
Err26			db	"Expressions stack space exhausted",0
Err27			db	"Error in expression",0
Err28			db	"Integer value expected",0
Err29			db	"Illegal char found",0
Err30			db	"'(' statement expected",0
Err31			db	"')' statement expected",0
Err32			db	"Ifs stack space exhausted",0
Err33			db	"Unexpected statement",0
Err34			db	"Unexpected end of file",0
Err35			db	"Even value expected",0
Err36			db	"'",34,"' statement expected",0
Err37			db	"Argument expected",0
Err38			db	"Variable or array address expected",0
Err39			db	"Invalid use of address reference",0
Err40			db	"Invalid index reference",0
Err41			db	"Datas memory overflow",0
Err42			db	"No argument allowed",0
Err43			db	"Strings table space exhausted",0
Err44			db	"Numeric value expected",0
Err45			db	"String value expected",0
Err46			db	"Not enough memory available for operation",0
Err47			db	"Positive value expected",0
Err48			db	"Integer value or string expected",0
Err49			db	"Invalid use of floating point variable",0
Err50			db	"Variable name too long",0
Err51			db	"Symbols table space exhausted",0
Err52			db	"Illegal use of reserved symbol",0
Err53			db	"Symbol already defined",0
Err54			db	"':' or 'AS' statements expected",0
Err55			db	"Unknown type in declaration",0
Err56			db	"Illegal array size",0
Err57			db	"Type mismatch",0
Err58			db	"Unknown symbol",0
Err59			db	"Array index out of bounds",0
Err60			db	"Variables must be of the same type",0
Err61			db	"Wrong variable type",0
Err62			db	"Array expected",0
Err63			db	"Available WHILE..WEND levels exhausted",0
Err64			db	"WEND without WHILE",0
Err65			db	"EXIT FOR without FOR",0
Err66			db	"Illegal use of label",0
Err67			db	"Illegal label name",0
Err68			db	"Integer value or floating point expected",0
Err69			db	"Invalid line number",0
StopMsg			db	"Break",0

;-----------------------------------------------------------------------------------------------
; Pre-conversion table
; (order MUST follow RunTbl/DRunTbl/RunFncTbl)
			align	16
PreCompTbl		dd	offset CMD_1_KEYWORD
			dd	offset CMD_2_KEYWORD
			dd	offset CMD_BEEP_KEYWORD
			dd	offset CMD_BITCLR_KEYWORD
			dd	offset CMD_BITINV_KEYWORD
			dd	offset CMD_BITSET_KEYWORD
			dd	offset CMD_CLS_KEYWORD
			dd	offset CMD_COLOR_KEYWORD
			dd	offset CMD_DIM_KEYWORD
			dd	offset CMD_DOEVENTS_KEYWORD
			dd	offset CMD_ELSE_KEYWORD
ENDIFPOS		equ	($-offset PreCompTbl)/4
			dd	offset CMD_ENDIF_KEYWORD
			dd	offset CMD_END_KEYWORD
EXITFORPOS		equ	($-offset PreCompTbl)/4
			dd	offset CMD_EXITFOR_KEYWORD
			dd	offset CMD_FCLOSE_KEYWORD
			dd	offset CMD_FCOPY_KEYWORD
			dd	offset CMD_FKILL_KEYWORD
			dd	offset CMD_FMKDIR_KEYWORD
			dd	offset CMD_FNAME_KEYWORD
			dd	offset CMD_FOR_KEYWORD
			dd	offset CMD_FRMDIR_KEYWORD
			dd	offset CMD_FSAVE_KEYWORD
			dd	offset CMD_FSEEK_KEYWORD
			dd	offset CMD_FWRITE_KEYWORD
			dd	offset CMD_FWRITELN_KEYWORD
			dd	offset CMD_GET_KEYWORD
			dd	offset CMD_GOSUB_KEYWORD
			dd	offset CMD_GOTO_KEYWORD
			dd	offset CMD_HWAIT_KEYWORD
IFPOS			equ	$
			dd	offset CMD_IF_KEYWORD
			dd	offset CMD_INPUT_KEYWORD
LETPOS			equ	$
			dd	offset CMD_LET_KEYWORD
			dd	offset CMD_LOCATE_KEYWORD
			dd	offset CMD_MCOPY_KEYWORD
			dd	offset CMD_MFILL_KEYWORD
			dd	offset CMD_MFREE_KEYWORD
			dd	offset CMD_MROTATEL_KEYWORD
			dd	offset CMD_MROTATER_KEYWORD
			dd	offset CMD_MWRITED_KEYWORD
			dd	offset CMD_MWRITEW_KEYWORD
			dd	offset CMD_MWRITE_KEYWORD
			dd	offset CMD_NEXT_KEYWORD
			dd	offset CMD_POKED_KEYWORD
			dd	offset CMD_POKEW_KEYWORD
			dd	offset CMD_POKE_KEYWORD
			dd	offset CMD_PRINT_KEYWORD
REMPOS			equ	$
			dd	offset CMD_REM_KEYWORD
			dd	offset CMD_RETURN_KEYWORD
			dd	offset CMD_SETCONTITLE_KEYWORD
			dd	offset CMD_STOP_KEYWORD
			dd	offset CMD_SWAPGT_KEYWORD
			dd	offset CMD_SWAPLW_KEYWORD
			dd	offset CMD_SWAP_KEYWORD
			dd	offset CMD_VARTOINT_KEYWORD
			dd	offset CMD_VARTOSTR_KEYWORD
			dd	offset CMD_WAIT_KEYWORD
			dd	offset CMD_WEND_KEYWORD
			dd	offset CMD_WHILE_KEYWORD
			dd	offset CMD_WINDOW_KEYWORD
NBRPRECOMPTBL		equ	($-offset PreCompTbl)/4
COMPREM			equ	(REMPOS-offset PreCompTbl)/4
COMPIF			equ	(IFPOS-offset PreCompTbl)/4
COMPLET			equ	(LETPOS-offset PreCompTbl)/4

;-----------------------------------------------------------------------------------------------
; Compiled commands in run mode (verified)
			align	16
RunTblPtr		dd	offset RunTbl
			align	16
			dd	offset AssignVar		; -1*4
RunTbl			dd	offset CMD_REMCOMP
			dd	offset CMD_PRINTCOMP
			dd	offset CMD_BEEPCOMP
			dd	offset CMD_BITCLRCOMP
			dd	offset CMD_BITINVCOMP
			dd	offset CMD_BITSETCOMP
			dd	offset CMD_CLSCOMP
			dd	offset CMD_COLORCOMP
			dd	offset CMD_DIMCOMP
			dd	offset CMD_DOEVENTSCOMP
			dd	offset CMD_ELSECOMP
			dd	offset CMD_ENDIFCOMP
			dd	offset CMD_ENDCOMP
			dd	offset CMD_EXITFORCOMP
			dd	offset CMD_FCLOSECOMP
			dd	offset CMD_FCOPYCOMP
			dd	offset CMD_FKILLCOMP
			dd	offset CMD_FMKDIRCOMP
			dd	offset CMD_FNAMECOMP
			dd	offset CMD_FORCOMP
			dd	offset CMD_FRMDIRCOMP
			dd	offset CMD_FSAVECOMP
			dd	offset CMD_FSEEKCOMP
			dd	offset CMD_FWRITECOMP
			dd	offset CMD_FWRITELNCOMP
			dd	offset CMD_GETCOMP
			dd	offset CMD_GOSUBCOMP
			dd	offset CMD_GOTOCOMP
			dd	offset CMD_HWAITCOMP
			dd	offset CMD_IFCOMP
			dd	offset CMD_INPUTCOMP
			dd	offset CMD_LETCOMP
			dd	offset CMD_LOCATECOMP
			dd	offset CMD_MCOPYCOMP
			dd	offset CMD_MFILLCOMP
			dd	offset CMD_MFREECOMP
			dd	offset CMD_MROTATELCOMP
			dd	offset CMD_MROTATERCOMP
			dd	offset CMD_MWRITEDCOMP
			dd	offset CMD_MWRITEWCOMP
			dd	offset CMD_MWRITECOMP
			dd	offset CMD_NEXTCOMP
			dd	offset CMD_POKEDCOMP
			dd	offset CMD_POKEWCOMP
			dd	offset CMD_POKECOMP
			dd	offset CMD_PRINTCOMP
			dd	offset CMD_REMCOMP
			dd	offset CMD_RETURNCOMP
			dd	offset CMD_SETCONTITLECOMP
			dd	offset CMD_STOPCOMP
			dd	offset CMD_SWAPGTCOMP
			dd	offset CMD_SWAPLWCOMP
			dd	offset CMD_SWAPCOMP
			dd	offset CMD_VARTOINTCOMP
			dd	offset CMD_VARTOSTRCOMP
			dd	offset CMD_WAITCOMP
			dd	offset CMD_WENDCOMP
			dd	offset CMD_WHILECOMP
			dd	offset CMD_WINDOWCOMP

; Compiled commands in run mode (unverified)
; IF/ELSE/ENDIF blocks
			align	16
			dd	offset NoThenUnVerified		; -1*4
UnVerifiedRunTblIF	dd	offset CMD_REMCOMP
			dd	offset NoThenUnVerified		; PRINT
			dd	offset NoThenUnVerified		; BEEP
			dd	offset NoThenUnVerified		; BITCLR
			dd	offset NoThenUnVerified		; BITINV
			dd	offset NoThenUnVerified		; BITSET
			dd	offset NoThenUnVerified		; CLS
			dd	offset NoThenUnVerified		; COLOR
			dd	offset NoThenUnVerified		; DIM
			dd	offset NoThenUnVerified		; DOEVENTS
			dd	offset CMD_ELSECOMP
			dd	offset CMD_ENDIFCOMP
			dd	offset NoThenUnVerified		; END
			dd	offset NoThenUnVerified		; EXIT FOR
			dd	offset NoThenUnVerified		; FCLOSE
			dd	offset NoThenUnVerified		; FCOPY
			dd	offset NoThenUnVerified		; FKILL
			dd	offset NoThenUnVerified		; FMKDIR
			dd	offset NoThenUnVerified		; FNAME
			dd	offset NoThenUnVerified		; FOR
			dd	offset NoThenUnVerified		; FRMDIR
			dd	offset NoThenUnVerified		; FSAVE
			dd	offset NoThenUnVerified		; FSEEK
			dd	offset NoThenUnVerified		; FWRITE
			dd	offset NoThenUnVerified		; FWRITELN
			dd	offset NoThenUnVerified		; GET
			dd	offset NoThenUnVerified		; GOSUB
			dd	offset NoThenUnVerified		; GOTO
			dd	offset NoThenUnVerified		; HWAIT
			dd	offset GhostedIFCOMP
			dd	offset NoThenUnVerified		; INPUT
			dd	offset NoThenUnVerified		; LET
			dd	offset NoThenUnVerified		; LOCATE
			dd	offset NoThenUnVerified		; MCOPY
			dd	offset NoThenUnVerified		; MFILL
			dd	offset NoThenUnVerified		; MFREE
			dd	offset NoThenUnVerified		; MROTATEL
			dd	offset NoThenUnVerified		; MROTATER
			dd	offset NoThenUnVerified		; MWRITED
			dd	offset NoThenUnVerified		; MWRITEW
			dd	offset NoThenUnVerified		; MWRITE
			dd	offset NoThenUnVerified		; NEXT
			dd	offset NoThenUnVerified		; POKED
			dd	offset NoThenUnVerified		; POKEW
			dd	offset NoThenUnVerified		; POKE
			dd	offset NoThenUnVerified		; PRINT
			dd	offset CMD_REMCOMP		; REM
			dd	offset NoThenUnVerified		; RETURN
			dd	offset NoThenUnVerified		; SETCONTITLE
			dd	offset NoThenUnVerified		; STOP
			dd	offset NoThenUnVerified		; SWAPGT
			dd	offset NoThenUnVerified		; SWAPLW
			dd	offset NoThenUnVerified		; SWAP
			dd	offset NoThenUnVerified		; VARTOINT
			dd	offset NoThenUnVerified		; VARTOSTR
			dd	offset NoThenUnVerified		; WAIT
			dd	offset NoThenUnVerified		; WEND
			dd	offset NoThenUnVerified		; WHILE
			dd	offset NoThenUnVerified		; WINDOW

; Compiled commands in run mode (unverified)
; WHILE/WEND blocks
			align	16
			dd	offset CMD_REMCOMP		; -1*4
UnVerifiedRunTblWHILE	dd	offset CMD_REMCOMP		; '
			dd	offset CMD_REMCOMP		; PRINT
			dd	offset CMD_REMCOMP		; BEEP
			dd	offset CMD_REMCOMP		; BITCLR
			dd	offset CMD_REMCOMP		; BITINV
			dd	offset CMD_REMCOMP		; BITSET
			dd	offset CMD_REMCOMP		; CLS
			dd	offset CMD_REMCOMP		; COLOR
			dd	offset CMD_REMCOMP		; DIM
			dd	offset CMD_REMCOMP		; DOEVENTS
			dd	offset CMD_REMCOMP		; ELSE
			dd	offset CMD_REMCOMP		; END IF
			dd	offset CMD_REMCOMP		; END
			dd	offset CMD_REMCOMP		; EXIT FOR
			dd	offset CMD_REMCOMP		; FCLOSE
			dd	offset CMD_REMCOMP		; FCOPY
			dd	offset CMD_REMCOMP		; FKILL
			dd	offset CMD_REMCOMP		; FMKDIR
			dd	offset CMD_REMCOMP		; FNAME
			dd	offset CMD_REMCOMP		; FOR
			dd	offset CMD_REMCOMP		; FRMDIR
			dd	offset CMD_REMCOMP		; FSAVE
			dd	offset CMD_REMCOMP		; FSEEK
			dd	offset CMD_REMCOMP		; FWRITE
			dd	offset CMD_REMCOMP		; FWRITELN
			dd	offset CMD_REMCOMP		; GET
			dd	offset CMD_REMCOMP		; GOSUB
			dd	offset CMD_REMCOMP		; GOTO
			dd	offset CMD_REMCOMP		; HWAIT
			dd	offset CMD_REMCOMP		; IF
			dd	offset CMD_REMCOMP		; INPUT
			dd	offset CMD_REMCOMP		; LET
			dd	offset CMD_REMCOMP		; LOCATE
			dd	offset CMD_REMCOMP		; MCOPY
			dd	offset CMD_REMCOMP		; MFILL
			dd	offset CMD_REMCOMP		; MFREE
			dd	offset CMD_REMCOMP		; MROTATEL
			dd	offset CMD_REMCOMP		; MROTATER
			dd	offset CMD_REMCOMP		; MWRITED
			dd	offset CMD_REMCOMP		; MWRITEW
			dd	offset CMD_REMCOMP		; MWRITE
			dd	offset CMD_REMCOMP		; NEXT
			dd	offset CMD_REMCOMP		; POKED
			dd	offset CMD_REMCOMP		; POKEW
			dd	offset CMD_REMCOMP		; POKE
			dd	offset CMD_REMCOMP		; PRINT
			dd	offset CMD_REMCOMP		; REM
			dd	offset CMD_REMCOMP		; RETURN
			dd	offset CMD_REMCOMP		; SETCONTITLE
			dd	offset CMD_REMCOMP		; STOP
			dd	offset CMD_REMCOMP		; SWAPGT
			dd	offset CMD_REMCOMP		; SWAPLW
			dd	offset CMD_REMCOMP		; SWAP
			dd	offset CMD_REMCOMP		; VARTOINT
			dd	offset CMD_REMCOMP		; VARTOSTR
			dd	offset CMD_REMCOMP		; WAIT
			dd	offset CMD_WENDUNVERCOMP	; WEND
			dd	offset CMD_WHILEUNVERCOMP	; WHILE
			dd	offset CMD_REMCOMP		; WINDOW

; Compiled commands in run mode (unverified)
; FOR/NEXT blocks iterations verification
			align	16
			dd	offset CMD_REMCOMP		; -1*4
UnVerifiedRunTblFOR	dd	offset CMD_REMCOMP		; '
			dd	offset CMD_REMCOMP		; PRINT
			dd	offset CMD_REMCOMP		; BEEP
			dd	offset CMD_REMCOMP		; BITCLR
			dd	offset CMD_REMCOMP		; BITINV
			dd	offset CMD_REMCOMP		; BITSET
			dd	offset CMD_REMCOMP		; CLS
			dd	offset CMD_REMCOMP		; COLOR
			dd	offset CMD_REMCOMP		; DIM
			dd	offset CMD_REMCOMP		; DOEVENTS
			dd	offset CMD_REMCOMP		; ELSE
			dd	offset CMD_REMCOMP		; END IF
			dd	offset CMD_REMCOMP		; END
			dd	offset CMD_REMCOMP		; EXIT FOR
			dd	offset CMD_REMCOMP		; FCLOSE
			dd	offset CMD_REMCOMP		; FCOPY
			dd	offset CMD_REMCOMP		; FKILL
			dd	offset CMD_REMCOMP		; FMKDIR
			dd	offset CMD_REMCOMP		; FNAME
			dd	offset CMD_FORUNVERCOMP		; FOR
			dd	offset CMD_REMCOMP		; FRMDIR
			dd	offset CMD_REMCOMP		; FSAVE
			dd	offset CMD_REMCOMP		; FSEEK
			dd	offset CMD_REMCOMP		; FWRITE
			dd	offset CMD_REMCOMP		; FWRITELN
			dd	offset CMD_REMCOMP		; GET
			dd	offset CMD_REMCOMP		; GOSUB
			dd	offset CMD_REMCOMP		; GOTO
			dd	offset CMD_REMCOMP		; HWAIT
			dd	offset CMD_REMCOMP		; IF
			dd	offset CMD_REMCOMP		; INPUT
			dd	offset CMD_REMCOMP		; LET
			dd	offset CMD_REMCOMP		; LOCATE
			dd	offset CMD_REMCOMP		; MCOPY
			dd	offset CMD_REMCOMP		; MFILL
			dd	offset CMD_REMCOMP		; MFREE
			dd	offset CMD_REMCOMP		; MROTATEL
			dd	offset CMD_REMCOMP		; MROTATER
			dd	offset CMD_REMCOMP		; MWRITED
			dd	offset CMD_REMCOMP		; MWRITEW
			dd	offset CMD_REMCOMP		; MWRITE
			dd	offset CMD_NEXTUNVERCOMP	; NEXT
			dd	offset CMD_REMCOMP		; POKED
			dd	offset CMD_REMCOMP		; POKEW
			dd	offset CMD_REMCOMP		; POKE
			dd	offset CMD_REMCOMP		; PRINT
			dd	offset CMD_REMCOMP		; REM
			dd	offset CMD_REMCOMP		; RETURN
			dd	offset CMD_REMCOMP		; SETCONTITLE
			dd	offset CMD_REMCOMP		; STOP
			dd	offset CMD_REMCOMP		; SWAPGT
			dd	offset CMD_REMCOMP		; SWAPLW
			dd	offset CMD_REMCOMP		; SWAP
			dd	offset CMD_REMCOMP		; VARTOINT
			dd	offset CMD_REMCOMP		; VARTOSTR
			dd	offset CMD_REMCOMP		; WAIT
			dd	offset CMD_REMCOMP		; WEND
			dd	offset CMD_REMCOMP		; WHILE
			dd	offset CMD_REMCOMP		; WINDOW

; Compiled commands in run mode (unverified)
; EXIT FOR
			align	16
			dd	offset CMD_REMCOMP		; -1*4
UnVerifiedRunTblEXITFOR	dd	offset CMD_REMCOMP		; '
			dd	offset CMD_REMCOMP		; PRINT
			dd	offset CMD_REMCOMP		; BEEP
			dd	offset CMD_REMCOMP		; BITCLR
			dd	offset CMD_REMCOMP		; BITINV
			dd	offset CMD_REMCOMP		; BITSET
			dd	offset CMD_REMCOMP		; CLS
			dd	offset CMD_REMCOMP		; COLOR
			dd	offset CMD_REMCOMP		; DIM
			dd	offset CMD_REMCOMP		; DOEVENTS
			dd	offset CMD_REMCOMP		; ELSE (Ghosted)
			dd	offset CMD_ENDIFSILENTCOMP	; END IF
			dd	offset CMD_REMCOMP		; END
			dd	offset CMD_REMCOMP		; EXIT FOR
			dd	offset CMD_REMCOMP		; FCLOSE
			dd	offset CMD_REMCOMP		; FCOPY
			dd	offset CMD_REMCOMP		; FKILL
			dd	offset CMD_REMCOMP		; FMKDIR
			dd	offset CMD_REMCOMP		; FNAME
			dd	offset CMD_FORUNVERCOMP		; FOR
			dd	offset CMD_REMCOMP		; FRMDIR
			dd	offset CMD_REMCOMP		; FSAVE
			dd	offset CMD_REMCOMP		; FSEEK
			dd	offset CMD_REMCOMP		; FWRITE
			dd	offset CMD_REMCOMP		; FWRITELN
			dd	offset CMD_REMCOMP		; GET
			dd	offset CMD_REMCOMP		; GOSUB
			dd	offset CMD_REMCOMP		; GOTO
			dd	offset CMD_REMCOMP		; HWAIT
			dd	offset GhostedIFCOMP		; IF
			dd	offset CMD_REMCOMP		; INPUT
			dd	offset CMD_REMCOMP		; LET
			dd	offset CMD_REMCOMP		; LOCATE
			dd	offset CMD_REMCOMP		; MCOPY
			dd	offset CMD_REMCOMP		; MFILL
			dd	offset CMD_REMCOMP		; MFREE
			dd	offset CMD_REMCOMP		; MROTATEL
			dd	offset CMD_REMCOMP		; MROTATER
			dd	offset CMD_REMCOMP		; MWRITED
			dd	offset CMD_REMCOMP		; MWRITEW
			dd	offset CMD_REMCOMP		; MWRITE
			dd	offset CMD_NEXTSILENTCOMP	; NEXT
			dd	offset CMD_REMCOMP		; POKED
			dd	offset CMD_REMCOMP		; POKEW
			dd	offset CMD_REMCOMP		; POKE
			dd	offset CMD_REMCOMP		; PRINT
			dd	offset CMD_REMCOMP		; REM
			dd	offset CMD_REMCOMP		; RETURN
			dd	offset CMD_REMCOMP		; SETCONTITLE
			dd	offset CMD_REMCOMP		; STOP
			dd	offset CMD_REMCOMP		; SWAPGT
			dd	offset CMD_REMCOMP		; SWAPLW
			dd	offset CMD_REMCOMP		; SWAP
			dd	offset CMD_REMCOMP		; VARTOINT
			dd	offset CMD_REMCOMP		; VARTOSTR
			dd	offset CMD_REMCOMP		; WAIT
			dd	offset CMD_WENDSILENTCOMP	; WEND
			dd	offset CMD_WHILESILENTCOMP	; WHILE
			dd	offset CMD_REMCOMP		; WINDOW

; Compiled functions
			align	16
RunFncTbl		dd	offset FNC_ABSCOMP
			dd	offset FNC_ACOSECCOMP
			dd	offset FNC_ACOSCOMP
			dd	offset FNC_ACOTANCOMP
			dd	offset FNC_ASCCOMP
			dd	offset FNC_ASECCOMP
			dd	offset FNC_ASINCOMP
			dd	offset FNC_ATNCOMP
			dd	offset FNC_BINBCOMP
			dd	offset FNC_BINDCOMP
			dd	offset FNC_BINWCOMP
			dd	offset FNC_BINCOMP
			dd	offset FNC_BITCOUNTCOMP
			dd	offset FNC_BITTSTCOMP
			dd	offset FNC_BSWAPCOMP
			dd	offset FNC_CARETXCOMP
			dd	offset FNC_CARETYCOMP
			dd	offset FNC_CHRCOMP
			dd	offset FNC_CINTCOMP
			dd	offset FNC_COSECCOMP
			dd	offset FNC_COSCOMP
			dd	offset FNC_COTANCOMP
			dd	offset FNC_CSTRCOMP
			dd	offset FNC_DATECOMP
			dd	offset FNC_EXPCOMP
			dd	offset FNC_ECOMP
			dd	offset FNC_FALSECOMP
			dd	offset FNC_FCLOSECOMP
			dd	offset FNC_FCREATECOMP
			dd	offset FNC_FEOFCOMP
			dd	offset FNC_FIXCOMP
			dd	offset FNC_FLENCOMP
			dd	offset FNC_FLOADCOMP
			dd	offset FNC_FLOCCOMP
			dd	offset FNC_FLOFCOMP
			dd	offset FNC_FOPENRCOMP
			dd	offset FNC_FOPENWCOMP
			dd	offset FNC_FRACCOMP
			dd	offset FNC_FREADCOMP
			dd	offset FNC_FSAVECOMP
			dd	offset FNC_FSEEKCOMP
			dd	offset FNC_FWRITECOMP
			dd	offset FNC_FWRITELNCOMP
			dd	offset FNC_GETCONTITLECOMP
			dd	offset FNC_HACOSECCOMP
			dd	offset FNC_HACOSCOMP
			dd	offset FNC_HASECCOMP
			dd	offset FNC_HASINCOMP
			dd	offset FNC_HATNCOMP
			dd	offset FNC_HCOATNCOMP
			dd	offset FNC_HCOSECCOMP
			dd	offset FNC_HCOSCOMP
			dd	offset FNC_HCOTANCOMP
			dd	offset FNC_HEXBCOMP
			dd	offset FNC_HEXDCOMP
			dd	offset FNC_HEXWCOMP
			dd	offset FNC_HEXCOMP
			dd	offset FNC_HIBYTECOMP
			dd	offset FNC_HIWORDCOMP
			dd	offset FNC_HSECCOMP
			dd	offset FNC_HSINCOMP
			dd	offset FNC_HTANCOMP
			dd	offset FNC_HTICKSCOMP
			dd	offset FNC_IIFCOMP
			dd	offset FNC_INKEYCOMP
			dd	offset FNC_INSTRCOMP
			dd	offset FNC_INTCOMP
			dd	offset FNC_ISDOUBLECOMP
			dd	offset FNC_ISINTEGERCOMP
			dd	offset FNC_ISSTRINGCOMP
			dd	offset FNC_LBOUNDCOMP
			dd	offset FNC_LCASECOMP
			dd	offset FNC_LEFTCOMP
			dd	offset FNC_LENCOMP
			dd	offset FNC_LINECOMP
			dd	offset FNC_LOBYTECOMP
			dd	offset FNC_LOGNCOMP
			dd	offset FNC_LOGCOMP
			dd	offset FNC_LOWORDCOMP
			dd	offset FNC_LTRIMCOMP
			dd	offset FNC_LTRIM2COMP
			dd	offset FNC_MALLOCCOMP
			dd	offset FNC_MFREECOMP
			dd	offset FNC_MIDCOMP
			dd	offset FNC_MREADCOMP
			dd	offset FNC_MREADDCOMP
			dd	offset FNC_MREADWCOMP
			dd	offset FNC_NOTCOMP
			dd	offset FNC_NOWCOMP
			dd	offset FNC_PEEKCOMP
			dd	offset FNC_PEEKDCOMP
			dd	offset FNC_PEEKWCOMP
			dd	offset FNC_PICOMP
			dd	offset FNC_RIGHTCOMP
			dd	offset FNC_RNDCOMP
			dd	offset FNC_RTRIMCOMP
			dd	offset FNC_RTRIM2COMP
			dd	offset FNC_SECCOMP
			dd	offset FNC_SGNCOMP
			dd	offset FNC_SINCOMP
			dd	offset FNC_SIZECOMP
			dd	offset FNC_LENCOMP
			dd	offset FNC_SPACECOMP
			dd	offset FNC_SQRTCOMP
			dd	offset FNC_STRCOMP
			dd	offset FNC_STRCMPCOMP
			dd	offset FNC_STRINGCOMP
			dd	offset FNC_STRLINESCOMP
			dd	offset FNC_STRPADCOMP
			dd	offset FNC_STRPADLCOMP
			dd	offset FNC_STRPADRCOMP
			dd	offset FNC_STRREVERSECOMP
			dd	offset FNC_STRROTATELCOMP
			dd	offset FNC_STRROTATERCOMP
			dd	offset FNC_STRSTOTCOMP
			dd	offset FNC_STRTTOSCOMP
			dd	offset FNC_TANCOMP
			dd	offset FNC_TCASECOMP
			dd	offset FNC_TICKSCOMP
			dd	offset FNC_TIMECOMP
			dd	offset FNC_TRIMCOMP
			dd	offset FNC_TRIM2COMP
			dd	offset FNC_TRUECOMP
			dd	offset FNC_UBOUNDCOMP
			dd	offset FNC_UCASECOMP
			dd	offset FNC_WSWAPCOMP

; Commands not compiled (all commands must be accessible)
			align	16
RunTblComp		dd	offset CMD_REM
			dd	offset CMD_PRINT
			dd	offset CMD_BEEP
			dd	offset CMD_BITCLR
			dd	offset CMD_BITINV
			dd	offset CMD_BITSET
			dd	offset CMD_CLS
			dd	offset CMD_COLOR
			dd	offset CMD_DIM
			dd	offset CMD_DOEVENTS
			dd	offset CMD_ELSE
			dd	offset CMD_ENDIF
			dd	offset CMD_END
			dd	offset CMD_EXIT
			dd	offset CMD_FCLOSE
			dd	offset CMD_FCOPY
			dd	offset CMD_FKILL
			dd	offset CMD_FMKDIR
			dd	offset CMD_FNAME
			dd	offset CMD_FOR
			dd	offset CMD_FRMDIR
			dd	offset CMD_FSAVE
			dd	offset CMD_FSEEK
			dd	offset CMD_FWRITE
			dd	offset CMD_FWRITELN
			dd	offset CMD_GET
			dd	offset CMD_GOSUB
			dd	offset CMD_GOTO
			dd	offset CMD_HWAIT
			dd	offset CMD_IF
			dd	offset CMD_INPUT
			dd	offset CMD_LET
			dd	offset CMD_LOCATE
			dd	offset CMD_MCOPY
			dd	offset CMD_MFILL
			dd	offset CMD_MFREE
			dd	offset CMD_MROTATEL
			dd	offset CMD_MROTATER
			dd	offset CMD_MWRITED
			dd	offset CMD_MWRITEW
			dd	offset CMD_MWRITE
			dd	offset CMD_NEXT
			dd	offset CMD_POKED
			dd	offset CMD_POKEW
			dd	offset CMD_POKE
			dd	offset CMD_PRINT
			dd	offset CMD_REM
			dd	offset CMD_RETURN
			dd	offset CMD_SETCONTITLE
			dd	offset CMD_STOP
			dd	offset CMD_SWAPGT
			dd	offset CMD_SWAPLW
			dd	offset CMD_SWAP
			dd	offset CMD_VARTOINT
			dd	offset CMD_VARTOSTR
			dd	offset CMD_WAIT
			dd	offset CMD_WEND
			dd	offset CMD_WHILE
			dd	offset CMD_WINDOW
			align	16
TableRel		dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_REL_UnknownCOMP
			dd	offset Op_EQUCOMP		; 013h
			dd	offset Op_LOWERCOMP
			dd	offset Op_GREATERCOMP
			dd	offset Op_LOWEREQUCOMP
			dd	offset Op_GREATEREQUCOMP
			dd	offset Op_NOTEQUCOMP
			repeat	(256-(WRAP_NOTEQU+1))
			dd	offset Op_REL_UnknownCOMP	; 019h
			endm

			align	16
TableLogic		dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_LOGIC_UnknownCOMP
			dd	offset Op_ORCOMP		; 01ah
			dd	offset Op_XORCOMP
			dd	offset Op_ANDCOMP
			dd	offset Op_SHLCOMP
			dd	offset Op_SHRCOMP
			dd	offset Op_ROLCOMP
			dd	offset Op_RORCOMP
			dd	offset Op_IMPCOMP
			dd	offset Op_EQVCOMP
			dd	offset Op_NORCOMP
			dd	offset Op_NANDCOMP
			dd	offset Op_NXORCOMP
			repeat	(256-(WRAP_NXOR+1))
			dd	offset Op_LOGIC_UnknownCOMP	; 026h
			endm

			align	16
TableLevel1Op		dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset NoOpCOMP
			dd	offset Op_DivCOMP		; 00fh
			dd	offset Op_DivIntCOMP
			dd	offset Op_MulCOMP
			dd	offset Op_ModCOMP
			repeat	(256-(WRAP_MOD+1))
			dd	offset NoOpCOMP			; 013h
			endm

			align	16
TableOperands		dd	offset GetFNCArgsFromExpr
			dd	offset GetFNCArgsFromExpr
			dd	offset GetFNCArgsFromExpr
			dd	offset GetFNCArgsFromExpr
			dd	offset GetFNCArgsFromExpr
			dd	offset GetFunctionCOMP		; 5
			dd	offset GetVariableCOMP
			dd	offset GetArrayCOMP
			dd	offset GetStringCOMP
			dd	offset GetVarAddressCOMP
			dd	offset GetArrayAddressCOMP
			dd	offset GetFPCOMP
			dd	offset GetIntegerCOMP
			repeat	(256-(WRAP_INT+1))
			dd	offset GetFNCArgsFromExpr	; 0dh
			endm

;-----------------------------------------------------------------------------------------------
; ASCII commands table
CMD_1_KEYWORD		equ	$
			CMD	"'"
CMD_2_KEYWORD		equ	$
			CMD	"?"
CMD_BEEP_KEYWORD	equ	$
			CMD	"BEEP"
CMD_BITCLR_KEYWORD	equ	$
			CMD	"BITCLR"
CMD_BITINV_KEYWORD	equ	$
			CMD	"BITINV"
CMD_BITSET_KEYWORD	equ	$
			CMD	"BITSET"
CMD_CLS_KEYWORD		equ	$
			CMD	"CLS"
CMD_COLOR_KEYWORD	equ	$
			CMD	"COLOR"
CMD_DIM_KEYWORD		equ	$
			CMD	"DIM"
CMD_DOEVENTS_KEYWORD	equ	$
			CMD	"DOEVENTS"
CMD_ELSE_KEYWORD	equ	$
			CMD	"ELSE"
CMD_ENDIF_KEYWORD	equ	$
			CMD	"ENDIF"
CMD_END_KEYWORD		equ	$
			CMD	"END"
CMD_EXITFOR_KEYWORD	equ	$
			CMD	"EXIT"
CMD_FCLOSE_KEYWORD	equ	$
			CMD	"FCLOSE"
CMD_FCOPY_KEYWORD	equ	$
			CMD	"FCOPY"
CMD_FKILL_KEYWORD	equ	$
			CMD	"FKILL"
CMD_FMKDIR_KEYWORD	equ	$
			CMD	"FMKDIR"
CMD_FNAME_KEYWORD	equ	$
			CMD	"FNAME"
CMD_FOR_KEYWORD		equ	$
			CMD	"FOR"
CMD_FRMDIR_KEYWORD	equ	$
			CMD	"FRMDIR"
CMD_FSAVE_KEYWORD	equ	$
			CMD	"FSAVE"
CMD_FSEEK_KEYWORD	equ	$
			CMD	"FSEEK"
CMD_FWRITELN_KEYWORD	equ	$
			CMD	"FWRITELN"
CMD_FWRITE_KEYWORD	equ	$
			CMD	"FWRITE"
CMD_GET_KEYWORD		equ	$
			CMD	"GET"
CMD_GOSUB_KEYWORD	equ	$
			CMD	"GOSUB"
CMD_GOTO_KEYWORD	equ	$
			CMD	"GOTO"
CMD_HWAIT_KEYWORD	equ	$
			CMD	"HWAIT"
CMD_IF_KEYWORD		equ	$
			CMD	"IF"
CMD_INPUT_KEYWORD	equ	$
			CMD	"INPUT"
CMD_LET_KEYWORD		equ	$
			CMD	"LET"
CMD_LOCATE_KEYWORD	equ	$
			CMD	"LOCATE"
CMD_MCOPY_KEYWORD	equ	$
			CMD	"MCOPY"
CMD_MFILL_KEYWORD	equ	$
			CMD	"MFILL"
CMD_MFREE_KEYWORD	equ	$
			CMD	"MFREE"
CMD_MROTATEL_KEYWORD	equ	$
			CMD	"MROTATEL"
CMD_MROTATER_KEYWORD	equ	$
			CMD	"MROTATER"
CMD_MWRITED_KEYWORD	equ	$
			CMD	"MWRITED"
CMD_MWRITEW_KEYWORD	equ	$
			CMD	"MWRITEW"
CMD_MWRITE_KEYWORD	equ	$
			CMD	"MWRITE"
CMD_NEXT_KEYWORD	equ	$
			CMD	"NEXT"
CMD_POKED_KEYWORD	equ	$
			CMD	"POKED"
CMD_POKEW_KEYWORD	equ	$
			CMD	"POKEW"
CMD_POKE_KEYWORD	equ	$
			CMD	"POKE"
CMD_PRINT_KEYWORD	equ	$
			CMD	"PRINT"
CMD_REM_KEYWORD		equ	$
			CMD	"REM"
CMD_RETURN_KEYWORD	equ	$
			CMD	"RETURN"
CMD_SETCONTITLE_KEYWORD	equ	$
			CMD	"SETCONTITLE"
CMD_STOP_KEYWORD	equ	$
			CMD	"STOP"
CMD_SWAP_KEYWORD	equ	$
			CMD	"SWAP"
CMD_SWAPGT_KEYWORD	equ	$
			CMD	"SWAPGT"
CMD_SWAPLW_KEYWORD	equ	$
			CMD	"SWAPLW"
CMD_VARTOINT_KEYWORD	equ	$
			CMD	"VARTOINT"
CMD_VARTOSTR_KEYWORD	equ	$
			CMD	"VARTOSTR"
CMD_WAIT_KEYWORD	equ	$
			CMD	"WAIT"
CMD_WEND_KEYWORD	equ	$
			CMD	"WEND"
CMD_WHILE_KEYWORD	equ	$
			CMD	"WHILE"
CMD_WINDOW_KEYWORD	equ	$
			CMD	"WINDOW"

;-----------------------------------------------------------------------------------------------
; Functions Table.
TAB_FNCA		equ	$
			FNC	"ABS",FNC_ABS
			FNC	"ACOSEC",FNC_ACOSEC
			FNC	"ACOS",FNC_ACOS
			FNC	"ACOTAN",FNC_ACOTAN
			FNC	"ASC",FNC_ASC
			FNC	"ASEC",FNC_ASEC
			FNC	"ASIN",FNC_ASIN
			FNC	"ATN",FNC_ATN
			FNCEND	Expr_GetVar
TAB_FNCB		equ	$
			FNC	"BINB",FNC_BINB
			FNC	"BIND",FNC_BIND
			FNC	"BINW",FNC_BINW
			FNC	"BIN",FNC_BIN
			FNC	"BITCOUNT",FNC_BITCOUNT
			FNC	"BITTST",FNC_BITTST
			FNC	"BSWAP",FNC_BSWAP
			FNCEND	Expr_GetVar
TAB_FNCC		equ	$
			FNC	"CARETX",FNC_CARETX
			FNC	"CARETY",FNC_CARETY
			FNC	"CHR",FNC_CHR
			FNC	"CINT",FNC_CINT
			FNC	"COSEC",FNC_COSEC
			FNC	"COS",FNC_COS
			FNC	"COTAN",FNC_COTAN
			FNC	"CSTR",FNC_CSTR
			FNCEND	Expr_GetVar
TAB_FNCD		equ	$
			FNC	"DATE",FNC_DATE
			FNCEND	Expr_GetVar
TAB_FNCE		equ	$
			FNC	"EXP",FNC_EXP
			FNC	"E",FNC_E
			FNCEND	Expr_GetVar
TAB_FNCF		equ	$
			FNC	"FALSE",FNC_FALSE
			FNC	"FCLOSE",FNC_FCLOSE
			FNC	"FCREATE",FNC_FCREATE
			FNC	"FEOF",FNC_FEOF
			FNC	"FIX",FNC_FIX
			FNC	"FLEN",FNC_FLEN
			FNC	"FLOAD",FNC_FLOAD
			FNC	"FLOC",FNC_FLOC
			FNC	"FLOF",FNC_FLOF
			FNC	"FOPENR",FNC_FOPENR
			FNC	"FOPENW",FNC_FOPENW
			FNC	"FRAC",FNC_FRAC
			FNC	"FREAD",FNC_FREAD
			FNC	"FSAVE",FNC_FSAVE
			FNC	"FSEEK",FNC_FSEEK
			FNC	"FWRITELN",FNC_FWRITELN
			FNC	"FWRITE",FNC_FWRITE
			FNCEND	Expr_GetVar
TAB_FNCG		equ	$
			FNC	"GETCONTITLE",FNC_GETCONTITLE
			FNCEND	Expr_GetVar
TAB_FNCH		equ	$
			FNC	"HACOSEC",FNC_HACOSEC
			FNC	"HACOS",FNC_HACOS
			FNC	"HASEC",FNC_HASEC
			FNC	"HASIN",FNC_HASIN
			FNC	"HATN",FNC_HATN
			FNC	"HCOATN",FNC_HCOATN
			FNC	"HCOSEC",FNC_HCOSEC
			FNC	"HCOS",FNC_HCOS
			FNC	"HCOTAN",FNC_HCOTAN
			FNC	"HEXB",FNC_HEXB
			FNC	"HEXD",FNC_HEXD
			FNC	"HEXW",FNC_HEXW
			FNC	"HEX",FNC_HEX
			FNC	"HIBYTE",FNC_HIBYTE
			FNC	"HIWORD",FNC_HIWORD
			FNC	"HSEC",FNC_HSEC
			FNC	"HSIN",FNC_HSIN
			FNC	"HTAN",FNC_HTAN
			FNC	"HTICKS",FNC_HTICKS
			FNCEND	Expr_GetVar
TAB_FNCI		equ	$
			FNC	"IIF",FNC_IIF
			FNC	"INKEY",FNC_INKEY
			FNC	"INSTR",FNC_INSTR
			FNC	"INT",FNC_INT
			FNC	"ISDOUBLE",FNC_ISDOUBLE
			FNC	"ISINTEGER",FNC_ISINTEGER
			FNC	"ISSTRING",FNC_ISSTRING
			FNCEND	Expr_GetVar
TAB_FNCL		equ	$
			FNC	"LBOUND",FNC_LBOUND
			FNC	"LCASE",FNC_LCASE
			FNC	"LEFT",FNC_LEFT
			FNC	"LEN",FNC_LEN
			FNC	"LINE",FNC_LINE
			FNC	"LOBYTE",FNC_LOBYTE
			FNC	"LOGN",FNC_LOGN
			FNC	"LOG",FNC_LOG
			FNC	"LOWORD",FNC_LOWORD
			FNC	"LTRIM2",FNC_LTRIM2
			FNC	"LTRIM",FNC_LTRIM
			FNCEND	Expr_GetVar
TAB_FNCM		equ	$
			FNC	"MALLOC",FNC_MALLOC
			FNC	"MFREE",FNC_MFREE
			FNC	"MID",FNC_MID
			FNC	"MREADD",FNC_MREADD
			FNC	"MREADW",FNC_MREADW
			FNC	"MREAD",FNC_MREAD
			FNCEND	Expr_GetVar
TAB_FNCN		equ	$
			FNC	"NOT",FNC_NOT
			FNC	"NOW",FNC_NOW
			FNCEND	Expr_GetVar
TAB_FNCP		equ	$
			FNC	"PEEKD",FNC_PEEKD
			FNC	"PEEKW",FNC_PEEKW
			FNC	"PEEK",FNC_PEEK
			FNC	"PI",FNC_PI
			FNCEND	Expr_GetVar
TAB_FNCR		equ	$
			FNC	"RIGHT",FNC_RIGHT
			FNC	"RND",FNC_RND
			FNC	"RTRIM2",FNC_RTRIM2
			FNC	"RTRIM",FNC_RTRIM
			FNCEND	Expr_GetVar
TAB_FNCS		equ	$
			FNC	"SEC",FNC_SEC
			FNC	"SGN",FNC_SGN
			FNC	"SIN",FNC_SIN
			FNC	"SIZEOF",FNC_LEN
			FNC	"SIZE",FNC_SIZE
			FNC	"SPACE",FNC_SPACE
			FNC	"SQRT",FNC_SQRT
			FNC	"STRCMP",FNC_STRCMP
			FNC	"STRING",FNC_STRING
			FNC	"STRLINES",FNC_STRLINES
			FNC	"STRPADL",FNC_STRPADL
			FNC	"STRPADR",FNC_STRPADR
			FNC	"STRPAD",FNC_STRPAD
			FNC	"STRREVERSE",FNC_STRREVERSE
			FNC	"STRROTATEL",FNC_STRROTATEL
			FNC	"STRROTATER",FNC_STRROTATER
			FNC	"STRSTOT",FNC_STRSTOT
			FNC	"STRTTOS",FNC_STRTTOS
			FNC	"STR",FNC_STR
			FNCEND	Expr_GetVar
TAB_FNCT		equ	$
			FNC	"TAN",FNC_TAN
			FNC	"TCASE",FNC_TCASE
			FNC	"TICKS",FNC_TICKS
			FNC	"TIME",FNC_TIME
			FNC	"TRIM2",FNC_TRIM2
			FNC	"TRIM",FNC_TRIM
			FNC	"TRUE",FNC_TRUE
			FNCEND	Expr_GetVar
TAB_FNCU		equ	$
			FNC	"UBOUND",FNC_UBOUND
			FNC	"UCASE",FNC_UCASE
			FNCEND	Expr_GetVar
TAB_FNCW		equ	$
			FNC	"WSWAP",FNC_WSWAP
			FNCEND	Expr_GetVar
TAB_FNCFALL		equ	$
			FNCEND	Expr_GetVar

;-----------------------------------------------------------------------------------------------
; TO keyword
TBL_TO			equ	$
			FNC	"TO ",TOKEYWORD
			FNCEND	ErrorTO

;-----------------------------------------------------------------------------------------------
; STEP keyword
TBL_STEP		equ	$
			FNC	"STEP ",STEPKEYWORD
			FNCEND	NOSTEPKEYWORD

;-----------------------------------------------------------------------------------------------
; EDIT keyword
TBL_EDIT		equ	$
			FNC	"EDIT",WINDOW_EDIT
			FNCEND	WINDOW_XXX

;-----------------------------------------------------------------------------------------------
; For pre-compilation purposes only
TBL_THENPRECOMP		equ	$
			FNC	"THEN ",PreCompThen
			FNC	"THEN",PreCompThen	; Required for THEN<CR>
			FNCEND	PreCompNoThen

;-----------------------------------------------------------------------------------------------
; ELSE IF keyword
TBL_ELSEIF		equ	$
			FNC	"IF",ELSEIFKEYWORD
			FNCEND	NOELSEIFKEYWORD

;-----------------------------------------------------------------------------------------------
; END keyword
TBL_END			equ	$
			FNC	"IF",ENDIFKEYWORD
			FNCEND	NOENDIFKEYWORD

;-----------------------------------------------------------------------------------------------
; EXIT keyword
TBL_EXIT		equ	$
			FNC	"FOR",EXITFORKEYWORD
			FNCEND	E9

;-----------------------------------------------------------------------------------------------
; Relational operators
TAB_REL_OP		equ	$
			FNC	">>",Op_LOGIC_Wrap	; Exclude these two operators
			FNC	"<<",Op_LOGIC_Wrap
			FNC	">=",Op_GREATEREQU
			FNC	"<>",Op_NOTEQU
			FNC	">",Op_GREATER
			FNC	"=",Op_EQU
			FNC	"<=",Op_LOWEREQU
			FNC	"<",Op_LOWER
			FNC	"!=",Op_NOTEQU
			FNCEND	Op_REL_Unknown

;-----------------------------------------------------------------------------------------------
; Logical/Binary operators
TAB_LOGIC_OP		equ	$
			FNC	"|",Op_OR2		; No space char required
			FNC	"~",Op_XOR2		; before these ones
			FNC	"&",Op_AND2
			FNC	"XOR ",Op_XOR
			FNC	"EOR ",Op_XOR
			FNC	"OR ",Op_OR
			FNC	"AND ",Op_AND
			FNC	"SHL ",Op_SHL
			FNC	"SHR ",Op_SHR
			FNC	"ROL ",Op_ROL
			FNC	"ROR ",Op_ROR
			FNC	"<<",Op_SHL2
			FNC	">>",Op_SHR2
			FNC	"IMP ",Op_IMP
			FNC	"EQV ",Op_EQV
			FNC	"NOR ",Op_NOR
			FNC	"NAND ",Op_NAND
			FNC	"NXOR ",Op_NXOR
			FNCEND	Op_LOGIC_Unknown

;-----------------------------------------------------------------------------------------------
; MOD operator substitute
TAB_MOD_OP		equ	$
			FNC	"MOD ",Op_Mod2
			FNCEND	R4

;-----------------------------------------------------------------------------------------------
; Variables/Arrays declarations
TAB_VAR_DEC		equ	$
			FNC	":",SetDIMDatas
			FNC	"AS ",DIM_DecAS
			FNCEND	RemoveVarEntryAS

;-----------------------------------------------------------------------------------------------
; Variables/Arrays type
TAB_VAR_DECTYPE		equ	$
			FNC	"INTEGER",SetDIMDatasINT_VAR
			FNC	"STRING",SetDIMDatasSTR_VAR
			FNC	"DOUBLE",SetDIMDatasFP_VAR
			FNC	"INT",SetDIMDatasINT_VAR		; Wrap
			FNC	"STR",SetDIMDatasSTR_VAR		; Wrap
			FNC	"DBL",SetDIMDatasFP_VAR			; Wrap
			FNC	"LONG",SetDIMDatasINT_VAR		; Wrap
			FNC	"LNG",SetDIMDatasINT_VAR		; Wrap
			FNC	"DWORD",SetDIMDatasINT_VAR		; Wrap
			FNCEND	RemoveVarEntryTYPE
TAB_ARR_DECTYPE		equ	$
			FNC	"INTEGER",SetDIMDatasINT_ARR
			FNC	"STRING",SetDIMDatasSTR_ARR
			FNC	"DOUBLE",SetDIMDatasFP_ARR
			FNC	"INT",SetDIMDatasINT_ARR		; Wrap
			FNC	"STR",SetDIMDatasSTR_ARR		; Wrap
			FNC	"DBL",SetDIMDatasFP_ARR			; Wrap
			FNC	"LONG",SetDIMDatasINT_ARR		; Wrap
			FNC	"LNG",SetDIMDatasINT_ARR		; Wrap
			FNC	"DWORD",SetDIMDatasINT_ARR		; Wrap
			FNCEND	RemoveVarEntryTYPE

;-----------------------------------------------------------------------------------------------
; MBasic code starts here.
			.code
start:			; Allocate necessary virtual memory for buffers, Basic text and @(array) 
			; !!! ALLOCATION ORDER MUST NOT BE CHANGED !!!
    			mov	eax,(256*2) + 128 + MEMSIZE + 2 + 256 + MAX_PATH + MAX_PATH + MAX_PATH + MAX_PATH + 80 + (256*4) + (256*4) + (256*4)
    			invoke	VirtualAlloc,0,eax,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			test	eax,eax
			jz	DisplayError			; Api Error
			mov	PrintBuffer,eax
			add	eax,256*2			; Print buffer area
			mov	TxtStart,eax
			mov	TxtEnd,eax
			add	eax,MEMSIZE			; Basic text area
			mov	LineNum,eax
			add	eax,2				; 2 bytes before ASCII line number
			mov	LineBuffer,eax
			add	eax,256				; Input line buffer area (256/line)
			mov	FileName,eax			; Loaded program name
			add	eax,MAX_PATH
			mov	CmdLine,eax			; Passed program name in argument line
			add	eax,MAX_PATH
			mov	FilePath,eax			; Used internally for filenames manipulations
			add	eax,MAX_PATH
			mov	FilePathName,eax		; Same...
			add	eax,MAX_PATH
			mov	DblString,eax
			add	eax,80
			mov	PtrTblFnc,eax
			; Alloc them separately to ensure correct padding
			; (and faster access)
    			invoke	VirtualAlloc,0,(6*4)*FORNEXTLEVELS,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	ForNextStack,eax		; FOR..NEXT stack area
			add	eax,(6*4)*FORNEXTLEVELS
			mov	ForNextStackEnd,eax
    			invoke	VirtualAlloc,0,(4*4)*WHILEWENDLEVELS,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	WhileWendStack,eax		; WHILE..WEND stack area
			add	eax,(4*4)*WHILEWENDLEVELS
			mov	WhileWendStackEnd,eax
    			invoke	VirtualAlloc,0,(8*GOSUBLEVELS),MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	GosubStack,eax
			add	eax,(8*GOSUBLEVELS)
			mov	GosubStackEnd,eax
    			invoke	VirtualAlloc,0,MEMSTRINGSIZE,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	LitStrings,eax
			mov	LitStringsPtr,eax
			add	eax,MEMSTRINGSIZE
			mov	LitStringsEnd,eax
    			invoke	VirtualAlloc,0,MEMVARSYMBOLS,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	VarSymb,eax
    			invoke	VirtualAlloc,0,MEMLABELSYMBOLS,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	LabelSymb,eax
    			invoke	VirtualAlloc,0,MEMEXPRSIZE,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	CompExpr,eax			; Block for precompiled expressions
			mov	CompExprPtr,eax
    			invoke	VirtualAlloc,0,(256*4),MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	OperStack,eax			; 256*4 bytes for expressions stack
			mov	OperStackPtr,eax
    			invoke	VirtualAlloc,0,(256*4),MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	TmpStringsStack,eax		; 256*4 bytes for temporary strings stack
			mov	TmpStringsStackPtr,eax
    			invoke	VirtualAlloc,0,MEMCOMSIZE,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	CompStart,eax			; Compiled commands
			mov	CompPtr,eax
			mov	CompEnd,eax
    			invoke	VirtualAlloc,0,MEMDATSIZE,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	DatStart,eax			; POKE/PEEK memory (64kb)
			add	eax,MEMDATSIZE
			mov	DatEnd,eax
    			invoke	VirtualAlloc,0,(256*8)+8,MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	dword ptr [eax],0
			mov	dword ptr [eax+4],-1
			add	eax,8				; Padding for IfStack
			mov	IfStack,eax
			mov	IfStackPtr,eax

    			invoke	VirtualAlloc,0,(256*4),MEM_COMMIT or MEM_RESERVE,PAGE_READWRITE
			mov	LitStack,eax
			mov	LitStackPtr,eax

			; Fill functions pointers table
			; (allow faster searching in first pass)
			invoke	FillMem,PtrTblFnc,(256*4),offset TAB_FNCFALL
			mov	eax,PtrTblFnc
			invoke	PutTabPointer,"a",offset TAB_FNCA
			invoke	PutTabPointer,"b",offset TAB_FNCB
			invoke	PutTabPointer,"c",offset TAB_FNCC
			invoke	PutTabPointer,"d",offset TAB_FNCD
			invoke	PutTabPointer,"e",offset TAB_FNCE
			invoke	PutTabPointer,"f",offset TAB_FNCF
			invoke	PutTabPointer,"g",offset TAB_FNCG
			invoke	PutTabPointer,"h",offset TAB_FNCH
			invoke	PutTabPointer,"i",offset TAB_FNCI
			invoke	PutTabPointer,"l",offset TAB_FNCL
			invoke	PutTabPointer,"m",offset TAB_FNCM
			invoke	PutTabPointer,"n",offset TAB_FNCN
			invoke	PutTabPointer,"p",offset TAB_FNCP
			invoke	PutTabPointer,"r",offset TAB_FNCR
			invoke	PutTabPointer,"s",offset TAB_FNCS
			invoke	PutTabPointer,"t",offset TAB_FNCT
			invoke	PutTabPointer,"u",offset TAB_FNCU
			invoke	PutTabPointer,"w",offset TAB_FNCW
			; Install a console handler 
			invoke	SetConsoleCtrlHandler,addr CONHandler,1
			; Retrieve command argument
			invoke	GetCL,1,CmdLine
			call	GetHTimer
			call	ObtainStdHandles
			invoke	GetConsoleScreenBufferInfo,hStdOut,addr Csbi_SizeX
			invoke	GetConsoleScreenBufferInfo,hStdOut,addr OldConBuffer
			lea	eax,OldConBuffer
			movzx	eax,word ptr [OldConBuffer.wAttributes]
			mov	EditColors,eax
			mov	ax,word ptr [OldConBuffer.dwSize.x]
			mov	EditSizeX,ax
			mov	ax,word ptr [OldConBuffer.dwSize.y]
			mov	EditSizeY,ax
			mov	ax,word ptr [OldConBuffer.dwCursorPosition.x]
			mov	Csbi_CursorPositionX,ax
			mov	ax,word ptr [OldConBuffer.dwCursorPosition.y]
			mov	Csbi_CursorPositionY,ax
			call	WinEdit				; Set window size and colors to standard MBasic editor
			invoke	SetConsoleTitle,addr WinTitle
			cld					; Direction flag = 0, for strings transfer
			finit					; Initialize FPU
			mov	LineMaxLen,255			; Basic text line maximum length
			; Try to load and run specified file in subroutine line (if any)
			mov	eax,CmdLine
			mov	bl,[eax]
			test	bl,bl
			jz	PrintUsage			; Nothing: exit.
			; Get parameter
			invoke	lstrcpy,FileName,CmdLine
			call	AppendMBasicExtension
			call	InitP
			call	AutoLoadFile
			jmp	CMD_RUNCOMP			; Run it
PrintUsage:		xor	al,al
			mov	edx,offset BasicTitle
			call	DispStr
			xor	al,al
			mov	edx,offset BasicCredits
			call	DispStr
			call	CrLf
			xor	al,al
			mov	edx,offset BasicUsage
			call	DispStr
			call	CrLf
Exit:			call	ReNewAll
			invoke	ExitProcess,0

; Clear all allocated memory
ReNewAll:		mov	CursorShape.bVisible,1
			call	SetConCursor
			mov	LineNumber,0
			; Free allocated strings for variables
			mov	eax,VarSymb
			mov	ecx,VarNbr
			test	ecx,ecx
			jz	NoVarToFree
FreeAllStrings:		; Free variable name
			cmp	dword ptr [eax+VARDAT_NAME],0
			je	NoVarNameToFree
			push	eax
			push	ebx
			push	ecx
			; Free associated variable name
			invoke	GlobalFree,dword ptr [eax+VARDAT_NAME]
			pop	ecx
			pop	ebx
			pop	eax
NoVarNameToFree:	; Free datas associated with variable/array
			; Free the contained strings
			cmp	dword ptr [eax+VARDAT_TYPE],VAR_STRING
			jne	FreeArrayStrings
			push	ecx
			mov	ecx,dword ptr [eax+VARDAT_ARRUBOUND]
			push	ebx
			mov	ebx,dword ptr [eax+VARDAT_DATASPTR]
FreeArrayElements:	push	eax
			push	ebx
			push	ecx
			invoke	GlobalFree,dword ptr [ebx]
			pop	ecx
			pop	ebx
			add	ebx,4				; Next string (+4)
			pop	eax
			dec	ecx
			jnz	FreeArrayElements
			pop	ebx
			pop	ecx
FreeArrayStrings:	; Free main array entry now
			push	eax
			push	ebx
			push	ecx
			invoke	GlobalFree,dword ptr [eax+VARDAT_DATASPTR]
			pop	ecx
			pop	ebx
			pop	eax
			; Reset it to integer
			mov	dword ptr [eax+VARDAT_TYPE],VAR_INTEGER	
			add	eax,VARDATSIZE			; Next variable
			dec	ecx
			jnz	FreeAllStrings
NoVarToFree:		; Reset number of variables and labels
			mov	VarNbr,0
			mov	eax,LabelSymb
			mov	ecx,LabelNbr
			test	ecx,ecx
			jz	NoLabelToFree
FreeAllLabels:		cmp	dword ptr [eax],0
			je	NoLabelName
			push	eax
			push	ebx
			push	ecx
			; Free associated variable name
			invoke	GlobalFree,dword ptr [eax]
			pop	ecx
			pop	ebx
			pop	eax
NoLabelName:		add	eax,8
			dec	ecx
			jnz	FreeAllLabels
NoLabelToFree:		mov	LabelNbr,0
			; Reset complete variables/arrays block
			invoke	FillMem,VarSymb,MEMVARSYMBOLS,0
			invoke	FillMem,LabelSymb,MEMLABELSYMBOLS,0
			ret
			align	16
FreeTmpStrings:		push	ecx
			push	edx
FreeAllTmpStrings:	call	PopTmpStrStack
			jz	FreeAllTmpStrings
			pop	edx
			pop	ecx
			mov	ebx,TmpStringsStack		; ReInit stack
			mov	TmpStringsStackPtr,ebx
			ret
; Free a string from tmp strings table
			align	16
PopTmpStrStack:		lea	ecx,TmpStringsStackPtr
			sub	dword ptr [ecx],4		; Decrement
			mov	eax,[ecx]
			sub	eax,TmpStringsStack
			jge	MinTmpStringsStack
			or	eax,-1
			ret
			align	16
MinTmpStringsStack:	mov	ecx,[ecx]
			mov	eax,[ecx]
			invoke	GlobalFree,eax
			xor	eax,eax
			ret

;-----------------------------------------------------------------------------------------------
; RUN
; Find the first stored line, store it's address and start to execute it.
; Note that only TAB_CMD commands are legal for stored programs
;
; Note: subroutines processing is divided into 2 stages.
; stage 1: performs syntax checking on awaited arguments (not on real passed values)
;          encode retrieved expressions in expr buffer and put a pointer
;          into expr entry of subroutine definition.
; stage 2: get the pointer and execute the encoded expressions in sequence
;	   (values coherencies are checked here).
;
; The "mov SaveCompExprPtr,0" line simply tells the precompiler to put a null pointer
; into expr entry (for subroutine that can or must run without parameters).
CMD_RUNCOMP:		mov	ebx,CompStart
			mov	ecx,CompExpr
			call	PreComp				; Pre-compile the program
			mov	edx,CompStart			; edx = first Basic text program address
			call	NormalizeLabels			; Correct GOTOs and GOSUBs
			; Reset if stack and variables here
			; Also init. FOR..NEXT and GOSUB stacks pointers
			call	InitP
			mov	edx,CompStart			; edx = first program token address
NextLine:		xor	ebx,ebx				; Line number = 0
			call	LineNumCompareComp		; End of Basic text ?
RunBackward:		jnc	ExecLine			; No, execute line
			call	CheckPendingIf
			cmp	ForAdrVar,0			; Pending for
			jne	E34
			cmp	WhilePreviousFlag,0		; Pending while
			jne	E34
			cmp	GosLineNum,0			; Pending gosub
			jne	E34
			jmp	Exit

;-----------------------------------------------------------------------------------------------
; Load a basic text file with '.MBI' or '.BAS' extension
; ASCII files are converted into MBasic files in memory.
; Tests if file fits in text memory.
AutoLoadFile:		invoke	CreateFile,FileName,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
			cmp	eax,INVALID_HANDLE_VALUE	; File doesn't exist ?
			jne	@F				; No,continue
			mov	edi,offset Err21		; Yes <File not found>
			jmp	DispError
@@:			mov	FileHandle,eax
			invoke	GetFileSize,FileHandle,addr dtemp1
			call	TestApiError
			cmp	eax,MEMSIZE			; File length < Basic text memory available ?
			jb	@F				; Yes, continue
			invoke	CloseHandle,FileHandle
			mov	edi,offset Err22		; No, error <File too large>
			jmp	DispError
@@:			push	eax				; Save file length
			invoke	ReadFile,FileHandle,addr dtemp1,4,addr dtemp2,0
			call	TestApiError			; read header to be sure file comes from MBasic
			cmp	dtemp1,0014D4249h		; File signature ?
			je	@F				; Yes: it's an old MBasic file
			; Top of file
			invoke	SetFilePointer,FileHandle,0,0,FILE_BEGIN
			pop	eax				; File length
			; Load it as ASCII
			push	eax
			add	eax,3				; Append chr(13)+chr(10)+null
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
			pop	ebx
			test	eax,eax
			jz	E46
			mov	ASCIIFileSize,ebx
			mov	ASCIIFileMem,eax
			invoke	ReadFile,FileHandle,eax,ebx,addr dtemp1,0
			call	TestApiError
			invoke	CloseHandle,FileHandle
			; Avoid unterminated line
			mov	eax,ASCIIFileSize
			mov	ebx,ASCIIFileMem
			mov	word ptr [ebx+eax],00a0dh
			; Count the number of lines
			mov	ebx,ASCIIFileMem
			call	FNC_STRLINESCODE
			mov	ecx,ebx
			jz	EmptyASCIIFile
			dec	ecx
			mov	esi,ASCIIFileMem
			mov	edi,TxtStart
			; 0 at start to test with the result of ExtractLineNumber
			; that can't be lower than 1
			mov	ASCIILineNumber,0
MoveASCIIFileLines:	push	eax
			push	ecx
			push	esi
			invoke	GetFileLineAddress,ASCIIFileMem,eax
			mov	edx,eax
			; Extract given line number if any and
			; set it as new base number which must be greater or equal
			; to the preceding one.
			; (equal because ASCIILineNumber is constantly increasing)
			call	ExtractLineNumber
			test	eax,eax
			jz	NoLineFound
			cmp	ASCIILineNumber,0
			je	UpdateLineNumber
			cmp	ASCIILineNumber,eax
			jbe	UpdateLineNumber
			; Correct line number
			mov	eax,[esp+8]
			inc	eax
			mov	LineNumber,eax
			jmp	E69
			; Set it a new base
UpdateLineNumber:	mov	ASCIILineNumber,eax
NoLineFound:		; If the first line number found isn't 1
			cmp	ASCIILineNumber,0
			jne	VoidLine
			mov	ASCIILineNumber,1
VoidLine:		mov	ebx,[esp+8]
			inc	ebx
			mov	LineNumber,ebx
			push	ASCIILineNumber
			pop	dword ptr [edi]
			mov	[esp],edx			; Set new pointer
			mov	ebx,edx
			invoke	GetLineLen,edx
			push	eax				; Length
			add	edi,4
			push	eax
			mov	edx,ebx
			mov	ecx,eax
			add	ecx,edx
			call	RemoveTabs
			pop	eax
			push	edi
			push	eax
			push	ebx
			push	edi
			mov	edx,ebx
			mov	ecx,eax
			add	ecx,edx
			call	Ucase				; Convert line to upper case
			pop	edi
			pop	ebx
			pop	eax
			invoke	RtlMoveMemory,edi,ebx,eax
			pop	edi
			pop	eax
			mov	byte ptr [edi+eax],0dh
			inc	edi
			add	edi,eax
			pop	esi
			pop	ecx
			pop	eax
			inc	ASCIILineNumber
			inc	eax
			dec	ecx
			jnz	MoveASCIIFileLines
EmptyASCIIFile:		invoke	GlobalFree,ASCIIFileMem
			mov	eax,edi
			sub	eax,TxtStart
			push	eax
			jmp	InitAfterLoad
@@:			pop	eax				; File length
			sub	eax,4				; minus header
			push	eax				; Save real file length
			invoke	ReadFile,FileHandle,dword ptr TxtStart,eax,addr dtemp1,0
			call	TestApiError			; File text is transfered in basic text area
			invoke	CloseHandle,FileHandle
InitAfterLoad:		call	ReNewAll			; Clear all
			pop	eax				; Basic text length
			add	eax,TxtStart			; Update end of text pointer
			mov	TxtEnd,eax
			ret

; --------------- Retrieve the address of a line in a file
; ecx=line number
; esi=text buffer
GetFileLineAddress	proc	TextBuf:dword,LineNbr:dword
			push	esi
			push	ecx
			mov	esi,TextBuf
			mov	ecx,LineNbr
			xor	eax,eax
			test	ecx,ecx
			jz	ReturnLine
GetLine:		mov	al,[esi]
			inc	esi
			test	al,al
			jz	ReturnLine
			cmp	al,13
			je	NextChar
			cmp	al,10
			jne	NextChar
			dec	ecx
			jz	ReturnLine
NextChar:		jmp	GetLine
ReturnLine:		mov	eax,esi
			pop	ecx
			pop	esi
			ret
GetFileLineAddress	endp

; --------------- Retrieve the length of a text line
GetLineLen		proc	TextBuf:dword
			push	esi
			mov	esi,TextBuf
CheckStrLenCR:		mov	al,[esi]
			inc	esi
			test	al,al
			jz	EndOfLine
			cmp	al,10
			je	EndOfLine
      			cmp	al,13
			je	EndOfLine
			jmp	CheckStrLenCR
EndOfLine:		sub	esi,TextBuf
			dec	esi
			mov	eax,esi
			pop	esi
			ret
GetLineLen		endp

; --------------- Extract a possible line number from a text line
; Out: update edx and return line number in eax
; or produce an error if found ASCII number is <=0
ExtractLineNumber:	push	edx
			push	edi
			mov	al,[edx]
			cmp	al,"0"
			jb	_1989_NotANumber
			cmp	al,"9"
			ja	_1989_NotANumber
			; Starting with a digit
			call	TstNum
			mov	eax,ebx
			; Since it started with a line number, it must be >0
			test	eax,eax
			jz	E69
			js	E69
			pop	edi
			; Don't restore edx as it is our new address
			; (with line number stripped out)
			add	esp,4
			ret
_1989_NotANumber:	xor	eax,eax
			pop	edi
			pop	edx
			ret
E69:			mov	edi,offset Err69		; Error: <Invalid line number>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; END xxx
; Handle END commands (END/END IF)
CMD_END:		mov	SaveCompExprPtr,0
			mov	ebx,TBL_END
			jmp	SearchKeyword
ENDIFKEYWORD:		mov	PreCompNbr,ENDIFPOS
			ret
NOENDIFKEYWORD:		jmp	TestNoArguments

			align	16
CMD_ENDCOMP:		jmp	Exit

;-----------------------------------------------------------------------------------------------
; STOP
; Stops program and report current line number
CMD_STOP:		mov	SaveCompExprPtr,0
			jmp	TestNoArguments

			align	16
CMD_STOPCOMP:		mov	edi,offset StopMsg
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; GOTO(EXPR) evaluates the expression, finds the target line and jumps to Execline to do it
; There's two modes availables: GOTO Numeric expression or GOTO Label
CMD_GOTO:		call	TestArgumentsExpected
			; Save text position if first letter
			; (we will correct forward references later on)
			invoke	AddWrapInteger,edx
			jmp	PassLine

			align	16
CMD_GOTOCOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			cmp	byte ptr [edx],WRAP_LABEL
			jne	PapaWasARollingLabel
			pop	eax				; (To garbage)
			inc	edx
			mov	edx,[edx]
			jmp	ExecLine
			align	16
PapaWasARollingLabel:	call	EvalExprCOMP			; Evaluate expression
			pop	edx
			add	edx,4
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			call	FindLineComp			; Look for line expression
			jz	ExecLine			; Found line number ? execute it
			mov	edi,offset Err11		; else, error <Line number not found>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; WINDOW X,Y or WINDOW EDIT
; With 2 parameters, WINDOW resizes current console window with (X) width, (Y) height,
; (EDIT) resizes console window with original size, position and colors of Windows console
CMD_WINDOW:		call	TestArgumentsExpected
			mov	WindowCmdParms2Pos,edx
			mov	ebx,TBL_EDIT			; 'EDIT' keyword after 'WINDOW' ?
			jmp	SearchKeyword
E37:			mov	edi,offset Err37		; Argument expected
			jmp	DispError
WINDOW_EDIT:		mov	eax,CompExprPtr			; Write -1 to invalidate everything later
			mov	byte ptr [eax],-1
			inc	CompExprPtr
			ret
WINDOW_XXX:		mov	edx,WindowCmdParms2Pos
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_WINDOWCOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			cmp	byte ptr [edx],-1
			jne	WasWindowEdit
			call	WinEdit
			call	RedimWindow			; Redim console window & buffer
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
WasWindowEdit:		call	EvalExprCOMP			; Evaluate expression
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			jle	E19				; Must be >0
			mov	si,bx				; Detected, si = window width
			push	esi
			call	EvalExprCOMP			; Check second parameter
			pop	esi
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			jle	E19				; Must be >0
			mov	di,bx				; di = window height
			call	RedimWindow
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; PRINT command is 'PRINT ....;' or 'PRINT ....(CR)'
; where '....' is a list of expressions, formats, backarrows and strings.
; these items are separated by semicolons (strings concatenations applies too).
;
; A format is a '#' sign followed by a number. It controls the number of spaces the value of an
; integer expression to be printed. It stays effective for the rest of the print, unless changed by
; another format. No format specified, no padding added.
;
; A string is quoted in a pair of double quotes.
; Concatenations from a string to a numeric expression
; or from a numeric expression to a string use the sign +
CMD_PRINT:		call	TestArgumentsExpected
GetPrintExpr:		cmp	byte ptr [edx],0dh
			je	EndOfPrint
			mov	ah,":"
			call	SkipSpaces
			jz	EndOfPrint
			mov	ah,'#'				; Format sign ?
			call	SkipSpaces
			jnz	@F				; No, test other possibilities
			invoke	AddWrapStringPadding
			call	EvalExpr			; Yes, evaluate padding expression
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			jmp	CheckPrintEnd
@@:			mov	ah,";"				; Is it a ';'
			call	SkipSpaces
			jnz	GetPrintElement
			jmp	GetPrintExpr
GetPrintElement:	call	EvalExpr			; Yes, evaluate expression
CheckPrintEnd:		call	TrimSpaces
			cmp	byte ptr [edx],0dh
			je	EndOfPrint
			cmp	byte ptr [edx],"'"
			je	EndOfPrint
			mov	ah,";"				; Must follow an expression if not EOL
			call	SkipSpaces
			jz	ProceedNextPrintArg
			mov	ah,":"
			call	SkipSpaces
			jnz	E27
EndOfPrint:		jmp	AddWrapExprEnd
ProceedNextPrintArg:	jmp	GetPrintExpr

			align	16
CMD_PRINTCOMP:		mov	NbrPadding,0
			xor	cl,cl
			push	edx
			mov	edx,[edx]			; Get expression address
GetNextPrintArg:	cmp	byte ptr [edx],WRAP_EXPREND
			je	PrintDone
			cmp	byte ptr [edx],WRAP_STRPADDING
			jne	AddStrPad
			inc	edx				; Pass padding byte
			push	ecx
			call	EvalExprCOMP
			pop	ecx
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			inc	ebx
			mov	NbrPadding,bl
			jmp	GetNextPrintArg
			align	16
AddStrPad:		push	ecx
			call	EvalExprCOMP
			pop	ecx
			cmp	ExprFinalResult,VAR_INTEGER
			jne	PrintInteger
			push	edx
			call	DispNumber
			pop	edx
			jmp	GetNextPrintArg
			align	16
PrintInteger:		cmp	ExprFinalResult,VAR_DOUBLE
			jne	PrintDouble
			push	edx
			call	DispDouble
			pop	edx
			jmp	GetNextPrintArg
			align	16
PrintDouble:		cmp	ExprFinalResult,VAR_STRING
			jne	PrintString
			push	edx
			mov	edx,ebx
			call	QuotedString
			pop	edx
PrintString:		jmp	GetNextPrintArg
			align	16
PrintDone:		mov	NbrPadding,0
			pop	edx
			add	edx,5
			jmp	NextLine

;----------------------------------------------------------------------------------------------
; GOSUB X
; Like the 'GOTO' command except that the current text
; pointer and line number are saved so that execution can be continued after the subroutine
; 'RETURN'. So that 'GOSUB' can be nested (and even recursively), the save area must be
; pileed. The stack pointer is saved in 'GosStackPtr'. Current GOSUB is not saved in the stack.
; It will be only if a second GOSUB appear before the first RETURN. A maximum of 'GOSUBLEVELS'
; GOSUBs can be nested thus. If we are in the main routine, 'GosStackPtr' must be set to zero to avoid
; RETURN without GOSUB. This is done in the main init routine, before running the program.
CMD_GOSUB:		call	TestArgumentsExpected
			; Save text position if first letter
			; (we will correct forward references later on)
			invoke	AddWrapInteger,edx
			jmp	PassLine

			align	16
CMD_GOSUBCOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			cmp	byte ptr [edx],WRAP_LABEL
			jne	PapaWasARollingLabel2
			pop	ebx				; (To garbage)
			add	ebx,4				; Next command for RETURN
			push	ebx
			inc	edx				; Pass command (WRAP_LABEL)
			mov	edx,[edx]
			mov	eax,[edx]			; Line number
			jmp	@F				; Handle GOSUB datas
			align	16
PapaWasARollingLabel2:	call	EvalExprCOMP			; Evaluate expression
			pop	edx
			add	edx,4
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	edx				; Save text pointer
			call	FindLineComp			; Look for line number (ebx) in Basic text
			je	@F				; Line found : edx = top of line, ax = line number
			mov	edi,offset Err11		; line not found : error <Line number not found>
			jmp	DispError
			align	16
@@:			cmp	GosLineNum,0			; Other GOSUB processing ?
			je	GS1				; No, update GosLineNum & GosPtrTxt
			mov	ebx,GosStackPtr			; Yes, room enough in Gosub stack ?
			add	ebx,8
			cmp	ebx,GosubStackEnd		; ebx < end of Gosub stack ?
			jbe	@F				;     Yes, save previous GOSUB parameters in stack
			mov	edi,offset Err12		;     No, Error <Available GOSUB levels exhausted>
			jmp	DispError
			align	16
@@:			sub	ebx,4
			mov	edi,LineNumber
			mov	[ebx],edi			; Save GOSUB Line number
			sub	ebx,4
			mov	edi,GosPtrTxt
			mov	[ebx],edi			; Save Text pointer (1st. address after GOSUB command)
			add	GosStackPtr,8			; Update stack pointers (may be optimized)
GS1:			mov	ebx,LineNumber			; save current GOSUB Line Num. & Text Ptr.
			mov	GosLineNum,ebx
			pop	ebx				; ebx = current text pointer
			mov	GosPtrTxt,ebx			; save it
			mov	LineNumber,eax			; update new line number
			jmp	ExecLine			; and execute GOSUB target line found by FindLine

;----------------------------------------------------------------------------------------------
; RETURN
; Undo everything that 'GOSUB' did, and thus return the execution to the command
; after the most recent 'GOSUB'. If GosLineNum = 0, it indicates that corresponding 'GOSUB'
; doesn't exist and generates an error message.
CMD_RETURN:		mov	SaveCompExprPtr,0
			jmp	TestNoArguments

			align	16
CMD_RETURNCOMP:		mov	ebx,GosLineNum			; Does a GOSUB exist ?
			test	ebx,ebx
			jnz	@F				; Yes, OK
			mov	edi,offset Err13		; No, error <RETURN without GOSUB>
			jmp	DispError
			align	16
@@:			mov	LineNumber,ebx			; Update corresponding GOSUB line number
			mov	edx,GosPtrTxt			; and text pointer
			mov	ecx,GosStackPtr
			cmp	ecx,GosubStack			; Is there other GOSUB(S) in the stack
			jnz	@F				; Yes, tranfer the last one line number & text pointer
			mov	GosLineNum,0			; No, GosLineNum = 0 and resume execution after GOSUB
			jmp	RT1
			align	16
@@:			sub	ecx,4
			mov	edi,[ecx]
			mov	GosLineNum,edi			; Previous GOSUB line number from stack
			sub	ecx,4
			mov	edi,[ecx]
			mov	GosPtrTxt,edi			; and text pointer
			mov	GosStackPtr,ecx			; update stack pointer
RT1:			jmp	CmdEnd				; Continue excution after corresponding GOSUB

;----------------------------------------------------------------------------------------------
; FOR has two forms :
;   'FOR VAR=EXP1 TO EXP2 STEP EXP3'
;   'FOR VAR=EXP1 TO EXP2'
; The second form means the same as the first but EXP3 = 1 
; MBasic will find the variable address and set its value to the current value of EXP1.
; It also evaluates EXP2 and EXP3 and save all of these together with the text pointer in
; the ForNextStack area. If there is already something in the save area (this is indicated
; by a non-zero ForAdrVar), then the old save area is saved in the stack before the new one
; overwrite it.
; MBasic will then dig in the stack and find out if this same variable was used in 
; another currently active FOR loop. If that is the case, an error occur.
CMD_FOR:		call	TestArgumentsExpected
			call	VarEquExprFOR			; Evaluate Variable=EXPR
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			call	CheckLastSpace
			jne	ErrorTO
			mov	ebx,TBL_TO			; Execute keyword 'TO'
			jmp	SearchKeyword
E44:			mov	edi,offset Err44		; Error <Numeric value expected>
			jmp	DispError
TOKEYWORD:		call	EvalExpr			; Evaluate expression after 'TO' (come back here after execute)
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			mov	al,[edx-1]
			mov	RequiredSpace,al
			mov	ebx,TBL_STEP			; Execute keyword STEP
			jmp	SearchKeyword
STEPKEYWORD:		cmp	RequiredSpace," "
			jne	E27
			call	EvalExpr			; Evaluate STEP expression (come back here)
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			jmp	@F
NOSTEPKEYWORD:		invoke	AddWrapInteger,1		; STEP 1 (default value)
@@:			mov	ebx,LineNumber			; Save current line
			invoke	AddWrapInteger,ebx
			invoke	AddWrapInteger,edx		; FOR entry point
			ret

			align	16
CMD_FORCOMP:		push	edx
			call	LoadVariables			; Get variable (ecx is real var address)
			mov	edx,eax				; eax is next entry in expr table
			push	ecx
			call	EvalExprCOMP			; LIMIT
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
			call	EvalExprCOMP			; STEP
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax				; Here we got all the elements
			pop	ecx
			cmp	ForAdrVar,0			; Another FOR..NEXT active loop ?
			jz	@F				; No
			push	eax				; (trash eax)
			call	ForPushStack			; Yes, save parameters of this loop in stack
			pop	eax
@@:			; eax=limit
			; ebx=step
			; ecx=var address
			; Load the variables...
			mov	ForLimit,eax
			mov	ForIncrement,ebx
			mov	ForAdrVar,ecx
			mov	eax,LineNumber			; Get current line number
			mov	ForLine,eax
			mov	ForTested,0			; To be tested
			; Check if FOR variable is already used in another active FOR..NEXT loop
			mov	edx,ForAdrVar			; edx = address of current FOR variable
			mov	ebx,ForStackPtr			; ebx = Stack pointer
			add	ebx,16				; Now points on possible previous active FOR..NEXT loop (previous ForAdrVar)
FR4:			cmp	ebx,ForNextStackEnd		; out of stack limit ?
			jae	FR5				; Yes, no identical variable, continue
			cmp	edx,[ebx]			; No, compare previous variable with current one
			jne	@F				;    Identical ? 
			mov	edi,offset Err14		;    Yes, error <Duplicate FOR..NEXT variable>
			jmp	DispError
			align	16
@@:			add	ebx,(6*4)			;    No, loop to previous FOR..NEXT stack area
			jmp	FR4
			align	16
FR5:			pop	edx
			add	edx,4
			mov	eax,edx
			inc	eax
			mov	ForPtrTxt,eax			; Should point on next line (error if not)
			; Pass in test mode
			lea	eax,UnVerifiedRunTblFOR
			mov	RunTblPtr,eax
			jmp	CmdEnd
			; Write phony infos in the for stack
			; to keep the balance in test mode
			align	16
CMD_FORUNVERCOMP:	call	ForPushStack			; Save previous one
			mov	ForTested,1			; Not to be tested
			add	edx,5
			jmp	NextLine

;----------------------------------------------------------------------------------------------- 
; Jump here if keyword 'TO' isn't found in a FOR..TO loop
ErrorTO:		mov	edi,offset Err6
			jmp	DispError

;----------------------------------------------------------------------------------------------- 
; NEXT can be followed by VAR or not. Either way, MBasic checks if a FOR loop is
; currently active then adds the STEP value to that variable and check the result with the limit.
; If it is within the LIMIT, control loops back to the command following the FOR. If outside the
; limit, the save area is purged (ForAdrVar=0) or replaced with superior level active FOR loop
; and execution continues after NEXT.
; in both cases, edx points on next command to execute.
CMD_NEXT:		call	TestVar				; Test variable following NEXT
			jc	NoNextVar
			cmp	cl,WRAP_ARRAYADDRESS
			je	DoneNextVar
			cmp	cl,WRAP_VARADDRESS
			jne	E38
DoneNextVar:		ret
NoNextVar:		mov	SaveCompExprPtr,0		; Command expression entry to 0
			ret

			align	16
CMD_NEXTCOMP:		push	edx
			mov	edx,[edx]
			xor	ebx,ebx				; No var addr in argument is default
			test	edx,edx				; No variable specified previously ?
			jz	NoNextVarToGet
			call	GetVarRealAddress
NoNextVarToGet:		mov	eax,ForAdrVar			; eax = FOR address variable
			test	eax,eax				; = 0 ?
			jnz	@F				; No, continue
			mov	edi,offset Err16		; Yes, no corresponding FOR, Error <NEXT without FOR>
			jmp	DispError
			align	16
@@:			test	ebx,ebx				; found NEXT variable ?
			jz	@F				; No, skip variables comparison 
			cmp	ebx,eax				; Compare NEXT adr. var. (eax) with FOR adr. var. (ebx)
			jz	@F				; OK, identical
			mov	edi,offset Err17		; Else, Error <NEXT variable doesn't match corresponding FOR>
			jmp	DispError
			align	16
@@:			mov	ebx,ForIncrement
			add	[eax],ebx			; Add increment (1 or STEP value)
			test	ebx,ebx
			js	NegativeNEXT
			mov	ebx,[eax]			; save it
			cmp	ForLimit,ebx			; FOR value > limit ?
			jl	@F				; Yes, end of FOR loop
			mov	ebx,ForLine			; No, restore FOR line number
			mov	LineNumber,ebx
			pop	eax				; To garbage...
			mov	edx,ForPtrTxt			; New text pointer
			clc					; (reset it due to jnc ExecLine)
			; Since we are pushing backwards
			; We can pass over several tests
			jmp	RunBackward
			; Case of negative step
			align	16
NegativeNEXT:		mov	ebx,[eax]
			cmp	ForLimit,ebx
			jg	@F
			mov	ebx,ForLine
			mov	LineNumber,ebx
			pop	eax
			mov	edx,ForPtrTxt
			clc
			jmp	RunBackward
			; Update FOR..NEXT stack and pointer if other active loops.
			align	16
@@:			mov	ForAdrVar,0			; Keep 0 value if no other loop to pop
			mov	eax,ForStackPtr
			cmp	eax,ForNextStackEnd		; Is there any FOR..NEXT loop to pop ?
			jae	@F				; No, no other FOR..NEXT active loop
			xchg	eax,esp				; Yes, Use esp to restore previous loop parameters
			pop	ForIncrement
			pop	ForLimit
			pop	ForLine
			pop	ForPtrTxt
			pop	ForAdrVar
			pop	ForTested
			; restore esp (we don't need eax anymore)
			; (mov is faster than xchg and pairable)
			mov	esp,eax
			add	ForStackPtr,(6*4)		; ForStackPtr now points on previous FOR..NEXT stack
@@:			pop	edx
			add	edx,5
			jmp	NextLine
			; Test the limits of the loop before performing anything else
			; (Can't reach this without a FOR loop initiated previously)
			align	16
CMD_NEXTUNVERCOMP:	push	edx
			mov	edx,[edx]
			cmp	ForTested,1			; No test (inside loop)
			je	EndOfNext
			xor	ebx,ebx				; No var addr in argument is default
			test	edx,edx				; No variable specified previously ?
			jz	NoNextVarToGetUnVer
			call	GetVarRealAddress
NoNextVarToGetUnVer:	mov	eax,ForAdrVar			; eax = FOR address variable
			test	eax,eax				; = 0 ?
			jnz	@F				; No, continue
			mov	edi,offset Err16		; Yes, no corresponding FOR, Error <NEXT without FOR>
			jmp	DispError
			align	16
@@:			test	ebx,ebx				; found NEXT variable ?
			jz	@F				; No, skip variables comparison 
			cmp	ebx,eax				; Compare NEXT adr. var. (eax) with FOR adr. var. (ebx)
			jz	@F				; OK, identical
			mov	edi,offset Err17		; Else, Error <NEXT variable doesn't match corresponding FOR>
			jmp	DispError
			align	16
@@:			lea	ebx,RunTbl			; Retablish normal behaviours
			mov	RunTblPtr,ebx
			mov	ebx,ForIncrement
			mov	eax,[eax]			; Don't modify the var itself
			test	ebx,ebx
			js	NegativeNEXTUnVer
			mov	ebx,eax				; save it
			cmp	ForLimit,ebx			; FOR value > limit ?
			jl	EndOfNext			; Yes, end of FOR loop
			mov	ebx,ForLine			; No, restore FOR line number
			mov	LineNumber,ebx
			pop	eax				; To garbage...
			mov	edx,ForPtrTxt			; New text pointer
			clc					; (reset it due to jnc ExecLine)
			; Since we are pushing backwards
			; We can pass over several tests
			jmp	RunBackward
			; Case of negative step
			align	16
NegativeNEXTUnVer:	mov	ebx,eax
			cmp	ForLimit,ebx
			jg	EndOfNext
			mov	ebx,ForLine
			mov	LineNumber,ebx
			pop	eax
			mov	edx,ForPtrTxt
			clc
			jmp	RunBackward
			; Update FOR..NEXT stack and pointer if other active loops.
			align	16
EndOfNext:		mov	ForAdrVar,0			; Keep 0 value if no other loop to pop
			mov	eax,ForStackPtr
			cmp	eax,ForNextStackEnd		; Is there any FOR..NEXT loop to pop ?
			jae	@F				; No, no other FOR..NEXT active loop
			xchg	eax,esp				; Yes, Use esp to restore previous loop parameters
			pop	ForIncrement
			pop	ForLimit
			pop	ForLine
			pop	ForPtrTxt
			pop	ForAdrVar
			pop	ForTested
			; restore esp (we don't need eax anymore)
			mov	esp,eax
			add	ForStackPtr,(6*4)		; ForStackPtr now points on previous FOR..NEXT stack
@@:			pop	edx
			add	edx,5
			jmp	NextLine
			; (Can't reach this without a FOR loop initiated previously)
			align	16
CMD_NEXTSILENTCOMP:	push	edx
			mov	edx,[edx]
			cmp	ForTested,1			; Not being executed
			je	EndOfNext
			lea	eax,RunTbl			; Retablish normal behaviours
			mov	RunTblPtr,eax
			jmp	EndOfNext

;----------------------------------------------------------------------------------------------- 
; EXIT FOR
; Stop a FOR..NEXT loop
CMD_EXIT:		mov	SaveCompExprPtr,0
			mov	ebx,TBL_EXIT
			jmp	SearchKeyword
EXITFORKEYWORD:		cmp	byte ptr [edx-4]," "
			jne	E58
			mov	PreCompNbr,EXITFORPOS
			ret

			align	16
CMD_EXITFORCOMP:	push	edx
			mov	edx,[edx]
			; Must be inside a loop
			mov	eax,ForAdrVar			; eax = FOR address variable
			test	eax,eax				; = 0 ?
			jnz	@F				; No, continue
			mov	edi,offset Err65		; Yes, no corresponding FOR, Error <EXIT FOR without FOR>
			jmp	DispError
			align	16
@@:			lea	eax,UnVerifiedRunTblEXITFOR
			mov	RunTblPtr,eax
			pop	edx
			add	edx,5
			jmp	NextLine

;----------------------------------------------------------------------------------------------
; WHILE EXPR
CMD_WHILE:		call	TestArgumentsExpected
			call	EvalExpr			; Store expression
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			ret

			align	16
CMD_WHILECOMP:		mov	eax,edx
			sub	eax,2+4				; Back to command entrypoint (cmd+line)
			mov	WhilePtrTxt,eax			; Save position of command
			mov	eax,LineNumber			; Get current line number
			mov	WhileLine,eax
			push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; LIMIT
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	WHILEDouble
			ftst					; Compare fp with 0.0
			fstsw	ax
			fstp	DblGarb				; Garbage it now
			and	eax,100010100000000b
			cmp	eax,100000000000000b
			je	WHILEUnVer
			jmp	WHILEVer
			align	16
WHILEDouble:		; String returned (implied comparison)
			cmp	ExprFinalResult,VAR_STRING
			jne	WHILEString
			; Take first char
			; and convert it into an integer
			movzx	ebx,byte ptr [ebx]		
WHILEString:		test	ebx,ebx
			jz	WHILEUnVer
WHILEVer:		; Pursue...
			mov	eax,RunTblPtr			; Save exec table
			mov	WhileExecTable,eax
			lea	eax,RunTbl
			mov	RunTblPtr,eax
			mov	WhilePreviousFlag,1
			call	WhilePushStack
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
WHILEUnVer:		; Change exec table if condition is unverified
			mov	eax,RunTblPtr			; Save exec table
			mov	WhileExecTable,eax
			lea	eax,UnVerifiedRunTblWHILE
			mov	RunTblPtr,eax
			mov	WhilePreviousFlag,1
			call	WhilePushStack
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
CMD_WHILEUNVERCOMP:	lea	eax,UnVerifiedRunTblWHILE
			mov	RunTblPtr,eax
			mov	eax,RunTblPtr			; Save exec table
			mov	WhileExecTable,eax
			call	WhilePushStack
			add	edx,5
			jmp	NextLine
			align	16
CMD_WHILESILENTCOMP:	mov	WhilePreviousFlag,1
			call	WhilePushStack
			add	edx,5
			jmp	NextLine

;----------------------------------------------------------------------------------------------- 
; WEND
CMD_WEND:		mov	SaveCompExprPtr,0
			jmp	TestNoArguments

			align	16
CMD_WENDCOMP:		push	edx
			mov	edx,[edx]
			mov	eax,WhileStackPtr
			xchg	eax,esp				; Yes, Use esp to restore previous loop parameters
			pop	WhileLine
			pop	WhilePtrTxt
			pop	WhilePreviousFlag
			pop	WhileExecTable			; Restore previous exec table
			mov	esp,eax
			add	WhileStackPtr,(4*4)		; Previous
			mov	eax,WhilePreviousFlag		; eax = FOR address variable
			test	eax,eax				; = 0 ?
			jnz	@F				; No, continue
E64:			mov	edi,offset Err64		; Yes, no corresponding WHILE, Error <WEND without WHILE>
			jmp	DispError
			align	16
@@:			mov	ebx,WhileStackPtr
			cmp	ebx,WhileWendStackEnd		; Is there any WHILE..WEND loop to pop ?
			jae	@F				; No, no other WHILE..WEND active loop
			mov	WhilePreviousFlag,0
@@:			mov	ebx,WhileLine			; No, restore WHILE line number
			mov	LineNumber,ebx
			pop	eax
			mov	edx,WhilePtrTxt			; New text pointer
			clc					; (reset it due to jnc ExecLine)
			jmp	RunBackward
			; End a loop
			align	16
CMD_WENDUNVERCOMP:	push	edx
			mov	edx,[edx]
			lea	eax,RunTbl
			mov	RunTblPtr,eax
			mov	eax,WhileStackPtr
			cmp	eax,WhileWendStackEnd
			jae	@F
			mov	eax,WhileStackPtr
			xchg	eax,esp				; Yes, Use esp to restore previous loop parameters
			pop	WhileLine
			pop	WhilePtrTxt
			pop	WhilePreviousFlag
			pop	WhileExecTable			; Restore previous exec table
			mov	esp,eax
			add	WhileStackPtr,(4*4)		; Previous
			mov	eax,WhileExecTable
			mov	RunTblPtr,eax
			mov	eax,WhileStackPtr
			cmp	eax,WhileWendStackEnd		; Is there any WHILE..WEND loop to pop ?
			jae	@F				; No, no other WHILE..WEND active loop
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
@@:			mov	WhilePreviousFlag,0		; Keep 0 value if no other loop to pop
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
CMD_WENDSILENTCOMP:	cmp	WhilePreviousFlag,0
			je	E64
			mov	eax,WhileStackPtr
			cmp	eax,WhileWendStackEnd		; Is there any FOR..NEXT loop to pop ?
			jae	@F				; No, no other FOR..NEXT active loop
			xchg	eax,esp				; Yes, Use esp to restore previous loop parameters
			pop	WhileLine
			pop	WhilePtrTxt
			pop	WhilePreviousFlag
			pop	WhileExecTable
			mov	esp,eax
			add	WhileStackPtr,(4*4)
			mov	eax,WhileStackPtr
			cmp	eax,WhileWendStackEnd		; Is there any WHILE..WEND loop to pop ?
			jae	@F				; No, no other WHILE..WEND active loop
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
@@:			mov	WhilePreviousFlag,0		; Keep 0 value if no other loop to pop
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; REM command doesn't exist. (') char. is used in place of REM
; Use a part of IF Cmd. (false condition) to skip rest of the current line and execute the next one
			align	16
CMD_REM:		mov	SaveCompExprPtr,0
			ret

			align	16
CMD_REMCOMP:		add	edx,5
			jmp	NextLine			; and run next line

;-----------------------------------------------------------------------------------------------
; IF command can evaluate following expressions in two ways.
;
; Mode 1:
;
; If condition is verified (=1), execute rest of current line.
; If condition is unverified (=0), skip the rest of line and execute next line. 
;
; Mode 2:
;
; THEN keyword is found after the IF expression.
; If the expression is verified (=1):
; Check if this is the last keyword:
;  If no then acts as in Mode 1 (execute rest of current line).
;  If yes enter IF mode
; If the expression is unverified (=0):
;  Enter IF mode 
; The IF mode:
;  Pass over all commands but check stacks for IF/ELSE/ENDIF commands
;  to find corresponding ELSE or ENDIF command.
CMD_IF:			call	TestArgumentsExpected
			push	CompExprPtr
			invoke	AddWrapInteger,0
			call	EvalExpr			; Store expression
			mov	al,[edx-1]
			mov	RequiredSpace,al
			mov	ebx,TBL_THENPRECOMP		; Search keyword THEN
			jmp	SearchKeyword
PreCompThen:		cmp	RequiredSpace," "
			jne	E27
			; Reduce IFs to 2 possibilities:
			; "single line" or "multi lines"
PreCompNoThen:		call	TrimSpaces
			cmp	byte ptr [edx],0dh
			je	@F
			cmp	byte ptr [edx],"'"
			je	@F
			cmp	byte ptr [edx],":"
			je	@F
			; Single line IF
			pop	eax				; Put if type in first position
			mov	dword ptr [eax+1],1		; (this will speedup ghostIFs)
			ret
@@:			; Multi lines IF
			pop	eax
			mov	dword ptr [eax+1],0
			ret

			align	16
GhostedIFCOMP:		; Push ghosted condition (-1) (for ELSE)
			; To keep stack balance (for ENDIFs matching)
			push	edx
			mov	edx,[edx]
			cmp	dword ptr [edx+1],1			
			je	GhostNoThen
			; -1 will ensure that the following ELSE commands belonging
			; to a ghosted IF, won't modify anything.
			invoke	PushIfStack,-1
			pop	edx
			add	edx,4
			jmp	NoThenUnVerifiedEnd
			; Then keyword not found
			align	16
GhostNoThen:		pop	edx
			add	edx,4
			jmp	NoThenUnVerifiedEnd

			align	16
CMD_IFCOMP:		push	edx
			mov	edx,[edx]
			push	dword ptr [edx+1]
			add	edx,5
			call	EvalExprCOMP			; Evaluate if expression
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	IfDouble
			ftst					; Compare fp with 0.0
			fstsw	ax
			fstp	DblGarb				; Garbage it now
			and	eax,100010100000000b
			cmp	eax,100000000000000b
			je	IFUnVer
			jmp	IFVer
			align	16
IfDouble:		; String returned (implied comparison)
			cmp	ExprFinalResult,VAR_STRING
			jne	IfString
			; Take first char
			; and convert it into an integer
			movzx	ebx,byte ptr [ebx]
IfString:		test	ebx,ebx				; Boolean result of expression = 0 (FALSE) ?
			jz	IFUnVer				; Yes, skip end of line & execute next line
IFVer:			pop	eax
			test	eax,eax
			jnz	WasMultiIFVer
			invoke	PushIfStack,1			; Push entry into the stack
			lea	edx,RunTbl			; Change commands table
			mov	RunTblPtr,edx
WasMultiIFVer:		pop	edx
			add	edx,5
			jmp	NextLine
			align	16
IFUnVer:		pop	eax
			test	eax,eax
			jnz	WasMultiIFUnVer
			invoke	PushIfStack,0			; Push entry into the stack
			lea	edx,UnVerifiedRunTblIF		; Change commands table
			mov	RunTblPtr,edx
WasMultiIFUnVer:	pop	edx
			add	edx,4
			jmp	NoThenUnVerifiedEnd
; Find true next line and execute it (usually next*2 one)
			align	16
NoThenUnVerifiedEnd:	mov	ebx,LineNumber
			inc	ebx
			call	FindNextLineCompEnd
			jc	@F
			jmp	ExecLine
			align	16
NoThenUnVerified:	mov	ebx,LineNumber
			inc	ebx
			call	FindEndOfLineComp
			jc	@F				; IF end of Basic text, jump to Prompt
			jmp	ExecLine			; else execute next line
			align	16
@@:			call	CheckPendingIf
			jmp	Exit

;-----------------------------------------------------------------------------------------------
; ENDIF
; Simply pop the current IF stack level
; (Possible underflow is checked in the PopIfStack routine itself)
CMD_ENDIF:		jmp	E9

			align	16
CMD_ENDIFCOMP:		call	PopIfStack
			call	CanExecute
			lea	eax,UnVerifiedRunTblIF		; Invert table if necessary
			jz	EndifUnVerified
			lea	eax,RunTbl
EndifUnVerified:	mov	RunTblPtr,eax
			add	edx,5
			jmp	NextLine
			align	16
CMD_ENDIFSILENTCOMP:	call	PopIfStack
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; ELSE/ELSE IF
; Retrieve current If stack value
; and invert it if it is not a ghosted one.
CMD_ELSE:		mov	ebx,TBL_ELSEIF
			jmp	SearchKeyword
			; Only if statements are accepted
ELSEIFKEYWORD:		mov	SaveCompExprPtr,-1
			; Step back for following checkup of
			; the if statement
			sub	edx,2
			ret
NOELSEIFKEYWORD:	mov	SaveCompExprPtr,0
			jmp	TestNoArguments

			align	16
CMD_ELSECOMP:		call	PeekIfStack
			jns	InvertIf			; Signed=ghosted
			add	edx,5
			jmp	NextLine
			align	16
InvertIf:		xor	eax,1				; Invert bit 0
			invoke	PokeIfStack,eax			; Save it
			call	CanExecute
			lea	eax,UnVerifiedRunTblIF		; Invert table if necessary
			jz	ElseUnVerified
			lea	eax,RunTbl
ElseUnVerified:		mov	RunTblPtr,eax
			; Is it followed by an IF statement ?
			cmp	dword ptr [edx],0
			je	NoElseIf
			; Discard latest if condition in stack
			call	PopIfStack
NoElseIf:		add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; INPUT [X],&Y,[Z]
; Wait for an input from the user.
; If an error occurs, input screen area is cleared and user have to type a new value.
; The variable following INPUT command. is then set to the value entered.   
; The execution will not terminate unless user type a valid value or 'ESC' 
CMD_INPUT:		call	TestArgumentsExpected
			push	edx
			push	CompExprPtr
			call	EvalExpr
			cmp	ExprFinalResult,VAR_STRING	; Can be a string
			pop	ebx
			pop	eax
			je	GetOptionalInputString
			mov	CompExprPtr,ebx			; Restore expressions pointer
			mov	edx,eax				; Restore text position
			call	TestVar				; Test variable following INUT
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			call	AddWrapExprEnd
			call	FindComma			; Maximum length specified ?
			jnz	@F
			call	EvalExpr
@@:			jmp	AddWrapExprEnd
GetOptionalInputString:	call	FindComma
			jnz	E18
NoOptionalInputString:	call	TestVar				; Test variable following INUT
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			call	AddWrapExprEnd
			call	FindComma			; Maximum length specified ?
			jnz	NoOptionalInputLength
			jmp	EvalExpr			; Get len
NoOptionalInputLength:	jmp	AddWrapExprEnd

			align	16
CMD_INPUTCOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			push	edx
			call	EvalExprCOMP
			cmp	ExprFinalResult,VAR_STRING	; Not a string ?
			jne	@F
			pop	eax
			push	edx
			push	ecx
			mov	edx,ebx
			call	QuotedString			; Print the prompt
			pop	ecx
			pop	edx
			cmp	byte ptr [edx],WRAP_EXPREND
			je	E37
			; Now get the variable
			jmp	GetINPUTVar
			align	16
@@:			pop	edx				; Back
GetINPUTVar:		call	GetVarRealAddress
			inc	edx
			mov	InputVarType,eax		; Save type
			mov	LineMaxLenUsr,18+1		; Default value
			cmp	byte ptr [edx],WRAP_EXPREND
			je	@F
			; Max length
			push	ebx
			call	EvalExprCOMP
			test	ebx,ebx				; Number of char allowed
			jz	E47				; must be >0
			js	E47
			inc	ebx
			push	ebx
			pop	LineMaxLenUsr
			pop	ebx
@@:			push	ebx				; save variable address
			push	edx				; Save Basic text pointer
IP1:			invoke	SetConsoleCursorPosition,hStdOut,dword ptr Csbi_CursorPositionX
			call	TestApiError
			push	dword ptr Csbi_CursorPositionX	; Save cursor position X,Y in case of user input error
			mov	LineLen,1			; Inits for LineInput
			mov	LinePtr,1
			push	LineMaxLenUsr
			pop	LineMaxLen
			call	LineInput			; Get an answer from user
			mov	LineMaxLen,255			; restore length of basic text line
			mov	edx,LineBuffer			; edx = start of expression entered by user
			inc	edx
			mov	wtemp3,0			; Flag for negative value (0 = +, 1 = -)
			push	ebx
			call	CheckTermSign
			test	ebx,ebx
			jz	@F
			mov	wtemp3,1
@@:			pop	ebx
			push	edx
			mov	al,[edx]
			call	TstToken			; Input value in ebx
			cmp	WasDouble,VAR_DOUBLE
			je	InputDouble
			cmp	WasDouble,VAR_INTEGER
			jne	@F
			mov	al,ch				; Number of digits
			test	al,al
			jnz	InputDouble
@@:			pop	edx
			call	GetPlainString
			test	ebx,ebx				; Error in string...
			jz	RestartInput
			jmp	InputString
			align	16
InputDouble:		add	esp,4				; Garbage
InputString:		mov	ah,0dh				; end with CR ?
			call	SkipSpaces
			jz	@F				; Yes, continue
RestartInput:		pop	ecx
			; No, restore input cursor position
			mov	dword ptr Csbi_CursorPositionX,ecx
			push	ecx
			invoke	SetConsoleCursorPosition,hStdOut,dword ptr Csbi_CursorPositionX
			mov	ebx,offset ClearInput-1		; Clear input screen area
			add	ebx,LineLen
			mov	byte ptr [ebx],0
			push	ebx
			mov	edx,offset ClearInput
			xor	al,al
			call	DispStr
			call	Beeep				; Error : Beep
			pop	ebx
			pop	ecx
			mov	byte ptr [ebx]," "
			; Restore again input cursor position
			mov	dword ptr Csbi_CursorPositionX,ecx
			jmp	IP1				; and user try again
			align	16
@@:			pop	edx				; Cursor position to garbage
			pop	edx				; Restore basic text pointer
			pop	eax				; Restore variable address
			mov	eax,InputVarType
			push	dword ptr [eax+VARDAT_TYPE]
			pop	VarToLoadType
			mov	ecx,[eax+VARDAT_DATASPTR]	; Take pointer to variable
			cmp	WasDouble,VAR_STRING
			je	StoreStringFromInput
			cmp	WasDouble,VAR_INTEGER
			je	StoreIntegerFromInput
			; Double
			cmp	VarToLoadType,VAR_INTEGER
			je	INPUTDoubleToInteger
			cmp	VarToLoadType,VAR_DOUBLE
			je	INPUTDoubleToDouble
			; Double -> String
			push	ecx
			invoke	DoubleToString,DblVal,15,addr DblTemp
			test	eax,eax
			jz	E25
			pop	ecx
			; Frees it before
			lea	ebx,DblTemp
			call	StoreStringVarDirect
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
INPUTDoubleToDouble:	; Double -> Double
			push	dword ptr DblVal		; Store floating point value
			pop	dword ptr [ecx]
			push	dword ptr DblVal+4
			pop	dword ptr [ecx+4]
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
INPUTDoubleToInteger:	; Double -> Integer
			fld	qword ptr [DblVal]
			frndint
			fistp	DblToInt
			mov	ebx,DblToInt
			mov	[ecx],ebx			; DAT1
			pop	edx
			add	edx,5
			jmp	NextLine
			; Integer
			align	16
StoreIntegerFromInput:	cmp	wtemp3,1
			jne	INPUTChangeIntSign
			neg	ebx
INPUTChangeIntSign:	cmp	VarToLoadType,VAR_STRING
			je	INPUTIntegerToString
			cmp	VarToLoadType,VAR_DOUBLE
			je	INPUTIntegerToDouble
			; Integer -> Integer
			mov	[ecx],ebx			; Store value in variable slot
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
INPUTIntegerToString:	; Integer -> String
			push	eax
			push	ecx
			push	edx
			push	edi
			call	IntToStringNoPad
			lea	ebx,dtemp1
			pop	edi
			pop	edx
			pop	ecx
			pop	eax
			call	StoreStringVarDirect
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
INPUTIntegerToDouble:	; Integer -> Double
			mov	FpIntLoad,ebx
			fild	FpIntLoad			; Load it as integer
			call	StoreDoubleDat
			pop	edx
			add	edx,5
			jmp	NextLine
			; String
			align	16
StoreStringFromInput:	cmp	VarToLoadType,VAR_INTEGER	; Can't convert here
			je	E57
			cmp	VarToLoadType,VAR_DOUBLE
			je	E57
			; String -> String
			call	StoreStringVarDirect
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; LET ...
; Just a variable assignation wrapper.
CMD_LET:		mov	SaveCompExprPtr,0
			ret

			align	16
CMD_LETCOMP:		call	LoadVariables
			jmp	CmdEnd

;-----------------------------------------------------------------------------------------------
; GET &X
; Wait and return ASCII key code typed or 0 in passed variable.
CMD_GET:		call	TestVar				; Test variable following GET
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			ret
E20:			mov	edi,offset Err20
			jmp	DispError
E38:			mov	edi,offset Err38
			jmp	DispError

			align	16
CMD_GETCOMP:		push	edx
			mov	edx,[edx]
			call	GetVarRealAddress
			cmp	dword ptr [eax+VARDAT_TYPE],VAR_DOUBLE
			je	E61				; Can't be a double
			push	eax				; Save type
			mov	edi,ebx				; save variable address
			call	TestKeyb			; If key pressed, bl = key ASCII code,
			test	bl,bl				; else ebx = 0 (except for functions keys)
			jz	@F				; If bl = 0 or bl = 224 (cursor keys), check scan code
			cmp	bl,224
			je	@F
			pop	eax				; Type
			jmp	GT1				; If none of above cases
			align	16
@@:			invoke	FlushConsoleInputBuffer,hStdIn	; Clear keyboard input buffer
			pop	eax				; Type
			xor	ebx,ebx
			xor	edx,edx
			cmp	dword ptr EventBuffer+4,0	; Is a keypress ?
			je	GT1				; Yes, save it in bl
			mov	dl,byte ptr EventBuffer+12	; Read buffer keyboard scan code
			cmp	dl,59				; scan codes between 59 and 88 (function & cursor keys)
			jb	GT1				; becomes 225 to 254
			cmp	dl,88
			ja	GT1
			add	dl,166
@@:			mov	bl,dl
GT1:			cmp	dword ptr [eax+VARDAT_TYPE],VAR_STRING
			jne	ConvertGETToString
			; Frees it before
			push	ebx
			push	edi
			invoke	GlobalFree,dword ptr [edi]
			; Allocate room for retrieved char
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,2
			pop	edi
			pop	ebx
			test	eax,eax
			jz	E46
			mov	[eax],bl			; Put char
			mov	[edi],eax			; Put temporary string
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
ConvertGETToString:	mov	[edi],ebx			; result is placed in variable address
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
E61:			mov	edi,offset Err61		; Error: <Wrong variable type>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; POKE X,Y[,Y,..]
; Put one or more 8 bits value (Y) in a memory location (X) inside Basic datas
; area. Y may be repeated, separated by commas, for successive memory locations.
CMD_POKE:		call	TestArgumentsExpected
			call	EvalExpr			; Address to put datas on
			call	FindComma			; First data is not optional
			jnz	E18
GetPOKEDatas:		call	EvalExpr
			call	FindComma			; Other datas are optional
			jnz	EndPOKEDatas
			jmp	GetPOKEDatas
EndPOKEDatas:		jmp	AddWrapExprEnd			; Mark expression as finished

			align	16
CMD_POKECOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
@@:			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	ebx,255
			ja	E3				; Yes, error <Numeric value overflow>
			mov	al,bl
			pop	ebx
			cmp	ebx,MEMDATSIZE			; Inside Basic datas memory ?
			jae	E41				; No, error <Datas memory overflow>
			mov	ecx,ebx
			add	ecx,DatStart
			mov	[ecx],al			; Put byte
			inc	ebx				; next address
			push	ebx
			cmp	byte ptr [edx],WRAP_EXPREND	; No third argument ?
			je	PK0
			jmp	@B
			align	16
PK0:			pop	ebx				; Flush stack
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
E41:			mov	edi,offset Err41		; Error: <Datas memory overflow>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; POKEW X,Y[,Y,..]
; Put one or more 16 bits value (Y) in a memory location (X) inside Basic datas
; area. Y may be repeated, separated by commas, for successive memory locations.
CMD_POKEW:		call	TestArgumentsExpected
			call	EvalExpr			; Address to put datas on
			call	FindComma			; First data is not optional
			jnz	E18
GetPOKEWDatas:		call	EvalExpr
			call	FindComma			; Other datas are optional
			jnz	EndPOKEWDatas
			jmp	GetPOKEWDatas
EndPOKEWDatas:		jmp	AddWrapExprEnd			; Mark expression as finished

			align	16
CMD_POKEWCOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
@@:			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	ebx,65535
			ja	E3				; Yes, error <Numeric value overflow>
			mov	ax,bx
			pop	ebx
			cmp	ebx,MEMDATSIZE-1		; Inside Basic datas memory ?
			jae	E41				; No, error <Datas memory overflow>
			mov	ecx,ebx
			add	ecx,DatStart
			mov	[ecx],ax			; Put word
			add	ebx,2				; next address
			push	ebx
			cmp	byte ptr [edx],WRAP_EXPREND	; No third argument ?
			je	PKW0
			jmp	@B
			align	16
PKW0:			pop	ebx				; Flush stack
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; POKED X,Y[,Y,..]
; Put one or more 32 bits value (Y) in a memory location (X) inside Basic datas
; area. Y may be repeated, separated by commas, for successive memory locations.
CMD_POKED:		call	TestArgumentsExpected
			call	EvalExpr			; Address to put datas on
			call	FindComma			; First data is not optional
			jnz	E18
GetPOKEDDatas:		call	EvalExpr
			call	FindComma			; Other datas are optional
			jnz	EndPOKEDDatas
			jmp	GetPOKEDDatas
EndPOKEDDatas:		jmp	AddWrapExprEnd			; Mark expression as finished

			align	16
CMD_POKEDCOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
@@:			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			mov	eax,ebx
			pop	ebx
			cmp	ebx,MEMDATSIZE-3		; Inside Basic datas memory ?
			jae	E41				; No, error <Datas memory overflow>
			mov	ecx,ebx
			add	ecx,DatStart
			mov	[ecx],eax			; Put word
			add	ebx,4				; next address
			push	ebx
			cmp	byte ptr [edx],WRAP_EXPREND	; No third argument ?
			je	PKD0
			jmp	@B
			align	16
PKD0:			pop	ebx				; Flush stack
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; LOCATE X,Y[,Z]
; Set cursor position at column X, line Y. Upper left position is 0,0
; The new cursor position must be within the boundaries of the console screen.  
; Optional argument Z hides cursor if 0 or makes cursor visible if 1
CMD_LOCATE:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	PutOptionalLocate
			jmp	EvalExpr
PutOptionalLocate:	jmp	AddWrapExprEnd			; Mark expression as finished
E18:			mov	edi,offset Err18		; Error: <',' statement expected!>
			jmp	DispError

			align	16
CMD_LOCATECOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			call	EvalExprCOMP
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	bx,Csbi_MaximumWindowSizeX	; X < Window Size X ?
			jc	@F				; Yes, continue
E19:			mov	edi,offset Err19		; No, error <Invalid argument>
			jmp	DispError
			align	16
@@:			mov	si,bx				; Save column in si
			call	EvalExprCOMP
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	bx,Csbi_MaximumWindowSizeY	; y < Window size Y ?
			jnc	E19
			mov	di,bx				; save line in di
			cmp	byte ptr [edx],WRAP_EXPREND	; No third argument ?
			je	LC0
			call	EvalExprCOMP
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	edx
			; Set cursor visible flag
			test	ebx,ebx				; (EXPR) = 0 ?
			jz	@F				; Yes, hide cursor
			mov	ebx,1				; No, set cursor
@@:			mov	CursorShape.bVisible,ebx
			call	SetConCursor
			call	TestApiError
			pop	edx
LC0:			mov	Csbi_CursorPositionX,si		; Update new cursor position
			mov	Csbi_CursorPositionY,di
			invoke	SetConsoleCursorPosition,hStdOut,dword ptr Csbi_CursorPositionX
			call	TestApiError
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; COLOR X,[Y] 
; Set foreground X and background Y colors to be used with further PRINT commands
; Parameters values must be between 0 & 15 (DOS colors)
; IF Y is not mentioned background color is not changed.
CMD_COLOR:		call	TestArgumentsExpected
			call	EvalExpr			; Get both arguments
			call	FindComma
			jnz	PutOptionalColor
			jmp	EvalExpr
PutOptionalColor:	jmp	AddWrapExprEnd			; Mark expression as finished

			align	16
CMD_COLORCOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			call	EvalExprCOMP			; Get first color
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	ebx,16				; Foreground color > 15 ?
			jnc	E19
			push	ebx
			; Check if Y value was not present in expression
			mov	eax,ColorsCurrent
			and	eax,0f0h
			cmp	byte ptr [edx],WRAP_EXPREND
			je	RestoreBackGroundCol
			call	EvalExprCOMP			; Check second parameter
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	ebx,16				; Background color > 15 ?
			jnc	E19
			mov	eax,ebx				; Background			
			shl	al,4				; Background color in 4 left bits of al
RestoreBackGroundCol:	pop	ebx				; Foreground
			add	al,bl				; Foreground color in 4 right bits  
			mov	ColorsCurrent,eax		; Update current color
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; CLS
; Fill screen with spaces and colors attributes.
CMD_CLS:		mov	SaveCompExprPtr,0
			jmp	TestNoArguments

			align	16
CMD_CLSCOMP:		push	edx
			call	WE1
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; WAIT X
; Wait for X milliseconds then continue execution.
CMD_WAIT:		call	TestArgumentsExpected
			jmp	EvalExpr			; Evaluate expression

			align	16
CMD_WAITCOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			call	WaitLoop			; Wait for ebx milliseconds
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; HWAIT X
; Wait for X milliseconds using high res counter then continue execution.
CMD_HWAIT:		call	TestArgumentsExpected
			jmp	EvalExpr			; Evaluate expression

			align	16
CMD_HWAITCOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			
			cmp	eax,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			js	E47				; Must be positive
			mov	eax,HTimer
			test	eax,eax
			jz	UseStandardHWAIT
			push	ebx
			invoke	QueryPerformanceCounter,addr HTimerV
			pop	ebx
			mov	esi,dword ptr HTimerV
			mov	eax,1000
			mov	ecx,ebx
			xor	edx,edx
			div	ecx
			mov	ecx,eax
			mov	eax,HTimerFREQ
			xor	edx,edx
			div	ecx
			mov	ebx,eax			
HWAITLoop:		push	ebx
			invoke	QueryPerformanceCounter,addr HTimerV
			pop	ebx
			mov	eax,dword ptr HTimerV
			sub	eax,esi
			sub	eax,ebx
			jle	HWAITLoop
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16						
UseStandardHWAIT:	push	ebx
			invoke	timeGetTime
			pop	ebx
			mov	esi,eax
HWAITLoop2:		push	ebx
			invoke	timeGetTime
			pop	ebx
			sub	eax,esi
			sub	eax,ebx
			jle	HWAITLoop2
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; BEEP
; Emit a 'beep' in internal loudspeaker or a standard Window alert sound 
; if a sound card connected.
CMD_BEEP:		mov	SaveCompExprPtr,0
			jmp	TestNoArguments
E42:			mov	edi,offset Err42		; Else, error <No argument allowed>
			jmp	DispError

			align	16
CMD_BEEPCOMP:		push	edx
			call	Beeep
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; SWAP &X,&Y
; Exchange the content of two given variables.
CMD_SWAP:		call	TestVar				; Get first variable
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			call	FindComma			; ,
			jnz	E18
			call	TestVar				; Get second variable
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			ret

			align	16
CMD_SWAPCOMP:		push	edx
			push	edi
			mov	edx,[edx]
			call	GetVarRealAddress		; 1st
			mov	edi,ebx
			push	dword ptr [eax+VARDAT_TYPE]
			call	GetVarRealAddress		; 2nd
			pop	ecx
			cmp	dword ptr [eax+VARDAT_TYPE],ecx	; Types must match
			jne	E60
			cmp	ecx,VAR_DOUBLE
			je	SWAPDoubles
			push	dword ptr [ebx]
			mov	eax,[edi]			; put 2nd into 1st
			mov	[ebx],eax
			pop	dword ptr [edi]			; restore and put 1st into 2nd
			pop	edi
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
SWAPDoubles:		push	dword ptr [ebx+4]
			push	dword ptr [ebx]
			mov	eax,[edi]			; put 2nd into 1st
			mov	[ebx],eax
			mov	eax,[edi+4]
			mov	[ebx+4],eax
			pop	dword ptr [edi]			; restore and put 1st into 2nd
			pop	dword ptr [edi+4]
			pop	edi	
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
E60:			mov	edi,offset Err60		; Error: <Variables must be of same type>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; SWAPGT &X,&Y
; Exchange the content of two given variables if &X > &Y
CMD_SWAPGT:		call	TestVar
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			call	FindComma
			jnz	E18
			call	TestVar
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			ret

			align	16
CMD_SWAPGTCOMP:		push	edx
			push	edi
			mov	edx,[edx]
			call	GetVarRealAddress
			mov	edi,ebx
			push	dword ptr [eax+VARDAT_TYPE]
			call	GetVarRealAddress
			pop	ecx
			cmp	dword ptr [eax+VARDAT_TYPE],ecx
			jne	E60
			cmp	ecx,VAR_DOUBLE
			je	SWAPGTDoubles
			cmp	ecx,VAR_STRING
			je	SWAPGTStrings
			; Integers
			mov	eax,[edi]
			cmp	[ebx],eax
			jge	SWAPGTItInteger
			push	dword ptr [ebx]
			mov	[ebx],eax
			pop	dword ptr [edi]
SWAPGTItInteger:	pop	edi
			pop	edx
			add	edx,5
			jmp	NextLine
			; Strings
			align	16
SWAPGTStrings:		mov	eax,[edi]
			push	ebx
			push	edi
			invoke	lstrcmpi,eax,dword ptr [ebx]
			pop	edi
			pop	ebx
			test	eax,eax
			jns	SWAPGTItString
			push	dword ptr [ebx]
			mov	eax,[edi]
			mov	[ebx],eax
			pop	dword ptr [edi]
SWAPGTItString:		pop	edi
			pop	edx
			add	edx,5
			jmp	NextLine
			; Doubles
			align	16
SWAPGTDoubles:		fld	qword ptr [edi]
			fcomp	qword ptr [ebx]
			fstsw	ax
			fstp	DblGarb				; Garbage it now
			and	eax,100010100000000b
			jnz	SWAPGTItDouble
			push	dword ptr [ebx+4]
			push	dword ptr [ebx]
			mov	eax,[edi]
			mov	[ebx],eax
			mov	eax,[edi+4]
			mov	[ebx+4],eax
			pop	dword ptr [edi]
			pop	dword ptr [edi+4]
SWAPGTItDouble:		pop	edi	
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; SWAPLW &X,&Y
; Exchange the content of two given variables if &X < &Y
CMD_SWAPLW:		call	TestVar
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			call	FindComma
			jnz	E18
			call	TestVar
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			ret

			align	16
CMD_SWAPLWCOMP:		push	edx
			push	edi
			mov	edx,[edx]
			call	GetVarRealAddress
			mov	edi,ebx
			push	dword ptr [eax+VARDAT_TYPE]
			call	GetVarRealAddress
			pop	ecx
			cmp	dword ptr [eax+VARDAT_TYPE],ecx
			jne	E60
			cmp	ecx,VAR_DOUBLE
			je	SWAPLWDoubles
			cmp	ecx,VAR_STRING
			je	SWAPLWStrings
			; Integers
			mov	eax,[ebx]
			cmp	[edi],eax
			jge	SWAPLWItInteger
			push	dword ptr [ebx]
			mov	eax,[edi]
			mov	[ebx],eax
			pop	dword ptr [edi]
SWAPLWItInteger:	pop	edi
			pop	edx
			add	edx,5
			jmp	NextLine
			; Strings
			align	16
SWAPLWStrings:		mov	eax,[edi]
			push	ebx
			push	edi
			invoke	lstrcmpi,dword ptr [ebx],eax
			pop	edi
			pop	ebx
			test	eax,eax
			jns	SWAPLWItString
			push	dword ptr [ebx]
			mov	eax,[edi]
			mov	[ebx],eax
			pop	dword ptr [edi]
SWAPLWItString:		pop	edi
			pop	edx
			add	edx,5
			jmp	NextLine
			; Doubles
			align	16
SWAPLWDoubles:		fld	qword ptr [ebx]
			fcomp	qword ptr [edi]
			fstsw	ax
			fstp	DblGarb				; Garbage it now
			and	eax,100010100000000b
			jnz	SWAPLWItDouble
			push	dword ptr [ebx+4]
			push	dword ptr [ebx]
			mov	eax,[edi]
			mov	[ebx],eax
			mov	eax,[edi+4]
			mov	[ebx+4],eax
			pop	dword ptr [edi]
			pop	dword ptr [edi+4]
SWAPLWItDouble:		pop	edi	
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; MWRITE X,Y
; Put Y (8 bits) into at memory location (X) 
CMD_MWRITE:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_MWRITECOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_STRING
			je	MWRITEString
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MWRITEString:		test	ebx,ebx
			jz	MWRITEZero
			push	ebx
			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax
			mov	[eax],bl
MWRITEZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; MWRITEW X,Y
; Put Y (16 bits) into at memory location (X) 
CMD_MWRITEW:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_MWRITEWCOMP:	push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_STRING
			je	MWRITEWString
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MWRITEWString:		test	ebx,ebx
			jz	MWRITEWZero
			push	ebx
			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax
			mov	[eax],bx
MWRITEWZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; MWRITED X,Y
; Put Y (32 bits) into at memory location (X) 
CMD_MWRITED:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_MWRITEDCOMP:	push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_STRING
			je	MWRITEDString
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MWRITEDString:		test	ebx,ebx
			jz	MWRITEDZero
			push	ebx
			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax
			mov	[eax],ebx
MWRITEDZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; MFILL X,Y,Z
; Fill memory location X with dword Y for Z bytes
CMD_MFILL:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_MFILLCOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_STRING
			je	MFILLString1
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MFILLString1:		push	ebx
			call	EvalExprCOMP			; Get filling datas
			cmp	ExprFinalResult,VAR_STRING
			je	MFILLString2
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MFILLString2:		push	ebx
			call	EvalExprCOMP			; Get bytes
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			mov	ecx,ebx
			pop	eax
			pop	edi
			jz	MFILLZero
			js	E47				; Must be positive
			cld
			push	ecx
			shr	ecx,2
			rep	stosd
			pop	ecx
			and	ecx,3
			rep	stosb
MFILLZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; MCOPY X,Y,Z 
; Copy memory location X into memory location Y for Z bytes
CMD_MCOPY:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_MCOPYCOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address 1
			cmp	ExprFinalResult,VAR_STRING
			je	MCOPYString1
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MCOPYString1:		push	ebx
			call	EvalExprCOMP			; Get address 2
			cmp	ExprFinalResult,VAR_STRING
			je	MCOPYString2
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MCOPYString2:		push	ebx
			call	EvalExprCOMP			; Get bytes
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			mov	ecx,ebx
			pop	edi				; (from address 2)
			pop	esi				; (from address 1)
			jz	MCOPYZero
			js	E47				; Must be positive
			cld
			push	ecx
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
MCOPYZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; MROTATEL X,Z 
; Rotate a memory block X with Z bytes size from right to left.
CMD_MROTATEL:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_MROTATELCOMP:	push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_STRING
			je	MROTATELString1
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MROTATELString1:	push	ebx
			call	EvalExprCOMP			; Get bytes
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			mov	ecx,ebx
			pop	edi				; Memory block
			jz	MROTATELZero
			js	E47				; Must be positive
			mov	esi,edi
			mov	al,[esi]			; Save first byte
			inc	esi
			cld
			push	ecx
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			dec	edi
			mov	[edi],al			; put last byte
MROTATELZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; MROTATER X,Z
; Rotate a memory block X with Z bytes size from right to left.
CMD_MROTATER:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_MROTATERCOMP:	push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_STRING
			je	MROTATERString1
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E48
MROTATERString1:	push	ebx
			call	EvalExprCOMP			; Get bytes
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			mov	ecx,ebx
			pop	edi				; Memory block
			jz	MROTATERZero
			js	E47				; Must be positive
			mov	esi,edi
			mov	ebx,esi				; Save address
			mov	al,[esi+ecx-1]			; Save last byte
			inc	edi
			cld
			push	ecx
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	[ebx],al			; put first byte
MROTATERZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; FKILL X
; Delete one of more files specified by string expression X.
CMD_FKILL:		call	TestArgumentsExpected
			jmp	EvalExpr			; Get string

			align	16
CMD_FKILLCOMP:		push	edx
			push	ecx
			push	esi
			push	edi
			mov	edx,[edx]
			call	EvalExprCOMP
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			mov	edi,ebx
			mov	ecx,FilePath
			mov	esi,ebx
LoopStringFKILLLEN:	mov	al,[esi]
			mov	[ecx],al			; Copy argument in temp buffer
			test	al,al
			je	StopStringFKILLLEN
			inc	esi
			inc	ecx
			jmp	LoopStringFKILLLEN
			align	16
StopStringFKILLLEN:	mov	ecx,esi
			sub	esi,ebx				; esi=String length
			test	esi,esi				; Nothing to delete
			jz	FKILLGroup	
			mov	esi,ecx
SeekSlash:		cmp	ebx,esi
			je	NoSlash
			dec	esi				; Go backward to last \ (if any)
			mov	al,[esi]
			cmp	al,"\"
			jne	SeekSlash
NoSlash:		mov	ecx,FilePath
			sub	esi,ebx				; Get the pos of the last slash
			test	esi,esi				; No slash found
			jz	NullSlash
			inc	esi
			mov	byte ptr [ecx+esi],0
NullSlash:		invoke	FindFirstFile,edi,addr FKILLDat
			mov	esi,eax
			cmp	esi,INVALID_HANDLE_VALUE
			je	FKILLGroup
KillFilesGroup:		mov	ebx,FilePath			; Copy the path
			mov	ecx,FilePathName
LoopFKILLPath:		mov	al,[ebx]
			inc	ebx
			test	al,al
			jz	CopyFKILLPath
			mov	[ecx],al
			inc	ecx
			jmp	LoopFKILLPath
			align	16
CopyFKILLPath:		lea	ebx,FKILLDat.cFileName		; And the filename
CopyFKILLName:		mov	al,[ebx]
			inc	ebx
			mov	[ecx],al
			inc	ecx
			test	al,al				; Should append 0 that way
			jnz	CopyFKILLName
			invoke	DeleteFile,FilePathName
			invoke	FindNextFile,esi,addr FKILLDat
			test	eax,eax
			jnz	KillFilesGroup
			invoke	GetLastError
			cmp	eax,ERROR_NO_MORE_FILES
			jne	KillFilesGroup
NoMoreFilesToKill:	invoke	FindClose,esi
FKILLGroup:		pop	edi
			pop	esi
			pop	ecx
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; SETCONTITLE X
; Change the title of the console
CMD_SETCONTITLE:	call	TestArgumentsExpected
			jmp	EvalExpr

			align	16
CMD_SETCONTITLECOMP:	push	edx
			mov	edx,[edx]			; Get expression address
			call	EvalExprCOMP			; Evaluate expression
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			invoke	SetConsoleTitle,ebx		; Must be string (by address)
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; DOEVENTS
; Flush windows events
CMD_DOEVENTS:		mov	SaveCompExprPtr,0
			jmp	TestNoArguments

			align	16
CMD_DOEVENTSCOMP:	push	edx
			push	edi
			lea	edi,DOEVENTSMsg
    			invoke	PeekMessage,edi,0,0,0,PM_REMOVE
			test	eax,eax
			jz	NoEventsPending
        		invoke	TranslateMessage,edi
        		invoke	DispatchMessage,edi
NoEventsPending:	pop	edi
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; FCLOSE X
; Close an opened file.
CMD_FCLOSE:		call	TestArgumentsExpected
			jmp	EvalExpr

			align	16
CMD_FCLOSECOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			call	EvalExprCOMP			; Evaluate expression
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E44
			test	ebx,ebx
			jz	CMDFCLOSEEmpty
			invoke	CloseHandle,ebx
CMDFCLOSEEmpty:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; FSAVE X,Y,Z
; Save memory Y with length of Z into file X.
CMD_FSAVE:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_FSAVECOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Filename
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx				; (Save filename)
			call	EvalExprCOMP			; Memory location
			cmp	ExprFinalResult,VAR_DOUBLE	; (can be a string or an int address)
			je	E19
			push	ebx				; (Save mem location)
			call	EvalExprCOMP			; Get char to put
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx	
			jz	E47				; size must be >0
			js	E47
			pop	ecx				; (Mem location from ebx)
			pop	eax				; (Filename from ebx)
			test	ecx,ecx				; Empty mem location ?
			jz	EmptyCMDFSAVE
			test	eax,eax				; Empty filename ?
			jz	EmptyCMDFSAVE
			push	ebx				; (Save size)
			push	ecx				; (Mem loc)
			push	edx
			invoke	CreateFile,eax,GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
			pop	edx
			pop	ebx				; (Mem location from ecx)
			pop	ecx				; (Size)
			cmp	eax,INVALID_HANDLE_VALUE
			je	EmptyCMDFSAVE
			push	eax
			push	edx
			invoke	WriteFile,eax,ebx,ecx,addr dtemp2,0
			pop	edx
			pop	eax
			invoke	CloseHandle,eax
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
EmptyCMDFSAVE:		pop	edx
			add	edx,5
			jmp	NextLine
		
;-----------------------------------------------------------------------------------------------
; FSEEK X,Y
; Set position Y inside a file X.
CMD_FSEEK:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_FSEEKCOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Handle
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
			call	EvalExprCOMP			; Position
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax
			test	eax,eax
			jz	@F
			invoke	SetFilePointer,eax,ebx,0,FILE_BEGIN	
@@:			pop	edx
			add	edx,5
			jmp	NextLine
		
;-----------------------------------------------------------------------------------------------
; FWRITE X,Y,Z
; write Y into an opened file X for Z bytes.
CMD_FWRITE:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_FWRITECOMP:		push	ecx
			push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Handle
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
			call	EvalExprCOMP			; Memory
			cmp	ExprFinalResult,VAR_DOUBLE	; (can be a string or an int address)
			je	E19
			push	ebx
			call	EvalExprCOMP			; Bytes
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	ecx				; ecx=Memory
			pop	eax				; eax=Handle
			mov	ReadAmount,0
			test	eax,eax
			jz	@F
			test	ecx,ecx
			jz	@F
			test	ebx,ebx
			js	E47
			jz	@F
			invoke	WriteFile,eax,ecx,ebx,addr ReadAmount,0
@@:			pop	edx
			pop	ecx
			add	edx,5
			jmp	NextLine
		
;-----------------------------------------------------------------------------------------------
; FWRITELN X,Y,Z
; write Y into an opened file X for Z bytes.
CMD_FWRITELN:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_FWRITELNCOMP:	push	ecx
			push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Handle
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
			call	EvalExprCOMP			; Memory
			cmp	ExprFinalResult,VAR_DOUBLE	; (can be a string or an int address)
			je	E19
			push	ebx
			call	EvalExprCOMP			; Bytes
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	ecx				; ecx=Memory
			pop	eax				; eax=Handle
			mov	ReadAmount,0
			test	eax,eax
			jz	@F
			test	ecx,ecx
			jz	@F
			test	ebx,ebx
			js	E47
			jz	EmptyFWRITELN
			push	eax
			invoke	WriteFile,eax,ecx,ebx,addr ReadAmount,0
			test	eax,eax
			pop	eax
			jz	FWRITELNEmpty
EmptyFWRITELN:		; Write CRLF even if specified length is 0
			invoke	WriteFile,eax,addr CrLfTxt,2,addr ReadAmountCrLf,0
			test	eax,eax
			jz	@F
			add	ReadAmount,2
@@:			pop	edx
			pop	ecx
			add	edx,5
			jmp	NextLine
		
;-----------------------------------------------------------------------------------------------
; MFREE X
; Release a block of allocated memory.
CMD_MFREE:		call	TestArgumentsExpected
			jmp	EvalExpr

			align	16
CMD_MFREECOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			call	EvalExprCOMP			; Evaluate expression
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E44
			test	ebx,ebx
			jz	CMDMFREEEmpty
			invoke	GlobalFree,ebx
CMDMFREEEmpty:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; FCOPY X,Y
; Copy file X under Y name
CMD_FCOPY:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_FCOPYCOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			test	ebx,ebx
			jz	FCOPYZero
			push	ebx
			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			pop	eax
			test	ebx,ebx
			jz	FCOPYZero
			invoke	CopyFile,eax,ebx,1
FCOPYZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; FMKDIR X
; Create a specified directory.
CMD_FMKDIR:		call	TestArgumentsExpected
			jmp	EvalExpr

			align	16
CMD_FMKDIRCOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			call	EvalExprCOMP			; Evaluate expression
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			invoke	CreateDirectory,ebx,0
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; FRMDIR X
; Delete a specified directory.
CMD_FRMDIR:		call	TestArgumentsExpected
			jmp	EvalExpr

			align	16
CMD_FRMDIRCOMP:		push	edx
			mov	edx,[edx]			; Get expression address
			call	EvalExprCOMP			; Evaluate expression
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			invoke	RemoveDirectory,ebx
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; FNAME X,Y
; Rename file X under Y name
CMD_FNAME:		call	TestArgumentsExpected
			call	EvalExpr
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_FNAMECOMP:		push	edx
			mov	edx,[edx]
			call	EvalExprCOMP			; Get address
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			test	ebx,ebx
			jz	FNAMEZero
			push	ebx
			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			pop	eax
			test	ebx,ebx
			jz	FNAMEZero
			invoke	MoveFile,eax,ebx
FNAMEZero:		pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; VARTOINT &X
; Force a variable type to be an integer.
CMD_VARTOINT:		call	TestArgumentsExpected
			call	TestVar				; Test variable following GET
			jc	E20
			cmp	cl,WRAP_ARRAYADDRESS		; Can't convert an array
			je	E39
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			ret

			align	16
CMD_VARTOINTCOMP:	push	edx
			mov	edx,[edx]
			call	GetVarRealAddress
			cmp	dword ptr [eax+VARDAT_TYPE],VAR_DOUBLE
			je	E49
			mov	dword ptr [eax+VARDAT_TYPE],VAR_INTEGER
			pop	edx
			add	edx,5
			jmp	NextLine
			align	16
E49:			mov	edi,offset Err49		; error <Invalid reference to floating point variable>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; VARTOSTR &X
; Force a variable type to be a string.
CMD_VARTOSTR:		call	TestArgumentsExpected
			call	TestVar				; Test variable following GET
			jc	E20
			cmp	cl,WRAP_ARRAYADDRESS
			je	E39
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			ret

			align	16
CMD_VARTOSTRCOMP:	push	edx
			mov	edx,[edx]
			call	GetVarRealAddress
			cmp	dword ptr [eax+VARDAT_TYPE],VAR_DOUBLE
			je	E49
			mov	dword ptr [eax+VARDAT_TYPE],VAR_STRING
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; DIM NAME[(SIZE)]:TYPE 
; Declare a variable of an array
; Note: Command only executed at first pass.
CMD_DIM:		call	TestArgumentsExpected
			call	DeclareVar
			jc	E20				; Invalid name (no entry created)
			mov	SaveCompExprPtr,0		; (We don't need any expression for this)
			cmp	cl,WRAP_ARRAYADDRESS
			je	RemoveVarEntryADDR
			cmp	cl,WRAP_VARADDRESS
			je	RemoveVarEntryADDR
			mov	ebx,offset TAB_VAR_DEC
			jmp	SearchKeyword
			; AS
DIM_DecAS:		cmp	byte ptr [edx-4]," "
			je	SetDIMDatas
			jmp	RemoveVarEntryAS
SetDIMDatas:		cmp	cl,WRAP_ARRAY
			jne	DeclareVariable
			mov	ebx,offset TAB_ARR_DECTYPE
			jmp	SearchKeyword
DeclareVariable:	mov	ebx,offset TAB_VAR_DECTYPE
			jmp	SearchKeyword
SetDIMDatasINT_VAR:	mov	ebx,DeclaredVarAddress
			mov	dword ptr [ebx+VARDAT_TYPE],VAR_INTEGER
			; Alloc the required datas
			push	ebx
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,4
			pop	edx
			pop	ebx
			test	eax,eax
			jz	RemoveVarEntryMEM
			; Store address of datas
			mov	[ebx+VARDAT_DATASPTR],eax
			ret
SetDIMDatasSTR_VAR:	mov	ebx,DeclaredVarAddress
			mov	dword ptr [ebx+VARDAT_TYPE],VAR_STRING
			; Alloc the required datas
			push	ebx
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,4
			pop	edx
			pop	ebx
			test	eax,eax
			jz	RemoveVarEntryMEM
			push	eax
			; Alloc an empty string
			push	ebx
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,1
			pop	edx
			pop	ebx
			pop	ecx				; (From eax)
			test	eax,eax
			jz	RemoveVarEntryMEM
			mov	[ecx],eax			; Store empty string address
			mov	[ebx+VARDAT_DATASPTR],ecx
			ret
SetDIMDatasFP_VAR:	mov	ebx,DeclaredVarAddress
			mov	dword ptr [ebx+VARDAT_TYPE],VAR_DOUBLE
			; Alloc the required datas
			push	ebx
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,8
			pop	edx
			pop	ebx
			test	eax,eax
			jz	RemoveVarEntryMEM
			; Store address of datas
			mov	[ebx+VARDAT_DATASPTR],eax
			ret
			; Arrays need to be allocated
			; (LBOUND is temporary set to 0)
			; We need to pad the allocated memory to the greatest
			; datas type for later speed considerations.
SetDIMDatasINT_ARR:	mov	ebx,DeclaredVarAddress
			mov	eax,DeclaredVarSize
			mov	dword ptr [ebx+VARDAT_TYPE],VAR_INTEGER
			mov	dword ptr [ebx+VARDAT_VARARR],DAT_ARRAY
			mov	dword ptr [ebx+VARDAT_ARRLBOUND],0
			mov	[ebx+VARDAT_ARRUBOUND],eax
			push	ebx
			push	edx
			inc	eax
			shl	eax,2				; *4
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
			pop	edx
			pop	ebx
			test	eax,eax
			jz	RemoveVarEntryMEM
			mov	[ebx+VARDAT_DATASPTR],eax
			ret
SetDIMDatasSTR_ARR:	mov	ebx,DeclaredVarAddress
			mov	ecx,DeclaredVarSize
			mov	dword ptr [ebx+VARDAT_TYPE],VAR_STRING
			mov	dword ptr [ebx+VARDAT_VARARR],DAT_ARRAY
			mov	dword ptr [ebx+VARDAT_ARRLBOUND],0
			mov	[ebx+VARDAT_ARRUBOUND],ecx
			inc	ecx
			shl	ecx,2				; *4
			push	ecx
			push	ebx
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED,ecx
			pop	edx
			pop	ebx
			pop	ecx
			test	eax,eax
			jz	RemoveVarEntryMEM
			; Store pointer
			mov	[ebx+VARDAT_DATASPTR],eax
			push	ecx
			push	edi
			mov	ecx,DeclaredVarSize
			inc	ecx
			mov	edi,eax
FillStringArray:	push	edi
			; Alloc empty strings
			push	ecx
			push	ebx
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,1
			pop	edx
			pop	ebx
			pop	ecx
			test	eax,eax
			jz	RemoveVarEntryMEM
			pop	edi
			mov	[edi],eax
			add	edi,4				; Next one (+4)
			dec	ecx
			jnz	FillStringArray
			pop	edi
			pop	ecx					
			ret
SetDIMDatasFP_ARR:	mov	ebx,DeclaredVarAddress
			mov	eax,DeclaredVarSize
			mov	dword ptr [ebx+VARDAT_TYPE],VAR_DOUBLE
			mov	dword ptr [ebx+VARDAT_VARARR],DAT_ARRAY
			mov	dword ptr [ebx+VARDAT_ARRLBOUND],0
			mov	[ebx+VARDAT_ARRUBOUND],eax
			push	ebx
			push	edx
			inc	eax
			shl	eax,3				; *8
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
			pop	edx
			pop	ebx
			test	eax,eax
			jz	RemoveVarEntryMEM
			mov	[ebx+VARDAT_DATASPTR],eax
			ret

			align	16
CMD_DIMCOMP:		add	edx,5
			jmp	NextLine
E54:			mov	edi,offset Err54		; error <':' or 'AS' statements expected>
			jmp	DispError
E55:			mov	edi,offset Err55		; error <Unknown declaration type>
			jmp	DispError
RemoveVarEntryAS:	call	InvalidateDIMEntry
			jmp	E54
RemoveVarEntryTYPE:	call	InvalidateDIMEntry
			jmp	E55
RemoveVarEntryMEM:	call	InvalidateDIMEntry
			jmp	E46
RemoveVarEntryADDR:	call	InvalidateDIMEntry
			jmp	E39
			; Mark last created entry as invalid
			; And free associated name memory block
			align	16
InvalidateDIMEntry:	cmp	VarNbr,0
			je	NoVarToInvalidate
			dec	VarNbr
NoVarToInvalidate:	invoke	GlobalFree,DeclaredVarName
			ret

;-----------------------------------------------------------------------------------------------
; BITCLR &X,Y
; Clear the bit specified by integer expression Y (0-31 range) in integer variable X.
CMD_BITCLR:		call	TestArgumentsExpected
			call	TestVar
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_BITCLRCOMP:		push	edx
			mov	edx,[edx]
			call	GetVarRealAddress		; Get address
			cmp	dword ptr [eax+VARDAT_TYPE],VAR_INTEGER
			jne	E28
			push	ebx
			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax
			test	ebx,ebx				; >=0
			js	E47
			cmp	ebx,31				; <=31
			ja	E3
			mov	ebx,[Bits_MaskTable+ebx*4]
			not	ebx
			and	[eax],ebx
			pop	edx
			add	edx,5
			jmp	NextLine
		
;-----------------------------------------------------------------------------------------------
; BITINV &X,Y
; Invert the bit specified by integer expression Y (0-31 range) in integer variable X.
CMD_BITINV:		call	TestArgumentsExpected
			call	TestVar
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_BITINVCOMP:		push	edx
			mov	edx,[edx]
			call	GetVarRealAddress		; Get address
			cmp	dword ptr [eax+VARDAT_TYPE],VAR_INTEGER
			jne	E28
			push	ebx
			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax
			test	ebx,ebx				; >=0
			js	E47
			cmp	ebx,31				; <=31
			ja	E3
			mov	ebx,[Bits_MaskTable+ebx*4]
			xor	[eax],ebx
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; BITSET &X,Y
; Set the bit specified by integer expression Y (0-31 range) in integer variable X.
CMD_BITSET:		call	TestArgumentsExpected
			call	TestVar
			jc	E20
			cmp	cl,WRAP_ARRAY
			je	E38
			cmp	cl,WRAP_VAR
			je	E38
			call	FindComma
			jnz	E18
			jmp	EvalExpr

			align	16
CMD_BITSETCOMP:		push	edx
			mov	edx,[edx]
			call	GetVarRealAddress		; Get address
			cmp	dword ptr [eax+VARDAT_TYPE],VAR_INTEGER
			jne	E28
			push	ebx
			call	EvalExprCOMP			; Get data
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax
			test	ebx,ebx				; >=0
			js	E47
			cmp	ebx,31				; <=31
			ja	E3
			mov	ebx,[Bits_MaskTable+ebx*4]
			or	[eax],ebx
			pop	edx
			add	edx,5
			jmp	NextLine

;-----------------------------------------------------------------------------------------------
; Functions
;-----------------------------------------------------------------------------------------------
CompileFnc1Arg:		invoke	AddWrapFnc,[RunFncTbl+eax*4]
			jmp	TestParenth
CompileFnc2Args:	invoke	AddWrapFnc,[RunFncTbl+eax*4]
			call	TestParenthOpen
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindCloseBracket
			jnz	E31
			invoke	AddWrapCloseBracket
			ret
CompileFnc3Args:	invoke	AddWrapFnc,[RunFncTbl+eax*4]
			call	TestParenthOpen
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindCloseBracket
			jnz	E31
			invoke	AddWrapCloseBracket
			ret
CompileFnc4ArgsOpt4:	invoke	AddWrapFnc,[RunFncTbl+eax*4]
			call	TestParenthOpen
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	FncArg4Opt
			call	EvalExpr
FncArg4Opt:		call	FindCloseBracket
			jnz	E31
			invoke	AddWrapCloseBracket
			ret
CompileFnc3ArgsOpt3:	invoke	AddWrapFnc,[RunFncTbl+eax*4]
			call	TestParenthOpen
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	FindComma
			jnz	E18
			call	EvalExpr
			call	FindComma
			jnz	FncArg3Opt
			call	EvalExpr			; Third argument is optional
FncArg3Opt:		call	FindCloseBracket		; Expresssion must be closed
			jnz	E31
			invoke	AddWrapCloseBracket
			ret

;-----------------------------------------------------------------------------------------------
; RND(expr) = (cycle_counter*dl MOD EXPR)+1
FNC_RND:		mov	eax,WRAP_FNC_RND
			jmp	CompileFnc1Arg

			align	16
FNC_RNDCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RndDouble
			call	TestGtZero
			push	edx
			fstp	DblGarb				; Get argument
			rdtsc
			and	edx,0ffh
			mul	edx
			and	eax,07fffffffh
			mov	DblFromInt,eax
			fild	DblFromInt
			fstp	DblGarb2
			fld	DblGarb
			fld	DblGarb2
			fprem
			fstp	DblGarb2			; Get st(0)
			fstp	DblGarb				; Flush st(1)
			fld	DblGarb2
			call	CheckSignDbl			; Ensure positive result
			pop	edx
			jmp	FinalizeFncCOMP
			align	16
RndDouble:		cmp	ExprFinalResult,VAR_INTEGER
			jne	E44
			test	ebx,ebx
			js	E47				; Must be positive
			jz	E19				; And <> zero
			push	ecx
			push	edx
			rdtsc					; Read Pentium cycles counter
			and	edx,0ffh			; (!!! Only Pentium instruction !!!)
			mul	edx				; 0<=eax<=32700
			xchg	edx,ebx
			mov	ebx,eax
			call	Divide				; RND(N)=MOD(M,N)+1
			pop	edx
			pop	ecx
			call	CheckSign			; Ensure positive result
			inc	ebx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ABS(EXPR) returns absolute value of EXPR
FNC_ABS:		mov	eax,WRAP_FNC_ABS
			jmp	CompileFnc1Arg

			align	16
FNC_ABSCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	AbsDouble
			call	CheckSignDbl			; (result in st(0)
			jmp	FinalizeFncCOMP
			align	16
AbsDouble:		cmp	ExprFinalResult,VAR_INTEGER
			jne	E44
			call	CheckSign			; Invert sign if negative
			test	eax,ebx
			jns	FinalizeFncCOMP			; OK, ret
			jmp	E19				; else error : <Invalid argument>

;-----------------------------------------------------------------------------------------------
; SGN(EXPR) returns the sign of EXPR
FNC_SGN:		mov	eax,WRAP_FNC_SGN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_SGNCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			; SGN returns an integer
			POKEOPERSTACKINTCOMP
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	SgnDouble
			ftst
			fstsw	ax
			mov	bx,ax
			fstp	DblGarb				; (garbage)
			and	bx,100010100000000b
			jz	Sgn_Return1
			cmp	bx,000000100000000b
			je	Sgn_ReturnM1
			cmp	bx,100000000000000b
			je	Sgn_Return0
			jmp	E25				; Shouldn't occurs
			align	16
SgnDouble:		cmp	ExprFinalResult,VAR_INTEGER
			jne	E44
			test	ebx,ebx				; Test s flag
			jz	Sgn_Return0
			jns	Sgn_Return1
Sgn_ReturnM1:		or	ebx,-1				; Return -1
			jmp	FinalizeFncCOMP
			align	16
Sgn_Return0:		xor	ebx,ebx				; Return 0
			jmp	FinalizeFncCOMP
			align	16
Sgn_Return1:		mov	ebx,1				; Return 1
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; SIN(EXPR) returns the sine of EXPR
FNC_SIN:		mov	eax,WRAP_FNC_SIN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_SINCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fsin
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; COS(EXPR) returns the cosine of EXPR
FNC_COS:		mov	eax,WRAP_FNC_COS
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_COSCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fcos
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; SEC(EXPR) returns the secant of EXPR
FNC_SEC:		mov	eax,WRAP_FNC_SEC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_SECCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fcos
			call	TestZero
			fstp	DblGarb
			fld1
			fdiv	DblGarb
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ASIN(EXPR) returns the arc sine of EXPR
FNC_ASIN:		mov	eax,WRAP_FNC_ASIN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_ASINCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			fchs
			fmul	DblGarb
			fadd	Dbl1
			call	TestGtZero
			fsqrt
			call	TestZero
			fstp	DblGarb2
			fld	DblGarb
			fdiv	DblGarb2
			fld1
			fpatan
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ACOS(EXPR) returns the arc cosine of EXPR
FNC_ACOS:		mov	eax,WRAP_FNC_ACOS
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_ACOSCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			fchs
			fmul	DblGarb
			fadd	Dbl1
			call	TestGtZero
			fsqrt
			call	TestZero
			fstp	DblGarb2
			fld	DblGarb
			fchs
			fdiv	DblGarb2
			fld1
			fpatan
			fstp	DblGarb2
			fld1
			fld1
			fpatan
			fmul	Dbl2
			fstp	DblGarb
			fld	DblGarb2
			fadd	DblGarb
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ASEC(EXPR) returns the arc secant of EXPR
FNC_ASEC:		mov	eax,WRAP_FNC_ASEC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_ASECCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			fmul	DblGarb
			fsub	Dbl1
			call	TestGtZero
			fsqrt
			call	TestZero
			fstp	DblGarb2
			fld	DblGarb
			fdiv	DblGarb2
			fld1
			fpatan
			fstp	DblGarb2
			fld1
			fld1
			fpatan
			fmul	Dbl2
			fstp	DblGarb3
			fld	DblGarb
			fsub	Dbl1
			call	SgnDbl
			fmul	DblGarb3
			fstp	DblGarb3
			fld	DblGarb2
			fadd	DblGarb3
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ACOSEC(EXPR) returns the arc cosecant of EXPR
FNC_ACOSEC:		mov	eax,WRAP_FNC_ACOSEC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_ACOSECCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			fmul	DblGarb
			fsub	Dbl1
			call	TestGtZero
			fsqrt
			call	TestZero
			fstp	DblGarb2
			fld	DblGarb
			fdiv	DblGarb2
			fld1
			fpatan
			fstp	DblGarb2
			fld1
			fld1
			fpatan
			fmul	Dbl2
			fstp	DblGarb3
			fld	DblGarb
			call	SgnDbl
			fsub	Dbl1
			fmul	DblGarb3
			fstp	DblGarb3
			fld	DblGarb2
			fadd	DblGarb3
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ACOTAN(EXPR) returns the arc cotangent of EXPR
FNC_ACOTAN:		mov	eax,WRAP_FNC_ACOTAN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_ACOTANCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fld1
			fpatan
			fstp	DblGarb
			fld1
			fld1
			fpatan
			fmul	Dbl2
			fstp	DblGarb2
			fld	DblGarb
			fadd	DblGarb2
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; COSEC(EXPR) returns the cosecant of EXPR
FNC_COSEC:		mov	eax,WRAP_FNC_COSEC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_COSECCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fsin
			call	TestZero
			fstp	DblGarb
			fld1
			fdiv	DblGarb
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; COTAN(EXPR) returns the cotangent of EXPR
FNC_COTAN:		mov	eax,WRAP_FNC_COTAN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_COTANCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fptan
			fstp	DblGarb
			call	TestZero
			fstp	DblGarb
			fld1
			fdiv	DblGarb
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; TAN(EXPR) returns the tangent of EXPR
FNC_TAN:		mov	eax,WRAP_FNC_TAN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_TANCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fptan
			fstp	DblGarb
			jmp	FinalizeFncCOMP
			
;-----------------------------------------------------------------------------------------------
; SQRT(EXPR) returns the square root of EXPR
FNC_SQRT:		mov	eax,WRAP_FNC_SQRT
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_SQRTCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			ftst
			fstsw	ax
			and	eax,000000100000000b
			jnz	E19
			fsqrt
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LOG(EXPR) returns the natural logarithm of EXPR
FNC_LOG:		mov	eax,WRAP_FNC_LOG
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_LOGCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			call	DoLog
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ATN(EXPR) returns the arc tangent of EXPR
FNC_ATN:		mov	eax,WRAP_FNC_ATN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_ATNCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fld1
			fpatan
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; EXP(EXPR) returns the e^EXPR
FNC_EXP:		mov	eax,WRAP_FNC_EXP
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_EXPCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			call	DoExp
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HSIN(EXPR) returns the hyperbolic sine of EXPR
FNC_HSIN:		mov	eax,WRAP_FNC_HSIN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HSINCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			call	DoExp
			fstp	DblGarb2
			fld	DblGarb
			fchs
			call	DoExp
			fstp	DblGarb3
			fld	DblGarb2
			fsub	DblGarb3
			fdiv	Dbl2
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HCOS(EXPR) returns the hyperbolic cosine of EXPR
FNC_HCOS:		mov	eax,WRAP_FNC_HCOS
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HCOSCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			call	DoExp
			fstp	DblGarb2
			fld	DblGarb
			fchs
			call	DoExp
			fstp	DblGarb3
			fld	DblGarb2
			fadd	DblGarb3
			fdiv	Dbl2
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HTAN(EXPR) returns the hyperbolic tangent of EXPR
FNC_HTAN:		mov	eax,WRAP_FNC_HTAN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HTANCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			call	DoExp
			fstp	DblGarb2
			fld	DblGarb
			fchs
			call	DoExp
			fstp	DblGarb3
			fld	DblGarb2
			fadd	DblGarb3
			call	TestZero
			fstp	DblGarb4
			fld	DblGarb
			call	DoExp
			fstp	DblGarb2
			fld	DblGarb
			fchs
			call	DoExp
			fstp	DblGarb3
			fld	DblGarb2
			fsub	DblGarb3
			fdiv	DblGarb4
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HSEC(EXPR) returns the hyperbolic secant of EXPR
FNC_HSEC:		mov	eax,WRAP_FNC_HSEC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HSECCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			call	DoExp
			fstp	DblGarb2
			fld	DblGarb
			fchs
			call	DoExp
			fstp	DblGarb3
			fld	DblGarb2
			fadd	DblGarb3
			call	TestZero
			fstp	DblGarb3
			fld	Dbl2
			fdiv	DblGarb3
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HCOSEC(EXPR) returns the hyperbolic cosecant of EXPR
FNC_HCOSEC:		mov	eax,WRAP_FNC_HCOSEC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HCOSECCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			call	DoExp
			fstp	DblGarb2
			fld	DblGarb
			fchs
			call	DoExp
			fstp	DblGarb3
			fld	DblGarb2
			fsub	DblGarb3
			call	TestZero
			fstp	DblGarb3
			fld	Dbl2
			fdiv	DblGarb3
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HCOTAN(EXPR) returns the hyperbolic cotangent of EXPR
FNC_HCOTAN:		mov	eax,WRAP_FNC_HCOTAN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HCOTANCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			call	DoExp
			fstp	DblGarb2
			fld	DblGarb
			fchs
			call	DoExp
			fstp	DblGarb3
			fld	DblGarb2
			fsub	DblGarb3
			call	TestZero
			fstp	DblGarb4
			fld	DblGarb
			call	DoExp
			fstp	DblGarb2
			fld	DblGarb
			fchs
			call	DoExp
			fstp	DblGarb3
			fld	DblGarb2
			fadd	DblGarb3
			fdiv	DblGarb4
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HASIN(EXPR) returns the inverted hyperbolic arc sine of EXPR
FNC_HASIN:		mov	eax,WRAP_FNC_HASIN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HASINCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			fmul	DblGarb
			fadd	Dbl1
			call	TestGtZero
			fsqrt
			fstp	DblGarb2
			fld	DblGarb
			fadd	DblGarb2
			call	DoLog
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HACOS(EXPR) returns the inverted hyperbolic arc cosine of EXPR
FNC_HACOS:		mov	eax,WRAP_FNC_HACOS
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HACOSCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			fmul	DblGarb
			fsub	Dbl1
			call	TestGtZero
			fsqrt
			fstp	DblGarb2
			fld	DblGarb
			fadd	DblGarb2
			call	DoLog
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HATN(EXPR) returns the inverted hyperbolic tangent of EXPR
FNC_HATN:		mov	eax,WRAP_FNC_HATN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HATNCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld1
			fadd	DblGarb
			fstp	DblGarb2
			fld1
			fsub	DblGarb
			call	TestZero
			fstp	DblGarb3
			fld	DblGarb2
			fdiv	DblGarb3
			call	DoLog
			fdiv	Dbl2
			jmp	FinalizeFncCOMP
	
;-----------------------------------------------------------------------------------------------
; HASEC(EXPR) returns the inverted hyperbolic secant of EXPR
FNC_HASEC:		mov	eax,WRAP_FNC_HASEC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HASECCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			call	TestZero
			fstp	DblGarb
			fld	DblGarb
			fchs
			fmul	DblGarb
			fadd	Dbl1
			call	TestGtZero
			fsqrt
			fadd	Dbl1
			fdiv	DblGarb
			call	DoLog
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HACOSEC(EXPR) returns the inverted hyperbolic cosecant of EXPR
FNC_HACOSEC:		mov	eax,WRAP_FNC_HACOSEC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HACOSECCOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			call	TestZero
			fstp	DblGarb
			fld	DblGarb
			fmul	DblGarb
			fadd	Dbl1
			call	TestGtZero
			fsqrt
			fstp	DblGarb2
			fld	DblGarb
			call	SgnDbl
			fmul	DblGarb2
			fadd	Dbl1
			fdiv	DblGarb
			call	DoLog
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HCOATN(EXPR) returns the inverted hyperbolic cotangent of EXPR
FNC_HCOATN:		mov	eax,WRAP_FNC_HCOATN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_HCOATNCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstp	DblGarb
			fld	DblGarb
			fsub	Dbl1
			call	TestZero
			fstp	DblGarb2
			fld	DblGarb
			fadd	Dbl1
			fdiv	DblGarb2
			call	DoLog
			fdiv	Dbl2
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LOGN(EXPR1,EXPR2) returns the natural logarithm of EXPR1 in EXPR2 base
FNC_LOGN:		mov	eax,WRAP_FNC_LOGN
			call	CompileFnc2Args
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_LOGNCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			call	DoLog
			fstp	DblGarb
			push	dword ptr [DblGarb]
			push	dword ptr [DblGarb+4]
			call	GetFNCLastArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			call	DoLog
			call	TestZero
			fstp	DblGarb
			pop	dword ptr [DblGarb2+4]
			pop	dword ptr [DblGarb2]
			fld	DblGarb2
			fdiv	DblGarb
			NORMALIZEOPERSTACKCOMP 1		; 1 step normalize since last arg was already a fp
			jmp	FinalizeFncCOMP
			align	16
E30:			mov	edi,offset Err30		; Error: <'(' statement expected>
			jmp	DispError
E31:			mov	edi,offset Err31		; Error: <')' statement expected>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; FIX(EXPR) returns the integer part of EXPR
FNC_FIX:		mov	eax,WRAP_FNC_FIX
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FIXCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstcw	ExpFPUState1
			push	eax
			mov	ax,ExpFPUState1
			or	ax,110000000000b		; Round toward zero
			mov	ExpFPUState2,ax
			pop	eax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FRAC(EXPR) returns the non-integer part of EXPR
FNC_FRAC:		mov	eax,WRAP_FNC_FRAC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_DOUBLE
			ret

			align	16
FNC_FRACCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstcw	ExpFPUState1
			push	eax
			mov	ax,ExpFPUState1
			or	ax,110000111111b		; Round toward zero
			mov	ExpFPUState2,ax
			pop	eax
			fldcw	ExpFPUState2
			fst	DblGarb				; Save it
			frndint
			fstp	DblGarb2
			fld	DblGarb
			fsub	DblGarb2
			fldcw	ExpFPUState1
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; INT(EXPR) returns the integer part of EXPR
FNC_INT:		mov	eax,WRAP_FNC_INT
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_INTCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			call	ConvertIntFromExpr
			fstcw	ExpFPUState1
			push	eax
			push	ebx
			mov	ax,ExpFPUState1
			mov	bx,ax
			and	ebx,100010100000000b		; > Zero ?
			cmp	ebx,100000000000000b
			jne	IntAbsolute
			or	eax,0000110000000000b		; Round toward zero
			jmp	IntIt
			align	16
IntAbsolute:		and	eax,1111001111111111b		; Round down negative numbers
			or	eax,0000010000000000b
IntIt:			mov	ExpFPUState2,ax
			pop	ebx
			pop	eax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; IIF(EXPR1,EXPR2,EXPR3) returns EXPR2 if EXPR1 is true or EXPR3 otherwise.
FNC_IIF:		mov	eax,WRAP_FNC_IIF
			call	CompileFnc3Args
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_IIFCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	IIfDouble
			ftst
			fstsw	ax
			fstp	DblGarb
			and	eax,100010100000000b
			cmp	eax,100000000000000b
			je	IIFFalse
			jmp	IIFTrue
			align	16
IIfDouble:		; String returned (implied comparison)
			cmp	ExprFinalResult,VAR_STRING
			jne	IIfString
			; Take first char
			; and convert it into an integer
			movzx	ebx,byte ptr [ebx]		
IIfString:		test	ebx,ebx
			jz	IIFFalse
; Condition was true: returns first part
IIFTrue:		call	EvalExprCOMP
			cmp	ExprFinalResult,VAR_DOUBLE
			je	IIFTrueDouble
			; Save it into stack
			; because of next expr checking (just to correct pointer)
			push	ebx
			call	GetFNCLastArgs
			pop	ebx
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKCOMP
			jmp	FinalizeFncCOMP
			align	16
IIFTrueDouble:		fstp	DblGarb
			push	dword ptr [DblGarb]
			push	dword ptr [DblGarb+4]
			call	GetFNCLastArgs
			pop	dword ptr [DblGarb+4]
			pop	dword ptr [DblGarb]
			fld	DblGarb
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKCOMP
			jmp	FinalizeFncCOMP
; Condition was false: returns second part
			align	16			
IIFFalse:		call	EvalExprCOMP
			call	GetFNCLastArgs
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; TICKS returns the number of milliseconds since Windows started in ebx
FNC_TICKS:		mov	eax,WRAP_FNC_TICKS
			jmp	CompileFnc1Arg

			align	16
FNC_TICKSCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			call	GetTicks
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HTICKS uses high resiolution timer to report the number of milliseconds
; since computer started in ebx
FNC_HTICKS:		mov	eax,WRAP_FNC_HTICKS
			jmp	CompileFnc1Arg

			align	16
FNC_HTICKSCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			mov	eax,HTimer
			test	eax,eax
			jz	UseStandardCount
        		invoke	QueryPerformanceCounter,addr HTimerV
			mov	ebx,dword ptr HTimerV
			ret
			align	16
UseStandardCount:	invoke	timeGetTime
			mov	ebx,eax
			ret

;-----------------------------------------------------------------------------------------------
; SIZE returns amount of free Basic text memory in ebx
FNC_SIZE:		mov	eax,WRAP_FNC_SIZE
			jmp	CompileFnc1Arg

			align	16
FNC_SIZECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			mov	ebx,LineNum
			sub	ebx,TxtEnd
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LEN(EXPR) returns the length of an expression.
FNC_LEN:		mov	eax,WRAP_FNC_LEN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_LENCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	GetStringLEN
			cmp	ExprFinalResult,VAR_DOUBLE
			je	GetDoubleLEN
			mov	ebx,4				; Integer = 4
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP
			align	16
GetStringLEN:		push	esi
			mov	esi,ebx
LoopStringLEN:		mov	al,[esi]
			test	al,al
			je	StopStringLEN
			inc	esi
			jmp	LoopStringLEN
			align	16
StopStringLEN:		xchg	esi,ebx
			sub	ebx,esi				; String length
			pop	esi
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP
			align	16
GetDoubleLEN:		mov	ebx,8				; Double = 8
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP
		
;-----------------------------------------------------------------------------------------------
; LINE returns in ebx the current line number
FNC_LINE:		mov	eax,WRAP_FNC_LINE
			jmp	CompileFnc1Arg

			align	16
FNC_LINECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			mov	ebx,LineNumber
			cmp	ebx,-1				; Not run yet ?
			jne	@F
			xor	ebx,ebx				; Then report 0
@@:			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FALSE returns 0
FNC_FALSE:		mov	eax,WRAP_FNC_FALSE
			jmp	CompileFnc1Arg

			align	16
FNC_FALSECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			xor	ebx,ebx
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; TRUE returns 1
FNC_TRUE:		mov	eax,WRAP_FNC_TRUE
			jmp	CompileFnc1Arg

			align	16
FNC_TRUECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			mov	ebx,1
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; PI returns PI in st(0)
FNC_PI:			mov	eax,WRAP_FNC_PI
			jmp	CompileFnc1Arg

			align	16
FNC_PICOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			fldpi
			call	PushOperStackDoubleCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; E returns e in st(0)
FNC_E:			mov	eax,WRAP_FNC_E
			jmp	CompileFnc1Arg

			align	16
FNC_ECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			fld	EConst
			call	PushOperStackDoubleCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; INKEY returns a pressed or 0 (non blocking)
FNC_INKEY:		mov	eax,WRAP_FNC_INKEY
			jmp	CompileFnc1Arg

			align	16
FNC_INKEYCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			push	edx
			mov	dtemp1,0
			invoke	GetNumberOfConsoleInputEvents,hStdIn,addr dtemp1
			cmp	dtemp1,0			; No inputs waiting ?
			je	NoINKEY
			mov	dtemp1,0
			invoke	ReadConsoleInput,hStdIn,addr EventBuffer,1,addr dtemp1
			cmp	word ptr EventBuffer,KEY_EVENT
			jne	NoINKEY
			pop	edx
			xor	ebx,ebx
			cmp	dword ptr EventBuffer+4,0	; Return pressed key
			je	@F
			mov	bl,byte ptr EventBuffer+14	; ASCII char
@@:			mov	dtemp1,0
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP
			align	16
NoINKEY:		pop	edx
			xor	ebx,ebx
			mov	dtemp1,0
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; PEEK(EXPR) reads a 8 bits value located in address EXPR located in Basic text area
FNC_PEEK:		mov	eax,WRAP_FNC_PEEK
			jmp	CompileFnc1Arg

			align	16
FNC_PEEKCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	ebx,MEMDATSIZE			; Inside Basic text memory ?
			jae	E41				; No, error <Memory value overflow>
			add	ebx,DatStart
			movzx	ebx,byte ptr [ebx]		; ebx = 8 bits value
			jmp	FinalizeFncCOMP
			align	16
E28:			mov	edi,offset Err28		; Yes <Integer value expected>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; PEEKW(EXPR) reads a 16 bits value located in address EXPR located in Basic text area
FNC_PEEKW:		mov	eax,WRAP_FNC_PEEKW
			jmp	CompileFnc1Arg

			align	16
FNC_PEEKWCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	ebx,MEMDATSIZE-2		; Inside Basic text memory ? (-2 for a word)
			ja	E41				; No, error <Memory value overflow>
			add	ebx,DatStart
			movzx	ebx,word ptr [ebx]		; ebx = 8 bits value
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; PEEKD(EXPR) reads a 32 bits value located in address EXPR located in Basic text area
FNC_PEEKD:		mov	eax,WRAP_FNC_PEEKD
			jmp	CompileFnc1Arg

			align	16
FNC_PEEKDCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			cmp	ebx,MEMDATSIZE-4		; Inside Basic text memory ? (-4 for a dword)
			ja	E41				; No, error <Memory value overflow>
			add	ebx,DatStart
			mov	ebx,[ebx]			; ebx = 8 bits value
			jmp	FinalizeFncCOMP
			align	16

;-----------------------------------------------------------------------------------------------
; CHR(EXPR) returns ASCII value of an integer.
FNC_CHR:		mov	eax,WRAP_FNC_CHR
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_CHRCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED,2	; chr()+0
			test	eax,eax
			jz	E46
			pop	edx
			mov	[eax],bl			; Put char in new string
			mov	byte ptr [eax+1],0		; Null pad
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ASC(EXPR) returns integer value of the first char of a string.
FNC_ASC:		mov	eax,WRAP_FNC_ASC
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_ASCCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			movzx	ebx,byte ptr [ebx]		; Take first char
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP
			align	16
E45:			mov	edi,offset Err45		; Yes <String expected>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; UCASE(EXPR) turn a string into uppercase.
FNC_UCASE:		mov	eax,WRAP_FNC_UCASE
			jmp	CompileFnc1Arg

			align	16
FNC_UCASECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	esi
			push	edx
			push	ebx
			mov	esi,ebx
LoopStringLenUCASE:	mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	LoopStringLenUCASE
			sub	esi,ebx				; String length
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax				; eax= temporary string
			jz	E46
			mov	ecx,esi
			pop	ebx				; ebx= string to copy		
			lea	esi,CharTableUpper
			xor	edx,edx
			push	eax				; (we will restore it in ebx)
PutUCASE:		mov	dl,[ebx]
			inc	ebx
			mov	dl,[esi+edx]			; work with a null zero
			mov	[eax],dl
			inc	eax
			dec	ecx
			jnz	PutUCASE
			pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	edx
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LCASE(EXPR) turn a string into uppercase.
FNC_LCASE:		mov	eax,WRAP_FNC_LCASE
			jmp	CompileFnc1Arg

			align	16
FNC_LCASECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	esi
			push	edx
			push	ebx
			mov	esi,ebx
LoopStringLenLCASE:	mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	LoopStringLenLCASE
			sub	esi,ebx				; String length
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax				; eax= temporary string
			jz	E46
			mov	ecx,esi
			pop	ebx				; ebx= string to copy		
			lea	esi,CharTableLower
			xor	edx,edx
			push	eax				; (we will restore it in ebx)
PutLCASE:		mov	dl,[ebx]
			inc	ebx
			mov	dl,[esi+edx]
			mov	[eax],dl
			inc	eax
			dec	ecx
			jnz	PutLCASE
			pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	edx
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; TCASE(EXPR) Toggle case of string expression X.
FNC_TCASE:		mov	eax,WRAP_FNC_TCASE
			jmp	CompileFnc1Arg

			align	16
FNC_TCASECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	esi
			push	edx
			push	ebx
			mov	esi,ebx
LoopStringLenTCASE:	mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	LoopStringLenTCASE
			sub	esi,ebx				; String length
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax				; eax= temporary string
			jz	E46
			mov	ecx,esi
			pop	ebx				; ebx= string to copy		
			lea	esi,CharTableToggle
			xor	edx,edx
			push	eax				; (we will restore it in ebx)
PutTCASE:		mov	dl,[ebx]
			inc	ebx
			mov	dl,[esi+edx]
			mov	[eax],dl
			inc	eax
			dec	ecx
			jnz	PutTCASE
			pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	edx
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HEX(EXPR) convert a numeric expression X into a hexadecimal string.
FNC_HEX:		mov	eax,WRAP_FNC_HEX
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_HEXCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	E44
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RoundHEX
			fstcw	ExpFPUState1			; Round it to integer
			push	eax
			mov	ax,ExpFPUState1
			or	ax,110000000000b
			mov	ExpFPUState2,ax
			pop	eax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
RoundHEX:		push	ecx
			push	edx
			push	esi
			mov	edx,ebx
			lea	esi,HEXTabASCII2
			lea	ebx,TempHEXNumber
			mov	byte ptr [ebx],"0"		; At least 0
			mov	byte ptr [ebx+1],0		; Null
			test	edx,edx
			jz	NullHEX
			mov	eax,edx
GetHEXLen:		inc	ebx
			shr	eax,4
			jnz	GetHEXLen
			mov	byte ptr [ebx],0		; Null
			dec	ebx
HEXToAscii:		mov	ecx,edx
			and	ecx,0fh
			mov	cl,[esi+ecx]
			mov	[ebx],cl
			dec	ebx
			shr	edx,4
			jnz	HEXToAscii
NullHEX:		invoke	GlobalAlloc,GMEM_FIXED,8+1	; xxxxxxxx+0
			lea	ecx,TempHEXNumber
			test	eax,eax
			jz	E46
			mov	ebx,eax
FinalizeHEX:		mov	dl,[ecx]
			inc	ecx
			mov	[eax],dl
			inc	eax
			test	dl,dl
			jnz	FinalizeHEX
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HEXB(EXPR) convert a numeric byte expression X into a hexadecimal string.
FNC_HEXB:		mov	eax,WRAP_FNC_HEXB
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_HEXBCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	E44
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RoundHEXB
			fstcw	ExpFPUState1			; Round it to integer
			mov	ax,ExpFPUState1
			or	ax,110000000000b
			mov	ExpFPUState2,ax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
RoundHEXB:		push	ecx
			push	edx
			push	esi
			mov	edx,ebx
			lea	esi,HEXTabASCII
			lea	ebx,TempHEXNumber
			add	ebx,(1*2)+1
			dec	ebx
			mov	byte ptr [ebx],0		; Null
			movzx	ecx,dl
			mov	cx,[esi+ecx*2]
			sub	ebx,2
			mov	[ebx],cx
			invoke	GlobalAlloc,GMEM_FIXED,2+1	; xx+0
			lea	ecx,TempHEXNumber
			test	eax,eax
			jz	E46
			mov	ebx,eax
FinalizeHEXB:		mov	dl,[ecx]
			inc	ecx
			mov	[eax],dl
			inc	eax
			test	dl,dl
			jnz	FinalizeHEXB
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HEXW(EXPR) convert a numeric word expression X into a hexadecimal string.
FNC_HEXW:		mov	eax,WRAP_FNC_HEXW
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_HEXWCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	E44
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RoundHEXW
			fstcw	ExpFPUState1			; Round it to integer
			mov	ax,ExpFPUState1
			or	ax,110000000000b
			mov	ExpFPUState2,ax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
RoundHEXW:		push	ecx
			push	edx
			push	esi
			mov	edx,ebx
			lea	esi,HEXTabASCII
			lea	ebx,TempHEXNumber
			add	ebx,(2*2)+1
			dec	ebx
			mov	byte ptr [ebx],0		; Null
			movzx	ecx,dl
			mov	cx,[esi+ecx*2]
			sub	ebx,2
			mov	[ebx],cx
			shr	edx,8
			movzx	ecx,dl
			mov	cx,[esi+ecx*2]
			sub	ebx,2
			mov	[ebx],cx
			invoke	GlobalAlloc,GMEM_FIXED,4+1	; xxxx+0
			lea	ecx,TempHEXNumber
			test	eax,eax
			jz	E46
			mov	ebx,eax
FinalizeHEXW:		mov	dl,[ecx]
			inc	ecx
			mov	[eax],dl
			inc	eax
			test	dl,dl
			jnz	FinalizeHEXW
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HEXD(EXPR) convert a numeric dword expression X into a hexadecimal string.
FNC_HEXD:		mov	eax,WRAP_FNC_HEXD
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_HEXDCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	E44
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RoundHEXD
			fstcw	ExpFPUState1			; Round it to integer
			mov	ax,ExpFPUState1
			or	ax,110000000000b
			mov	ExpFPUState2,ax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
RoundHEXD:		push	ecx
			push	edx
			push	esi
			mov	edx,ebx
			lea	esi,HEXTabASCII
			lea	ebx,TempHEXNumber
			add	ebx,(4*2)+1
			dec	ebx
			mov	byte ptr [ebx],0		; Null
			movzx	ecx,dl
			mov	cx,[esi+ecx*2]
			sub	ebx,2
			mov	[ebx],cx
			shr	edx,8
			movzx	ecx,dl
			mov	cx,[esi+ecx*2]
			sub	ebx,2
			mov	[ebx],cx
			shr	edx,8
			movzx	ecx,dl
			mov	cx,[esi+ecx*2]
			sub	ebx,2
			mov	[ebx],cx
			shr	edx,8
			movzx	ecx,dl
			mov	cx,[esi+ecx*2]
			sub	ebx,2
			mov	[ebx],cx
			invoke	GlobalAlloc,GMEM_FIXED,8+1	; xxxxxxxx+0
			lea	ecx,TempHEXNumber
			test	eax,eax
			jz	E46
			mov	ebx,eax
FinalizeHEXD:		mov	dl,[ecx]
			inc	ecx
			mov	[eax],dl
			inc	eax
			test	dl,dl
			jnz	FinalizeHEXD
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; SPACE(EXPR) return a string filled with the number of spaces specified by EXPR.
FNC_SPACE:		mov	eax,WRAP_FNC_SPACE
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_SPACECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			js	E47
			push	ecx
			push	edx
			push	edi
			push	ebx
			inc	ebx				; +null
			invoke	GlobalAlloc,GMEM_FIXED,ebx
			test	eax,eax
			jz	E46
			pop	ecx				; (was ebx without null)
			mov	edi,eax
			mov	ebx,eax
			cld
			mov	eax,020202020h
			push	ecx
			shr	ecx,2
			rep	stosd				; fill it
			pop	ecx
			and	ecx,3
			rep	stosb
			mov	byte ptr [edi],0
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	edi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP
			align	16
E47:			mov	edi,offset Err47		; Error: <Positive value expected>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; LTRIM(EXPR) returns a string from expression EXPR with leading spaces stripped out.
FNC_LTRIM:		mov	eax,WRAP_FNC_LTRIM
			jmp	CompileFnc1Arg

			align	16
FNC_LTRIMCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	edx
			push	edi
			push	ecx
LoopStringLTRIM:	mov	al,[ebx]			; Search first non space char
			cmp	al," " 
			jne	StopStringLTRIM
			inc	ebx
			jmp	LoopStringLTRIM
			align	16
StopStringLTRIM:	test	al,al				; Last found char
			jnz	EmptyLTRIM			; was a null char ?
			; Create a null string
			invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0		; clear it
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP			; store it
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP
			align	16
EmptyLTRIM:		push	ebx
			mov	esi,ebx				; esi now points to first valid char
LoopStringLTRIMLEN:	mov	al,[esi]
			test	al,al
			je	StopStringLTRIMLEN
			inc	esi
			jmp	LoopStringLTRIMLEN
			align	16
StopStringLTRIMLEN:	sub	esi,ebx				; esi=String length
			push	esi				; allocate it
			inc	esi				; (null zero)
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax
			jz	E46
			pop	ecx				; (from esi)
			pop	esi				; (from ebx)
			mov	edi,eax
			cld
			push	ecx				; copy it
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; append null zero
			mov	ebx,eax				; start of string to store
			PUSHTMPSTRSTACKCOMP			; store it
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; RTRIM(EXPR) returns a string from expression EXPR with trailing spaces stripped out.
FNC_RTRIM:		mov	eax,WRAP_FNC_RTRIM
			jmp	CompileFnc1Arg

			align	16
FNC_RTRIMCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	edx
			push	edi
			push	ecx
			push	ebx
			mov	esi,ebx
LoopStringRTRIMLEN:	mov	al,[esi]
			test	al,al
			je	StopStringRTRIMLEN
			inc	esi
			jmp	LoopStringRTRIMLEN
			align	16
StopStringRTRIMLEN:	xchg	esi,ebx
			sub	ebx,esi				; String length
			test	ebx,ebx				; Empty string ?
			jnz	EmptyRTRIM
			; Create a null string
			pop	eax				; (from ebx to garbage)
SetRTRIMEmpty:		invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0		; clear it
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP			; store it
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP
			align	16
EmptyRTRIM:		pop	esi				; start of string
			mov	ecx,esi
			add	ecx,ebx				; add length
BackwardRTRIM:		dec	ecx				; (can't be zero)
			mov	al,[ecx]
			cmp	al," "
			jne	RightPosRTRIM
			cmp	esi,ecx				; Reached start of string ?
			jne	BackwardRTRIM			; No: continue...
			jmp	SetRTRIMEmpty			; Yes: it's filled with spaces
			align	16
RightPosRTRIM:		inc	ecx				; (replace on correct char)
			sub	ecx,esi				; ecx=real length
			push	ecx				; allocate it
			inc	ecx				; (null zero)
			invoke	GlobalAlloc,GMEM_FIXED,ecx
			test	eax,eax
			jz	E46
			pop	ecx
			mov	edi,eax
			cld
			push	ecx				; copy it
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; append null zero
			mov	ebx,eax				; start of string to store
			PUSHTMPSTRSTACKCOMP			; store it
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP
		
;-----------------------------------------------------------------------------------------------
; ISFLOAT(EXPR) returns 1 if expression resolves to a floating pointer number, 0 otherwise.
FNC_ISDOUBLE:		mov	eax,WRAP_FNC_ISDOUBLE
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_ISDOUBLECOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			xor	ebx,ebx
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	IsNotDouble
			inc	ebx
IsNotDouble:		POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ISINTEGER(EXPR) returns 1 if expression resolves to an integer number, 0 otherwise.
FNC_ISINTEGER:		mov	eax,WRAP_FNC_ISINTEGER
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_ISINTEGERCOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			xor	ebx,ebx
			cmp	ExprFinalResult,VAR_INTEGER
			jne	IsNotInteger
			inc	ebx
IsNotInteger:		POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; ISSTRING(EXPR) returns 1 if expression resolves to a string, 0 otherwise.
FNC_ISSTRING:		mov	eax,WRAP_FNC_ISSTRING
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_ISSTRINGCOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			xor	ebx,ebx
			cmp	ExprFinalResult,VAR_STRING
			jne	IsNotString
			inc	ebx
IsNotString:		POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; TRIM(EXPR) returns a string from expression EXPR with both leading and trailing spaces stripped out.
FNC_TRIM:		mov	eax,WRAP_FNC_TRIM
			jmp	CompileFnc1Arg

			align	16
FNC_TRIMCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	edx
			push	edi
			push	ecx
LoopStringTRIM:		mov	al,[ebx]			; Search first non space char
			cmp	al," " 
			jne	StopStringTRIM
			inc	ebx
			jmp	LoopStringTRIM
			align	16
StopStringTRIM:		test	al,al				; Last found char
			jnz	EmptyTRIM			; was a null char ?
			; Create a null string
SetTRIMEmpty:		invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0		; clear it
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP			; store it
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP
			align	16
EmptyTRIM:		mov	esi,ebx
LoopStringTRIMLEN:	mov	al,[esi]
			test	al,al
			je	StopStringTRIMLEN
			inc	esi
			jmp	LoopStringTRIMLEN
			align	16
StopStringTRIMLEN:	sub	esi,ebx				; esi=String length
			mov	ecx,esi
			add	ecx,ebx				; add start of string
BackwardTRIM:		dec	ecx				; (can't be zero)
			mov	al,[ecx]
			cmp	al," "
			jne	RightPosTRIM
			cmp	esi,ecx				; Reached start of string ?
			jne	BackwardTRIM			; No: continue...
			jmp	SetTRIMEmpty			; Yes: it's filled with spaces
			align	16
RightPosTRIM:		inc	ecx				; (replace on correct char)
			sub	ecx,ebx				; ecx=real length
			push	ebx
			push	ecx				; allocate it
			inc	ecx				; (null zero)
			invoke	GlobalAlloc,GMEM_FIXED,ecx
			test	eax,eax
			jz	E46
			pop	ecx				; (from esi)
			pop	esi				; (from ebx)
			mov	edi,eax
			cld
			push	ecx				; copy it
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; append null zero
			mov	ebx,eax				; start of string to store
			PUSHTMPSTRSTACKCOMP			; store it
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; MALLOC(EXPR) alloc a block of memory
FNC_MALLOC:		mov	eax,WRAP_FNC_MALLOC
			jmp	CompileFnc1Arg

			align	16
FNC_MALLOCCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			js	E47
			push	ecx
			push	edx
			inc	ebx
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,ebx
			test	eax,eax
			jz	E46
			mov	ebx,eax
			pop	edx
			pop	ecx
MALLOCZero:		jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; MFREE(EXPR) release a block of allocated memory
FNC_MFREE:		mov	eax,WRAP_FNC_MFREE
			jmp	CompileFnc1Arg

			align	16
FNC_MFREECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			jz	MFREEZero
			push	ecx
			push	edx
			invoke	GlobalFree,ebx
			mov	ebx,eax				; Return 0 or error
			pop	edx
			pop	ecx
MFREEZero:		jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; MREAD(EXPR) retrieve a byte from memory
FNC_MREAD:		mov	eax,WRAP_FNC_MREAD
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_MREADCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			je	MREADString
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
MREADString:		test	ebx,ebx
			jz	MREADZero
			movzx	ebx,byte ptr [ebx]
MREADZero:		jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; MREADW(EXPR) retrieve a word from memory
FNC_MREADW:		mov	eax,WRAP_FNC_MREADW
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_MREADWCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			je	MREADWString
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
MREADWString:		test	ebx,ebx
			jz	MREADWZero
			movzx	ebx,word ptr [ebx]
MREADWZero:		jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; MREADD(EXPR) retrieve a dword from memory
FNC_MREADD:		mov	eax,WRAP_FNC_MREADD
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_MREADDCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			je	MREADDString
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
MREADDString:		test	ebx,ebx
			jz	MREADDZero
			mov	ebx,[ebx]
MREADDZero:		jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STR(EXPR) returns a string representation of a numeric expression.
FNC_STR:		mov	eax,WRAP_FNC_STR
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_STRCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			push	ecx
			push	edx
			push	esi
			push	edi
			cmp	ExprFinalResult,VAR_STRING
			je	STRSaveConversion
			cmp	ExprFinalResult,VAR_INTEGER
			je	STRInt
			fstp	DblVal				; Get fp value
			invoke	DoubleToString,DblVal,15,addr DblTemp
			lea	ebx,DblTemp
			jmp	STRSaveConversion
			align	16
STRInt:			call	IntToString
			lea	ebx,dtemp1
STRSaveConversion:	mov	esi,ebx
LoopStringSTRLEN:	mov	al,[esi]
			test	al,al
			je	StopStringSTRLEN
			inc	esi
			jmp	LoopStringSTRLEN
			align	16
StopStringSTRLEN:	sub	esi,ebx
			push	ebx
			push	esi
			inc	esi
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax
			jz	E46
			pop	ecx				; (from esi)
			pop	esi				; (from ebx)
			mov	edi,eax
			cld
			push	ecx				; copy it
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; append null zero
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HIBYTE(EXPR) returns high 8 bits of a 16 bits integer expression.
FNC_HIBYTE:		mov	eax,WRAP_FNC_HIBYTE
			jmp	CompileFnc1Arg

			align	16
FNC_HIBYTECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			movzx	ebx,bh
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; HIWORD(EXPR) returns high 16 bits of a 32 bits integer expression.
FNC_HIWORD:		mov	eax,WRAP_FNC_HIWORD
			jmp	CompileFnc1Arg

			align	16
FNC_HIWORDCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			rol	ebx,16
			movzx	ebx,bx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LOBYTE(EXPR) returns low 8 bits of a 16 bits integer expression.
FNC_LOBYTE:		mov	eax,WRAP_FNC_LOBYTE
			jmp	CompileFnc1Arg

			align	16
FNC_LOBYTECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			movzx	ebx,bl
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LOWORD(EXPR) returns low 16 bits of a 32 bits integer expression.
FNC_LOWORD:		mov	eax,WRAP_FNC_LOWORD
			jmp	CompileFnc1Arg

			align	16
FNC_LOWORDCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			movzx	ebx,bx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; BSWAP(EXPR) swaps 8 bits values of a 32 bits integer expression.
FNC_BSWAP:		mov	eax,WRAP_FNC_BSWAP
			jmp	CompileFnc1Arg

			align	16
FNC_BSWAPCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			bswap	ebx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; WSWAP(EXPR) swaps 16 bits values of a 32 bits integer expression.
FNC_WSWAP:		mov	eax,WRAP_FNC_WSWAP
			jmp	CompileFnc1Arg

			align	16
FNC_WSWAPCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			ror	ebx,16
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FOPENR(EXPR) open a file for reading purposes.
FNC_FOPENR:		mov	eax,WRAP_FNC_FOPENR
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FOPENRCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	edx
			invoke	CreateFile,ebx,GENERIC_READ,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
			mov	ebx,eax
			pop	edx
			pop	ecx
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FCLOSE(EXPR) close an opened file.
FNC_FCLOSE:		mov	eax,WRAP_FNC_FCLOSE
			jmp	CompileFnc1Arg

			align	16
FNC_FCLOSECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ecx
			push	edx
			test	ebx,ebx
			jz	FCLOSEEmpty
			invoke	CloseHandle,ebx
FCLOSEEmpty:		mov	ebx,eax
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FOPENW(EXPR) open a file for writing purposes.
FNC_FOPENW:		mov	eax,WRAP_FNC_FOPENW
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FOPENWCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	edx
			invoke	CreateFile,ebx,GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
			mov	ebx,eax
			pop	edx
			pop	ecx
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FREAD(EXPR1,EXPR2,EXPR3) read from from an opened file.
FNC_FREAD:		mov	eax,WRAP_FNC_FREAD
			call	CompileFnc3Args
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FREADCOMP:		push	ecx
			call	GetFNCArgs			; File handle
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28				; Error: <Invalid argument>
			push	ebx
			call	EvalExprCOMP			; Dest memory
			cmp	ExprFinalResult,VAR_DOUBLE	; (can be a string or an int address)
			je	E19
			push	ebx
			call	GetFNCLastArgs			; Size
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	ecx				; (dest memory)
			pop	eax				; (file handle)
			push	edx
			mov	ReadAmount,0
			test	eax,eax
			jz	FREADEmpty
			test	ecx,ecx
			jz	FREADEmpty
			test	ebx,ebx
			jz	FREADEmpty
			invoke	ReadFile,eax,ecx,ebx,addr ReadAmount,0
FREADEmpty:		mov	ebx,ReadAmount
			pop	edx
			pop	ecx
			NORMALIZEOPERSTACKCOMP 2		; only two steps since EvalExprCOMP doesn't push forward
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FWRITE(EXPR1,EXPR2,EXPR3) write EXPR2 into an opened file EXPR1 for EXPR3 bytes.
FNC_FWRITE:		mov	eax,WRAP_FNC_FWRITE
			call	CompileFnc3Args
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FWRITECOMP:		push	ecx
			call	GetFNCArgs			; File handle
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28				; Error: <Invalid argument>
			push	ebx
			call	EvalExprCOMP			; Source memory
			cmp	ExprFinalResult,VAR_DOUBLE	; (can be a string or an int address)
			je	E19
			push	ebx
			call	GetFNCLastArgs			; Size
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	ecx				; (dest memory)
			pop	eax				; (file handle)
			push	edx
			mov	ReadAmount,0
			test	eax,eax
			jz	FWRITEEmpty
			test	ecx,ecx
			jz	FWRITEEmpty
			test	ebx,ebx				; Must be positive
			js	E47
			jz	FWRITEEmpty
			invoke	WriteFile,eax,ecx,ebx,addr ReadAmount,0
FWRITEEmpty:		mov	ebx,ReadAmount
			pop	edx
			pop	ecx
			NORMALIZEOPERSTACKCOMP 2
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FLEN(EXPR) return the length of a file.
FNC_FLEN:		mov	eax,WRAP_FNC_FLEN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FLENCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	edx
			invoke	CreateFile,ebx,GENERIC_READ,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
			mov	ecx,eax
			mov	ebx,eax
			cmp	ecx,INVALID_HANDLE_VALUE
			je	EmptyFLEN
			push	ecx
			invoke	GetFileSize,ecx,0
			pop	ecx
			mov	ebx,eax
			push	ebx
			invoke	CloseHandle,ecx
			pop	ebx
EmptyFLEN:		pop	edx
			pop	ecx
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FLOF(EXPR) return the length an opened file.
FNC_FLOF:		mov	eax,WRAP_FNC_FLOF
			jmp	CompileFnc1Arg

			align	16
FNC_FLOFCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ecx
			push	edx
			test	ebx,ebx
			jz	EmptyFLOF
			invoke	GetFileSize,ebx,0
			mov	ebx,eax
EmptyFLOF:		pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FCREATE(EXPR) erase a file and open it for writing purposes.
FNC_FCREATE:		mov	eax,WRAP_FNC_FCREATE
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FCREATECOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	edx
			invoke	CreateFile,ebx,GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
			mov	ebx,eax
			pop	edx
			pop	ecx
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FWRITE(EXPR1,EXPR2,EXPR3) write EXPR2 into an opened file EXPR1 for EXPR3 bytes
; and append a carriage return and a line feed.
FNC_FWRITELN:		mov	eax,WRAP_FNC_FWRITELN
			call	CompileFnc3Args
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FWRITELNCOMP:	push	ecx
			call	GetFNCArgs			; File handle
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28				; Error: <Invalid argument>
			push	ebx
			call	EvalExprCOMP			; Source memory
			cmp	ExprFinalResult,VAR_DOUBLE	; (can be a string or an int address)
			je	E19
			push	ebx
			call	GetFNCLastArgs			; Size
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	ecx				; (dest memory)
			pop	eax				; (file handle)
			push	edx
			mov	ReadAmount,0
			test	eax,eax
			jz	FWRITELNEmpty
			test	ecx,ecx
			jz	FWRITELNEmpty
			test	ebx,ebx
			js	E47
			jz	FWRITELNZero
			push	eax
			invoke	WriteFile,eax,ecx,ebx,addr ReadAmount,0
			test	eax,eax
			pop	eax
			jz	FWRITELNEmpty
FWRITELNZero:		; Specified length was 0
			invoke	WriteFile,eax,addr CrLfTxt,2,addr ReadAmountCrLf,0
			test	eax,eax
			jz	FWRITELNEmpty
			add	ReadAmount,2
FWRITELNEmpty:		mov	ebx,ReadAmount
			pop	edx
			pop	ecx
			NORMALIZEOPERSTACKCOMP 2
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FSEEK(EXPR1,EXPR2) set position EXPR2 inside a file EXPR1.
FNC_FSEEK:		mov	eax,WRAP_FNC_FSEEK
			jmp	CompileFnc2Args

			align	16
FNC_FSEEKCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
			call	GetFNCLastArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			pop	eax
			push	ecx
			push	edx
			test	eax,eax
			jz	@F
			invoke	SetFilePointer,eax,ebx,0,FILE_BEGIN	
@@:			mov	ebx,eax
			pop	edx
			pop	ecx
			NORMALIZEOPERSTACKCOMP 1		; Only one step coz we're sure that last arg is an integer
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRREVERSE(EXPR) reverse all letters of string EXPR.
FNC_STRREVERSE:		mov	eax,WRAP_FNC_STRREVERSE
			jmp	CompileFnc1Arg

			align	16
FNC_STRREVERSECOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	esi
			push	edx
			push	ebx
			mov	esi,ebx
GetSTRREVERSELen:	mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	GetSTRREVERSELen
			sub	esi,ebx				; String length
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax				; eax= temporary string
			jz	E46
			mov	ecx,esi
			pop	ebx				; ebx= string to copy		
			xor	edx,edx
			push	eax				; (we will restore it in ebx)
			add	eax,ecx				; Go to the end of the string
			dec	eax
			mov	byte ptr [eax],0		; Put null terminating char now
			dec	ecx				; (Don't reverse null char)
			jz	EmptySTRREVERSE			; Empty string ?
LoopSTRREVERSE:		mov	dl,[ebx]			; Reverse it
			inc	ebx
			dec	eax
			mov	[eax],dl
			dec	ecx
			jnz	LoopSTRREVERSE
EmptySTRREVERSE:	pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	edx
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; MID(EXPR1,EXPR2[,EXPR3]) Returns the specified number of chars EXPR3 from a string expression EXPR1 beginning at EXPR2
FNC_MID:		mov	eax,WRAP_FNC_MID
			call	CompileFnc3ArgsOpt3
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_MIDCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45				; Must be a string
			push	ecx
			push	esi
			push	edi
			mov	esi,ebx				; Get len now
GetMIDLen:		mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	GetMIDLen
			sub	esi,ebx
			push	esi				; Save len
			push	ebx				; Save string address
			call	EvalExprCOMP			; Get start in string
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx				; Must be >=1
			jz	E19
			js	E19
			push	ebx				; Save requested start
			mov	ebx,[esp+8]			; Default = string len
			cmp	byte ptr [edx],WRAP_CLOSEBRACKET ; No third argument ?
			jne	MID_2Args
			inc	edx
			NORMALIZEOPERSTACKCOMP 1		; (GetFNCArgs only)
			jmp	SetMID_2Args
			align	16
MID_2Args:		; Get string length
			call	GetFNCLastArgs			; Get size
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			NORMALIZEOPERSTACKCOMP 2		; (GetFNCArgs+GetFNCLastArgs)
			test	ebx,ebx				; Size must be positive
			js	E47				; or 0
			jz	EmptyMIDZero
			inc	ebx				; Add null char
SetMID_2Args:		mov	ecx,ebx				; ecx=length to copy
			pop	eax				; eax=start
			pop	esi				; esi=string address
			pop	ebx				; edx=string len
			push	edx				; (correct stack)
			mov	edx,ebx
			sub	edx,eax				; Get max of chars we can copy
			jle	EmptyMID
			inc	edx
			cmp	ecx,edx				; Bound requested length
			jb	PadMIDLen			; Requested greater size ?
			mov	ecx,edx				; Set max length
PadMIDLen:		push	eax
			push	ecx
			; Allocate dest string
			invoke	GlobalAlloc,GMEM_FIXED,ecx
			test	eax,eax
			jz	E46
			mov	edi,eax				; edi=dest string
			mov	ebx,eax
			pop	ecx				; (length)
			dec	ecx
			pop	eax				; (start)
			dec	eax				; (Start is 0 based)
			add	esi,eax				; Add start to string address
			cld					; Copy the string
			push	ecx				; (Also copy 0 padding)
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; Ensure null terminating string
			PUSHTMPSTRSTACKCOMP			; (Tmp string created)
			PUSHOPERSTACKSTRCOMP
			pop	edx
			pop	edi
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP
			align	16
EmptyMIDZero:		pop	eax				; (Garbage)
			pop	eax
			pop	eax
			push	edx				; (Correct stack)
EmptyMID:		; Return an empty string
			invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP			; (Tmp string created)
			PUSHOPERSTACKSTRCOMP
			pop	edx
			pop	edi
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LEFT(EXPR1,EXPR2) Return EXPR2 number of leading chars from string expression EXPR1
FNC_LEFT:		mov	eax,WRAP_FNC_LEFT
			call	CompileFnc2Args
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_LEFTCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45				; Must be a string
			push	ecx
			push	esi
			push	edi
			mov	esi,ebx				; Get len now
GetLEFTLen:		mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	GetLEFTLen
			sub	esi,ebx
			push	ebx				; Save string address
			push	esi				; Save len
			call	GetFNCLastArgs			; Get start in string
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx				; Must be >=0
			js	E47
			jz	EmptyLEFT
			pop	eax				; Length of string
			inc	ebx
			cmp	eax,ebx
			ja	PadLEFTLen
			mov	ebx,eax
PadLEFTLen:		pop	esi				; (start)
			push	edx
			push	ebx
			; Allocate dest string
			invoke	GlobalAlloc,GMEM_FIXED,ebx
			test	eax,eax
			jz	E46
			mov	edi,eax				; edi=dest string
			mov	ebx,eax
			pop	ecx				; (length)
			dec	ecx
			cld					; Copy the string
			push	ecx				; (Also copy 0 padding)
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; Ensure null terminating string
			NORMALIZEOPERSTACKCOMP 1
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP			; (Re-use last operand as a string)
			pop	edx
			pop	edi
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP
			align	16
EmptyLEFT:		pop	eax				; (Garbage)
			pop	eax
			; Return an empty string
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0
			mov	ebx,eax
			NORMALIZEOPERSTACKCOMP 1
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	edx
			pop	edi
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; RIGHT(EXPR1,EXPR2) Return EXPR2 number of trailing chars from string expression EXPR1
FNC_RIGHT:		mov	eax,WRAP_FNC_RIGHT
			call	CompileFnc2Args
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_RIGHTCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45				; Must be a string
			push	ecx
			push	esi
			push	edi
			mov	esi,ebx				; Get len now
GetRIGHTLen:		mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	GetRIGHTLen
			sub	esi,ebx
			push	ebx				; Save string address
			push	esi				; Save len
			call	GetFNCLastArgs			; Get start in string
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx				; Must be >=0
			js	E47
			jz	EmptyRIGHT
			pop	eax				; Length of string
			inc	ebx
			cmp	eax,ebx
			ja	PadRIGHTLen
			mov	ebx,eax
PadRIGHTLen:		pop	esi				; (start)
			push	edx
			push	ebx
			push	eax				; Save primary string length
			; Allocate dest string
			invoke	GlobalAlloc,GMEM_FIXED,ebx
			test	eax,eax
			jz	E46
			mov	edi,eax				; edi=dest string
			mov	ebx,eax
			pop	eax
			add	esi,eax
			pop	ecx				; (length)
			sub	esi,ecx
			cld					; Copy the string
			push	ecx
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			NORMALIZEOPERSTACKCOMP 1
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP			; (Re-use last operand as a string)
			pop	edx
			pop	edi
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP
			align	16
EmptyRIGHT:		pop	eax				; (Garbage)
			pop	eax
			; Return an empty string
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0
			mov	ebx,eax
			NORMALIZEOPERSTACKCOMP 1
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	edx
			pop	edi
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FLOC(EXPR) return the position in an opened file.
FNC_FLOC:		mov	eax,WRAP_FNC_FLOC
			jmp	CompileFnc1Arg

			align	16
FNC_FLOCCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ecx
			push	edx
			test	ebx,ebx
			jz	@F
			; Move 0:0 to obtain current position
			invoke	SetFilePointer,ebx,0,0,FILE_CURRENT
			mov	ebx,eax
@@:			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; BIN(EXPR) convert a 32 bits expression X into a binary string.
FNC_BIN:		mov	eax,WRAP_FNC_BIN
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_BINCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	E44
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RoundBIN
			fstcw	ExpFPUState1			; Round it to integer
			push	eax
			mov	ax,ExpFPUState1
			or	ax,110000000000b
			mov	ExpFPUState2,ax
			pop	eax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
RoundBIN:		push	ecx
			push	edx
			push	esi
			mov	edx,ebx
			lea	ebx,TempBINNumber
			mov	byte ptr [ebx],"0"		; At least 0
			mov	byte ptr [ebx+1],0		; Null
			test	edx,edx
			jz	NullBIN
			mov	eax,edx
GetBINLen:		inc	ebx				; +1 bit
			shr	eax,1
			jnz	GetBINLen
			mov	byte ptr [ebx],0		; Null
			dec	ebx
BINToAscii:		mov	ecx,edx
			and	ecx,01h
			add	ecx,030h			; +"0"
			mov	[ebx],cl
			dec	ebx
			shr	edx,1
			jnz	BINToAscii
NullBIN:		invoke	GlobalAlloc,GMEM_FIXED,32+1	; x*32+0
			lea	ecx,TempBINNumber
			test	eax,eax
			jz	E46
			mov	ebx,eax
FinalizeBIN:		mov	dl,[ecx]
			inc	ecx
			mov	[eax],dl
			inc	eax
			test	dl,dl
			jnz	FinalizeBIN
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; BINB(EXPR) convert a numeric byte expression X into a binary string.
FNC_BINB:		mov	eax,WRAP_FNC_BINB
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_BINBCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	E44
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RoundBINB
			fstcw	ExpFPUState1			; Round it to integer
			mov	ax,ExpFPUState1
			or	ax,110000000000b
			mov	ExpFPUState2,ax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
RoundBINB:		push	ecx
			push	edx
			push	esi
			movzx	ecx,bl
			push	ecx
			invoke	GlobalAlloc,GMEM_FIXED,8+1	; xxxxxxxx+0
			pop	ecx
			test	eax,eax
			jz	E46
			mov	ebx,eax
			lea	esi,BINTabASCII
			mov	edx,ecx
			and	edx,0fh
			and	ecx,0f0h
			shr	ecx,4				; f0->0f
			mov	edx,[esi+edx*4]
			mov	[eax+4],edx
			mov	ecx,[esi+ecx*4]
			mov	[eax],ecx
			mov	byte ptr [eax+8],0
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; BINW(EXPR) convert a numeric word expression X into a binary string.
FNC_BINW:		mov	eax,WRAP_FNC_BINW
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_BINWCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	E44
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RoundBINW
			fstcw	ExpFPUState1			; Round it to integer
			mov	ax,ExpFPUState1
			or	ax,110000000000b
			mov	ExpFPUState2,ax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
RoundBINW:		push	ecx
			push	edx
			push	esi
			push	edi
			movzx	ecx,bx
			push	ecx
			invoke	GlobalAlloc,GMEM_FIXED,16+1	; x*16+0
			pop	edi
			test	eax,eax
			jz	E46
			mov	ebx,eax
			lea	esi,BINTabASCII
			lea	eax,[eax+16]
			mov	byte ptr [eax],0
			lea	eax,[eax-4]
			mov	ecx,4
ConvertBINW:		mov	edx,edi
			and	edx,0fh
			mov	edx,[esi+edx*4]
			mov	[eax],edx
			sub	eax,4
			shr	edi,4
			dec	ecx
			jnz	ConvertBINW
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; BIND(EXPR) convert a numeric dword expression X into a binary string.
FNC_BIND:		mov	eax,WRAP_FNC_BIND
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_BINDCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_STRING
			je	E44
			cmp	ExprFinalResult,VAR_DOUBLE
			jne	RoundBIND
			fstcw	ExpFPUState1			; Round it to integer
			mov	ax,ExpFPUState1
			or	ax,110000000000b
			mov	ExpFPUState2,ax
			fldcw	ExpFPUState2
			frndint
			fldcw	ExpFPUState1
			fistp	DblToInt
			mov	ebx,DblToInt
RoundBIND:		push	ecx
			push	edx
			push	esi
			push	edi
			mov	ecx,ebx
			push	ecx
			invoke	GlobalAlloc,GMEM_FIXED,32+1	; x*32+0
			pop	edi
			test	eax,eax
			jz	E46
			mov	ebx,eax
			lea	esi,BINTabASCII
			lea	eax,[eax+32]
			mov	byte ptr [eax],0
			lea	eax,[eax-4]
			mov	ecx,8
ConvertBIND:		mov	edx,edi
			and	edx,0fh
			mov	edx,[esi+edx*4]
			mov	[eax],edx
			sub	eax,4
			shr	edi,4
			dec	ecx
			jnz	ConvertBIND
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP
			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRING(EXPR1,EXPR2) Return a string of length EXPR1 filled with the first char (byte) found in expression EXPR2.
FNC_STRING:		mov	eax,WRAP_FNC_STRING
			call	CompileFnc2Args
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_STRINGCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx				; Must be positive
			js	E47
			push	ebx				; Save length
			call	GetFNCLastArgs			; Get char to put
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E48
			pop	eax				; Retrieve len (from ebx)
			push	ecx
			push	edx
			push	edi
			push	ebx				; Save char
			push	eax
			inc	eax				; +null
			invoke	GlobalAlloc,GMEM_FIXED,eax
			test	eax,eax
			jz	E46
			pop	ecx				; (was ebx without null)
			pop	edx				; Datas (from ebx)
			mov	edi,eax
			mov	ebx,eax
			cld
			; Populates eax from a byte
			cmp	ExprFinalResult,VAR_STRING	; Second arg was a string
			jne	STRINGFromString
			movzx	eax,byte ptr [edx]		; Take first char in string
			mov	ah,al
			shl	eax,8
			mov	al,ah
			shl	eax,8
			mov	al,ah
			jmp	FillSTRING
			align	16
STRINGFromString:	movzx	eax,dl				; (From an integer)
			mov	ah,al
			shl	eax,8
			mov	al,ah
			shl	eax,8
			mov	al,ah
FillSTRING:		push	ecx
			shr	ecx,2
			rep	stosd				; fill it
			pop	ecx
			and	ecx,3
			rep	stosb
			mov	byte ptr [edi],0
			NORMALIZEOPERSTACKCOMP 1
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP			; (Make it a string)
			pop	edi
			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP
			align	16
E48:			mov	edi,offset Err48		; Error: <Integer value or string expected>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; FLOAD(EXPR) load a file into memory and return it's location or 0.
FNC_FLOAD:		mov	eax,WRAP_FNC_FLOAD
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FLOADCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	edx
			invoke	CreateFile,ebx,GENERIC_READ,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
			mov	ecx,eax
			mov	ebx,eax				; (Return value)
			cmp	ecx,INVALID_HANDLE_VALUE
			je	EmptyFLOAD
			push	ecx
			invoke	GetFileSize,ecx,0
			pop	ecx
			push	eax
			push	ecx
			inc	eax
			; Allocate required memory
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
			test	eax,eax
			jz	E46
			pop	ecx				; File handle
			pop	ebx				; length (from eax)
			push	ecx				; (Save file handle)
			push	eax				; (Save memory location)
			push	ebx				; (Bytes to read)
			invoke	ReadFile,ecx,eax,ebx,addr dtemp2,0
			pop	ebx
			pop	eax				; Allocated memory
			cmp	dtemp2,ebx			; Check bytes
			je	FLOADRead
			invoke	GlobalFree,eax
			xor	eax,eax				; Report 0
FLOADRead:		pop	ebx				; (File handle from ecx)
			push	eax
			invoke	CloseHandle,ebx
			pop	ebx				; (Mem location as return value)
EmptyFLOAD:		pop	edx
			pop	ecx
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FSAVE(EXPR1,EXPR2,EXPR3) save memory EXPR2 with length of EXPR3 into file EXPR1.
FNC_FSAVE:		mov	eax,WRAP_FNC_FSAVE
			call	CompileFnc3Args
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_FSAVECOMP:		push	ecx
			call	GetFNCArgs			; Filename
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx				; (Save filename)
			call	EvalExprCOMP			; Memory location
			cmp	ExprFinalResult,VAR_DOUBLE	; (can be a string or an int address)
			je	E19
			push	ebx				; (Save mem location)
			call	GetFNCLastArgs			; Get char to put
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			jz	E47				; size must be >0
			js	E47
			pop	ecx				; (Mem location from ebx)
			pop	eax				; (Filename from ebx)
			test	ecx,ecx				; Empty mem location ?
			jz	EmptyFSAVE
			test	eax,eax				; Empty filename ?
			jz	EmptyFSAVE
			push	ebx				; (Save size)
			push	ecx				; (Mem loc)
			push	edx
			invoke	CreateFile,eax,GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
			pop	edx
			pop	ebx				; (Mem location from ecx)
			pop	ecx				; (Size)
			cmp	eax,INVALID_HANDLE_VALUE
			je	EmptyFSAVE
			push	eax
			push	edx
			invoke	WriteFile,eax,ebx,ecx,addr dtemp2,0
			pop	edx
			pop	eax
			push	edx
			invoke	CloseHandle,eax
			pop	edx
			mov	ebx,dtemp2			; Report written bytes
			NORMALIZEOPERSTACKCOMP 1		; (GetFNCArgs)
			POKEOPERSTACKINTCOMP
			pop	ecx
			jmp	FinalizeFncCOMP
			align	16
EmptyFSAVE:		or	ebx,-1
			NORMALIZEOPERSTACKCOMP 1		; (GetFNCArgs)
			POKEOPERSTACKINTCOMP
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; CINT(EXPR) Forces the type of an expression to be an integer.
FNC_CINT:		mov	eax,WRAP_FNC_CINT
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_CINTCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; CSTR(EXPR) Forces the type of an expression to be a string.
FNC_CSTR:		mov	eax,WRAP_FNC_CSTR
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_CSTRCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E37
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			POKEOPERSTACKSTRCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; FEOF(EXPR) return 1 if the end of an opened file has been reached or 0.
FNC_FEOF:		mov	eax,WRAP_FNC_FEOF
			jmp	CompileFnc1Arg

			align	16
FNC_FEOFCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ecx
			push	edx
			test	ebx,ebx
			jz	@F
			push	ebx
			invoke	GetFileSize,ebx,0
			pop	ebx
			push	eax			; (Save length)
			invoke	SetFilePointer,ebx,0,0,FILE_CURRENT
			pop	ecx
			xor	ebx,ebx			; 0
			cmp	ecx,eax			; Compare position with length
			jne	@F
			inc	ebx			; 1
@@:			pop	edx
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRROTATEL(EXPR) rotate a string from right to left.
FNC_STRROTATEL:		mov	eax,WRAP_FNC_STRROTATEL
			jmp	CompileFnc1Arg

			align	16
FNC_STRROTATELCOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	esi
			push	edx
			push	ebx
			mov	esi,ebx
@@:			mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	@B
			sub	esi,ebx				; String length
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax				; eax= temporary string
			jz	E46
			mov	ecx,esi
			mov	ebx,eax
			pop	esi				; ebx= string to rotate
			mov	edi,eax
			dec	ecx				; -1
			jle	@F				; empty or 1 char ?
			mov	al,[esi]			; save first char
			cld
			inc	esi				; 2nd source char
			push	ecx				; (Also copy 0 padding)
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			dec	edi
			mov	[edi],al			; 1st char=last char
			inc	edi
@@:			mov	byte ptr [edi],0		; Ensure null terminating string
			PUSHTMPSTRSTACKCOMP
			pop	edx
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRROTATER(EXPR) rotate a string from left to right.
FNC_STRROTATER:		mov	eax,WRAP_FNC_STRROTATER
			jmp	CompileFnc1Arg

			align	16
FNC_STRROTATERCOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	esi
			push	edx
			push	ebx
			mov	esi,ebx
@@:			mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	@B
			sub	esi,ebx				; String length
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax				; eax= temporary string
			jz	E46
			mov	ecx,esi
			mov	ebx,eax
			pop	esi				; ebx= string to rotate
			mov	edi,eax
			dec	ecx				; -1
			jle	@F				; empty or 1 char ?
			cld
			inc	edi				; 2nd dest char
			push	ecx				; (Also copy 0 padding)
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			dec	esi
			mov	al,[esi]			; get last char
			mov	[ebx],al			; last char=1st char
			dec	edi
@@:			mov	byte ptr [edi],0		; Ensure null terminating string
			PUSHTMPSTRSTACKCOMP
			pop	edx
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; INSTR(EXPR1,EXPR2,EXPR3,EXPR4) search the first EXPR3 occurence in EXPR2 starting at EXPR1
; (EXPR4 = case sensitive ON/OFF)
FNC_INSTR:		mov	eax,WRAP_FNC_INSTR
			call	CompileFnc4ArgsOpt4
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_INSTRCOMP:		push	ecx
			push	esi
			call	GetFNCArgs			; Starting position
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
			call	EvalExprCOMP			; String
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx
			call	EvalExprCOMP			; String to search
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx
			cmp	byte ptr [edx],WRAP_CLOSEBRACKET ; No fourth argument ?
			jne	INSTR_4Args
			inc	edx
			xor	ebx,ebx
			NORMALIZEOPERSTACKCOMP 1		; (GetFNCArgs)
			jmp	PerformINSTR
			align	16
INSTR_4Args:		call	GetFNCLastArgs			; Case sensitive ON/OFF
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			NORMALIZEOPERSTACKCOMP 2		; (GetFNCArgs+GetFNCLastArgs)
PerformINSTR:		push	ebx
			push	edx				; Save pcode pointer (Add 4)
			mov	ecx,[esp+12+4]			; Start pos
			test	ecx,ecx	
			jz	E47				; pos must be >0
			js	E47
			mov	ebx,[esp+8+4]			; Calc main string len
			mov	esi,ebx
LoopStringLenINSTR:	mov	al,[esi]
			inc	esi
			test	al,al
			jnz	LoopStringLenINSTR
			dec	esi				; Remove 0
			sub	esi,ebx				; Main string len
			jz	StringEnd
			cmp	ecx,esi				; Start pos >= strlen ?
			jae	StringEnd
			mov	edx,esi				; edx=len
			mov	ebx,[esp+4+4]			; Get sub string len
			mov	esi,ebx
LoopSubStringLenINSTR:	mov	al,[esi]
			inc	esi
			test	al,al
			jnz	LoopSubStringLenINSTR
			dec	esi				; Remove 0
			sub	esi,ebx				; Sub string len
			jz	StringEnd
			mov	eax,[esp+4]			; Case sensitive ?
			test	eax,eax
			jz	INSTRCaseSens
			; If case sensitive search is wanted
			; Use two uppercase strings
			mov	ecx,edx
			inc	ecx				; +null
			push	ecx
			invoke	GlobalAlloc,GMEM_FIXED,ecx	; Main string
			pop	ecx
			test	eax,eax
			jz	E46
			; Copy main string
			mov	ebx,eax
			mov	eax,esi				; Sub string len
			mov	esi,[esp+8+4]			; Old main string
			mov	[esp+8+4],ebx			; New main string
			lea	edi,CharTableUpper
			xor	edx,edx
INSTRUpperCaseMainStr:	mov	dl,[esi]
			inc	esi
			mov	dl,[edi+edx]
			mov	[ebx],dl
			inc	ebx
			dec	ecx
			jnz	INSTRUpperCaseMainStr
			mov	ecx,eax				; Get sub string len
			mov	esi,eax
			inc	ecx
			push	ecx
			invoke	GlobalAlloc,GMEM_FIXED,ecx	; Sub string
			test	eax,eax
			jz	E46
			pop	ecx				; (Restore len)
			mov	ebx,eax
			mov	eax,[esp+4+4]			; Old sub string
			mov	[esp+4+4],ebx			; New sub string
			lea	edi,CharTableUpper
			xor	edx,edx
INSTRUpperCaseSubStr:	mov	dl,[eax]
			inc	eax
			mov	dl,[edi+edx]
			mov	[ebx],dl
			inc	ebx
			dec	ecx
			jnz	INSTRUpperCaseSubStr
INSTRCaseSens:		mov	edx,[esp+4+4]			; Sub string
			mov	bl,[edx]			; Save first substring char in bl
			mov	edi,[esp+8+4]			; Main string
			add	edi,[esp+12+4]			; Start pos
			dec	edi				; Start pos is 1 based
SeekFirstChar:		mov	al,[edi]			; Search for first char
			inc	edi				; Load char
			test	al,al				; End of string ?
			jz	StringEnd
			cmp	al,bl
			je	FoundFirstChar
			jmp	SeekFirstChar
			align	16
StringEnd:		xor	ebx,ebx				; Not found: return 0
			jmp	SearchStrExit
			align	16
FoundFirstChar:		mov	ecx,esi				; Sub string len
			push	edi
			push	esi
			mov	esi,edi				; Main string
			dec	esi
			mov	edi,edx				; Sub string
			cld
			repe	cmpsb
			pop	esi
			pop	edi
			jnz	SeekFirstChar
			sub	edi,[esp+8+4]			; Main string
			mov	ebx,edi				; Found pos
SearchStrExit:		pop	edx				; Restore text pointer
			add	esp,(4*4)			; Align stack
			call	PushOperStackIntCOMP
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRCMP(EXPR1,EXPR2,EXPR3) compare string EXPR1 with string EXPR2.
; (EXPR3 = case sensitive ON/OFF)
FNC_STRCMP:		mov	eax,WRAP_FNC_STRCMP
			call	CompileFnc3ArgsOpt3
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_STRCMPCOMP:		push	ecx
			call	GetFNCArgs			; First string
			cmp	ExprFinalResult,VAR_STRING
			jne	E45				; Error: <Invalid argument>
			push	ebx
			call	EvalExprCOMP			; Second string
			cmp	ExprFinalResult,VAR_STRING	; (can be a string or an int address)
			jne	E45
			push	ebx
			cmp	byte ptr [edx],WRAP_CLOSEBRACKET ; No third argument ?
			jne	STRCMP_3Args
			inc	edx
			xor	ebx,ebx
			NORMALIZEOPERSTACKCOMP 1
			jmp	PerformSTRCMP			
			align	16
STRCMP_3Args:		call	GetFNCLastArgs			; Comparison type
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			NORMALIZEOPERSTACKCOMP 2		; only two steps since EvalExprCOMP doesn't push forward
PerformSTRCMP:		pop	ecx				; (Second string)
			pop	eax				; (First string)
			push	edx
			test	ebx,ebx
			jz	STRCMPCaseSens
			invoke	lstrcmpi,eax,ecx		; Not case sensitive
			mov	ebx,eax
			pop	edx
			pop	ecx
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP
			align	16
STRCMPCaseSens:		invoke	lstrcmp,eax,ecx			; Case sensitive
			mov	ebx,eax
			pop	edx
			pop	ecx
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRPADL(EXPR1,EXPR2,EXPR3[,EXPR4])
; Insert first char of EXPR3 with EXPR2 size before string EXPR1
; with no more than optional EXPR4 integer number.
FNC_STRPADL:		mov	eax,WRAP_FNC_STRPADL
			call	CompileFnc4ArgsOpt4
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_STRPADLCOMP:	push	esi
			push	ecx
			call	GetFNCArgs			; Main string
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx				; Main string address
			mov	esi,ebx
LoopStringSTRPADL:	mov	al,[esi]
			inc	esi				; +null in len
			test	al,al
			jnz	LoopStringSTRPADL
			dec	esi
			sub	esi,ebx
			push	esi				; Save length of main string
			call	EvalExprCOMP			; Number of chars
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx				; Must be positive
			js	E47
			push	ebx
			call	EvalExprCOMP			; Char to duplicate
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E48
			cmp	ExprFinalResult,VAR_STRING
			jne	STRPADLString
			movzx	ebx,byte ptr [ebx]		; Take first char in string
STRPADLString:		push	ebx
			cmp	byte ptr [edx],WRAP_CLOSEBRACKET ; No fourth argument ?
			jne	STRPADL_4Args
			inc	edx
			xor	ebx,ebx				; Impossible value
			NORMALIZEOPERSTACKCOMP 1		; (GetFNCArgs)
			jmp	PerformSTRPADL
			align	16
STRPADL_4Args:		call	GetFNCLastArgs			; Case sensitive ON/OFF
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			NORMALIZEOPERSTACKCOMP 2		; (GetFNCArgs+GetFNCLastArgs)
			test	ebx,ebx				; Number of char allowed
			jz	E47				; must be >0
			js	E47
PerformSTRPADL:		mov	eax,ebx
			pop	ebx
			mov	bh,bl				; Populate it
			shl	ebx,8
			mov	bl,bh
			shl	ebx,8
			mov	bl,bh
			push	edx
			push	ebx				; Save char
			mov	ebx,[esp+8]			; Get number of chars to duplicate
			add	ebx,[esp+12]			; Add main string length
			test	eax,eax				; No size specified
			jz	Max_STRPADL			; Proceed...
			cmp	ebx,eax
			jbe	Max_STRPADL
			cmp	eax,[esp+12]
			ja	Null_STRPADL
			; Return original string if no chars could be added
			pop	eax				; Char (was ebx)
			pop	edx				; Pointer
			pop	ecx				; Nbr of chars
			pop	ecx				; Main string len
			pop	ebx				; Main string
			pop	eax				; (garbage)
			pop	eax
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP			; (Make it a string)
			jmp	FinalizeFncCOMP
			align	16
Null_STRPADL:		; Truncate (slow: should be revised)
LoopTruncate_STRPADL:	dec	dword ptr [esp+8]
			mov	ebx,[esp+8]			; Get number of chars to duplicate
			add	ebx,[esp+12]			; Add main string length
			cmp	ebx,eax
			ja	LoopTruncate_STRPADL
Max_STRPADL:		inc	ebx				; Don't allow zero len
			invoke	GlobalAlloc,GMEM_FIXED,ebx
			test	eax,eax
			jz	E46
			mov	edi,eax
			mov	ebx,eax				; Dest string
			pop	eax				; Char (was ebx)
			pop	edx				; Pointer
			pop	ecx				; Nbr of chars
			cld
			; Set leading chars
			push	ecx
			shr	ecx,2
			rep	stosd				; fill it
			pop	ecx
			and	ecx,3
			rep	stosb
			; Append main string
			pop	ecx				; Main string len
			pop	esi				; Main string
			push	ecx				; Append main string
			shr	ecx,2
			rep	movsd				; fill it
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; Append null char
			NORMALIZEOPERSTACKCOMP 1
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP			; (Make it a string)
			pop	ecx
			pop	esi
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRPADR(EXPR1,EXPR2,EXPR3) 
; Append first char of EXPR3 with EXPR2 size after string EXPR1
; with no more than optional EXPR4 integer number.
FNC_STRPADR:		mov	eax,WRAP_FNC_STRPADR
			call	CompileFnc4ArgsOpt4
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_STRPADRCOMP:	push	esi
			push	ecx
			call	GetFNCArgs			; Main string
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx				; Main string address
			mov	esi,ebx
LoopStringSTRPADR:	mov	al,[esi]
			inc	esi				; +null in len
			test	al,al
			jnz	LoopStringSTRPADR
			dec	esi
			sub	esi,ebx
			push	esi				; Save length of main string
			call	EvalExprCOMP			; Number of chars
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx				; Must be positive
			js	E47
			push	ebx
			call	EvalExprCOMP			; Char to duplicate
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E48
			cmp	ExprFinalResult,VAR_STRING
			jne	STRPADRString
			movzx	ebx,byte ptr [ebx]		; Take first char in string
STRPADRString:		push	ebx
			cmp	byte ptr [edx],WRAP_CLOSEBRACKET ; No fourth argument ?
			jne	STRPADR_4Args
			inc	edx
			xor	ebx,ebx				; Impossible value
			NORMALIZEOPERSTACKCOMP 1		; (GetFNCArgs)
			jmp	PerformSTRPADR
			align	16
STRPADR_4Args:		call	GetFNCLastArgs			; Case sensitive ON/OFF
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			NORMALIZEOPERSTACKCOMP 2		; (GetFNCArgs+GetFNCLastArgs)
			test	ebx,ebx				; Number of char allowed
			jz	E47				; must be >0
			js	E47
PerformSTRPADR:		mov	eax,ebx
			pop	ebx
			mov	bh,bl				; Populate it
			shl	ebx,8
			mov	bl,bh
			shl	ebx,8
			mov	bl,bh
			push	edx
			push	ebx				; Save char
			mov	ebx,[esp+8]			; Get number of chars to duplicate
			add	ebx,[esp+12]			; Add main string length
			test	eax,eax				; No size specified
			jz	Max_STRPADR			; Proceed...
			cmp	ebx,eax
			jbe	Max_STRPADR
			cmp	eax,[esp+12]
			ja	Null_STRPADR
			; Return original string if no chars could be added
			pop	eax				; Char (was ebx)
			pop	edx				; Pointer
			pop	ecx				; Nbr of chars
			pop	ecx				; Main string len
			pop	ebx				; Main string
			pop	eax				; (garbage)
			pop	eax
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP			; (Make it a string)
			jmp	FinalizeFncCOMP
			align	16
Null_STRPADR:		; Truncate (slow: should be revised)
LoopTruncate_STRPADR:	dec	dword ptr [esp+8]
			mov	ebx,[esp+8]			; Get number of chars to duplicate
			add	ebx,[esp+12]			; Add main string length
			cmp	ebx,eax
			ja	LoopTruncate_STRPADR
Max_STRPADR:		inc	ebx				; Don't allow zero len
			invoke	GlobalAlloc,GMEM_FIXED,ebx
			test	eax,eax
			jz	E46
			mov	edi,eax
			mov	ebx,eax				; Dest string
			pop	eax				; Char (was ebx)
			pop	edx				; Pointer
			; Append main string
			mov	ecx,[esp+4]			; Main string len
			mov	esi,[esp+8]			; Main string
			push	ecx				; Append main string
			shr	ecx,2
			cld
			rep	movsd				; fill it
			pop	ecx
			and	ecx,3
			rep	movsb
			;dec	edi				; Remove null char
			pop	ecx				; Nbr of chars
			; Set leading chars
			push	ecx
			shr	ecx,2
			rep	stosd				; fill it
			pop	ecx
			and	ecx,3
			rep	stosb
			mov	byte ptr [edi],0		; Append null char
			pop	eax				; To garbage
			pop	eax
			NORMALIZEOPERSTACKCOMP 1
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP			; (Make it a string)
			pop	ecx
			pop	esi
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRPAD(EXPR1,EXPR2,EXPR3[,EXPR4])
; Insert first char of EXPR3 with EXPR2 size before and after string EXPR1
; with no more than optional EXPR4 integer number.
FNC_STRPAD:		mov	eax,WRAP_FNC_STRPAD
			call	CompileFnc4ArgsOpt4
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_STRPADCOMP:		push	esi
			push	ecx
			call	GetFNCArgs			; Main string
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx				; Main string address
			mov	esi,ebx
LoopStringSTRPAD:	mov	al,[esi]
			inc	esi
			test	al,al
			jnz	LoopStringSTRPAD
			dec	esi
			sub	esi,ebx
			push	esi				; Save length of main string
			call	EvalExprCOMP			; Number of chars
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx				; Must be positive
			js	E47
			push	ebx
			call	EvalExprCOMP			; Char to duplicate
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E48
			cmp	ExprFinalResult,VAR_STRING
			jne	STRPADString
			movzx	ebx,byte ptr [ebx]		; Take first char in string
STRPADString:		push	ebx
			cmp	byte ptr [edx],WRAP_CLOSEBRACKET ; No fourth argument ?
			jne	STRPAD_4Args
			inc	edx
			xor	ebx,ebx				; Impossible value
			NORMALIZEOPERSTACKCOMP 1		; (GetFNCArgs)
			jmp	PerformSTRPAD
			align	16
STRPAD_4Args:		call	GetFNCLastArgs			; Case sensitive ON/OFF
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			NORMALIZEOPERSTACKCOMP 2		; (GetFNCArgs+GetFNCLastArgs)
			test	ebx,ebx				; Number of char allowed
			jz	E47				; must be >0
			js	E47
PerformSTRPAD:		mov	eax,ebx
			test	eax,1
			jnz	E35
			pop	ebx
			mov	bh,bl				; Populate it
			shl	ebx,8
			mov	bl,bh
			shl	ebx,8
			mov	bl,bh
			push	edx
			push	ebx				; Save char
			mov	ebx,[esp+8]			; Get number of chars to duplicate
			add	ebx,ebx
			add	ebx,[esp+12]			; Add main string length
			test	eax,eax				; No size specified
			jz	Max_STRPAD			; Proceed...
			cmp	ebx,eax
			jbe	Max_STRPAD
			cmp	eax,[esp+12]
			ja	Null_STRPAD
			; Return original string if no chars could be added
			pop	eax				; Char (was ebx)
			pop	edx				; Pointer
			pop	ecx				; Nbr of chars
			pop	ecx				; Main string len
			pop	ebx				; Main string
			pop	eax				; (garbage)
			pop	eax
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP			; (Make it a string)
			jmp	FinalizeFncCOMP
			align	16
Null_STRPAD:		; Truncate (slow: should be revised)
LoopTruncate_STRPAD:	dec	dword ptr [esp+8]
			mov	ebx,[esp+8]			; Get number of chars to duplicate
			add	ebx,ebx
			add	ebx,[esp+12]			; Add main string length
			cmp	ebx,eax
			ja	LoopTruncate_STRPAD
Max_STRPAD:		inc	ebx				; Don't allow zero len
			invoke	GlobalAlloc,GMEM_FIXED,ebx
			test	eax,eax
			jz	E46
			mov	edi,eax
			mov	ebx,eax				; Dest string
			pop	eax				; Char (was ebx)
			pop	edx				; Pointer
			pop	ecx				; Nbr of chars
			mov	esi,ecx				; Save len
			cld
			; Set leading chars
			push	ecx
			shr	ecx,2
			rep	stosd				; fill it
			pop	ecx
			and	ecx,3
			rep	stosb
			; Set trailing chars
			mov	ecx,[esp]			; Main string len
			push	edi
			lea	edi,[edi+ecx]
			mov	ecx,esi
			push	ecx
			shr	ecx,2
			rep	stosd				; fill it
			pop	ecx
			and	ecx,3
			rep	stosb
			mov	byte ptr [edi],0		; Append null terminating char
			pop	edi
			; Append main string
			pop	ecx				; Main string len
			pop	esi				; Main string
			push	ecx				; Append main string
			shr	ecx,2
			rep	movsd				; fill it
			pop	ecx
			and	ecx,3
			rep	movsb
			NORMALIZEOPERSTACKCOMP 1
			PUSHTMPSTRSTACKCOMP
			POKEOPERSTACKSTRCOMP			; (Make it a string)
			pop	ecx
			pop	esi
			jmp	FinalizeFncCOMP
E35:			mov	edi,offset Err35		; else, error <Even value expected>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; STRTTOS(EXPR) replace all tabs of string EXPR with spaces.
FNC_STRTTOS:		mov	eax,WRAP_FNC_STRTTOS
			jmp	CompileFnc1Arg

			align	16
FNC_STRTTOSCOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	esi
			push	edx
			push	ebx
			mov	esi,ebx
LoopStringLenSTRTTOS:	mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	LoopStringLenSTRTTOS
			sub	esi,ebx				; String length
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax				; eax= temporary string
			jz	E46
			mov	ecx,esi
			pop	ebx				; ebx= string to copy		
			lea	esi,CharTableTTOS
			xor	edx,edx
			push	eax				; (we will restore it in ebx)
PutSTRTTOS:		mov	dl,[ebx]
			inc	ebx
			mov	dl,[esi+edx]			; work with a null zero
			mov	[eax],dl
			inc	eax
			dec	ecx
			jnz	PutSTRTTOS
			pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	edx
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRSTOT(EXPR) replace all spaces of string EXPR with tabs.
FNC_STRSTOT:		mov	eax,WRAP_FNC_STRSTOT
			jmp	CompileFnc1Arg

			align	16
FNC_STRSTOTCOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ecx
			push	esi
			push	edx
			push	ebx
			mov	esi,ebx
LoopStringLenSTRSTOT:	mov	al,[esi]
			inc	esi				; work with a null zero (1=min)
			test	al,al
			jnz	LoopStringLenSTRSTOT
			sub	esi,ebx				; String length
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax				; eax= temporary string
			jz	E46
			mov	ecx,esi
			pop	ebx				; ebx= string to copy		
			lea	esi,CharTableSTOT
			xor	edx,edx
			push	eax				; (we will restore it in ebx)
PutSTRSTOT:		mov	dl,[ebx]
			inc	ebx
			mov	dl,[esi+edx]			; work with a null zero
			mov	[eax],dl
			inc	eax
			dec	ecx
			jnz	PutSTRSTOT
			pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	edx
			pop	esi
			pop	ecx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; STRLINES(EXPR) returns the number of lines of a string expression.
FNC_STRLINES:		mov	eax,WRAP_FNC_STRLINES
			call	CompileFnc1Arg
			invoke	PushOperStack,VAR_INTEGER
			ret

			align	16
FNC_STRLINESCOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			call	FNC_STRLINESCODE
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

			; (Re-used to load ascii files)
			align	16
FNC_STRLINESCODE:	push	esi
			mov	esi,ebx
			xor	eax,eax
			xor	ebx,ebx
CountSTRLINES:		mov	al,[esi]
			inc	esi
			cmp	al,13			; Pass over
			je	NextCharSTRLINES
			cmp	al,10			; Count as line
			jne	NextCharSTRLINES
			inc	ebx
NextCharSTRLINES:	test	al,al
			jnz	CountSTRLINES
			inc	ebx
			pop	esi
			ret

;-----------------------------------------------------------------------------------------------
; BITCOUNT(EXPR) Count the number of bits set in EXPR
FNC_BITCOUNT:		mov	eax,WRAP_FNC_BITCOUNT
			jmp	CompileFnc1Arg

			align	16
FNC_BITCOUNTCOMP:	call	GetFNCArgs			; Integer to test
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	edx
			mov	eax,ebx
			and	eax,055555555h
			shr	ebx,1
			and	ebx,055555555h
			add	eax,ebx
			mov	ebx,eax
			and	eax,033333333h
			shr	ebx,2
			and	ebx,033333333h
			add	eax,ebx
			mov	ebx,eax
			and	eax,00f0f0f0fh
			shr	ebx,4
			and	ebx,00f0f0f0fh
			add	eax,ebx
			cdq
			mov	ebx,255
			div	ebx
			xchg	ebx,edx
			pop	edx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; BITTST(EXPR1,EXPR2) Test bit specified by EXPR2 in EXPR1
FNC_BITTST:		mov	eax,WRAP_FNC_BITTST
			jmp	CompileFnc2Args

			align	16
FNC_BITTSTCOMP:		call	GetFNCArgs			; Integer to test
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			push	ebx
			call	GetFNCLastArgs			; Bit to test
			pop	eax
			test	ebx,ebx				; >=0
			js	E47
			cmp	ebx,31				; <=31
			ja	E3
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			and	eax,[Bits_MaskTable+ebx*4]
			jz	BITTST_Set
			xor	ebx,ebx
			inc	ebx
			NORMALIZEOPERSTACKCOMP 1
			jmp	FinalizeFncCOMP
			align	16
BITTST_Set:		xor	ebx,ebx
			NORMALIZEOPERSTACKCOMP 1
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; UBOUND(ARRAYNAME()) returns the maximum index of an array.
FNC_UBOUND:		mov	eax,WRAP_FNC_UBOUND
			jmp	CompileFnc1Arg

			align	16
FNC_UBOUNDCOMP:		call	GetArrayBounds
			mov	al,[edx]			; Must finish here
			cmp	al,WRAP_CLOSEBRACKET		; (Special case)
			jne	E40
			inc	edx
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LBOUND(ARRAYNAME()) returns the minimum index of an array.
FNC_LBOUND:		mov	eax,WRAP_FNC_LBOUND
			jmp	CompileFnc1Arg

			align	16
FNC_LBOUNDCOMP:		call	GetArrayBounds
			mov	al,[edx]			; Must finish here
			cmp	al,WRAP_CLOSEBRACKET		; (Special case)
			jne	E40
			inc	edx
			mov	ebx,eax
			POKEOPERSTACKINTCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; DATE returns the current system date.
FNC_DATE:		mov	eax,WRAP_FNC_DATE
			jmp	CompileFnc1Arg

			align	16
FNC_DATECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			push	edx
			push	ecx
			invoke	GetLocalTime,addr SysDt
			invoke	GetDateFormat,LOCALE_USER_DEFAULT,DATE_SHORTDATE,addr SysDt,0,0,0
			mov	ecx,eax
			push	ecx
			inc	eax
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
			pop	ecx
			mov	ebx,eax
			test	eax,eax
			jz	E46
			push	ebx
			invoke	GetDateFormat,LOCALE_USER_DEFAULT,DATE_SHORTDATE,addr SysDt,0,ebx,ecx
			pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	ecx
			pop	edx
			PUSHOPERSTACKSTRCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; TIME returns the current system time.
FNC_TIME:		mov	eax,WRAP_FNC_TIME
			jmp	CompileFnc1Arg

			align	16
FNC_TIMECOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			push	edx
			push	ecx
			invoke	GetLocalTime,addr SysDt
			invoke	GetTimeFormat,LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT,addr SysDt,0,0,0
			mov	ecx,eax
			push	ecx
			inc	eax
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,eax
			pop	ecx
			mov	ebx,eax
			test	eax,eax
			jz	E46
			push	ebx
			invoke	GetTimeFormat,LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT,addr SysDt,0,ebx,ecx
			pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	ecx
			pop	edx
			PUSHOPERSTACKSTRCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; NOW returns the current system date and time.
FNC_NOW:		mov	eax,WRAP_FNC_NOW
			jmp	CompileFnc1Arg

			align	16
FNC_NOWCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			push	edx
			push	ecx
			invoke	GetLocalTime,addr SysDt
			invoke	GetDateFormat,LOCALE_USER_DEFAULT,DATE_SHORTDATE,addr SysDt,0,0,0
			mov	ecx,eax
			push	ecx
			invoke	GetTimeFormat,LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT,addr SysDt,0,0,0
			pop	edx			; Date length
			mov	ecx,eax			; Time length
			push	ecx
			push	edx
			add	edx,eax			; Complete length in edx
			add	edx,2			; Space+Null terminating 0
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,edx
			pop	edx
			pop	ecx
			mov	ebx,eax
			test	eax,eax
			jz	E46
			push	ebx
			push	ecx
			push	edx
			invoke	GetDateFormat,LOCALE_USER_DEFAULT,DATE_SHORTDATE,addr SysDt,0,ebx,edx
			pop	edx
			pop	ecx
			mov	ebx,[esp]
			add	ebx,edx
			mov	byte ptr [ebx-1]," "
			invoke	GetTimeFormat,LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT,addr SysDt,0,ebx,ecx
			pop	ebx
			PUSHTMPSTRSTACKCOMP
			pop	ecx
			pop	edx
			PUSHOPERSTACKSTRCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; LTRIM2(EXPR1,EXPR2) returns a string from expression EXPR1 with leading char from EXPR2 stripped out.
FNC_LTRIM2:		mov	eax,WRAP_FNC_LTRIM2
			call	CompileFnc2Args
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_LTRIM2COMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx
			call	GetFNCLastArgs
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E48
			mov	eax,ebx
			pop	ebx
			push	edx
			push	edi
			push	ecx
			cmp	ExprFinalResult,VAR_STRING
			jne	LTRIM2FromString
			mov	cl,byte ptr [eax]
			jmp	TestStringLTRIM2
			align	16
LTRIM2FromString:	mov	cl,al
TestStringLTRIM2:	mov	al,[ebx]
			test	al,al
			jz	StopStringLTRIM2
LoopStringLTRIM2:	mov	al,[ebx]			; Search first non space char
			cmp	al,cl
			jne	StopStringLTRIM2
			inc	ebx
			jmp	LoopStringLTRIM2
			align	16
StopStringLTRIM2:	test	al,al				; Last found char
			jnz	EmptyLTRIM2			; was a null char ?
			; Create a null string
			invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0		; clear it
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP			; store it
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP
			align	16
EmptyLTRIM2:		push	ebx
			mov	esi,ebx				; esi now points to first valid char
LoopStringLTRIM2LEN:	mov	al,[esi]
			test	al,al
			je	StopStringLTRIM2LEN
			inc	esi
			jmp	LoopStringLTRIM2LEN
			align	16
StopStringLTRIM2LEN:	sub	esi,ebx				; esi=String length
			push	esi				; allocate it
			inc	esi				; (null zero)
			invoke	GlobalAlloc,GMEM_FIXED,esi
			test	eax,eax
			jz	E46
			pop	ecx				; (from esi)
			pop	esi				; (from ebx)
			mov	edi,eax
			cld
			push	ecx				; copy it
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; append null zero
			mov	ebx,eax				; start of string to store
			PUSHTMPSTRSTACKCOMP			; store it
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; RTRIM2(EXPR1,EXPR2) returns a string from expression EXPR1 with trailing EXPR2 char stripped out.
FNC_RTRIM2:		mov	eax,WRAP_FNC_RTRIM2
			call	CompileFnc2Args
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_RTRIM2COMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx
			call	GetFNCLastArgs
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E48
			mov	eax,ebx
			pop	ebx
			push	edx
			push	edi
			push	ecx
			push	ebx
			cmp	ExprFinalResult,VAR_STRING
			jne	RTRIM2FromString
			mov	cl,[eax]
			jmp	LoopStringRTRIM2
			align	16
RTRIM2FromString:	mov	cl,al
LoopStringRTRIM2:	push	ecx
			mov	esi,ebx
			mov	al,[esi]
			test	al,al
			jz	StopStringRTRIM2LEN
LoopStringRTRIM2LEN:	mov	al,[esi]
			test	al,al
			je	StopStringRTRIM2LEN
			inc	esi
			jmp	LoopStringRTRIM2LEN
			align	16
StopStringRTRIM2LEN:	xchg	esi,ebx
			sub	ebx,esi				; String length
			test	ebx,ebx				; Empty string ?
			jnz	EmptyRTRIM2
			; Create a null string
			pop	eax				; (from ecx to garbage)
			pop	eax				; (from ebx to garbage)
SetRTRIM2Empty:		invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0		; clear it
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP			; store it
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP
			align	16
EmptyRTRIM2:		pop	edx				; Char to remove (from ecx)
			pop	esi				; start of string (from ebx)
			mov	ecx,esi
			add	ecx,ebx				; add length
BackwardRTRIM2:		dec	ecx				; (can't be zero)
			mov	al,[ecx]
			cmp	al,dl
			jne	RightPosRTRIM2
			cmp	esi,ecx				; Reached start of string ?
			jne	BackwardRTRIM2			; No: continue...
			jmp	SetRTRIM2Empty			; Yes: it's filled with spaces
			align	16
RightPosRTRIM2:		inc	ecx				; (replace on correct char)
			sub	ecx,esi				; ecx=real length
			push	ecx				; allocate it
			inc	ecx				; (null zero)
			invoke	GlobalAlloc,GMEM_FIXED,ecx
			test	eax,eax
			jz	E46
			pop	ecx
			mov	edi,eax
			cld
			push	ecx				; copy it
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; append null zero
			mov	ebx,eax				; start of string to store
			PUSHTMPSTRSTACKCOMP			; store it
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; TRIM2(EXPR1,EXPR2) returns a string from expression EXPR with both leading and trailing EXPR2 char stripped out.
FNC_TRIM2:		mov	eax,WRAP_FNC_TRIM2
			call	CompileFnc2Args
			invoke	PushOperStack,VAR_STRING
			ret

			align	16
FNC_TRIM2COMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_STRING
			jne	E45
			push	ebx
			call	GetFNCLastArgs
			cmp	ExprFinalResult,VAR_DOUBLE
			je	E48
			cmp	ExprFinalResult,VAR_NOFNCARG
			je	E48
			mov	eax,ebx
			pop	ebx
			push	edx
			push	edi
			push	ecx
			cmp	ExprFinalResult,VAR_STRING
			jne	TRIM2FromString
			mov	cl,[eax]
			jmp	TestStringTRIM2
			align	16
TRIM2FromString:	mov	cl,al
TestStringTRIM2:	push	ecx				; Save char to remove
			mov	al,[ebx]
			test	al,al
			jz	StopStringTRIM2
LoopStringTRIM2:	mov	al,[ebx]			; Search first non space char
			cmp	al,cl
			jne	StopStringTRIM2
			inc	ebx
			jmp	LoopStringTRIM2
			align	16
StopStringTRIM2:	test	al,al				; Last found char
			jnz	EmptyTRIM2			; was a null char ?
			pop	eax				; (From ecx to garbage)
			; Create a null string
SetTRIM2Empty:		invoke	GlobalAlloc,GMEM_FIXED,1
			test	eax,eax
			jz	E46
			mov	byte ptr [eax],0		; clear it
			mov	ebx,eax
			PUSHTMPSTRSTACKCOMP			; store it
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP
			align	16
EmptyTRIM2:		mov	esi,ebx
LoopStringTRIM2LEN:	mov	al,[esi]
			test	al,al
			je	StopStringTRIM2LEN
			inc	esi
			jmp	LoopStringTRIM2LEN
			align	16
StopStringTRIM2LEN:	sub	esi,ebx				; esi=String length
			mov	ecx,esi
			add	ecx,ebx				; add start of string
			pop	edx				; (Char to remove from ecx)
BackwardTRIM2:		dec	ecx				; (can't be zero)
			mov	al,[ecx]
			cmp	al,dl
			jne	RightPosTRIM2
			cmp	esi,ecx				; Reached start of string ?
			jne	BackwardTRIM2			; No: continue...
			jmp	SetTRIM2Empty			; Yes: it's filled with spaces
			align	16
RightPosTRIM2:		inc	ecx				; (replace on correct char)
			sub	ecx,ebx				; ecx=real length
			push	ebx
			push	ecx				; allocate it
			inc	ecx				; (null zero)
			invoke	GlobalAlloc,GMEM_FIXED,ecx
			test	eax,eax
			jz	E46
			pop	ecx				; (from esi)
			pop	esi				; (from ebx)
			mov	edi,eax
			cld
			push	ecx				; copy it
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			mov	byte ptr [edi],0		; append null zero
			mov	ebx,eax				; start of string to store
			PUSHTMPSTRSTACKCOMP			; store it
			NORMALIZEOPERSTACKCOMP 1
			POKEOPERSTACKSTRCOMP
			pop	ecx
			pop	edi
			pop	edx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; GETCONTITLE returns the titlebar of the console
FNC_GETCONTITLE:	mov	eax,WRAP_FNC_GETCONTITLE
			jmp	CompileFnc1Arg

			align	16
FNC_GETCONTITLECOMP:	call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			push	edx
			; Alloc room for title
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,257
			test	eax,eax
			jz	E46
			push	eax
			invoke	GetConsoleTitle,eax,256
			pop	ebx				; Text
			PUSHTMPSTRSTACKCOMP			; Make it temporary
			pop	edx
			PUSHOPERSTACKSTRCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; CARETX returns the X position of the console caret
FNC_CARETX:		mov	eax,WRAP_FNC_CARETX
			jmp	CompileFnc1Arg

			align	16
FNC_CARETXCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			movzx	ebx,Csbi_CursorPositionX
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; CARETY returns the Y position of the console caret
FNC_CARETY:		mov	eax,WRAP_FNC_CARETY
			jmp	CompileFnc1Arg

			align	16
FNC_CARETYCOMP:		call	GetFNCArgs
			cmp	ExprFinalResult,VAR_NOFNCARG
			jne	E42
			movzx	ebx,Csbi_CursorPositionY
			call	PushOperStackIntCOMP
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; NOT(EXPR) returns the negative complement of an integer expression.
FNC_NOT:		mov	eax,WRAP_FNC_NOT
			jmp	CompileFnc1Arg

			align	16
FNC_NOTCOMP:		call	GetFNCArgs			; Integer to test
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			not	ebx
			jmp	FinalizeFncCOMP

;-----------------------------------------------------------------------------------------------
; Support routines
;-----------------------------------------------------------------------------------------------

;-----------------------------------------------------------------------------------------------
; Load an integer into fpu when returned from evalexpr()
			align	16
ConvertIntFromExpr:	cmp	ExprFinalResult,VAR_DOUBLE
			je	NoIntConvert
			cmp	ExprFinalResult,VAR_STRING
			je	E68
			mov	DblFromInt,ebx
			fild	DblFromInt
			POKEOPERSTACKDOUBLECOMP
			ret
			align	16
NoIntConvert:		ret
			align	16
E68:			mov	edi,offset Err68		; Error: <Integer value of floating point expected>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; Calculate neperian logarithm of st(0)
			align	16
DoLog:			call	TestGtZero			; Don't calculate
			fldln2					; 0 or negative logarithms
			fxch	st(1)
			fyl2x
			ret

;-----------------------------------------------------------------------------------------------
; Exponentiate e by st(0)
			align	16
DoExp:			fldl2e
			fmulp	st(1),st(0)
			fld	st(0)
			frndint
			fxch	st(1)
			fsub	st(0),st(1)
			f2xm1
			fld1
			faddp	st(1),st(0)
			fscale
			fstp	st(1)
			ret

;-----------------------------------------------------------------------------------------------
; Return the sign of a fp number.
			align	16
SgnDbl:			push	eax
			ftst
			fstsw	ax
			mov	bx,ax
			fstp	DblGarbSgn
			pop	eax
			and	bx,100010100000000b
			jz	SgnDbl_Return1
			cmp	bx,000000100000000b
			je	SgnDbl_ReturnM1
			cmp	bx,100000000000000b
			je	SgnDbl_Return0
			jmp	E25
			align	16
SgnDbl_ReturnM1:	fld1
			fchs
			ret
			align	16
SgnDbl_Return0:		fldz
			ret
			align	16
SgnDbl_Return1:		fld1
			ret

;-----------------------------------------------------------------------------------------------
; Test a fp against 0
			align	16
TestZero:		ftst
			fstsw	ax
			and	eax,100010100000000b
			cmp	eax,100000000000000b
			je	ExprDivZero			; Must be > zero
			ret

;-----------------------------------------------------------------------------------------------
; Test a fp against >0
			align	16
TestGtZero:		ftst
			fstsw	ax
			and	eax,100010100000000b
			jnz	E19
			ret

;-----------------------------------------------------------------------------------------------
; Tests event presence in console input buffer.
; In case of event, jumps to TestKeyb, else return to caller
			align	16
TestInpBuf:		push	edx
			mov	dtemp1,0
			invoke	GetNumberOfConsoleInputEvents,hStdIn,addr dtemp1
			call	TestApiError
			mov	ebx,dtemp1
			test	ebx,ebx				; Events in input buffer ? 
			jnz	TK1				; Yes, read it  
			pop	edx				; No, return to caller with ebx = 0
			ret

;-----------------------------------------------------------------------------------------------
; Test keyboard key pressed. If pressed, the scan code is in bx, if not pressed, bx = 0
			align	16
TestKeyb:		; [registers used ecx, eax (API call)]
			push	edx
TK1:			invoke	ReadConsoleInput,hStdIn,addr EventBuffer,1,addr dtemp1
			xor	ebx,ebx				; bx = keyscan number or 0
			call	TestApiError
			cmp	dword ptr dtemp1,0		; Events in input buffer ?
			je	TK2				; No, return to caller
			cmp	word ptr EventBuffer,KEY_EVENT	; Yes, Is a Keyboard Event ?
			jne	TK2				; no : send to valhalla
			cmp	dword ptr EventBuffer+4,0	; Not a keypress ?
			jne	@F				; Yes, save it in bl
			mov	al,byte ptr EventBuffer+14	; No, save key release value for Alt+num case
			mov	btemp1,al
			jmp	TK2				; and return with bx=0
			align	16
@@:			mov	bl,byte ptr EventBuffer+14
TK2:			pop	edx
			ret

;-----------------------------------------------------------------------------------------------
; LineInput processes char. arrows and edit keys in the line editor.
; Alt+num entry displays the corresponding ASCII char.
			align	16
LineInput:		; Event loop
			call	TestKeyb			; Keyboard event ?
			cmp	btemp1,0			; Release key = 0 ?
			je	KR1				; Yes, it's a keypress, continue
			cmp	btemp2,1			; No, previous keyboard entry was an Alt+number ?
			je	@F				;    Yes, released code is an ASCII code
			mov	btemp1,0			;    No, reset KeyRelease flag and check next key
			jmp	LineInput
			align	16
@@:			mov	bl,btemp1			;    Yes,
			jmp	DispChar			;    print char
			align	16
KR1:			test	bl,bl
			jnz	KR2				; if bl=0 (no ASCII key pressed)
			mov	al,EventBuffer+12		; Test if a key of Alt+num is valid
			cmp	dword ptr EventBuffer+4,0
			je	LineInput
			cmp	al,71				; Home ?
			je	HomeKey
			cmp	al,79				; End ?
			je	EndKey
			cmp	al,75				; Left arrow ?
			je	LeftArrowKey
			cmp	al,77				; Right arrow ?
			je	RightArrowKey
			cmp	al,82				; Insert ?
			je	ToggleInsertMode
			cmp	al,83				; Delete ?
			je	DeleteKey
KeyDownKeys:		cmp	al,71				; Key '0' to '9' From 71 to 82 except 74 & 78
			jb	@F
			cmp	al,82
			ja	@F
			cmp	al,74
			je	@F
			cmp	al,78
			je	@F
			mov	btemp2,1			; OK, it's a valid key, set Alt+num flag
@@:			jmp	LineInput			; and wait for next key
			align	16
KR2:			cmp	bl,13				;     = CR ?
			je	EL0
			cmp	bl,8				;     = BackSpace ?
			je	EL8
			cmp	bl,27				;     = ESC ?
			je	CTC				;       Leave and ignore current edited line
			jmp	DispChar			; If none of above cases, it's a letter key, print it
			; Execute control char.
			align	16
EL0:			mov	eax,LineBuffer			; [CR] Add a CR (Odh) to end of line and return to caller
			add	eax,LineLen
			mov	byte ptr [eax],0dh
CTC:			push	ebx				; save ESC flag, if exists
			or	si,-1				; flag for End Of Line routine
			call	EndKey				; Use END key routine to find end of line cursor position
			xor	si,si
			call	CrLf
			mov	btemp2,0			; Reset Atl+num flag
			pop	ebx
			ret					; End of LineInput. Return to caller
			align	16
LeftArrowKey:		dec	LinePtr				; [LEFT ARROW]
			jnz	@F
			inc	LinePtr				; 1st. char. Impossible to go left
			jmp	LineInput
			align	16
@@:			cmp	Csbi_CursorPositionX,0		; 1st. position in the line ?
			jne	@F				; No
			dec	Csbi_CursorPositionY		; Yes : Go to end of previous line
			mov	cx,Csbi_MaximumWindowSizeX
			mov	Csbi_CursorPositionX,cx
@@:			dec	Csbi_CursorPositionX		; No exceptions : X-1
			jmp	InputCP				; Update cursor position & LineInput
			align	16
RightArrowKey:		mov	eax,LinePtr			; [Right Arrow]
			inc	eax
			cmp	LineLen,eax			; LineLen >= LinePtr ?
			jb	LineInput			; No, forget & LineInput
@@:			mov	LinePtr,eax			; Yes, update LinePtr
			mov	ax,Csbi_WindowRight
			mov	cx,Csbi_CursorPositionY
			cmp	Csbi_CursorPositionX,ax		; Csbi_CursorPositionX inside console X limit ?
			jb	@F				; Yes, go to Right
			mov	Csbi_CursorPositionX,-1		; No, Csbi_CursorPositionX=0 (-1+increment)
			inc	cx
			cmp	cx,Csbi_WindowBottom		; Csbi_CursorPositionY+1 inside console Y limit ?
			jb	@F				; Yes, Csbi_CursorPositionY+1 & update cursor position
			call	ScrollUp			; No, Scroll up
			mov	cx, Csbi_WindowBottom
@@:			inc	Csbi_CursorPositionX		; Update cursor position
			mov	Csbi_CursorPositionY,cx
			jmp	InputCP
			align	16
ToggleInsertMode:	xor	InsertMode,1			; [INSERT] Invert InsertMode bit 1
			mov	CursorShape.bVisible,1
			call	SetConCursor
			jmp	LineInput
			align	16
DeleteKey:		mov	eax,LineLen			; [DELETE]
			cmp	eax,LinePtr			; Line Length = LinePtr ?
			jne	@F				; No, we can cancel 1 char
			jmp	LineInput			; Yes, we do nothing
			align	16
@@:			mov	edi,LineBuffer
			add	edi,LinePtr			; edi=buffer ADDR to write char. read by API
			mov	ebx,LineLen
			sub	ebx,LinePtr			; ebx=Nbr. of char. to move left 1 position
			push	dword ptr Csbi_CursorPositionX
			mov	cx,Csbi_CursorPositionX
			inc	cx
			cmp	cx,Csbi_SizeX
			jb	@F
			xor	cx,cx
			inc	Csbi_CursorPositionY
@@:			mov	Csbi_CursorPositionX,cx		; Csbi_CursorPositionX-Y = 1 position right (or CR-LF)
			invoke	ReadConsoleOutputCharacter,hStdOut,edi,ebx,dword ptr Csbi_CursorPositionX,addr dtemp1
			call	TestApiError			; Read console char. to move & update LineBuf buffer
			pop	dword ptr Csbi_CursorPositionX
			invoke	WriteConsoleOutputCharacter,hStdOut,edi,ebx,dword ptr Csbi_CursorPositionX,addr dtemp1
			call	TestApiError			; Write char. previously read 1 position right
			dec	LineLen
			jmp	LineInput
			align	16
EndKey:			mov	ecx,LineLen			; [END] Loop from LinePtr to LineLen
			mov	edx,LinePtr			; and update cursor position
			mov	ax,Csbi_CursorPositionX
			mov	bx,Csbi_CursorPositionY
@@:			cmp	edx,ecx
			je	@F
			inc	edx
			inc	ax
			cmp	ax,Csbi_SizeX
			jb	@B
			xor	ax,ax
			inc	bx
			jmp	@B
			align	16
@@:			cmp	si,-1				; Call from CR key ?
			jne	@F				; No
			mov	Csbi_CursorPositionY,bx		; Update end of line Y cursor position before CrLf
			ret					; Ret to CR key routine
			align	16
@@:			mov	LinePtr,ecx
			jmp	ICP
			align	16
HomeKey:		mov	ax,Csbi_CursorPositionX		; [HOME] Loop from LinePtr to top of line
			mov	bx,Csbi_CursorPositionY		; and update cursor position
			mov	edx,LinePtr
@@:			dec	edx
			jz	@F
			dec	ax
			jns	@B
			mov	ax,Csbi_WindowRight
			dec	bx
			jns	@B
@@:			mov	LinePtr,1
			jmp	ICP
			align	16
EL8:			cmp	LinePtr,1			; [BACKSPACE] LinePtr > 1 ?
			je	LineInput
			mov	edi,LineBuffer			; Yes, we can BS
			dec	edi
			add	edi,LinePtr			; edi=buffer ADDR to write char. read by API
			mov	ebx,LineLen
			sub	ebx,LinePtr
			inc	ebx				; ebx=Nbr. of char. to move left 1 position
			invoke	ReadConsoleOutputCharacter,hStdOut,edi,ebx,dword ptr Csbi_CursorPositionX,addr dtemp1
			call	TestApiError			; Read console char. to move & update LineBuffer buffer
			mov	cx,Csbi_CursorPositionX
			dec	cx
			jns	@F
			mov	cx,Csbi_WindowRight
			dec	Csbi_CursorPositionY
@@:			mov	Csbi_CursorPositionX,cx		; Csbi_CursorPositionX-Y = 1 position right (or CR-LF)
			push	edi
			add	edi,ebx
			mov	byte ptr [edi],"X"
			pop	edi
			invoke	WriteConsoleOutputCharacter,hStdOut,edi,ebx,dword ptr Csbi_CursorPositionX,addr dtemp1
			call	TestApiError			; Write char. previously read 1 position right
			dec	LineLen
			dec	LinePtr
			jmp	InputCP

;-----------------------------------------------------------------------------------------------
; Display a char in line editor.
; Manage auto-insert, CR-LF and scroll. Update cursor position.
			align	16
DispChar:		cmp	ebx,9				; Is it a tabulation ?
			jne	NoTabKey
			mov	ebx," " 			; Replace it with a space
NoTabKey:		mov	dtemp2,ebx			; save char. to print
			mov	eax,LineMaxLen			; Line length = maximum length allowed ?
			cmp	eax,LineLen
			jne	@F
			call	Beeep				; Yes : Beep & return to keyboard loop
			jmp	LineInput
			align	16
@@:			inc	LinePtr
			mov	eax,LineLen
			cmp	eax,LinePtr			; Line Length >= LinePtr ?
			jb	RC1				; No, LineLen + 1
			cmp	InsertMode,1			; Insert mode ?
			je	RC2				; No
			mov	ax,Csbi_CursorPositionY		; Yes, calculate position value of Csbi_CursorPositionX-Y
			mov	bx,Csbi_SizeX
			mul	bx
			add	ax,Csbi_CursorPositionX
			inc	ax				; ax=cursor position value
			inc	LineLen
			mov	ebx,LineLen
			sub	ebx,LinePtr			; bx=Nbr. of char. to move 1 position right
			push	eax
			add	ax,bx				; ax= End of line position value
			dec	ax
			cmp	ax,word ptr ConsoleCharNbr	; End of line at last console position ?
			pop	eax
			jb	@F				; No, we can insert 1 char.
			call	ScrollUp			; Yes, Scroll Up,
			sub	ax,Csbi_SizeX			; update ax position value
			dec	Csbi_CursorPositionY
@@:			mov	edi,LineBuffer
			add	edi,LinePtr			; edi=buffer ADDR to store char. read by API
			invoke	ReadConsoleOutputCharacter,hStdOut,edi,ebx,dword ptr Csbi_CursorPositionX,addr dtemp1
			call	TestApiError			; Read console char. to move & update LineBuffer buffer
			push	dword ptr Csbi_CursorPositionX
			mov	cx,Csbi_CursorPositionX
			inc	cx
			cmp	cx,Csbi_SizeX
			jb	@F
			xor	cx,cx
			inc	Csbi_CursorPositionY
@@:			mov	Csbi_CursorPositionX,cx		; Csbi_CursorPositionX-Y = 1 position right (or CR-LF)
			invoke	WriteConsoleOutputCharacter,hStdOut,edi,ebx,dword ptr Csbi_CursorPositionX,addr dtemp1
			call	TestApiError			; Write char. previously read 1 position right
			pop	dword ptr Csbi_CursorPositionX
			invoke	SetConsoleCursorPosition,hStdOut,dword ptr Csbi_CursorPositionX
			call	TestApiError
			jmp	RC2
			align	16
RC1:			inc	LineLen
RC2:			invoke	WriteConsole,hStdOut,addr dtemp2,1,addr dtemp1,0
			call	TestApiError
			mov	eax,LineBuffer			; Put chr at Ptr position
			dec	eax
			add	eax,LinePtr
			mov	ecx,dtemp2			; Chr. to put
			mov	[eax],cl			; set chr. in LineBuffer at LinePtr position
			mov	ax,Csbi_CursorPositionX
			mov	bx,Csbi_CursorPositionY
			inc	ax
			cmp	ax,Csbi_SizeX			; X cursor position in console limit ?
			jb	ICP				; Yes
			xor	ax,ax
			mov	Csbi_CursorPositionX,ax		; No  CR+LF  Y=Y+1, X=0
			inc	bx
			cmp	bx,Csbi_SizeY			; Y cursor position in console limit ?
			jb	ICP				; Yes
			call	ScrollUp			; No, Scroll Up & update cursor position
			jmp	InputCP
			align	16
ICP:			; X & Y cursor position in console limit
			mov	Csbi_CursorPositionX,ax
			mov	Csbi_CursorPositionY,bx
InputCP:		; Line input Cursor Position (!called by most of editor keys!)
			invoke	SetConsoleCursorPosition,hStdOut,dword ptr Csbi_CursorPositionX
			call	TestApiError
			mov	btemp2,0			; Reset Atl+num flag
			jmp	LineInput

;----------------------------------------------------------------------------------------------
; Divides ebx by edx. Result in ecx, Remainder in ebx
			align	16
Divide:			; [register used ecx, eax]
			push	edx				; Preserve edx
			mov	ecx,edx
			mov	eax,ebx
			cdq					; Extend sign
			test	ecx,ecx				; Can't divide by zero
			jz	@F
			idiv	ecx
@@:			mov	ecx,eax				; Quotient
			mov	ebx,edx				; Remainder
			pop	edx
			ret

;-----------------------------------------------------------------------------------------------
; CheckSign checks the sign of ebx. If +, no change. If -, change sign and invert sign of ch
			align	16
CheckSign:		test	ebx,ebx				; Test s flag
			jns	@F				; If -, change sign, else ret
			neg	ebx				; Change ebx sign (2 complement)
			xor	ch,128				; Change ch sign
			ret
			align	16
@@:			ret

;-----------------------------------------------------------------------------------------------
; CheckSign checks the sign of st(0). If +, no change. If -, change sign and invert sign of ch
			align	16
CheckSignDbl:		ftst
			fstsw	ax
			and	ax,100010100000000b		; mask condition codes
			cmp	ax,000000100000000b		; should be 001 if <0.0
			jne	@F				; If -, change sign, else ret
			fchs
			ret
			align	16
@@:			ret

;-----------------------------------------------------------------------------------------------
; CompareSign checks the sign of ebx and edx.
; If different, ebx and edx are interchanged, if same sign, they are not.
; Either case, ebx and edx are compared to set flags
			align	16
CompareSign:		bswap	ebx
			bswap	edx				; signs are now in bl and dl
			mov	al,bl
			xor	al,dl				; Same sign ?
			bswap	ebx				; back to original values
			bswap	edx				; (bswap doesn't affect flags)
			jns	@F				; Yes, only compare
			xchg	edx,ebx				; No, exchange and compare
@@:			cmp	ebx,edx
			ret

;-----------------------------------------------------------------------------------------------
; CompareSignDbl checks the sign of DblTerm1 and DblTerm2.
; If different, ebx and edx are interchanged, if same sign, they are not.
; Either case, ebx and edx are compared to set flags
			align	16
CompareSignDbl:		fld	DblTerm1
			fcom	DblTerm2
			fstsw	ax
			and	eax,100010100000000b
			cmp	eax,000000100000000b		; lower
			jne	DblNotLower
			or	eax,-1
			ret
			align	16
DblNotLower:		cmp	eax,100000000000000b		; equal
			jne	DblNotEqual
			xor	eax,eax
			ret
			align	16
DblNotEqual:		mov	eax,1				; greater
			test	eax,eax				; (set flags)
			ret

;-----------------------------------------------------------------------------------------------
; VarEquExpr expects a variable, followed by an equal sign and then an expression
; Evaluates the expression and sets the variable to the value
			align	16
VarEquExprFOR:		call	TestVar
			jnc	@F
			jmp	E9
			align	16
VarEquExpr:		call	TestVarLabel			; A variable is found ?
			jnc	@F
E9:			mov	edi,offset Err9			; No, error <Keyword or variable expected>
			jmp	DispError
			align	16
@@:			cmp	cl,WRAP_LABEL
			je	LabelStored
			push	ebx				; Save address of variable
			mov	ah,'='
			call	SkipSpaces			; Sign '=' found ?
			jz	@F				; Yes, evaluate expression
			mov	edi,offset Err10		; No, error <'=' statement expected>
			jmp	DispError
			align	16
@@:			call	EvalExpr
			pop	ebx
LabelStored:		ret

;-----------------------------------------------------------------------------------------------
; CmdEnd checks the end of a command. If command ends with ':', execution continues,
; if command ends with a CR, finds the next line and continues from there
			align	16
CmdEnd:			inc	edx
			jmp	NextLine			; and run next line

;----------------------------------------------------------------------------------------------
; Report an error if an argument is found
			align	16
TestNoArguments:	call	TrimSpaces
			cmp	byte ptr [edx],0dh
			je	@F
			cmp	byte ptr [edx],"'"
			je	@F
			cmp	byte ptr [edx],":"
			jne	E42
@@:			ret

;----------------------------------------------------------------------------------------------
; Report an error if no arguments are found
			align	16
TestArgumentsExpected:	call	TrimSpaces
			cmp	byte ptr [edx],0dh
			je	E37
			cmp	byte ptr [edx],":"
			je	E37
			cmp	byte ptr [edx],"'"
			je	E37
			ret

;----------------------------------------------------------------------------------------------
			align	16
DispError:		push	edi				; save offset of error message
			cmp	Csbi_CursorPositionX,0		; Message must be printed at top of line
			je	@F
			call	CrLf
@@:			mov	eax,EditColors			; Set default editor colors
			mov	ColorsCurrent,eax
			xor	al,al
			mov	edx,FileName			; print filename
			call	DispStr
			xor	al,al
			mov	edx,offset Colon		; print ":"
			call	DispStr
			mov	ebx,LineNumber
			test	ebx,ebx
			jnz	@F
			inc	ebx
@@:			call	IntToStringNoPad
			lea	edx,dtemp1
			call	DispStr
			xor	al,al
			mov	edx,offset Colon		; print ":"
			call	DispStr
			xor	al,al
			pop	edx				; edx = Offset error message
			call	DispStr
			call	CrLf
			jmp	Exit				; Reset pointers & LineInput

;----------------------------------------------------------------------------------------------
; FindLine looks for a same line number as ebx in Basic text
; edx is used as text pointer.
; If line number is found :
;   edx points on the line first byte. Flags are NC & Z
; if an higher line number is found :
;   edx points on the line first byte. Flags are NC & NZ
; if End of Basic Text reached:
;   edx points on Basic text start. Flags are C et NZ
;
; 'FindNextLine' looks for End of line (0dh) from the line beginning and jump to LineNumCompare.
; 'FindEndOfLine' does the same but start searching after line number.
			align	16
FindLine:		test	ebx,ebx				; Line number Sign bit must be 0
			jns	@F				; Yes, OK
			mov	edi,offset Err2			; No, error : Invalid line number
			jmp	DispError
			align	16
@@:			mov	edx,TxtStart			; edx = Basic text start
LineNumCompare:		mov	eax,TxtEnd			; Check if Basic text end passed
			dec	eax
			cmp	eax,edx
			jb	@F				; Yes, passed end : C & NZ
			mov	eax,[edx]			; No, eax = line number found
			cmp	eax,ebx				; eax > line number to find ?
			jc	FindNextLine			; no, loop to following line number in Basic text
@@:			ret					; Yes, line number found : NC & Z; not found : NC &,NZ
			align	16
FindNextLine:		add	edx,4
@@:			inc	edx
FindEndOfLine:		mov	al,[edx]
			cmp	al,0dh
			jnz	@B				; Loop while not find a CR
			inc	edx
			jmp	LineNumCompare			; CHECK IF END OF TEXT

; Pre-compiled version
			align	16
FindLineComp:		test	ebx,ebx
			jns	@F
			mov	edi,offset Err2			; Invalid line number	
			jmp	DispError
			align	16
@@:			mov	edx,CompStart
LineNumCompareComp:	mov	eax,CompEnd
			dec	eax
			cmp	eax,edx				; End of block ?
			jb	@F
			mov	eax,[edx]			; Get next line number
			cmp	eax,ebx
			jc	FindNextLineComp
@@:			ret
			align	16
FindNextLineComp:	add	edx,11
			jmp	LineNumCompareComp
			align	16
FindEndOfLineComp:	add	edx,11-6
			jmp	LineNumCompareComp
			align	16
FindNextLineCompEnd:	inc	edx
			jmp	LineNumCompareComp

;-----------------------------------------------------------------------------------------------
; DispStr prints a string pointed to by edx. Returns to caller when either a Odh is found &
; printed or when the next byte is the same as what was in al (given by the caller)
; [Register used ax, ebx, ecx, edx, esi, edi]
; DispNumStr displays a BCPL string (Number as DWORD,String itself)
			align	16
DispNumStr:		mov	ecx,[edx]			; Get number of chars
			add	edx,4
			mov	ebx,PrintBuffer
			mov	edi,ebx
NumPS1:			mov	al,[edx]
			mov	[ebx],al
			inc	ebx
;			push	word ptr ColorsCurrent-1
;			pop	word ptr [ebx]
;			mov	byte ptr [ebx],0
;			add	ebx,3
			inc	edx
			dec	ah				; Number of char to pad
			dec	ecx
			jnz	NumPS1
			test	ah,ah
			jle	@F
PadStr:			mov	byte ptr [ebx]," "
			inc	ebx
;			push	word ptr ColorsCurrent-1
;			pop	word ptr [ebx]
;			mov	byte ptr [ebx],0
;			add	ebx,3
			dec	ah
			jnz	PadStr
			push	edx
			sub	ebx,edi
			jz	PS3
			mov	edi,edx
			mov	edx,ebx
			jmp	PrintStr
			align	16
DispStr:		mov	edi,edx				; edi will be used to count char. to print
			mov	ebx,PrintBuffer			; Chars. to print are transfered in PrintBuffer
PS1:			mov	ah,[edx]			; Get a char.
			cmp	ah,al				; same as al flag ?
			je	@F				; Yes, end of tranfer
			cmp	ah,0ah
			jne	PassCRLF
			push	eax
			push	ebx
			push	ecx
			push	edi
			push	edx
			call	@F				; Print it
			call	CrLf				; Add crlf
			pop	edx
			pop	edi
			pop	ecx
			pop	ebx
			pop	eax
			inc	edx				; Pass over
			mov	edi,edx				; reset chars counter
			mov	ebx,PrintBuffer			; Chars. to print are transfered in PrintBuffer
			jmp	PS1
			align	16
PassCRLF:		mov	[ebx],ah			; None of above cases, add char. in print buffer
			inc	ebx
;			push	word ptr ColorsCurrent-1
;			pop	word ptr [ebx]
;			mov	byte ptr [ebx],0
;			add	ebx,3
			inc	edx
			jmp	PS1				; transfer loop back
			align	16
@@:			push	edx
			sub	edx,edi				; edx = Number of char. to print
			jz	PS3				; No char. to print
PrintStr:		push	eax				; Does the line to print need a scroll ?
			xchg	edx,edi				; edi = Number of char. to print
			mov	cx,Csbi_WindowRight
			mov	ebx,ecx
			inc	ebx				; ebx becomes Csbi-SizeX
			sub	cx,Csbi_CursorPositionX		; cx = available space on the current line
			cmp	cx,di				; Length of line to print > available space on the current line ?
			jnc	PS2				; No, OK to print
			mov	ax,Csbi_WindowBottom		; Yes...
			sub	ax,Csbi_CursorPositionY
			mul	bx
			add	ax,cx				; ... ax = char. availables from cursor to end of screen
			sub	ax,di				; Line length to print > ax ?
			jnc	PS2				; No, OK to print
@@:			call	ScrollUp			; Yes, Scroll up necessary lines and update cursor position
			dec	Csbi_CursorPositionY		; to get room enough to print line
			add	ax,bx
			jnc	@B
PS2:			pop	eax
			mov	bh,ah				; ah will be modified by API calls
; This was just meant to be a test
; (apparently it brings no speed gain)
;			mov	Csbi_CharX,di
;			mov	word ptr Csbi_CharY,1
;			mov	ax,Csbi_CursorPositionX
;			mov	Csbi_WriteReg.Left,ax
;			mov	ax,Csbi_CursorPositionY
;			mov	Csbi_WriteReg.Top,ax
;			mov	ax,Csbi_WriteReg.Left
;			add	ax,Csbi_CharX
;			mov	Csbi_WriteReg.Right,ax
;			mov	ax,Csbi_WriteReg.Top
;			mov	Csbi_WriteReg.Bottom,ax
;			push	ebx
;			invoke	WriteConsoleOutputA,hStdOut,PrintBuffer,dword ptr Csbi_CharX,dword ptr Csbi_CharPosX,addr Csbi_WriteReg
;			call	TestApiError
;			pop	ebx
			; I used these 2 API to print text because 'SetConsoleTextAttribute' and 'WriteConsoleA' didn't
			; work correctly with automatic CR and scroll up
			invoke	FillConsoleOutputAttribute,hStdOut,dword ptr ColorsCurrent,edi,dword ptr Csbi_CursorPositionX,addr dtemp1
			call	TestApiError			; set BackGround & Foreground colors
			invoke	WriteConsoleOutputCharacter,hStdOut,dword ptr PrintBuffer,edi,dword ptr Csbi_CursorPositionX,addr dtemp1
			call	TestApiError			; Print line of chars.
			mov	si,Csbi_CursorPositionX		; Calculate new physical cursor position in buffer
			mov	ax,Csbi_CursorPositionY
			mov	cx,Csbi_SizeX
			mul	cx
			add	ax,si				; ax = old position
			add	ax,di				; now, ax=new physical position
			div	cl				; Result of ax/cl in al, remainder in ah
			mov	byte ptr Csbi_CursorPositionY,al
			mov	byte ptr Csbi_CursorPositionX,ah
			invoke	SetConsoleCursorPosition,hStdOut,dword ptr Csbi_CursorPositionX
			call	TestApiError			; Update cursor position
			cmp	bh,0dh
			jnz	PS3
			call	CrLf
PS3:			pop	edx
			inc	edx
			ret

;-----------------------------------------------------------------------------------------------
; Print a string between quotes.
; Perform a CR without LF if '\' is found
			align	16
QuotedString:		xor	al,al
			jmp	DispStr

;-----------------------------------------------------------------------------------------------
; Convert an integer to a string
; In: ebx: number to convert
			align	16
IntToStringNoPad:	mov	NbrPadding,0
IntToString:		push	edx
			mov	edx,10				; For divide by 10
			push	edx				; SAVE AS A FLAG
			mov	ch,dh				; ch = sign (0)
			mov	cl,NbrPadding
			dec	cl				; cl=SPACES
			test	ebx,ebx				; Do not check sign if number is 0
			jz	@F				; (this won't print -0)
			call	CheckSign			; Check sign, change it if negative
			jns	@F				; No sign
			mov	ch,"-"				;
			dec	cl				; '-' takes 1 space
@@:			push	ecx				; Save sign & space
@@:			call	Divide				; Divides ebx by edx (10). Result in ecx, Remainder in ebx
			test	ecx,ecx				; Result > 0 ?
			jz	@F				; No,
			pop	eax				; Yes, GET SIGN AND SPACE COUNT
			push	ebx				; Save remainder
			dec	al				; dec space counter
			push	eax				; Save new sign & space counter
			mov	ebx,ecx				; Move result to ebx
			jmp	@B				; and Divide by 10 again
			align	16
@@:			lea	edi,dtemp1			; Buffer to print the number
			pop	ecx				; Now, all digits are in the stack
@@:			dec	cl				; Dec space counter
			test	cl,cl				; Leading blanks ?
			js	@F				; No, We can print number
			mov	al,32				; Yes, we print a space
			stosb					; in [edi]
			jmp	@B
			align	16
@@:			test	ch,ch
			jz	@F
			mov	al,ch				; PRINT SIGN '-'
			stosb
@@:			mov	dl,bl				; Take off each digits from stack and print it
@@:			mov	al,dl
			cmp	al,10				; if stack value = 10 then display number & return
			pop	edx
			jz	@F
			add	al,48				; convert digit to ASCII
			stosb					; & store it in display buffer
			jmp	@B				; Loop to next digit
			align	16
@@:			xor	al,al
			mov	[edi],al			; Display number
			ret

;-----------------------------------------------------------------------------------------------
; DispNumber prints the number in edx. Leading blanks are added if needed to pad the number
; of spaces to the value in cl. If the number of digits is larger than the cl value, all digits
; are printed anyway. Negative sign is also printed and counted. Positive sign is not
; On entry, ebx = binary number, cl = spaces
			align	16
DispNumber:		call	IntToString
			push	edx
			lea	edx,dtemp1
			call	DispStr
			pop	edx
			ret

;-----------------------------------------------------------------------------------------------
; DispDouble prints the floating point number in st(0).
; On entry, st(0) = fp number
			align	16
DispDouble:		push	edx
			fstp	DblVal				; Store fp value
			; Convert it
			invoke	DoubleToString,DblVal,15,addr DblTemp
			test	eax,eax
			jz	E25
			lea	edx,DblTemp
			xor	al,al
			; Print it
			call	DispStr
			pop	edx
			ret

;-----------------------------------------------------------------------------------------------
; Check a space char in lastest position
			align	16
CheckLastSpace:		mov	al,[edx-1]
			cmp	al,32
			ret

;-----------------------------------------------------------------------------------------------
			align	16
FindCloseBracket:	mov	ah,")"
			jmp	SkipSpaces
			align	16
FindComma:		mov	ah,","				; Next char. is a comma ?
SkipSpacesComma:	mov	al,[edx]
			cmp	al,32
			jne	@F
			inc	edx
			jmp	SkipSpacesComma
			align	16
@@:			inc	edx
			cmp	al,ah
			je	@F
			dec	edx
			ret
			align	16
@@:			push	edx
CheckTrailingSpace:	cmp	byte ptr [edx],020h
			jne	PassTrailingSpace
			inc	edx
			jmp	CheckTrailingSpace
			align	16
PassTrailingSpace:	cmp	byte ptr [edx],0dh		; Can't be
			je	E37
			pop	edx
			cmp	al,ah
			je	@F
			dec	edx
@@:			ret

;-------------------------------------------
; Skip spaces and test if 1st. [edx]char. = ah. If yes, z = 1
;           [register used : ax]
			align	16
SkipSpaces:		mov	al,[edx]
			cmp	al," "				; [edx]=" "?
			jne	@F				; No, Test ah before end of loop
			inc	edx				; Yes, loop to next char.
			jmp	SkipSpaces
			align	16
@@:			inc	edx				; edx+1 if ah test OK
			cmp	al,ah				; [edx]=ah ?
			je	@F				; Yes, Return with edx+1, pointing on next char.
			dec	edx				; No , edx points on ah char.
@@:			ret

;-------------------------------------------
; Trim spaces 
			align	16
TrimSpaces:		mov	al,[edx]
			cmp	al," "				; [edx]=" "?
			jne	@F				; No, Test ah before end of loop
			inc	edx				; Yes, loop to next char.
			jmp	TrimSpaces
			align	16
@@:			ret

;-----------------------------------------------------------------------------------------------
; Try to obtain a high precision timer
			align	16
GetHTimer:		invoke	QueryPerformanceFrequency,addr HTimerV
			test	eax,eax
			jnz	GetHTimerInfos
			mov	HTimer,0
			ret
GetHTimerInfos:		mov	HTimer,1
			mov	eax,dword ptr HTimerV
			mov	HTimerFREQ,eax
			mov	ebx,1000
			xor	edx,edx
			div	ebx
			mov	HTimerTPMS,eax
			ret

;-----------------------------------------------------------------------------------------------
; This subroutine is called after each API call and display a simple MessageBox with
; 'API Error' if an error occurs.
; Mainly used for debugging stage.
; All 'call TestApiError' can be removed to save execution time
			align	16
TestApiError:		test	eax,eax
			jz	DisplayError
			ret

;------------------------------------------------------------------------------------------------    
; Display the API error number and exit.
			align	16
DisplayError:		invoke	StdOut,addr APIText
			invoke	GetLastError
			invoke	dw2hex,eax,addr NbrBlock
			invoke	StdOut,addr NbrBlock
			invoke	StdOut,addr APIText2
			invoke	ExitProcess,0

;----------------------------------------------------------------------------------------------
; See CMD_BEEP routine
			align	16
Beeep:			invoke	Beep,440,250			; 440 Hz. 250 Msec. (or default Windows alert sound)
			ret

;----------------------------------------------------------------------------------------------- 
; Performs a CR+LF vith eventual scroll up and update cursor position
			align	16
CrLf:			push	edx
			mov	Csbi_CursorPositionX,0		; Csbi_CursorPositionX = 0
			mov	ax,Csbi_CursorPositionY
			cmp	ax,Csbi_WindowBottom		; Csbi_CursorPositionY wil be over Y screen limit ?
			jb	@F				; No, Csbi_CursorPositionY + 1                         
			call	ScrollUp			; Yes, Scroll Up
			jmp	CR1
			align	16
@@:			inc	Csbi_CursorPositionY
			; Update cursor position
CR1:			invoke	SetConsoleCursorPosition,hStdOut,dword ptr Csbi_CursorPositionX
			pop	edx
			ret

;-----------------------------------------------------------------------------------------------
; Redim a new console window with sizes Y (si) and X (di) and update screen colors attributes
; Tests if new size fits in Window's screen sizes
			align	16
RedimWindow:		push	esi
			invoke	GetConsoleScreenBufferInfo,hStdOut,addr Csbi_SizeX
			invoke	GetLargestConsoleWindowSize,hStdOut
			pop	esi
			; X in wtemp1 Y in wtemp2
			mov	dword ptr wtemp1,eax
			cmp	si,wtemp1			; requested width > maximum allowed ?
			ja	E19				; Yes, error <Invalid argument>
			cmp	di,wtemp2			; Same for height
			ja	E19
			mov	ax,si
			mul	di				; ax = Requested Buffer size
			push	eax				; save requested buffer size
			mov	ax,word ptr Csbi_SizeX
			mul	word ptr Csbi_SizeY		; ax = current buffer size
			mov	Csbi_SizeX,si
			mov	Csbi_SizeY,di
			mov	word ptr Csbi_WindowLeft,0	; Update parameters for new window size : X position
			mov	word ptr Csbi_WindowTop,0	; Y position
			dec	si
			dec	di
			mov	Csbi_WindowRight,si		; Bottom-right position X
			mov	Csbi_WindowBottom,di		; Bottom-right position Y
			pop	ebx				; bx = Requested buffer size
			cmp	ax,bx				; Compare it with current buffer
			je	RD1				; If equal sizes, nothing to do, return to caller
			jb	@F				; Current buffer is smaller
			; Current buffer is higher, redim window first, then buffer
			invoke	SetConsoleWindowInfo,hStdOut,1,addr Csbi_WindowLeft
			invoke	SetConsoleScreenBufferSize,hStdOut,dword ptr Csbi_SizeX
			jmp	RD1
			align	16
			; Current buffer is smaller, redim buffer first, then window 
@@:			invoke	SetConsoleScreenBufferSize,hStdOut,dword ptr Csbi_SizeX
			call	TestApiError
			; Invert it
			invoke	SetConsoleWindowInfo,hStdOut,1,addr Csbi_WindowLeft
RD1:			mov	ConsoleCharNbr,ebx		; Save new console screen char. numbers
			; update Csbi buffer
RD3:			invoke	GetConsoleScreenBufferInfo,hStdOut,addr Csbi_SizeX
			xor	eax,eax				; Nothing allowed in input
			invoke	SetConsoleMode,hStdOut,eax
			call	TestApiError
			mov	eax,ENABLE_PROCESSED_INPUT	; Ctrl-C is used to leave MBasic, mouse ignored   
			invoke	SetConsoleMode,hStdIn,eax
			call	TestApiError
			jmp	WE1				; Set screen attributes

;------------------------------------------------------------------------------------------------
			align	16
ScrollUp:		; Scroll up 1 line  [registers used : edx, ecx]
			push	eax
			mov	SMALL_RECT_Left,0		; Init of rectangle borders
			mov	SMALL_RECT_Top,1
			mov	ax,Csbi_SizeX
			mov	SMALL_RECT_Right,ax
			mov	ax,Csbi_SizeY
			mov	SMALL_RECT_Bottom,ax
			mov	eax,ColorsCurrent		; Foreground = 7, Background = 0
 			mov	wtemp1," "			; Char. to fill empty line
			mov	wtemp2,ax			; Colors attributes
			invoke	ScrollConsoleScreenBuffer,hStdOut,addr SMALL_RECT_Left,0,0,addr wtemp1
			call	TestApiError
			pop	eax
			ret

;-----------------------------------------------------------------------------------------------
; WaitLoop waits for ebx milliseconds and returns to caller
			align	16
WaitLoop:		pushad
			invoke	Sleep,ebx
			popad
			ret

;-----------------------------------------------------------------------------------------------
; Return number of milliseconds since Windows started
			align	16
GetTicks:		push	eax
			push	ecx
			push	edx
			invoke	GetTickCount
			mov	ebx,eax
			pop	edx
			pop	ecx
			pop	eax
			ret

;-----------------------------------------------------------------------------------------------
; Allocates standard Input and Output handles for a new console screen 
			align	16
ObtainStdHandles:	invoke	GetStdHandle,STD_INPUT_HANDLE
			call	TestApiError
			mov	hStdIn,eax
			invoke	GetStdHandle,STD_OUTPUT_HANDLE
			call	TestApiError
			mov	hStdOut,eax
			ret

;-----------------------------------------------------------------------------------------------
; Redim window screen with original editor sizes and colors
			align	16
WinEdit:		mov	eax,EditColors			; Set editor colors
			mov	ColorsCurrent,eax
			invoke	GetLargestConsoleWindowSize,hStdOut
			mov	dword ptr wtemp1,eax
			mov	si,EditSizeX			; and sizes
			mov	di,EditSizeY
			; Correct the values if necessary
			cmp	si,wtemp1
			jna	CorrectConX
			mov	si,wtemp1
CorrectConX:		cmp	di,wtemp2
			jna	CorrectConY
			mov	di,wtemp2
CorrectConY:		mov	EditSizeX,si
			mov	EditSizeY,di
			ret
			align	16
WE1:			mov	eax,ColorsCurrent		; fill console screen with current colors attributes
			xor	ecx,ecx				; Starting at cursor position 0,0
			invoke	FillConsoleOutputAttribute,hStdOut,eax,ConsoleCharNbr,ecx,addr dtemp1
			call	TestApiError
			mov	eax,32				; Char. to fill screen with (space)
			invoke	FillConsoleOutputCharacter,hStdOut,eax,ConsoleCharNbr,0,addr dtemp1
			call	TestApiError			; Fill screen xith spaces
			mov	dword ptr Csbi_CursorPositionX,0
			invoke	SetConsoleCursorPosition,hStdOut,dword ptr Csbi_CursorPositionX
			jmp	TestApiError

;-----------------------------------------------------------------------------------------------
; InitP initialize FOR..NEXT and GOSUB stacks pointers
			align	16
InitP:			lea	eax,RunTbl
			mov	RunTblPtr,eax
			xor	eax,eax
			mov	GosLineNum,eax			; To check RETURN without GOSUB
			mov	eax,GosubStack			; GosStackPtr on top of GOSUB stack
			mov	GosStackPtr,eax			; GosStackPtr goes up
			mov	eax,ForNextStack
			add	eax,(6*4)*FORNEXTLEVELS		; (end of stack)
			mov	ForStackPtr,eax			; ForStackPtr goes down
			mov	eax,WhileWendStack
			add	eax,(4*4)*FORNEXTLEVELS		; (end of stack)
			mov	WhileStackPtr,eax		; WhileStackPtr goes down
			mov	WhilePreviousFlag,0
			mov	ForAdrVar,0
			mov	eax,IfStack
			mov	IfStackPtr,eax
			mov	dword ptr [eax-8],0
			or	dword ptr [eax-4],-1
			invoke	FillMem,IfStack,256*8,-1
			ret

;-----------------------------------------------------------------------------------------------
; Test if a variable or array 'XXX(EXPR)' can be found.
; If found, c=0, ebx=variable address, else c=1 [registers used : ax, ebx]
			align	16
DeclareVar:		mov	VarDeclareAllowed,0
			mov	VarLabelAllowed,0
			jmp	TestDeclareVarAddress
			align	16
TestVarLabel:		mov	VarDeclareAllowed,1
			mov	VarLabelAllowed,1
			jmp	TestDeclareVarAddress
			align	16
TestVar:		mov	VarDeclareAllowed,1
			mov	VarLabelAllowed,0
TestDeclareVarAddress:	xor	ah,ah				; Move to first char
			call	SkipSpaces
			mov	DeclaredVarAddress,0
			xor	cl,cl
TestVarAddress:		xor	ebx,ebx
			movzx	eax,byte ptr [edx]
			mov	ah,[VarNameTableFirst+eax]	; Ensure only valid chars
			cmp	ah,"&"				; Address ?
			jne	NotVarAddress
			test	cl,cl				; Defined twice
			jnz	E39
			inc	edx
			or	cl,-1				; Mark it as referenced
			jmp	TestVarAddress			; Check back
			align	16
NotVarAddress:		test	ah,ah				; First char was valid for a var name ?
			je	NoValidVarName
			jmp	GetVariableName
			align	16
NoValidVarName:		stc					; Clear carry
			ret
; Test variable name
			align	16
GetVariableName:	push	esi
			push	edi
			push	ecx
			push	eax
			push	ebx
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,64
			test	eax,eax
			jz	E46
			mov	esi,eax				; Var name slot
			mov	edi,eax
			pop	edx
			pop	ebx
			pop	eax
			mov	ecx,MAXVARNAME
			; Get the variable name
CopyVarName:		movzx	eax,byte ptr [edx]		; Copy variable name
			inc	edx
			mov	al,[VarNameTable+eax]		; Ensure only valid chars
			mov	[edi],al			; (Store null terminating 0 too)
			inc	edi
			cmp	al,1
			je	GotArrayName
			cmp	al,2
			jne	NoLabelTerm
			cmp	VarLabelAllowed,1
			je	GotLabelName
			xor	al,al
			mov	byte ptr [edi-1],0
NoLabelTerm:		test	al,al				; Was an invalid char ?
			jz	GotVarName
			dec	ecx				; Char counter
			test	ecx,ecx				; Max reached ?
			jnz	CopyVarName
			mov	edi,offset Err50		; error <Variable name too long>
			jmp	DispError
			align	16
GotLabelName:		cmp	VarLabelAllowed,0
			je	E66
			mov	byte ptr [edi-1],0		; Correct label name
			mov	WasLabelName,1			; Mark it
			jmp	ProceedArrayName
			align	16
GotArrayName:		mov	byte ptr [edi-1],0		; Correct array name
			mov	WasArrayName,1			; Mark it
			mov	WasLabelName,0
			jmp	ProceedArrayName
			align	16
GotVarName:		mov	WasArrayName,0
			mov	WasLabelName,0
ProceedArrayName:	call	SearchRSSymbol			; Is it a reserved keyword ?
			; Now check if this variable already exists in symbols table
			mov	ebx,VarSymb			; Global table
			mov	ecx,VarNbr
			test	ecx,ecx				; Empty table
			jz	CreateNewVar
			mov	eax,ecx
			dec	eax				; -1
			mov	ecx,eax
			shl	eax,5				; * 16
			add	ebx,eax				; Last variable in table
CheckVarName:		mov	edi,[ebx+VARDAT_NAME]		; Var name ptr
			push	ebx				; Store entry
			pop	ReferencedVarAddress
			push	ecx
			push	esi
			; Name are always copied the same way in uppercase
			; so we can use dwords here.
			mov	ecx,MAXVARNAME/4
CheckVarNameBlock:	mov	eax,[esi]			; Faster with dword
			cmp	[edi],eax			; as it must match exactly
			jne	VarNotFound
			add	esi,4
			add	edi,4
			dec	ecx
			jnz	CheckVarNameBlock
			; Variable found:
			; Free the temporary variable name and proceed
			pop	esi				; Restore name to search
			push	edx
			invoke	GlobalFree,esi
			pop	edx
			pop	ecx				; (Contains index)
			cmp	WasLabelName,1
			je	E53
			cmp	VarDeclareAllowed,0
			je	E53				; Don't allow double symbols
			jmp	EmptyVarNames
			align	16
VarNotFound:		; Variable not found: proceed
			pop	esi				; Restore name to search
			pop	ecx
			sub	ebx,VARDATSIZE			; Previous variable in table
			dec	ecx
			test	ecx,ecx
			jns	CheckVarName
			cmp	WasLabelName,1
			jne	StoreLabel
StoreNewLabel:		mov	DeclaredVarName,esi		; Save name
			cmp	LabelNbr,(MEMLABELSYMBOLS/8)
			jae	MaxVarReached
			push	edx
			mov	edx,esi
			call	SearchLabel
			pop	edx
			test	eax,eax
			jnz	E24
			; Store it as a label
			pop	ecx
			test	cl,cl				; Can't be prefixed
			jnz	E67
			mov	ebx,LabelSymb
			mov	ecx,LabelNbr
			shl	ecx,3				; * 8
			add	ebx,ecx
			mov	[ebx],esi			; Store name
			push	CompPtr				; Store address
			pop	[ebx+4]
			invoke	AddWrapLabel,ebx
			pop	edi
			pop	esi
			inc	LabelNbr
			mov	cl,WRAP_LABEL
			clc
			ret
			; As variable
			align	16
StoreLabel:		mov	ebx,VarSymb			; Global table
			mov	ecx,VarNbr
			mov	eax,ecx
			shl	eax,5				; * 32
			add	ebx,eax				; Last variable in table
			; Can't be found in the table
			; End of table: create new variable
CreateNewVar:		cmp	WasLabelName,1
			je	StoreNewLabel
			cmp	VarDeclareAllowed,0		; Can't use or load an unknown entity
			je	UnknownVarArr
			invoke	GlobalFree,esi			; Free temporary name
			jmp	E58
			align	16
UnknownVarArr:		mov	DeclaredVarName,esi		; Save name
			mov	DeclaredVarAddress,ebx		; Save address
EmptyVarNames:		mov	ebx,ecx				; Will be the index to store
			pop	ecx
			pop	edi
			pop	esi
			shl	ebx,5				; Calc offset in the symbols table
			dec	edx				; Back from invalid char
			cmp	WasArrayName,0
			je	WasAVar
			cmp	VarDeclareAllowed,0
			jne	ArrayReference
			; Declaration of an array
			inc	edx				; (We already know about the bracket)
			call	TstToken			; Need a constant integer
			cmp	WasDouble,VAR_INTEGER
			jne	E28
			mov	ah,")"				; followed by a ")"
			call	SkipSpaces			; OK, ret
			jnz	E31
			test	ebx,ebx				; Need to be >0
			js	E56
			jz	E56
			mov	DeclaredVarSize,ebx
			call	StoreVarHeader			; New entry
			test	cl,cl
			jz	WasArrayAddressDeclare
			; (Will produce an error in this context anyway)
			mov	cl,WRAP_ARRAYADDRESS
			clc
			ret
			align	16
WasArrayAddressDeclare:	mov	cl,WRAP_ARRAY
			clc
			ret
			; --- Reference to an array
			align	16
ArrayReference:		mov	eax,ReferencedVarAddress
			; Must be an explicit array
			cmp	dword ptr [eax+VARDAT_VARARR],DAT_ARRAY
			jne	E58
			test	cl,cl
			jz	WasArrayAddressRef
			invoke	AddWrapArrayAddress,ReferencedVarAddress
			call	StoreArrayAddress
			mov	cl,WRAP_ARRAYADDRESS
			clc
			ret
			align	16
WasArrayAddressRef:	invoke	AddWrapArray,ReferencedVarAddress
			call	StoreArrayAddress
			mov	cl,WRAP_ARRAY
			clc
			ret
			align	16
StoreArrayAddress:	; Check that an expression is there
			; (To be modified for dynamic arrays handling)
			call	TestParenth
			; Array index must be present and must be constant integer
			clc
			ret
			align	16
			; Store it as a variable
WasAVar:		cmp	VarDeclareAllowed,0
			jne	VariableReference
			call	StoreVarHeader			; Create variable datas
			jmp	WriteVarDatas
			align	16
VariableReference:	mov	eax,ReferencedVarAddress
			; Must be an explicit variable
			cmp	dword ptr [eax+VARDAT_VARARR],DAT_VARIABLE
			jne	E58
WriteVarDatas:		test	cl,cl
			jz	WasVarAddress
			invoke	AddWrapVarAddress,ebx
			mov	cl,WRAP_VARADDRESS
			clc
			ret
			align	16
WasVarAddress:		invoke	AddWrapVar,ebx
			mov	cl,WRAP_VAR
			clc
			ret
			align	16
E51:			mov	edi,offset Err51		; Error: <Symbol table space exhausted>
			jmp	DispError
			align	16
E53:			mov	edi,offset Err53		; Error: <Symbol already defined>
			jmp	DispError
			align	16
E56:			mov	edi,offset Err56		; Error: <Invalid array size>
			jmp	DispError
			align	16
E66:			mov	edi,offset Err66		; Error: <Illegal use of label name>
			jmp	DispError
			align	16
E67:			mov	edi,offset Err67		; Error: <Illegal label name>
			jmp	DispError
			align	16
E24:			mov	edi,offset Err24		; Error: <Label already defined>
			jmp	DispError
; Search a reserved symbol
; (Not allowed for variables names)
			align	16
SearchRSSymbol:		mov	ebx,PtrTblFnc			; (we can trash ebx here)
			movzx	eax,byte ptr [esi]		; Take first char of var name
			mov	ebx,[ebx+eax*4]			; Get the corresponding table
			push	edx
			mov	edx,esi				; New variable name
			push	edi
			push	ecx
			mov	edi,edx				; Save name
SearchInSymb:		mov	ecx,[ebx]
			test	ecx,ecx
			jz	@F
			add	ebx,4-1
SearchSymbChar:		mov	al,[edx]
			inc	edx
			inc	ebx
			cmp	[ebx],al
			je	SymbCharFound
			lea	ebx,[ebx+ecx+4]
			mov	edx,edi
			jmp	SearchInSymb
			align	16
SymbCharFound:		dec	ecx
			jnz	SearchSymbChar
			cmp	byte ptr [edx],0		; Was it the end of the name ?
			jne	@F				; No: then accept it
			pop	ecx
			pop	edi
			pop	edx
			mov	edi,offset Err52		; Error: <Illegal use of reserved symbol>
			jmp	DispError
			align	16
@@:			pop	ecx
			pop	edi
			pop	edx
			ret
			; Store a newly created variable or array
			align	16
StoreVarHeader:		cmp	VarNbr,(MEMVARSYMBOLS/VARDATSIZE)
			jae	MaxVarReached
			inc	VarNbr				; Increase number of variables
			push	ebx
			push	esi
			mov	esi,DeclaredVarName
			mov	ebx,DeclaredVarAddress
			mov	dword ptr [ebx],0			; Datas pointer
			mov	dword ptr [ebx+VARDAT_RESERVED],0	; Future extensions
			mov	dword ptr [ebx+VARDAT_TYPE],VAR_INTEGER	; (Default type)
			mov	[ebx+VARDAT_NAME],esi			; Name of var/array
			mov	dword ptr [ebx+VARDAT_VARARR],DAT_VARIABLE
			mov	dword ptr [ebx+VARDAT_ARRLBOUND],0	; Reserved for LBOUND
			; Note: ubound is fixed to 1 for variables
			; due to renewall procedure that needs to free 
			; at least one string element.
			mov	dword ptr [ebx+VARDAT_ARRUBOUND],1	; Size of elements/UBOUND
			pop	esi
			pop	ebx
			ret
			align	16
MaxVarReached:		invoke	GlobalFree,DeclaredVarName
			jmp	E51

;-----------------------------------------------------------------------------------------------
; Test an ASCII integer 32 bits number from [edx]. ebx = binary result or 0 if not.
; [registers used : eax, ecx]
			align	16
TstNum:			push	edi
			xor	ebx,ebx				; bx = binary result
			mov	ch,bh				; ch=0. Char. counter
			xor	eax,eax				; cancel SkipSpaces comparison
			call	SkipSpaces			; al = first char. found
			cmp	al,"0"				; Hex prefix ?
			jne	@F
			cmp	byte ptr [edx+1],"X"
			je	GetHex
			cmp	byte ptr [edx+1],"x"
			je	GetHex
			cmp	byte ptr [edx+1],"B"
			je	GetBin
			cmp	byte ptr [edx+1],"b"
			jne	@F
GetBin:			; Binary numbers conversion
			inc	edx
			lea	edi,BINTab
ConvertBin:		inc	edx
			mov	al,[edx]
			mov	al,[edi+eax]
			test	al,al				; Invalid char ?
			js	R1
			inc	ch				; Char. counter
			cmp	ch,33				; Overflow
			je	E3
			add	ebx,ebx
			or	ebx,eax
			jmp	ConvertBin
			align	16
GetHex:			; Hex numbers conversion
			inc	edx
			lea	edi,HEXTab
ConvertHex:		inc	edx
			mov	al,[edx]
			mov	al,[edi+eax]
			test	al,al				; Invalid char ?
			js	R1
			inc	ch				; Char. counter
			cmp	ch,9				; Overflow
			je	E3
			shl	ebx,4				; XXXXXXXY-> XXXXXXYX
			or	ebx,eax
			jmp	ConvertHex
			; Decimal numbers conversion
			align	16
@@:			cmp	al,"0"				; char al must be between '0' & '9'.
			jc	R1				; If not, return
			cmp	al,":"
			jnc	R1
			inc	ch				; Char. counter
			push	ecx
			mov	eax,ebx				; bx=(bx*10) + new al char. value
			mov	ecx,10
			push	edx				; edx will be modified by MUL
			mul	ecx
			mov	ebx,eax				; Partial result (bx=bx*10)
			pop	edx
			xor	eax,eax
			mov	al,[edx]			; al = ASCII value '0' to '9'
			sub	al,48				; now in binary value
			inc	edx
			add	ebx,eax				; added do ebx
			mov	al,[edx]
			pop	ecx				; Char. counter
			cmp	ch,11
			jne	@B				; Next char. or error if sign Flag = 1
E3:			mov	edi,offset Err3			; Error : <Numeric value overflow>
			jmp	DispError
			align	16
R1:			pop	edi
			ret

;-----------------------------------------------------------------------------------------------
; Test an ASCII string between quotes
; Return the address of the string in the table or 0
; (Called from TstToken)
			align	16
TstString:		push	ecx
			xor	ecx,ecx
			cmp	al,34
			jne	NotAString
			inc	edx
			mov	ebx,LitStringsPtr
			push	ebx
			mov	ecx,LitStringsEnd
GetString:		mov	al,[edx]
			inc	edx
			cmp	al,34
			je	@F
			cmp	ebx,ecx
			jae	E43
			mov	[ebx],al
			inc	ebx
			inc	LitStringsPtr
			cmp	al,0dh
			jne	GetString
			mov	edi,offset Err36
			jmp	DispError
			align	16
E43:			mov	edi,offset Err43
			jmp	DispError
			align	16
@@:			mov	byte ptr [ebx],0
			inc	LitStringsPtr
			mov	WasDouble,VAR_STRING
			pop	ebx
NotAString:		pop	ecx
			ret

; String without quotes (called from INPUT)
			align	16
GetPlainString:		push	ecx
			xor	ecx,ecx
			mov	ebx,LitStringsPtr
			cmp	wtemp3,1
			jne	ErrInString
			xor	ebx,ebx
			mov	WasDouble,VAR_STRING
			pop	ecx
			ret
			align	16
ErrInString:		push	ebx
			mov	ecx,LitStringsEnd
StorePlainString:	mov	al,[edx]
			cmp	al,27
			je	@F
			cmp	al,0dh
			je	@F
			inc	edx
			cmp	ebx,ecx
			jae	E43
			mov	[ebx],al
			inc	ebx
			inc	LitStringsPtr
			test	al,al
			jnz	StorePlainString
@@:			mov	byte ptr [ebx],0
			inc	LitStringsPtr
			mov	WasDouble,VAR_STRING
			pop	ebx
			pop	ecx
			ret

;-----------------------------------------------------------------------------------------------
; Test an ASCII Double number from [edx]. 
			align	16
TstToken:		xor	ebx,ebx				; bx = binary result
			call	TstString
			test	ebx,ebx
			jz	ContWithDouble
			ret
			align	16
ContWithDouble:		push	edx				; Fall back
			mov	ch,bh				; ch=0. Char. counter
			xor	ah,ah				; cancel SkipSpaces comparison
			call	SkipSpaces			; al = first char. found
			push	edi
			mov	edi,DblString
			cmp	wtemp3,1
			jne	SearchFloatingPoint
			mov	byte ptr [edi],"-"		; Add minus sign if reported previously
			inc	edi
			; Conversion loop
SearchFloatingPoint:	cmp	al,'.'
			je	PassStrDoubleChar
			cmp	al,'E'
			je	PassStrDoubleExpChar
			cmp	al,'e'
			je	PassStrDoubleExpChar
			test	ebx,2				; Search a possible exponent
			jz	SearchExponentSign		; sign if value is a floating point
			cmp	al,'+'
			je	FoundExponentSign
			cmp	al,'-'
			jne	SearchExponentSign
FoundExponentSign:	test	ebx,4
			jnz	R1Dbl
			or	ebx,4
			jmp	NoDoubleYet
			align	16
SearchExponentSign:	cmp	al,'0'
			jc	R1Dbl
			cmp	al,":"
			jnc	R1Dbl
			jmp	NoDoubleYet
			align	16
PassStrDoubleExpChar:	test	ebx,2				; Only one exponent
			jnz	E25
			or	ebx,2				; Found exponent
			jmp	NoDoubleYet
			align	16
PassStrDoubleChar:	test	ebx,1				; Only one dot
			jnz	E25
			or	ebx,1				; Mark it as floating point
NoDoubleYet:		inc	ch				; Char. counter
			mov	[edi],al
			inc	edi
			inc	edx
			mov	al,[edx]
			jmp	SearchFloatingPoint
			align	16
R1Dbl:			mov	byte ptr [edi],0		; Append zero
			test	ebx,1
			jz	NoDoubleFound
			push	ecx
			invoke	StringToDouble,DblString,addr DblVal
			pop	ecx
			test	eax,eax
			jnz	CorrectDouble
E25:			mov	edi,offset Err25
			jmp	DispError
			align	16
CorrectDouble:		pop	edi
			mov	WasDouble,VAR_DOUBLE
			add	esp,4				; Don't restore edx
			ret
			align	16
NoDoubleFound:		pop	edi
			pop	edx				; Restore position
			mov	WasDouble,VAR_INTEGER
			jmp	TstNum				; And check again with standard routine

;----------------------------------------------------------------------------------------------- 
; Load a variable.
			align	16
AssignVar:		call	LoadVariables			; or variables...
			jmp	CmdEnd

			align	16
SearchKeyword:		xor	ah,ah				; No char. for SkipSpaces
			call	SkipSpaces
			push	edi
			push	ecx
			mov	edi,edx
ExecuteCmd:		mov	ecx,[ebx]
			test	ecx,ecx
			jz	@F
			add	ebx,4-1				; Start of keyword-1 (see inc ebx below)
EX1:			mov	al,[edx]			; al = text letter 
			inc	edx				; Text pointer +1
			inc	ebx				; Keywords table pointer +1
			cmp	[ebx],al			; and compare...
			je	EX2				; yes, identicals
			lea	ebx,[ebx+ecx+4]			; Wrap to next entry in the table
			mov	edx,edi				; Restore text
			jmp	ExecuteCmd			; Test next keyword (no need to skip spaces again)
			align	16
EX2:			dec	ecx
			jnz	EX1
			pop	ecx
			inc	ebx				; else, keyword found. ebx points on routine execution
			pop	edi
			jmp	dword ptr [ebx]			; and jump to routine address
			align	16
@@:			pop	ecx
			add	ebx,4+1				; keyword not found.
			pop	edi
			jmp	dword ptr [ebx]
			; Search for a function/variable name
			align	16
SearchKeywordFnc:	xor	ah,ah				; No char. for SkipSpaces
			call	SkipSpaces
			push	edi
			push	ecx
			push	esi
			; Retrieve the len of the keyword to check
			mov	esi,edx
SearchFncLen:		movzx	eax,byte ptr [esi]
			mov	cl,[VarNameTableFnc+eax]
			test	cl,cl
			jz	FoundFncLen
			inc	esi
			jmp	SearchFncLen
			align	16
FoundFncLen:		sub	esi,edx				; Length
SearchFncAgain:		mov	edi,edx
SearchFnc:		mov	ecx,[ebx]
			push	ecx
			test	ecx,ecx
			jz	@F
			add	ebx,4-1
SearchCharFnc:		mov	al,[edx]
			inc	edx
			inc	ebx
			cmp	[ebx],al
			je	FoundCharFnc
			lea	ebx,[ebx+ecx+4]
			mov	edx,edi
			pop	ecx
			jmp	SearchFnc
			align	16
FoundCharFnc:		dec	ecx
			jnz	SearchCharFnc
			mov	ecx,[esp]			; (Length of function name)
			cmp	esi,ecx				; Compare lengths
			je	FncNameMatch
			; Doesn't match
			pop	ecx
			add	ebx,4+1				; keyword not found.
			mov	edx,edi				; Start of keyword
			jmp	SearchFncAgain
			align	16
FncNameMatch:		pop	ecx
			pop	esi
			pop	ecx
			pop	edi
			inc	ebx				; else, keyword found. ebx points on routine execution
			jmp	dword ptr [ebx]			; and jump to routine address
			align	16
@@:			pop	ecx
			pop	esi
			pop	ecx
			add	ebx,4+1				; keyword not found.
			pop	edi
			jmp	dword ptr [ebx]			; (End of list)

;-----------------------------------------------------------------------------------------------
; Execute a line (prefixed with a line number)
			align	16
ExecLine:		mov	ebx,[edx]			; No, Line number in location LineNumber
			mov	LineNumber,ebx
			add	edx,4				; edx skip binary line number & points on 1st. line char
			mov	ebx,OperStack
			mov	OperStackPtr,ebx
			; Free the temporary strings allocated for the previous expression
			call	FreeTmpStrings
			mov	ebx,RunTblPtr
			movsx	eax,word ptr [edx]		; Get command (+ extend sign)
			add	edx,2				; (command datas)
			jmp	dword ptr [ebx+eax*4]		; Jump to command routine

;-----------------------------------------------------------------------------------------------
; Ucase converts all typed line char. in upper case, except "strings" and REM, from edx to ecx
			align	16
Ucase:			call	TrimSpaces			; Trim the spaces before the command
			mov	btemp1,0			; Reset quote flag
			xor	eax,eax
UC1:			cmp	ecx,edx				; Reached end of line ?
			jb	UC2				; Yes, return to caller
			mov	al,[edx]
			cmp	al,34				; Quote ?
			jne	@F
			xor	btemp1,1			; Switch btemp1 flag value between 0 and 1
@@:			test	btemp1,1			; String is being read ?
			jnz	UcaseString			; Yes, ignore this char.
			cmp	al,"'"				; Comment ?
			je	UC2				; Yes, nothing more to modify in the line. Return to caller
			cmp	al,"a"				; If char = 'a' to 'z'
			jb	NoLetterREM
			cmp	al,"z"
			ja	NoLetterREM
			sub	al,32				; convert it in upper case
			mov	[edx],al
NoLetterREM:		test	btemp1,16			; 10000
			jnz	UcaseString
			cmp	al,"R"				; Handle REM command
			jne	Rem1
			or	btemp1,2			; 10
Rem1:			cmp	al,"E"
			jne	Rem2
			test	btemp1,2
			jz	Rem2
			or	btemp1,4			; 100
Rem2:			cmp	al,"M"
			jne	NoLetter
			test	btemp1,4
			jz	NoLetter
			or	btemp1,8			; 1000
NoLetter:		mov	al,btemp1
			and	al,14				; 1110 ? found a REM !
			cmp	al,14				; Stop process
			je	UcaseREM			; if found
UcaseString:		inc	edx
			jmp	UC1
			align	16
UcaseREM:		cmp	dword ptr [edx-2]," MER"
			je	UC2				; or just a line containing R...E...M... ?
			inc	edx
			or	btemp1,16			; 10000
			jmp	UC1
			align	16
UC2:			ret

;-----------------------------------------------------------------------------------------------
; Remove all tabs of from a text line
			align	16
RemoveTabs:		mov	btemp1,0
			xor	eax,eax
RemTab1:		cmp	ecx,edx
			jb	RemTab2
			mov	al,[edx]
			cmp	al,34
			jne	@F
			xor	btemp1,1
@@:			test	btemp1,1
			jnz	NoTabToRemove
			cmp	al,9
			jne	NoTabToRemove
			mov	byte ptr [edx]," "
NoTabToRemove:		inc	edx
			jmp	RemTab1
			align	16
RemTab2:		ret

;-----------------------------------------------------------------------------------------------
; Normalize referenced labels
; Write expressions if needed and correct labels references
; (Needed with forward references)
			align	16
NormalizeLabels:	push	eax
			push	ebx
			push	ecx
			push	edx
			push	esi
			push	edi
NormNextCmd:		mov	eax,CompEnd
			dec	eax
			cmp	eax,edx				; End.
			jb	@F
			push	dword ptr [edx]			; Save line number
			pop	LineNumber
			add	edx,4				; Pass line number
			movsx	eax,word ptr [edx]		; Get command
			add	edx,2
			cmp	eax,WRAP_CMD_GOTO
			je	CorrectRef
			cmp	eax,WRAP_CMD_GOSUB
			je	CorrectRef
			add	edx,4				; Pass expression pointer
			inc	edx				; Pass terminator
			jmp	NormNextCmd
			align	16
CorrectRef:		mov	ebx,[edx]			; Get expression pointer
			inc	ebx				; Pass INTEGER flag
			push	CompExprPtr			; Store new expression pointer
			pop	dword ptr [edx]
			; Set new expression pointer at current position
			push	edx
			; Get backward text pointer (referenced label)
			mov	edx,[ebx]
			; No need to correct referenced line numbers
			mov	al,[edx]
			cmp	al,"0"
			jb	WasNotANumber
			cmp	al,"9"
			jbe	WasANumber
WasNotANumber:		; Check if it is a label
			call	SearchLabel
			test	eax,eax
			jz	E11
			pop	edx
			invoke	AddWrapLabel,eax
			jmp	LabelCorrected
			align	16
E11:			mov	edi,offset Err11		; else, error <Label not found>
			jmp	DispError
			align	16
WasANumber:		; Get the (numeric) expression
			call	EvalExpr
			pop	edx
LabelCorrected:		add	edx,4				; Pass expression pointer now
			inc	edx				; Pass terminator
			jmp	NormNextCmd
			align	16
@@:			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			pop	ebx
			pop	eax
			ret

			; Go to end of a line after a label
			align	16
PassLine:		cmp	byte ptr [edx],0dh
			je	PassEOL
			cmp	byte ptr [edx],":"
			je	PassEOL
			inc	edx
			jmp	PassLine
			align	16
PassEOL:		ret

;-----------------------------------------------------------------------------------------------
; Search for a label in table
; Return label address in eax or 0
			align	16
SearchLabel:		xor	ah,ah
			call	SkipSpaces
			push	ebx
			push	ecx
			push	esi
			mov	esi,LabelSymb
			mov	ecx,LabelNbr
			test	ecx,ecx
			jz	NoLabelToSearch
SearchLabelTable:	mov	ebx,[esi]			; Take label name
			push	ecx
			push	edx
CheckLblName:		mov	al,[ebx]
			test	al,al
			jz	EndOfLabelName
			cmp	[edx],al
			jne	WrongLabelName
			inc	ebx
			inc	edx
			jmp	CheckLblName
			align	16
EndOfLabelName:		cmp	byte ptr [edx],0
			je	LabelNameOk
			cmp	byte ptr [edx],0dh
			je	LabelNameOk
			jmp	WrongLabelName
			align	16
LabelNameOk:		pop	eax				; (From edx to garbage)
			pop	ecx				; Label found
			mov	eax,[esi+4]			; Return jump address
			jmp	FoundLabel
			align	16					
WrongLabelName:		pop	edx
			pop	ecx
			add	esi,8
			dec	ecx				; Next label
			jnz	SearchLabelTable
NoLabelToSearch:	xor	eax,eax
FoundLabel:		pop	esi
			pop	ecx
			pop	ebx
			ret

;-----------------------------------------------------------------------------------------------
; Pre-compile a program prior to an execution (or full compilation).
; (Just replace commands with their numbers and length)
; Output encoding:
; 1.l: line number
; 1.w: command number
; 1.l: pointer to parameters block
; 1.b: 0dh char
; Lines containing several commands are "unfolded".
; Comments are completly removed.
; Variables assignments are passed "as is" with -1 command
; Spaces are NOT stripped (we need them for the interpreter).
; IF command is a special case:
; we need to obtain the expression following it and then the possible command.
			align	16
PreComp:		mov	CompPtr,ebx
			mov	CompExprPtr,ecx
			xor	ebx,ebx
			call	FindLine			; Point in first line
PreLine:		jnc	@F				; If c=1, end of text, else proceed with next line
			mov	ebx,CompPtr
			mov	CompEnd,ebx
			mov	ebx,CompExprPtr
			mov	CompExprEnd,ebx
			ret
			align	16
@@:			push	edi
			push	ecx
			call	PreCompSingleLine
			pop	ecx
			pop	edi
			xor	ebx,ebx
			call	LineNumCompare			; Find next line to print
			jmp	PreLine				; and loop back
			align	16
; Pre-compile a single line
PreCompSingleLine:	mov	edi,[edx]
			mov	PreCompLine,edi
			add	edx,4				; Pass line number now
PreCompCheckMulti:	mov	PreCompNbr,0
			lea	edi,PreCompTbl
			; Search the command in the list
			mov	ah,0dh				; Check empty line
			call	SkipSpaces			; + skip leading spaces
			jz	PreCompNext
PreCompAgain:		mov	ebx,[edi]			; Get address of command
			mov	ecx,[ebx]			; Len (min=1)
			mov	PreCompLen,cx
			add	ebx,4				; Go to keyword
			push	esi
			mov	esi,edx				; Save position of text
PreCompSearch:		mov	al,[edx]
			cmp	[ebx],al
			je	PreCompCheckChar
			; Not found: next command
			add	edi,4
			inc	PreCompNbr
			; Command can't be found in the whole table
			; Write it as a variable assignment
			; the interpreter will check for the validity of the
			; statement itself.
			cmp	PreCompNbr,NBRPRECOMPTBL
			jne	MaxPreComp
			mov	PreCompNbr,-1			; -1 = var assignment
			mov	edx,esi				; Start of line
			; (don't pass over any command in this case)
			jmp	CompVar
			align	16
MaxPreComp:		mov	edx,esi
			pop	esi
			jmp	PreCompAgain
			align	16
PreCompCheckChar:	inc	ebx
			inc	edx
			dec	ecx
			jne	PreCompSearch
			; Ensure that a space or enter char follows the found command
			cmp	byte ptr [edx]," "
			je	PreCompTrailingSpc
			cmp	byte ptr [edx],0dh		; Empty...
			je	PreCompTrailingSpc
			cmp	byte ptr [edx],":"		; Next command
			je	PreCompTrailingSpc
			cmp	PreCompNbr,0			; Comments don't need
			je	PreCompTrailingSpc		; trailing spaces
			mov	eax,PreCompLine
			mov	LineNumber,eax			; Register the line
			jmp	E1
			align	16
PreCompTrailingSpc:	; Found it: backup'n'modify the line in back buffer
			mov	edx,esi				; Start of line
			movzx	eax,PreCompLen			; Pass over command
			add	edx,eax
CompVar:		cmp	PreCompNbr,COMPREM
			je	PreCompStripREM
			cmp	PreCompNbr,0			; Handle comments
			jne	PassCompREM
PreCompStripREM:	; Write a commented line
			mov	eax,PreCompLine
			mov	ebx,CompPtr
			mov	[ebx],eax			; Write line number
			add	ebx,4
			mov	ax,PreCompNbr
			mov	[ebx],ax			; Write command number
			add	ebx,2
			mov	dword ptr [ebx],0		; No args
			add	ebx,4
			; Go to end of line
WrapCommentsComp:	mov	al,[edx]
			cmp	al,0dh
			jz	@F
			inc	edx
			jmp	WrapCommentsComp
@@:			inc	edx
			jmp	WrapComments
			align	16
PassCompREM:		mov	eax,PreCompLine
			mov	LineNumber,eax
			mov	eax,OperStack			; Reset expressions stack here
			mov	OperStackPtr,eax		; (Local to one command)
			; LET is handled as a standard variable assignment
			cmp	PreCompNbr,COMPLET		; Same as var assignment
			je	WrapVarLet
			cmp	PreCompNbr,-1			; -1 = var assignment
			jne	PassCompVar
WrapVarLet:		push	ecx
			push	esi
			push	edi
			mov	edi,CompExprPtr
			mov	SaveCompExprPtr,edi
			call	VarEquExpr
			pop	edi
			pop	esi
			pop	ecx
			mov	eax,PreCompLine
			mov	ebx,CompPtr
			mov	[ebx],eax			; Write line number
			mov	ax,PreCompLen
			add	ebx,4
			mov	ax,PreCompNbr
			mov	[ebx],ax			; Write command number
			add	ebx,2
			mov	eax,SaveCompExprPtr
			mov	[ebx],eax			; Save address of decoded var loading
			add	ebx,4
			jmp	CompCmdTerminator
			align	16
PassCompVar:		push	ecx
			push	esi
			push	edi
			mov	edi,CompExprPtr
			mov	SaveCompExprPtr,edi
			movzx	eax,word ptr PreCompNbr
			call	[RunTblComp+eax*4]
			pop	edi
			pop	esi
			pop	ecx
PassOtherCmd:		mov	eax,PreCompLine
			mov	ebx,CompPtr
			mov	[ebx],eax			; Write line number
			mov	ax,PreCompLen
			add	ebx,4
			mov	ax,PreCompNbr
			mov	[ebx],ax			; Write command number
			add	ebx,2
			; Write a pointer to calculated expression
			mov	eax,SaveCompExprPtr
			mov	[ebx],eax			; Save address of decoded var loading
			add	ebx,4
CompCmdTerminator:	mov	byte ptr [ebx],0dh		; End of IF
			inc	ebx
			mov	CompPtr,ebx
			pop	esi
PassCommandSeps:	cmp	byte ptr [edx],":"		; Another command following ?
			jne	PassLineSeparator
			inc	edx
			jmp	PassCommandSeps
			align	16
PassLineSeparator:	jmp	PreCompCheckMulti
			; Store the line terminator first
			align	16
WrapComments:		mov	byte ptr [ebx],0dh
			inc	ebx
			mov	CompPtr,ebx
PreCompComment:		pop	esi
PreCompNext:		ret

;-----------------------------------------------------------------------------------------------
; Save FOR loop parameters FOR stack
			align	16
ForPushStack:		mov	eax,ForStackPtr
			cmp	eax,ForNextStack		; ForStackPtr out of ForNextStack area limit ?
			ja	@F				; No, OK
			mov	edi,offset Err15
			jmp	DispError			; Yes, error <Available FOR..NEXT levels exhausted>
			align	16
@@:			xchg	eax,esp				; esp at the top of stack area
			push	ForTested
			push	ForAdrVar			; Save 5 parameters of FOR..NEXT loop
			push	ForPtrTxt
			push	ForLine				; backward line
			push	ForLimit			; Max
			push	ForIncrement			; Step
			xchg	esp,eax				; Restore esp
			mov	ForStackPtr,eax			; update FOR..NEXT stack pointer
			ret

;-----------------------------------------------------------------------------------------------
; Save WHILE loop parameters
			align	16
WhilePushStack:		mov	eax,WhileStackPtr
			cmp	eax,WhileWendStack
			ja	@F
			mov	edi,offset Err63
			jmp	DispError			; Yes, error <Available WHILE..WEND levels exhausted>
			align	16
@@:			xchg	eax,esp
			push	WhileExecTable			; Save previous exec table
			push	WhilePreviousFlag
			push	WhilePtrTxt
			push	WhileLine
			xchg	esp,eax
			mov	WhileStackPtr,eax
			ret

;----------------------------------------------------------------------------------------------
; LoadVariables test end of line.
; If found execute next line, else execute a variable assignation
; Strings are stored in main memory (allocated) other are stored in vars slots.
; Datas conversions are performed if necessary.			
; Return variable address in ecx
			align	16
LoadVariables:		; Can be a variable assignation of an array assignation
			mov	eax,[edx]			; Get address
			add	edx,4
			mov	bl,[eax]			; Get command
			cmp	bl,WRAP_VARADDRESS		; Can't assign to an address
			je	E39
			cmp	bl,WRAP_ARRAYADDRESS
			je	E39
			cmp	bl,WRAP_VAR
			jne	GetArrayAssign
			inc	eax				; (pass command)
			mov	ebx,[eax]			; Get variable offset
			add	eax,4				; Point to first data of loading expr
			add	ebx,VarSymb			; Calculate address
			push	dword ptr [ebx+VARDAT_TYPE]
			pop	VarToLoadType
			mov	ebx,[ebx+VARDAT_DATASPTR]	; Take pointer to variable
LoadVarValue:		push	ebx				; Save it
			push	edx
			mov	edx,eax				; pass new pointer
			call	EvalExprCOMP			; Evaluate
			mov	eax,edx				; obtained new pos
			pop	edx
			pop	ecx				; (from ebx)
			cmp	ExprFinalResult,VAR_STRING
			je	StoreStringVar
			cmp	ExprFinalResult,VAR_DOUBLE
			je	StoreDoubleVar
			; Integer -> String
			cmp	VarToLoadType,VAR_STRING
			jne	LoadIntegerIntoString
			push	eax
			push	ecx
			push	edx
			push	edi
			call	IntToStringNoPad
			lea	ebx,dtemp1
			pop	edi
			pop	edx
			pop	ecx
			pop	eax
			jmp	StoreStringVarDirect
			align	16
LoadIntegerIntoString:	; Integer -> Double
			cmp	VarToLoadType,VAR_DOUBLE
			jne	LoadIntegerIntoDouble
			mov	FpIntLoad,ebx
			fild	FpIntLoad			; Load it as integer
			fstp	qword ptr [ecx]			; Store floating point (DAT1/DAT2)
			ret
			align	16
LoadIntegerIntoDouble:	; Integer -> Integer
			mov	[ecx],ebx			; DAT1
			ret
			align	16
StoreDoubleVar:		; Double -> String
			cmp	VarToLoadType,VAR_STRING
			jne	LoadDoubleIntoString
			fstp	DblVal
			invoke	DoubleToString,DblVal,15,addr DblTemp
			test	eax,eax
			jz	E25
			lea	ebx,DblTemp
			jmp	StoreStringVarDirect
			align	16
LoadDoubleIntoString:	; Double -> Integer
			cmp	VarToLoadType,VAR_INTEGER
			jne	StoreDoubleDat
			frndint
			fistp	DblToInt
			mov	ebx,DblToInt
			mov	[ecx],ebx			; DAT1
			ret
			align	16
StoreDoubleDat:		; Double -> Double
			fstp	qword ptr [ecx]			; Store floating point (DAT1/DAT2)
			ret
			align	16
StoreStringVar:		cmp	VarToLoadType,VAR_STRING
			je	StoreStringVarDirect
			; Try to convert the number inside the string
			push	ecx
			push	edx
			push	edi
			mov	edx,ebx
			mov	WasDouble,VAR_STRING		; Default value
			mov	wtemp3,0
			call	CheckTermSign
			test	ebx,ebx
			jz	@F
			mov	wtemp3,1
@@:			mov	al,[edx]
			call	TstToken			; Or is it a number ?
			cmp	byte ptr [edx],0
			jne	E57
			pop	edi
			pop	edx
			pop	ecx
			cmp	WasDouble,VAR_STRING		; Was it a string ?
			je	E57				; Error: Type mismatch
			cmp	WasDouble,VAR_INTEGER
			je	LoadStringIntoDouble
			; String -> Double
			fld	qword ptr [DblVal]
			cmp	VarToLoadType,VAR_INTEGER
			je	StoreStringInteger
			fstp	qword ptr [ecx]			; Store floating point (DAT1/DAT2)
			ret
			align	16
StoreStringInteger:	; Dest variable is an integer
			frndint
			fistp	DblToInt
			mov	ebx,DblToInt
			mov	[ecx],ebx			; DAT1
			ret
			align	16
LoadStringIntoDouble:	cmp	wtemp3,1
			jne	ChangeStringIntSign
			neg	ebx
ChangeStringIntSign:	cmp	VarToLoadType,VAR_INTEGER
			je	StoreStringDouble
			; Dest variable is a Double
			; String -> Double
			mov	FpIntLoad,ebx
			fild	FpIntLoad
			fstp	qword ptr [ecx]			; Store floating point (DAT1/DAT2)
			ret
			align	16
StoreStringDouble:	; String -> Integer
			mov	[ecx],ebx			; DAT1
			ret
			align	16
StoreStringVarDirect:	; If it was already a string then we need to release it first
			push	eax
			push	ebx
			push	ecx
			push	edx
			invoke	GlobalFree,dword ptr [ecx]
			pop	edx
			pop	ecx
			pop	ebx
			pop	eax
FreeString:		push	eax
			push	esi
			push	edi
			push	ecx
			push	edx
			; Get len of string
			; (begin at 0) so min len=1
			mov	esi,ebx
			mov	ecx,esi
GetLoadStrLen:		mov	al,[ecx]
			inc	ecx
			test	al,al				; then test
			jnz	GetLoadStrLen
			sub	ecx,esi
			push	ebx
			push	ecx
			; Alloc it in main memory
			invoke	GlobalAlloc,GMEM_FIXED,ecx
			test	eax,eax
			jz	E46
			pop	ecx
			pop	ebx
			; Now, copy it into allocated memory
			mov	esi,ebx
			mov	edi,eax
			mov	ebx,eax				; Save dest
			cld
			push	ecx
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			pop	edx
			pop	ecx
			pop	edi
			pop	esi
			pop	eax
			; Finally store it in var table
			mov	[ecx],ebx			; DAT1
			ret
			; --- Array elements loading
			align	16
GetArrayAssign:		cmp	bl,WRAP_ARRAY			; An array index...
			jne	@F				; No: might be a label
			inc	eax				; pass command
			push	edx
			push	dword ptr [eax]
			add	eax,4
			push	edx
			mov	edx,eax
			call	GetArrayArgs
			mov	eax,edx
			pop	edx
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			js	E40
			pop	edx
			test	edx,edx
			jz	E58
			cmp	ebx,[edx+VARDAT_ARRLBOUND]	; Check bounds
			jb	E59
			cmp	ebx,[edx+VARDAT_ARRUBOUND]
			ja	E59
			push	ecx
			mov	ecx,[edx+VARDAT_TYPE]
			mov	VarToLoadType,ecx
			call	[TypeLenTable+ecx*4]
			add	ebx,[edx+VARDAT_DATASPTR]	; Get datas
			pop	ecx
			pop	edx	
			jmp	LoadVarValue
			align	16
@@:			ret
			align	16
E39:			mov	edi,offset Err39		; Error: <Unexpected address>
			jmp	DispError
			align	16
E46:			mov	edi,offset Err46		; Error: <Not enough memory available for operation>
			jmp	DispError
			align	16
E57:			mov	edi,offset Err57		; Error: <Type mismatch>
			jmp	DispError
			align	16
E58:			mov	edi,offset Err58		; Error: <Unknown symbol>
			jmp	DispError
			align	16
E59:			mov	edi,offset Err59		; Error: <Array index out of bounds>
			jmp	DispError

;----------------------------------------------------------------------------------------------
; EvalExpr evaluates arithmetic or relational expressions.
; <EXPR> = <EXPR2> or <EXPR2><REL.OP><EXPR2>
; Where <REL.OP> is one of the operators in TAB_REL_OP and the result of these operations is
; 1 if True or 0 if False
; <EXPR2> = (+ or -) <EXPR3> (+ or -) <EXPR3> (....)
; Where () are optional and (....) are optional repeats.
; <EXPR3> = <EXPR2> (* or / or \) <EXPR2>) (....)
; <TERM> = (+ or -) <VARIABLE> or (+ or -) <FUNCTION> or (+ or -) <EXPR>
;
; <EXPR> is recursive so that - variable '@' can have an EXPR as index,
;                             - FUNCTIONS can have an <EXPR> as arguments, and
;                             - <TERM> can be an <EXPR> in parentheses
; Note: floating points have priority over integers: if there's any floating point
; in a complete expression of same level then the whole expression 
; will be calculated with fpu.
; Strings have priority over integers and floating points in comparisons and additions.
; ExprFinalResult variable contains the last known type of an expression.
EvalExpr:		call	EXPR2				; <EXPR2> = (+ or -) <EXPR3> (+ or -) <EXPR3> (....)
ReEvalExpr:		mov	ebx,offset TAB_REL_OP		; Lookup relational operators table
			jmp	SearchKeyword			; Go do it. If not found, go to Op_REL_Unknown
Op_GREATEREQU:		invoke	AddWrapOperator,WRAP_GREATEREQU
			call	DoRelOp				; Rel.Op '>='
			jmp	ReEvalExpr
Op_NOTEQU:		invoke	AddWrapOperator,WRAP_NOTEQU
			call	DoRelOp				; Rel.Op '<>'
			jmp	ReEvalExpr
Op_GREATER:		invoke	AddWrapOperator,WRAP_GREATER
			call	DoRelOp				; Rel.Op '>'
			jmp	ReEvalExpr
Op_LOWEREQU:		invoke	AddWrapOperator,WRAP_LOWEREQU
			call	DoRelOp				; Rel.Op '<='
			jmp	ReEvalExpr
Op_EQU:			invoke	AddWrapOperator,WRAP_EQU
			call	DoRelOp				; Rel.Op '='
			jmp	ReEvalExpr
Op_LOWER:		invoke	AddWrapOperator,WRAP_LOWER
			call	DoRelOp				; Rel.Op '<'
			jmp	ReEvalExpr
Op_LOGIC_Wrap:		sub	edx,2				; << and >>
Op_REL_Unknown:		push	edx				; Save it for further checking
			mov	ebx,offset TAB_LOGIC_OP		; Lookup logical operators table
			jmp	SearchKeyword
Op_OR:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_OR
			call	DoLogicOp
			jmp	ReEvalExpr
Op_OR2:			pop	ebx
			invoke	AddWrapOperator,WRAP_OR
			call	DoLogicOp
			jmp	ReEvalExpr
Op_XOR:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_XOR
			call	DoLogicOp
			jmp	ReEvalExpr
Op_XOR2:		pop	ebx
			invoke	AddWrapOperator,WRAP_XOR
			call	DoLogicOp
			jmp	ReEvalExpr
Op_AND:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_AND
			call	DoLogicOp
			jmp	ReEvalExpr
Op_AND2:		pop	ebx
			invoke	AddWrapOperator,WRAP_AND
			call	DoLogicOp
			jmp	ReEvalExpr
Op_SHL:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_SHL
			call	DoLogicOp
			jmp	ReEvalExpr
Op_SHL2:		pop	ebx
			invoke	AddWrapOperator,WRAP_SHL
			call	DoLogicOp
			jmp	ReEvalExpr
Op_SHR:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_SHR
			call	DoLogicOp
			jmp	ReEvalExpr
Op_SHR2:		pop	ebx
			invoke	AddWrapOperator,WRAP_SHR
			call	DoLogicOp
			jmp	ReEvalExpr
Op_ROL:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_ROL
			call	DoLogicOp
			jmp	ReEvalExpr
Op_ROR:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_ROR
			call	DoLogicOp
			jmp	ReEvalExpr
Op_IMP:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_IMP
			call	DoLogicOp
			jmp	ReEvalExpr
Op_EQV:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_EQV
			call	DoLogicOp
			jmp	ReEvalExpr
Op_NOR:			pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_NOR
			call	DoLogicOp
			jmp	ReEvalExpr
Op_NAND:		pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_NAND
			call	DoLogicOp
			jmp	ReEvalExpr
Op_NXOR:		pop	ebx
			cmp	byte ptr [ebx-1]," "
			jne	E27
			invoke	AddWrapOperator,WRAP_NXOR
			call	DoLogicOp
			jmp	ReEvalExpr

; Exit expression parsing
Op_LOGIC_Unknown:	pop	ebx
			call	PopOperStack
			mov	ExprFinalResult,eax		; Store evaluated type for commands
			jmp	AddWrapExprEnd			; Mark expression as finished

; Logical operator operand
DoLogicOp:		call	EXPR2
			call	LoadOperTerms
			jmp	PushOperStackInteger

; Relational operator operand
DoRelOp:		call	EXPR2				; Get 2nd. expression <EXPR2>
			call	LoadOperTermsStr		; (Pass over strings)
			jmp	PushOperStackInteger

EXPR2:			;<EXPR2> = (+ or -) <EXPR3> (+ or -) <EXPR3> (....)
			mov	ah,'-'
			call	SkipSpaces			; Negative sign before EXPR3 ?
			jnz	X21				; No
			call	PushOperStackInteger
			invoke	AddWrapOperator,WRAP_MINUS
			jmp	X27				; Treat like substract

X21:			mov	ah,'+'				; Positive sign before EXPR3 ?
			call	SkipSpaces			; '+' or nothing is same
			call	EXPR3				; 1st <EXPR3> = <TERM> (<* or />) <TERM>) (....)
; Check additions
X23:			mov	ah,'+'
			call	SkipSpaces			; Add a new EXPR3 ?
			jnz	X26				; No, test '-'
			invoke	AddWrapOperator,WRAP_PLUS
			call	EXPR3				;     Get 2nd <EXPR3>
			call	LoadOperTermsStr		; (Pass over strings)
			call	PushOperStackInteger		; We don't care about the type here
			jmp	X23				; Look for more

X24:			call	LoadOperTerms
			call	PushOperStackInteger
			jmp	X23				; Look for more
; Check substractions
X26:			mov	ah,'-'
			call	SkipSpaces			; Substract a new EXPR3 ?
			jnz	R4				; No, Ret EXPR2
			invoke	AddWrapOperator,WRAP_MINUS

X27:			call	EXPR3				; get 2nd <EXPR3> (= <TERM> (<* or />) <TERM>) (....))
			call	PeekOperStack
			cmp	eax,VAR_DOUBLE
			je	ChangeDblSign
			neg	ebx
			jmp	X24				; and looks for a next '+' or '-'

ChangeDblSign:		fchs
			jmp	X24

			;<EXPR3> = <TERM> (* or / or \) <TERM>) (....)
EXPR3:			call	Expr_GetTerm			; Get 1st. <TERM>
; Check muls
Op_Mul:			mov	ah,'*'
			call	SkipSpaces			; Multiply ?
			jnz	Op_Div				; No, test divide
			invoke	AddWrapOperator,WRAP_MUL
			call	Expr_GetTerm			; and get 2nd <TERM>
			call	LoadOperTerms
			call	PushOperStackInteger
			jmp	Op_Mul				; Look for more

; Check divs
Op_Div:			mov	ah,'/'
			call	SkipSpaces			; Divide ?
			jnz	Op_DivDbl			; No, ret 
			invoke	AddWrapOperator,WRAP_DIV
			call	Expr_GetTerm			; and get the second one
			call	LoadOperTermsDbl		; Force terms to fp
			call	PushOperStackDouble		; Last term was fp
			jmp	Op_Mul				; Look for more
NormDiv:		call	PushOperStackInteger
			jmp	Op_Mul				; Look for more terms
ExprDivZero:		mov	edi,offset Err7			; Yes, Error : Division by zero
			jmp	DispError
; Check integer divs
Op_DivDbl:		mov	ah,'\'
			call	SkipSpaces			; Divide ?
			jnz	Op_ModDbl			; No, ret 
			invoke	AddWrapOperator,WRAP_INTDIV
			call	Expr_GetTerm			; and get the second one
			call	LoadOperTerms			; load them into fpu
			jmp	NormDiv
; Check mods (%)
Op_ModDbl:		mov	ah,'%'
			call	SkipSpaces			; Mod ?
			jnz	Op_ModDbl2			; No, ret 
Store_Op_Mod:		invoke	AddWrapOperator,WRAP_MOD
			call	Expr_GetTerm			; and get the second one
			call	LoadOperTerms			; load them into fpu
			call	PushOperStackInteger
			jmp	Op_Mul
; Check mods (MOD)
Op_ModDbl2:		mov	ebx,offset TAB_MOD_OP
			jmp	SearchKeyword
Op_Mod2:		cmp	byte ptr [edx-5]," "
			jne	E27
			jmp	Store_Op_Mod

;----------------------------------------------------------------------------------------------
; Get real term sign
CheckTermSign:		xor	ebx,ebx
CheckNegTerm:		mov	ah,'-'
			call	SkipSpaces
			jnz	NegTerm
			xor	ebx,1
			jmp	CheckNegTerm
NegTerm:		mov	ah,'+'
			call	SkipSpaces
			jnz	NegatedTerm
			jmp	CheckNegTerm
NegatedTerm:		ret

;----------------------------------------------------------------------------------------------
; Unary terms retrieving
; <TERM> = (+ or -) <VARIABLE> or (+ or -) <FUNCTION> or (+ or -) <EXPR>
Expr_GetTerm:		call	CheckTermSign
			test	ebx,ebx
			jz	NoMarkNegTerm
			invoke	AddWrapMinusSign
NoMarkNegTerm:		mov	ebx,PtrTblFnc
			movzx	eax,al				; Take char
			mov	ebx,[ebx+eax*4]			; Find the function
			jmp	SearchKeywordFnc		; And got do it
Expr_GetVar:		call	TestVar				; A variable ?
			jc	Expr_GetNumber			; Not a variable
			jmp	PushOperStackInteger
Expr_GetNumber:		mov	wtemp3,0			; Don't test local sign here
			call	TstToken			; Or is it a number ?
			cmp	WasDouble,VAR_STRING		; Was it a string ?
			je	StringInExpr
			cmp	WasDouble,VAR_INTEGER
			je	NoDoubleInExpr
			test	ch,ch				; ch=Number of digits
			jz	NoDoubleInExpr			; No digits found ?
			call	PushOperStackDouble
			; Load floating point value
			invoke	AddWrapFp,DblVal
			ret
StringInExpr:		call	PushOperStackString
			; (Note: TstToken returns string in ebx)
			invoke	AddWrapString,ebx
R4:			ret
NoDoubleInExpr:		test	ch,ch				; ch=Number of digits
			jnz	NoTestParenth			; A recognized number ?
			jmp	TestParenth			; (Should return the last known type)
NoTestParenth:		call	PushOperStackInteger
			; (Note: TstToken returns integer in ebx)
			invoke	AddWrapInteger,ebx
			ret
TestParenthOpen:	mov	ah,"("
			call	SkipSpaces			; Not a number, must be an (expr)
			jnz	E30				; Not a "("
			invoke	AddWrapOpenBracket
			cmp	byte ptr [edx],")"
			je	EmptyParenthOpen
			call	EvalExpr			; "(" found, evaluate EXPR
			; Load last expression type as current one
			invoke	PushOperStack,ExprFinalResult
			ret
EmptyParenthOpen:	mov	ExprFinalResult,VAR_NOFNCARG
			invoke	PushOperStack,ExprFinalResult
			ret
TestParenth:		mov	ah,"("
			call	SkipSpaces			; Not a number, must be an (expr)
			jnz	EmptyParenthOpen		; Not a "("
AddBracketFnc:		invoke	AddWrapOpenBracket
			cmp	byte ptr [edx],")"
			je	EmptyParenth
			call	EvalExpr			; "(" found, evaluate EXPR
			invoke	AddWrapCloseBracket
			; Load last expression type as current one
			invoke	PushOperStack,ExprFinalResult
			jmp	@F
EmptyParenth:		call	EmptyParenthOpen
			invoke	AddWrapCloseBracket
@@:			mov	ah,")"				; followed by a ")"
			call	SkipSpaces			; OK, ret
			jz	NoBrackH
E1:			mov	edi,offset Err1			; else error <Syntax error>
			jmp	DispError
NoBrackH:		ret

;----------------------------------------------------------------------------------------------
; Check operation terms types and load them in DblTerm1/DblTerm2 
; if they are floating points
; Retrieve 2 terms for an operation
; out: bl=1 if fp operation
;      bl=0 if integer operation
LoadOperTerms:		push	esi
			push	eax
			call	PopOperStack
			cmp	eax,VAR_STRING
			je	E44
			mov	ebx,eax
			call	PopOperStack
			cmp	eax,VAR_STRING
			je	E44
			mov	esi,ebx				; check if the operation terms
			or	esi,eax				; contains at least one fp
			mov	bh,bl				; bh=2nd term (last) (was xchg)
			mov	bl,al				; bl=1th term (first)
			pop	eax
			test	esi,VAR_DOUBLE			; Yes: everything must be converted to fp
			jz	NormTerm
			; Term 2 was a Double (should be in st(0) then)
ForcedDblTerms:		cmp	bh,VAR_DOUBLE
			jne	LoadTerm2Dbl
			jmp	LoadTerm2
LoadTerm2Dbl:		cmp	bh,VAR_INTEGER
			jne	LoadTerm2
LoadTerm2:		cmp	bl,VAR_DOUBLE
			jne	LoadTerm1Dbl
			mov	bl,VAR_DOUBLE
			pop	esi
			ret
LoadTerm1Dbl:		cmp	bl,VAR_INTEGER
			jne	LoadTerm1
LoadTerm1:		mov	bl,VAR_DOUBLE
			pop	esi
			ret
NormTerm:		xor	bl,bl
			pop	esi
			ret

;----------------------------------------------------------------------------------------------
; This one will allow strings operands
; (Used with + operator)
LoadOperTermsStr:	push	eax
			call	PopOperStack
			cmp	eax,VAR_STRING			; Allow strings as operands
			je	NormTermStr
			mov	ebx,eax
			call	PopOperStack
			cmp	eax,VAR_STRING
			je	NormTermStr
			mov	bh,bl				; bh=2nd term (last)
			mov	bl,al				; bl=1th term (first)
			or	al,bh				; operation terms contain one fp ?
			test	al,VAR_DOUBLE			; Yes: everything must be converted to fp
			pop	eax
			jz	LoadTerm1Str
			; Term 2 was a Double (should be in st(0) then)
ForcedDblTermsStr:	cmp	bh,VAR_DOUBLE
			jne	LoadTerm2DblStr
			jmp	LoadTerm2Str
LoadTerm2DblStr:	cmp	bh,VAR_INTEGER
			jne	LoadTerm2Str
LoadTerm2Str:		cmp	bl,VAR_DOUBLE
			jne	LoadTerm1DblStr
			mov	bl,VAR_DOUBLE
			ret
LoadTerm1DblStr:	cmp	bl,VAR_INTEGER
			jne	LoadTerm1Str
LoadTerm1Str:		mov	bl,VAR_DOUBLE
			ret
NormTermStr:		pop	eax
			xor	bl,bl
			ret

;----------------------------------------------------------------------------------------------
; Pre-compiled version
			align	16
LoadOperTermsCOMP:	push	eax
			POPOPERSTACKCOMP
			cmp	eax,VAR_STRING
			je	E44
			mov	ebx,eax
			POPOPERSTACKCOMP
			cmp	eax,VAR_STRING
			je	E44
			mov	bh,bl				; bh=2nd term (last)
			mov	bl,al				; bl=1th term (first)
			or	al,bh				; operation terms contain one fp ?
			test	al,VAR_DOUBLE			; Yes: everything must be converted to fp
			pop	eax
			jz	NormTermCOMP
			; Term 2 was a Double (should be in st(0) then)
ForcedDblTermsCOMP:	cmp	bh,VAR_DOUBLE
			jne	LoadTerm2DblCOMP
			fstp	DblTerm2			; get it
			jmp	LoadTerm2COMP
			align	16
LoadTerm2DblCOMP:	mov	FpIntLoad,edx
			fild	FpIntLoad			; Load it as integer
			fstp	DblTerm2			; save it as fp
LoadTerm2COMP:		cmp	bl,VAR_DOUBLE
			jne	LoadTerm1DblCOMP
			fstp	DblTerm1			; Retrieve it from the FPU reg
			mov	ebx,VAR_DOUBLE
			ret
			align	16
LoadTerm1DblCOMP:	mov	FpIntLoad,eax
			fild	FpIntLoad
			fstp	DblTerm1
			mov	ebx,VAR_DOUBLE
			ret
			align	16
NormTermCOMP:		xor	ebx,ebx				; (VAR_INTEGER = 0)
			ret

;----------------------------------------------------------------------------------------------
; This one will convert and returns strings if any of the 2 operand is a string.
; (Used with + operator)
; In: eax: first operand
;     edx: second operand
; Returns: 0 if integer operation required
;	   1 if fp operation required
;	   2 if string operation required
			align	16
LoadOperTermsStrCOMP:	push	eax
			POPOPERSTACKCOMP
			cmp	eax,VAR_STRING
			je	StrTermSecondStrCOMP
			mov	ebx,eax
			POPOPERSTACKCOMP
			cmp	eax,VAR_STRING
			je	StrTermFirstStrCOMP
			mov	bh,bl				; bh=2nd term (last)
			mov	bl,al				; bl=1th term (first)
			or	al,bh				; operation terms contain one fp ?
			test	al,VAR_DOUBLE			; Yes: everything must be converted to fp
			pop	eax
			jz	NormTermStrCOMP
			; Term 2 was a Double (should be in st(0) then)
ForcedDblTermsStrCOMP:	cmp	bh,VAR_DOUBLE
			jne	LoadTerm2DblStrCOMP
			fstp	DblTerm2			; get it
			jmp	LoadTerm2StrCOMP
			align	16
LoadTerm2DblStrCOMP:	mov	FpIntLoad,edx
			fild	FpIntLoad			; Load it as integer
			fstp	DblTerm2			; save it as fp
LoadTerm2StrCOMP:	cmp	bl,VAR_DOUBLE
			jne	LoadTerm1DblStrCOMP
			fstp	DblTerm1			; retrieve it from the stack
			mov	ebx,VAR_DOUBLE
			ret
			align	16
LoadTerm1DblStrCOMP:	mov	FpIntLoad,eax
			fild	FpIntLoad
			fstp	DblTerm1
			mov	ebx,VAR_DOUBLE
			ret
			align	16
NormTermStrCOMP:	xor	ebx,ebx
			ret
; Convert second operand to a string			
			align	16
StrTermFirstStrCOMP:	; Second operand is not a string
			cmp	ebx,VAR_INTEGER			; Was it an integer ?
			je	ConvertIntEXPRToStr
			; No: it is a Double
			fstp	DblVal				; Get fp value
			; Convert it
			invoke	DoubleToString,DblVal,15,addr DblTemp
			test	eax,eax
			jz	E25
			lea	edx,DblTemp
			pop	eax				; First stays unchanged (if int)
			mov	ebx,VAR_STRING
			ret
			align	16
ConvertIntEXPRToStr:	mov	ebx,edx
			call	IntToStringNoPad
			lea	edx,dtemp1
			pop	eax
			mov	ebx,VAR_STRING
			ret
			align	16
StrTermStrCOMP:		pop	eax
			mov	ebx,VAR_STRING
			ret
; Convert first operand to a string			
			align	16
StrTermSecondStrCOMP:	POPOPERSTACKCOMP
			cmp	eax,VAR_STRING
			je	StrTermStrCOMP
			cmp	eax,VAR_INTEGER			; Is it an integer ?
			je	ConvertIntEXPRToStrF
			; No: it is a Double
			fstp	DblVal				; Get fp value
			; Convert it
			push	edx
			invoke	DoubleToString,DblVal,15,addr DblTemp
			test	eax,eax
			jz	E25
			pop	edx
			lea	eax,DblTemp
			pop	ebx				; To garbage
			mov	ebx,VAR_STRING
			ret
			align	16
ConvertIntEXPRToStrF:	pop	ebx				; Get first operand
			push	edx
			call	IntToStringNoPad
			pop	edx
			lea	eax,dtemp1
			mov	ebx,VAR_STRING
			ret

;----------------------------------------------------------------------------------------------
; Load terms into fpu
LoadOperTermsDbl:	push	esi
			push	eax
			call	PopOperStack
			cmp	eax,VAR_STRING
			je	E44
			mov	ebx,eax
			call	PopOperStack
			cmp	eax,VAR_STRING
			je	E44
			mov	bh,bl				; bh=2nd term (last)
			mov	bl,al				; bl=1th term (first)
			pop	eax
			jmp	ForcedDblTerms

;----------------------------------------------------------------------------------------------
; Pre-compiled version
			align	16
LoadOperTermsDblCOMP:	push	eax
			POPOPERSTACKCOMP
			cmp	eax,VAR_STRING
			je	E44
			mov	ebx,eax
			POPOPERSTACKCOMP
			cmp	eax,VAR_STRING
			je	E44
			mov	bh,bl				; bh=2nd term (last)
			mov	bl,al				; bl=1th term (first)
			pop	eax
			jmp	ForcedDblTermsCOMP

;----------------------------------------------------------------------------------------------
; Manages incremental stack for operations terms types
; (functions with COMP suffix are here for speed purposes only).
			align	16
PushOperStack		proc	StackValue:dword
			push	eax
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4		; Increment
			mov	ecx,[ecx]
			sub	ecx,OperStack
			cmp	ecx,256				; 256 terms = max
			jl	MaxOperStack
			mov	edi,offset Err26
			jmp	DispError
MaxOperStack:		mov	ecx,StackValue
			mov	[eax],ecx			; Write type
			pop	eax
			ret
PushOperStack		endp

PushOperStackInteger:	push	eax
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4		; Increment
			mov	ecx,[ecx]
			sub	ecx,OperStack
			cmp	ecx,256				; 256 terms = max
			jl	MaxOperStackInteger
			mov	edi,offset Err26
			jmp	DispError
MaxOperStackInteger:	mov	dword ptr [eax],VAR_INTEGER	; Write type
			pop	eax
			ret

			align	16
PushOperStackIntCOMP:	push	eax
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4		; Increment
			mov	dword ptr [eax],VAR_INTEGER	; Write type
			pop	eax
			ret

			align	16
PushOperStackDouble:	push	eax
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4		; Increment
			mov	ecx,[ecx]
			sub	ecx,OperStack
			cmp	ecx,256				; 256 terms = max
			jl	MaxOperStackDouble
			mov	edi,offset Err26
			jmp	DispError
			align	16
MaxOperStackDouble:	mov	dword ptr [eax],VAR_DOUBLE	; Write type
			pop	eax
			ret

			align	16
PushOperStackDoubleCOMP:
			push	eax
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4
			mov	dword ptr [eax],VAR_DOUBLE
			pop	eax
			ret

PushOperStackString:	push	eax
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			add	dword ptr [ecx],4		; Increment
			mov	ecx,[ecx]
			sub	ecx,OperStack
			cmp	ecx,256				; 256 terms = max
			jl	MaxOperStackString
			mov	edi,offset Err26
			jmp	DispError
MaxOperStackString:	mov	dword ptr [eax],VAR_STRING	; Write type
			pop	eax
			ret

; Return term type in eax
; and pop the stack
PopOperStack:		lea	ecx,OperStackPtr
			sub	dword ptr [ecx],4		; Decrement
			mov	eax,[ecx]
			sub	eax,OperStack
			jge	MinOperStack
E27:			mov	edi,offset Err27
			jmp	DispError
MinOperStack:		mov	ecx,[ecx]
			mov	eax,[ecx]
			ret

; Return term type in eax
PeekOperStack:		lea	ecx,OperStackPtr
			mov	eax,[ecx]
			sub	eax,OperStack
			jg	MinPeekOperStack
			jmp	E27
MinPeekOperStack:	mov	ecx,[ecx]
			mov	eax,[ecx-4]			; Peek from previous value
			ret

; Set type of the current entry
PokeOperStack		proc	StackValue:dword
			push	eax
			lea	ecx,OperStackPtr
			mov	eax,[ecx]
			sub	eax,OperStack
			jg	MinPokeOperStack
			jmp	E27
MinPokeOperStack:	mov	ecx,[ecx]
			mov	eax,StackValue
			mov	[ecx-4],eax			; Poke in previous value
			pop	eax
			ret
PokeOperStack		endp

;----------------------------------------------------------------------------------------------
; Manages incremental stack for if commands
			align	16
PushIfStack		proc	StackValue:dword
			push	eax
			push	ebx
			push	ecx
			push	edi
			push	edx
			mov	eax,StackValue
			lea	ecx,IfStackPtr
			mov	ebx,[ecx]
			mov	edi,LineNumber
			cmp	[ebx-4],edi			; Don't push it twice
			je	RefreshIfStack
			mov	[ebx],eax			; Condition result
			mov	[ebx+4],edi			; Save line number
			add	dword ptr [ecx],8		; Increment
			mov	edx,[ecx]
			sub	edx,IfStack
			cmp	edx,256				; 256 levels = max
			jl	MaxIfStack
			mov	edi,offset Err32
			jmp	DispError
			align	16
RefreshIfStack:		; Just refresh IF status
			; If an entry for the same line is already set
			mov	[ebx-8],eax
MaxIfStack:		pop	edx
			pop	edi
			pop	ecx
			pop	ebx
			pop	eax
			ret
PushIfStack		endp

; Return condition result in eax
; and pop the stack
			align	16
PopIfStack:		push	ecx
			lea	ecx,IfStackPtr
			sub	dword ptr [ecx],8		; Decrement
			mov	eax,[ecx]
			mov	dword ptr [eax],0		; Erase it
			mov	dword ptr [eax+4],-1
			sub	eax,IfStack
			jge	MinIfStack
			mov	edi,offset Err33
			jmp	DispError
			align	16
MinIfStack:		mov	ecx,[ecx]
			mov	eax,[ecx]
			pop	ecx
			ret

; Return condition result type in eax
			align	16
PeekIfStack:		lea	ecx,IfStackPtr
			mov	eax,[ecx]
			sub	eax,IfStack
			jg	MinPeekIfStack
			mov	edi,offset Err33
			jmp	DispError
			align	16
MinPeekIfStack:		mov	ecx,[ecx]
			mov	eax,[ecx-8]			; Peek from previous value
			test	eax,eax
			ret

; Set condition result of the current entry
			align	16
PokeIfStack		proc	StackValue:dword
			push	eax
			push	ecx
			lea	ecx,IfStackPtr
			mov	eax,[ecx]
			sub	eax,IfStack
			jg	MinPokeIfStack
			mov	edi,offset Err33
			jmp	DispError
			align	16
MinPokeIfStack:		mov	ecx,[ecx]
			mov	eax,StackValue
			mov	[ecx-8],eax			; Poke in previous value
			pop	ecx
			pop	eax
			ret
PokeIfStack		endp

; Check if program is running in IF mode by checking stack level
; Returns 0 if in IF mode, 1 otherwise.
			align	16
CheckIFMode:		lea	eax,IfStackPtr
			mov	eax,[eax]
			sub	eax,IfStack
			jg	InIFMode
			xor	eax,eax
			inc	eax				; 1 (we need z flag=0)
			ret
			align	16
InIFMode:		xor	eax,eax				; 0 (we need z flag=1)
			ret

; Check if program is running in IF mode and under a verified condition
; Returns 1 if ok, 0 otherwise.
; CheckIfMode (see above) returns 1 to simulate a verified condition.
			align	16
CanExecute:		lea	eax,IfStackPtr
			mov	eax,[eax]
			sub	eax,IfStack
			jg	InIFModeExec
			xor	eax,eax
			inc	eax				; 1 (we need z flag=0)
			ret
			align	16
InIFModeExec:		call	PeekIfStack			; Returns condition type
			jns	ValidExecute			; Ghosted IF (-1)
			xor	eax,eax
ValidExecute:		ret

;----------------------------------------------------------------------------------------------
; Look for any pending if statements
			align	16
CheckPendingIf:		call	CheckIFMode			; Pending IFs ?
			jnz	UnexpectedEOF
E34:			mov	edi,offset Err34		; else, error <Unexpected end of file>
			jmp	DispError
			align	16
UnexpectedEOF:		ret

;----------------------------------------------------------------------------------------------
; Append .BAS extension to a filename if necessary
AppendMBasicExtension:	; Check if .BAS extension is present
			push	edx
			invoke	lstrlen,FileName
			pop	edx
			cmp	eax,4				; Check if it is equal of smaller than extension
			jg	MinFileExt			; If yes then we can append it safely
			push	edx
			invoke	lstrcat,FileName,addr FileExt
			pop	edx
			jmp	ExtAppened
MinFileExt:		mov	ebx,FileName
			mov	ebx,[ebx+eax-4]
			and	ebx,0dfdfdfffh			; Lower case
			cmp	ebx,"SAB."			; Extension already present ?
			je	ExtAppened			; Yes: no need to append it twice
			cmp	ebx,"IBM."			; Extension already present ?
			je	ExtAppened			; Yes: no need to append it twice
			push	edx
			invoke	lstrcat,FileName,addr FileExt
			pop	edx
ExtAppened:		ret

;----------------------------------------------------------------------------------------------
; Handle console signals (responds to any signal)
; Frees allocated memory
			align	16
CONHandler		proc	dwCtrlType:dword
			jmp	Exit
CONHandler		endp

;----------------------------------------------------------------------------------------------
; Convert a string into a floating point
			align	16
StringToDouble		proc	lpSrc:dword,lpDest:ptr qword
			local	tempdw:dword
			local	stword:word
			local	bcdstr:tbyte
			finit
			push	ebx
			push	ecx
			push	edx
			push	esi
			push	edi
			xor	eax,eax
			xor	ebx,ebx
			xor	edx,edx
			lea	edi,bcdstr
			stosd
			stosd
			mov	[edi],ax
			mov	esi,lpSrc
			mov	ecx,19
@@:			lodsb
			cmp	al," "
			jz	@B
			test	al,al
			jnz	@F
atoflerr:		xor	eax,eax
			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			pop	ebx
			ret
			align	16
@@:			cmp	al,"+"
			jz	@F
			cmp	al,"-"
			jnz	integer
			mov	ah,80h
@@:			mov	[edi+1],ah
			xor	eax,eax
			lodsb
integer:		cmp	al,"."
			jnz	@F
			test	bh,1
			jnz	atoflerr
			or	bh,1
			lodsb
@@:			cmp	al,"e"
			jnz	@F
			cmp	cl,19
			jz	atoflerr
			jmp	scient
			align	16
@@:			cmp	al,"E"
			jnz	@F
			cmp	cl,19
			jz	atoflerr
			jmp	scient
			align	16
@@:			test	al,al
			jnz	@F
			cmp	cl,19
			jz	atoflerr
			jmp	laststep
			align	16
@@:			sub	al,"0"
			jc	atoflerr
			cmp	al,9
			ja	atoflerr
			test	bh,1
			jnz	@F
			inc	bl
@@:			dec	ecx
			jz	atoflerr
			mov	ah,al
			lodsb
			cmp	al,"."
			jnz	@F
			test	bh,1
			jnz	atoflerr
			or	bh,1
			lodsb
@@:			cmp	al,"e"
			jnz	@F
			cmp	cl,19
			jz	atoflerr
			mov	al,0
			rol	al,4
			ror	ax,4
			mov	[edi],al
			jmp	scient
			align	16
@@:			cmp	al,"E"
			jnz	@F
			cmp	cl,19
			jz	atoflerr
			mov	al,0
			rol	al,4
			ror	ax,4
			mov	[edi],al
			jmp	scient
			align	16
@@:			test	al,al
			jnz	@F
			cmp	cl,19
			jz	atoflerr
			rol	al,4
			ror	ax,4
			mov	[edi],al
			jmp	laststep
			align	16
@@:			sub	al,"0"
			jc	atoflerr
			cmp	al,9
			ja	atoflerr
			test	bh,1
			jnz	@F
			inc	bl
@@:			dec	ecx
			jz	atoflerr
			rol	al,4
			ror	ax,4
			mov	[edi],al
			dec	edi
			lodsb
			jmp	integer
			align	16
laststep:		fbld	bcdstr
			xor	eax,eax
			mov	al,18
			sub	al,bl
			sub	edx,eax
			mov	tempdw,edx
			fild	tempdw
			fldl2t
			fmul
			fld	st(0)
			frndint
			fsub	st(1),st
			fxch
			f2xm1
			fld1
			fadd
			fscale
			fxch
			fstp	st(0)
			fmul
			fstsw	stword
			fwait
			test	stword,1
			jnz	srcerr
			mov	eax,lpDest
			fstp	qword ptr [eax]
			mov	eax,1
@@:			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			pop	ebx
			ret
			align	16
srcerr:			finit
			xor	eax,eax
			jmp	@B
			align	16
scient:			xor	eax,eax
			lodsb
			cmp	al,"+"
			jz	@F
			cmp	al,"-"
			jnz	scient1
			stc
			rcr	eax,1
@@:			lodsb
scient1:		push	eax
			and	eax,0ffh
			jnz	@F
scienterr:		pop	eax
			jmp	atoflerr          ;no exponent
			align	16
@@:			sub	al,30h
			jc	scienterr         ;unacceptable character
			cmp	al,9
			ja	scienterr         ;unacceptable character
			push	eax
			mov	eax,edx
			mul	TenInt
			mov	edx,eax
			pop	eax
			add	edx,eax
			cmp	edx,4931
			ja	scienterr         ;exponent too large
			lodsb
			test	al,al
			jnz	@B
			pop	eax               ;retrieve exponent sign flag
			rcl	eax,1             ;is most significant bit set?
			jnc	@F
			neg	edx
@@:			jmp	laststep
StringToDouble		endp

;----------------------------------------------------------------------------------------------
; Convert a floating point into a string
DoubleToString		proc	lpSrc:qword,lpDecimal:dword,lpDest:dword
			local	Decimal:dword
			local	stword:word
			local	esize:dword
			local	oldcw:word
			local	truncw:word
			local	tempdw:dword
			local	bcdstr:tbyte
			fclex
			mov	eax,lpDecimal
			test	eax,eax
			jns	@F
			xor	eax,eax
@@:			cmp	eax,16
			jb	@F
			mov	eax,15
@@:			mov	Decimal,eax
			finit
			fld	qword ptr [lpSrc]
			jmp	dest0
			align	16
srcerr:			finit
			xor	eax,eax
			ret
			align	16
dest0:			ftst
			fstsw	stword
			fwait
			test	stword,4000h
			jz	@F
			test	stword,100h
			jnz	srcerr
			push	ebx
			mov	ebx,lpDest
			mov	ax,30h
			mov	[ebx],ax
			pop	ebx
			jmp	finish1
			align	16
@@:			fld	st(0)
			fabs
			fld1
			fldl2t
			fdiv
			fxch
			fyl2x
			fstcw	oldcw
			fwait
			mov	ax,oldcw
			or	ax,0c00h
			mov	truncw,ax
			fldcw	truncw
			fist	esize
			fldcw	oldcw
			ftst
			fstsw	stword
			fwait
			test	stword,100h
			jz	@F
			dec	esize
@@:			fstp	st(0)
			mov	eax,15
			sub	eax,esize
			jz	@F
			mov	tempdw,eax
			fild	tempdw
			fldl2t
			fmul
			fld	st(0)
			frndint
			fxch
			fsub	st,st(1)
			f2xm1
			fld1
			fadd
			fscale
			fxch
			fstp	st(0)
			fmul
@@:			fbstp	bcdstr
			fstsw	stword
			fwait
			test	stword,1
			jnz	srcerr
			push	ecx
			push	esi
			push	edi
			lea	esi,bcdstr+9
			mov	edi,lpDest
			mov	al,[esi]
			dec	esi
			dec	esi
			.if	al == 80h
				mov	al,"-"
				stosb
			.endif
			cmp	esize,15
			jg	scientific
			mov	eax,15
			sub	eax,esize
			cmp	eax,Decimal
			jae	@F
			mov	Decimal,eax 
@@:			mov	ecx,esize
			test	ecx,ecx
			jns	regular1
			mov	al,"0"			; Traliing zeroes
			mov	ah,"."
			stosw
			neg	ecx
			cmp	ecx,Decimal
			jbe	@F
			jmp	finish
   			align	16
@@:			dec	ecx
			jz	reg1
			stosb
			jmp	@B
			align	16
reg1:			mov	ecx,Decimal
			inc	ecx
			add	ecx,esize
			jg	regular2
			jmp	finish
			align	16
regular1:		inc	ecx
@@:			xor	eax,eax
			mov	al,[esi]
			dec	esi
			ror	ax,4
			ror	ah,4
			add	ax,"00"
			stosw
			sub	ecx,2
			jg	@B
			jz	@F
			dec	edi
@@:			cmp	Decimal,0
			jz	finish
			mov	al,"."
			stosb
			test	ecx,ecx
			mov	ecx,Decimal
			jz	regular2
			mov	al,ah
			stosb
			dec	ecx
			jz	finish
regular2:		xor	eax,eax
			mov	al,[esi]
			dec	esi
			ror	ax,4
			ror	ah,4
			add	ax,"00"
			stosw
			sub	ecx,2
			jg	regular2
			jz	@F
			dec	edi
@@:			jmp	finish
			align	16
scientific:		mov	ecx,Decimal
			inc	ecx
			xor	eax,eax
			mov	al,[esi]
			dec	esi
			ror	ax,4
			ror	ah,4
			add	ax,"00"
			stosb
			mov	al,"."
			stosb
			mov	al,ah
			stosb
			sub	ecx,2
			jz	exponent
			jns	@F
			dec	edi
			jmp	exponent
			align	16
@@:			xor	eax,eax
			mov	al,[esi]
			dec	esi
			ror	ax,4
			ror	ah,4
			add	ax,3030h
			stosw
			sub	ecx,2
			jg	@B
			jz	exponent
			dec	edi
exponent:		mov	al,"E"
			stosb
			mov	al,"+"
			mov	ecx,esize
			test	ecx,ecx
			jns	@F
			mov	al,"-"
			neg	ecx
@@:			stosb
			mov	eax,ecx
			mov	cl,100
			div	cl
			push	eax
			and	eax,0ffh
			mov	cl,10
			div	cl
			add	ax,3030h
			stosw
			pop	eax
			shr	eax,8
			div	cl
			add	ax,3030h
			stosw
finish:			cmp	byte ptr [edi-1],"0"
			jne	RemoveExtraZeroes
			mov	byte ptr [edi-1],0
			dec	edi
			jmp	finish
			align	16
RemoveExtraZeroes:	cmp	byte ptr [edi-1],"."
			jne	RemoveExtraDot
			mov	byte ptr [edi-1],0
RemoveExtraDot:		xor	eax,eax
			stosb
			pop	edi
			pop	esi
			pop	ecx
finish1:		finit
@@:			mov	eax,1
			ret
DoubleToString		endp

;----------------------------------------------------------------------------------------------
; Set the cursor shape
			align	16
SetConCursor:		mov	CursorShape.dwSize,100
			cmp	InsertMode,1
			je	@F
			mov	CursorShape.dwSize,20
@@:			invoke	SetConsoleCursorInfo,hStdOut,addr CursorShape
			ret

;----------------------------------------------------------------------------------------------
; Set a pointer in function table present in eax
			align	16
PutTabPointer		proc	Letter:dword,TabEntry:dword
			mov	ebx,Letter
			mov	ecx,TabEntry
			mov	[eax+ebx*4],ecx
			sub	ebx,20h				; Upper case
			mov	[eax+ebx*4],ecx
			ret
PutTabPointer		endp

;----------------------------------------------------------------------------------------------
; Fill a memory array
			align	16
FillMem			proc	uses eax ecx edi Mem:dword,Bytes:dword,Dat:dword
			mov	edi,Mem
			mov	ecx,Bytes
			cld
			mov	eax,Dat
			shr	ecx,2
			rep	stosd
			mov	ecx,Bytes
			and	ecx,3
			rep	stosb
			ret
FillMem			endp

;-----------------------------------------------------------------------------------------------
; Add an operator into wrap expressions buffer
			align	16
AddWrapOperator		proc	OperatorNumber:byte
			push	eax
			push	ebx
			mov	eax,CompExprPtr
			mov	bl,OperatorNumber
			mov	[eax],bl
			inc	CompExprPtr
			pop	ebx
			pop	eax
			ret
AddWrapOperator		endp

;-----------------------------------------------------------------------------------------------
; Add an integer into wrap expressions buffer
			align	16
AddWrapInteger		proc	IntegerNumber:dword
			push	eax
			push	ebx
			mov	eax,CompExprPtr
			mov	ebx,IntegerNumber
			mov	byte ptr [eax],WRAP_INT
			mov	[eax+1],ebx
			add	CompExprPtr,4+1
			pop	ebx
			pop	eax
			ret
AddWrapInteger		endp

;-----------------------------------------------------------------------------------------------
; Add a string reference into wrap expressions buffer
			align	16
AddWrapString		proc	StringAddress:dword
			push	eax
			push	ebx
			mov	eax,CompExprPtr
			mov	ebx,StringAddress
			mov	byte ptr [eax],WRAP_STRING
			mov	[eax+1],ebx
			add	CompExprPtr,4+1
			pop	ebx
			pop	eax
			ret
AddWrapString		endp

;-----------------------------------------------------------------------------------------------
; Add a floating point into wrap expressions buffer
			align	16
AddWrapFp		proc	FpNumber:qword
			push	eax
			push	ebx
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_FP
			mov	ebx,dword ptr FpNumber
			mov	[eax+1],ebx
			mov	ebx,dword ptr FpNumber+4
			mov	[eax+4+1],ebx
			add	CompExprPtr,8+1
			pop	ebx
			pop	eax
			ret
AddWrapFp		endp

;-----------------------------------------------------------------------------------------------
; Add a function into wrap expressions buffer
			align	16
AddWrapFnc		proc	FncNumber:dword
			push	eax
			push	ebx
			mov	eax,CompExprPtr
			mov	ebx,FncNumber
			mov	byte ptr [eax],WRAP_FNC
			mov	[eax+1],ebx
			add	CompExprPtr,4+1
			pop	ebx
			pop	eax
			ret
AddWrapFnc		endp

;-----------------------------------------------------------------------------------------------
; Add a variable into wrap expressions buffer
			align	16
AddWrapVar		proc	VarOffset:dword
			push	eax
			push	ebx
			mov	eax,CompExprPtr
			mov	ebx,VarOffset
			mov	byte ptr [eax],WRAP_VAR
			mov	[eax+1],ebx
			add	CompExprPtr,4+1
			pop	ebx
			pop	eax
			ret
AddWrapVar		endp

;-----------------------------------------------------------------------------------------------
; Add a var address into wrap expressions buffer
			align	16
AddWrapVarAddress	proc	VarOffset:dword
			push	eax
			push	ebx
			mov	eax,CompExprPtr
			mov	ebx,VarOffset
			mov	byte ptr [eax],WRAP_VARADDRESS
			mov	[eax+1],ebx
			add	CompExprPtr,4+1
			pop	ebx
			pop	eax
			ret
AddWrapVarAddress	endp

;-----------------------------------------------------------------------------------------------
; Add an array into wrap expressions buffer
			align	16
AddWrapArray		proc	ArrayOffset:dword
			push	eax
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_ARRAY
			push	ArrayOffset
			pop	dword ptr [eax+1]
			add	CompExprPtr,4+1
			pop	eax
			ret
AddWrapArray		endp

;-----------------------------------------------------------------------------------------------
; Add an array address into wrap expressions buffer
			align	16
AddWrapArrayAddress	proc	ArrayOffset:dword
			push	eax
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_ARRAYADDRESS
			push	ArrayOffset
			pop	dword ptr [eax+1]
			add	CompExprPtr,4+1
			pop	eax
			ret
AddWrapArrayAddress	endp

;-----------------------------------------------------------------------------------------------
; Add a label address into wrap expressions buffer
			align	16
AddWrapLabel		proc	LabelOffset:dword
			push	eax
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_LABEL
			push	LabelOffset
			pop	dword ptr [eax+1]
			add	CompExprPtr,4+1
			pop	eax
			ret
AddWrapLabel		endp

;-----------------------------------------------------------------------------------------------
; Add an open bracket into wrap expressions buffer
			align	16
AddWrapOpenBracket	proc
			push	eax
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_OPENBRACKET
			inc	CompExprPtr
			pop	eax
			ret
AddWrapOpenBracket	endp

;-----------------------------------------------------------------------------------------------
; Add a string padding into wrap expressions buffer
			align	16
AddWrapStringPadding	proc
			push	eax
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_STRPADDING
			inc	CompExprPtr
			pop	eax
			ret
AddWrapStringPadding	endp

;-----------------------------------------------------------------------------------------------
; Add a close bracket into wrap expressions buffer
			align	16
AddWrapCloseBracket	proc
			push	eax
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_CLOSEBRACKET
			inc	CompExprPtr
			pop	eax
			ret
AddWrapCloseBracket	endp

;-----------------------------------------------------------------------------------------------
; Negate a number
			align	16
AddWrapMinusSign	proc
			push	eax
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_MINUSSIGN
			inc	CompExprPtr
			pop	eax
			ret
AddWrapMinusSign	endp

;-----------------------------------------------------------------------------------------------
; Add an expression suffix reference into wrap expressions buffer
			align	16
AddWrapExprEnd:		push	eax
			mov	eax,CompExprPtr
			mov	byte ptr [eax],WRAP_EXPREND
			inc	CompExprPtr
			pop	eax
			ret

;-----------------------------------------------------------------------------------------------
; Evaluate a precompiled expression
; In:
; edx:   address of expression block
; Out:
; ebx:   contains final term type (either integer or string address)
; st(0): contains a possible floating point result
			align	16
EvalExprCOMP:		call	EXPR2COMP
ReEvalExprCOMP:		push	ebx
			movzx	eax,byte ptr [edx]
			jmp	[TableRel+eax*4]		; Relational operators
			align	16
Op_GREATEREQUCOMP:	inc	edx
			call	DoRELOpCOMP
			jc	@F
			mov	bl,al
@@:			jmp	ReEvalExprCOMP
			align	16
Op_NOTEQUCOMP:		inc	edx
			call	DoRELOpCOMP
			jz	@F
			mov	bl,al
@@:			jmp	ReEvalExprCOMP
			align	16
Op_GREATERCOMP:		inc	edx
			call	DoRELOpCOMP
			jz	@F
			jc	@F
			mov	bl,al
@@:			jmp	ReEvalExprCOMP
			align	16
Op_LOWEREQUCOMP:	inc	edx
			call	DoRELOpCOMP
			mov	bl,al
			jz	@F
			jc	@F
			mov	bl,bh
@@:			jmp	ReEvalExprCOMP
			align	16
Op_EQUCOMP:		inc	edx
			call	DoRELOpCOMP
			jnz	@F
			mov	bl,al
@@:			jmp	ReEvalExprCOMP
			align	16
Op_LOWERCOMP:		inc	edx
			call	DoRELOpCOMP
			jnc	@F
			mov	bl,al
@@:			jmp	ReEvalExprCOMP
			align	16
Op_REL_UnknownCOMP:	jmp	[TableLogic+eax*4]		; Logical oeprators
			align	16
Op_ORCOMP:		inc	edx
			call	DoLOGICOpCOMP
			or	eax,ebx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_XORCOMP:		inc	edx
			call	DoLOGICOpCOMP
			xor	eax,ebx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_ANDCOMP:		inc	edx
			call	DoLOGICOpCOMP
			and	eax,ebx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_SHLCOMP:		inc	edx
			call	DoLOGICOpCOMP
			push	ecx
			mov	cl,bl
			shl	eax,cl
			pop	ecx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_SHRCOMP:		inc	edx
			call	DoLOGICOpCOMP
			push	ecx
			mov	cl,bl
			shr	eax,cl
			pop	ecx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_ROLCOMP:		inc	edx
			call	DoLOGICOpCOMP
			push	ecx
			mov	cl,bl
			rol	eax,cl
			pop	ecx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_RORCOMP:		inc	edx
			call	DoLOGICOpCOMP
			push	ecx
			mov	cl,bl
			ror	eax,cl
			pop	ecx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_IMPCOMP:		inc	edx
			call	DoLOGICOpCOMP
			push	ecx
			push	edx
			push	esi
			push	edi
			xor	edi,edi
			mov	ecx,32
Do_IMP_Op:		mov	esi,eax
			mov	edx,ebx
			and	esi,1
			and	edx,1
			add	edx,edx
			or	esi,edx
			ror	edi,1
			or	edi,[LOGIC_IMP_MaskTable+esi*4]
			shr	eax,1
			shr	ebx,1
			dec	ecx
			jnz	Do_IMP_Op
			ror	edi,1
			mov	ebx,edi
			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			jmp	ReEvalExprCOMP
			align	16
Op_EQVCOMP:		inc	edx
			call	DoLOGICOpCOMP
			push	ecx
			push	edx
			push	esi
			push	edi
			xor	edi,edi
			mov	ecx,32
Do_EQV_Op:		mov	esi,eax
			mov	edx,ebx
			and	esi,1
			and	edx,1
			add	edx,edx
			or	esi,edx
			ror	edi,1
			or	edi,[LOGIC_EQV_MaskTable+esi*4]
			shr	eax,1
			shr	ebx,1
			dec	ecx
			jnz	Do_EQV_Op
			ror	edi,1
			mov	ebx,edi
			pop	edi
			pop	esi
			pop	edx
			pop	ecx
			jmp	ReEvalExprCOMP
			align	16
Op_NORCOMP:		inc	edx
			call	DoLOGICOpCOMP
			not	ebx
			or	eax,ebx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_NANDCOMP:		inc	edx
			call	DoLOGICOpCOMP
			not	ebx
			and	eax,ebx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_NXORCOMP:		inc	edx
			call	DoLOGICOpCOMP
			not	ebx
			xor	eax,ebx
			mov	ebx,eax
			jmp	ReEvalExprCOMP
			align	16
Op_LOGIC_UnknownCOMP:	pop	ebx				; Restore value
			mov	al,[edx]
			cmp	al,WRAP_EXPREND			; Pass end flag
			jne	GetExprEndFlag
			inc	edx
GetExprEndFlag:		lea	eax,OperStackPtr		; (PopOperStackCOMP)
			sub	dword ptr [eax],4		; Decrement
			mov	eax,[eax]
			mov	eax,[eax]
			mov	ExprFinalResult,eax
			ret
; Load logical operands
			align	16
DoLOGICOpCOMP:		mov	al,cl
			pop	ebx
			pop	ecx
			push	ebx
			push	ecx
			mov	cl,al
			call	EXPR2COMP
			xchg	edx,ebx
			pop	eax
			push	ebx
			call	LoadOperTermsCOMP
			call	PushOperStackIntCOMP		; Will be integer
			test	ebx,ebx				; Logical operations are
			jz	NormLOGICCOMP			; performed on integer only
			fld	DblTerm1			; Convert operands into integers
			frndint
			fistp	DblToInt
			mov	eax,DblToInt
			fld	DblTerm2
			frndint
			fistp	DblToInt
			mov	ebx,DblToInt
			pop	edx
			ret
			align	16
NormLOGICCOMP:		xchg	edx,ebx
			pop	edx
			ret
; Load comparison operands
			align	16
DoRELOpCOMP:		mov	al,cl
			pop	ebx
			pop	ecx
			push	ebx
			push	ecx
			mov	cl,al
			call	EXPR2COMP
			xchg	edx,ebx
			pop	eax
			push	ebx
			call	LoadOperTermsStrCOMP		; Also checks for strings
			cmp	ebx,VAR_STRING			; Want a string comparison ?
			jne	CompStringCOMP
			call	PushOperStackIntCOMP		; Result will be int anyway
			; Compare both strings
			invoke	lstrcmp,eax,edx
			xor	ebx,ebx
			test	eax,eax				; Set flag (safe way)
			pop	edx
			mov	al,1
			ret
			align	16
CompStringCOMP:		test	ebx,ebx
			jz	NormCompareCOMP
			call	PushOperStackIntCOMP
			call	CompareSignDbl
			pop	edx
			mov	ebx,0				; Don't modify flags
			mov	al,1
			ret
			align	16
NormCompareCOMP:	mov	ebx,eax
			call	PushOperStackIntCOMP
			call	CompareSign
			pop	edx
			mov	ebx,0				; Same...
			mov	al,1
			ret

;-----------------------------------------------------------------------------------------------
			align	16
EXPR2COMP:		cmp	byte ptr [edx],WRAP_MINUS	; "-"
			jne	X21COMP
			inc	edx
			xor	ebx,ebx
			call	PushOperStackIntCOMP
			jmp	X27COMP
			align	16
X21COMP:		call	EXPR3COMP
X23COMP:		cmp	byte ptr [edx],WRAP_PLUS	; "+"
			jne	X26COMP
			inc	edx
			push	ebx				; Save first operand
			call	EXPR3COMP			
			xchg	edx,ebx				; edx=second operand
			pop	eax				; eax=first operand
			push	ebx				; ebx=text pointer
			call	LoadOperTermsStrCOMP		; Also checks for strings
			cmp	ebx,VAR_STRING
			jne	ConcatStringCOMP
			; Add both strings into a third one
			; Get len of both string
			push	esi
			push	edi
			push	ecx
			push	edx
			push	eax				; String 2
			mov	esi,eax
LoopStringLenConCat1:	mov	bl,[esi]
			inc	esi
			test	bl,bl
			jnz	LoopStringLenConCat1
			xchg	esi,eax
			sub	eax,esi				; String length
			dec	eax				; do not store null for first one
			mov	ecx,eax
			mov	esi,edx
LoopStringLenConCat2:	mov	bl,[esi]
			inc	esi
			test	bl,bl
			jnz	LoopStringLenConCat2
			xchg	esi,edx
			sub	edx,esi				; String length
			add	edx,ecx
			; Alloc new string with both len (+ one 0 from second string)
			push	ecx
			push	edx
			invoke	GlobalAlloc,GMEM_FIXED,edx
			pop	edx
			pop	ecx				; Len of first string
			sub	edx,ecx				; Restore len of second string
			test	eax,eax
			jz	E46
			mov	ebx,eax				; (ebx=new operand address)
			mov	edi,eax				; edi=dest
			pop	esi				; string 2 (from eax)
			; Copy first string
			cld
			push	ecx
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			pop	esi				; string 1
			; Copy second string
			cld
			mov	ecx,edx				; 2nd len
			push	ecx
			shr	ecx,2
			rep	movsd
			pop	ecx
			and	ecx,3
			rep	movsb
			pop	ecx
			pop	edi
			pop	esi
			PUSHOPERSTACKSTRCOMP			; Push it as string
			pop	edx				; Restore text pointer
			jmp	X23COMP
			align	16
ConcatStringCOMP:	test	ebx,ebx
			jz	NormAddCOMP
			fld	DblTerm1			; FPU addition
			fadd	DblTerm2
			call	PushOperStackDoubleCOMP
			pop	edx
			jmp	X23COMP
			align	16
X24COMP:		xchg	edx,ebx
			pop	eax
			push	ebx
			call	LoadOperTermsCOMP
			test	ebx,ebx
			jz	NormAddCOMP
			fld	DblTerm1
			fadd	DblTerm2
			call	PushOperStackDoubleCOMP
			pop	edx
			jmp	X23COMP
			align	16
NormAddCOMP:		call	PushOperStackIntCOMP		; CPU addition
			mov	ebx,eax				; First oper
			add	ebx,edx				; Second oper
			pop	edx
			jno	X23COMP
			mov	edi,offset Err3			; Overflow
			jmp	DispError
			align	16
NoOpCOMP:		ret			
			align	16
X26COMP:		cmp	byte ptr [edx],WRAP_MINUS	; "-"
			jne	NoOpCOMP
			inc	edx
X27COMP:		push	ebx
			call	EXPR3COMP
			PEEKOPERSTACKCOMP
			cmp	eax,VAR_DOUBLE
			je	ChangeDblSignCOMP
			neg	ebx
			jmp	X24COMP
			align	16
ChangeDblSignCOMP:	fchs
			jmp	X24COMP

;-----------------------------------------------------------------------------------------------
			align	16
EXPR3COMP:		call	Expr_GetTermCOMP
			movzx	eax,byte ptr [edx]
			jmp	[TableLevel1Op+eax*4]
			align	16
Op_MulCOMP:		inc	edx				; "*"
			push	ebx
			call	Expr_GetTermCOMP
			xchg	edx,ebx
			pop	eax
			push	ebx
			call	LoadOperTermsCOMP
			test	ebx,ebx
			jz	NormMulCOMP
			fld	DblTerm1
			fmul	DblTerm2
			call	PushOperStackDoubleCOMP
			pop	edx
			movzx	eax,byte ptr [edx]
			jmp	[TableLevel1Op+eax*4]
			align	16
NormMulCOMP:		call	PushOperStackIntCOMP		; Integer mul
			imul	eax,edx
			jo	E3
			mov	ebx,eax
			pop	edx
			movzx	eax,byte ptr [edx]
			jmp	[TableLevel1Op+eax*4]
		
;-----------------------------------------------------------------------------------------------
			align	16
Op_DivCOMP:		inc	edx				; "/"
			push	ebx
			call	Expr_GetTermCOMP
			xchg	edx,ebx
			pop	eax
			push	ebx
			call	LoadOperTermsDblCOMP		; Force operands to fp
			fld	DblTerm2
			ftst
			fstsw	ax
			fstp	DblTerm2
			and	ax,100010100000000b
			cmp	ax,100000000000000b
			je	ExprDivZeroCOMP
			fld	DblTerm1
			fdiv	DblTerm2
			call	PushOperStackDoubleCOMP
			pop	edx
			movzx	eax,byte ptr [edx]
			jmp	[TableLevel1Op+eax*4]

;-----------------------------------------------------------------------------------------------
			align	16
Op_DivIntCOMP:		inc	edx				; "\"
			push	ebx
			call	Expr_GetTermCOMP
			xchg	edx,ebx
			pop	eax
			push	ebx
			call	LoadOperTermsCOMP
			test	ebx,ebx
			jz	NormDivCOMP
			fld	DblTerm1			; Convert operands into integers
			frndint
			fistp	DblToInt
			mov	eax,DblToInt
			fld	DblTerm2
			frndint
			fistp	DblToInt
			mov	edx,DblToInt
NormDivCOMP:		mov	ebx,eax				; Integer div
			test	edx,edx
			jnz	@F
ExprDivZeroCOMP:	mov	edi,offset Err7			; Div/0
			jmp	DispError
			align	16
@@:			call	PushOperStackIntCOMP
			mov	ecx,edx
			mov	eax,ebx
			cdq
			idiv	ecx
			mov	ebx,eax
			pop	edx
			movzx	eax,byte ptr [edx]
			jmp	[TableLevel1Op+eax*4]

;-----------------------------------------------------------------------------------------------
			align	16
Op_ModCOMP:		inc	edx				; "%" / "MOD"
			push	ebx
			call	Expr_GetTermCOMP
			xchg	edx,ebx
			pop	eax
			push	ebx
			call	LoadOperTermsDblCOMP
			test	ebx,ebx
			jz	NormModCOMP
			fld	DblTerm1			; Convert operands into integers
			frndint
			fistp	DblToInt
			mov	eax,DblToInt
			fld	DblTerm2
			frndint
			fistp	DblToInt
			mov	edx,DblToInt
NormModCOMP:		mov	ebx,eax				; Integer mod
			test	edx,edx
			jz	ExprDivZeroCOMP
			call	PushOperStackIntCOMP
			mov	ecx,edx
			mov	eax,ebx
			cdq
			idiv	ecx
			mov	ebx,edx
			pop	edx
			movzx	eax,byte ptr [edx]
			jmp	[TableLevel1Op+eax*4]

;-----------------------------------------------------------------------------------------------
			align	16
Expr_GetTermCOMP:	xor	ecx,ecx
			movzx	eax,byte ptr [edx]
			cmp	al,WRAP_MINUSSIGN
			jne	ToNegate
			xor	ecx,1
			inc	edx
			mov	al,[edx]
ToNegate:		push	ecx
			jmp	[TableOperands+eax*4]
; --- Functions
			align	16
GetFunctionCOMP:	inc	edx
			mov	ebx,[edx]			; Function address
			add	edx,4
			jmp	ebx
; --- Variables
; (Retrieve the datas of variables)
			align	16
GetVariableCOMP:	inc	edx
			mov	ebx,[edx]			; Var offset
			add	ebx,VarSymb
			add	edx,4
			mov	eax,[ebx+VARDAT_TYPE]
			cmp	eax,VAR_DOUBLE
			jne	DoubleFromVar
			mov	ebx,[ebx+VARDAT_DATASPTR]
			fld	qword ptr [ebx]			; FP datas (DAT1+DAT2)
			call	PushOperStackDoubleCOMP
			pop	ecx
			test	ecx,ecx				; Negate
			jz	FinalizeFPFromVar
			fchs
FinalizeFPFromVar:	ret
			align	16
DoubleFromVar:		cmp	eax,VAR_STRING
			jne	StringFromVar
			mov	ebx,[ebx+VARDAT_DATASPTR]
			mov	ebx,[ebx]			; DAT1
			PUSHOPERSTACKSTRCOMP
			pop	ecx
			test	ecx,ecx				; Can't negate string
			jnz	E27
			ret
			align	16
StringFromVar:		mov	ebx,[ebx+VARDAT_DATASPTR]
StringFromArray:	mov	ebx,[ebx]			; DAT1
			call	PushOperStackIntCOMP
NegateInteger:		pop	ecx
			test	ecx,ecx				; Negate
			jz	FinalizeIntFromVar
			neg	ebx
FinalizeIntFromVar:	ret
; --- Array element
			align	16
GetArrayCOMP:		inc	edx
			push	dword ptr [edx]
			add	edx,4
			call	GetArrayArgs			; We need to calculate array offset here
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			js	E40
			pop	eax
			cmp	ebx,[eax+VARDAT_ARRLBOUND]	; Check bounds
			jb	E59
			cmp	ebx,[eax+VARDAT_ARRUBOUND]
			ja	E59
			mov	ecx,[eax+VARDAT_TYPE]
			call	[TypeLenTable+ecx*4]
			add	ebx,[eax+VARDAT_DATASPTR]	; Get datas
			mov	eax,ecx				; Get type
			cmp	eax,VAR_DOUBLE
			jne	DoubleFromArray
			fld	qword ptr [ebx]			; FP datas (DAT1+DAT2)
			call	PushOperStackDoubleCOMP
			pop	ecx
			test	ecx,ecx
			jz	FinalizeFPFromArray
			fchs
FinalizeFPFromArray:	ret
			align	16
DoubleFromArray:	cmp	eax,VAR_STRING
			jne	StringFromArray
			mov	ebx,[ebx]			; DAT1
			PUSHOPERSTACKSTRCOMP
			pop	ecx
			test	ecx,ecx
			jnz	E27
			ret
			align	16
E4:			mov	edi,offset Err4			; No, Error : <Subscript out of array range>
			jmp	DispError
; Calculate element index in an array
			align	16
TypeLenInteger:		shl	ebx,2
			ret
			align	16
TypeLenDouble:		shl	ebx,3
			ret
			align	16
TypeLenString:		shl	ebx,2
			ret
; --- Variable address
			align	16
GetVarAddressCOMP:	inc	edx
			mov	ebx,[edx]			; ebx has already been multiplied because variables
			add	ebx,VarSymb			; are fixed in memory
			mov	ebx,[ebx+VARDAT_DATASPTR]
			add	edx,4
			call	PushOperStackIntCOMP
			pop	eax
			test	eax,eax
			jnz	E27				; Negative address ? too weird
			ret
; --- Array address
			align	16
GetArrayAddressCOMP:	inc	edx
			push	dword ptr [edx]
			add	edx,4
			call	GetArrayArgs			; We need to calculate array offset here
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			js	E40
			pop	eax
			cmp	ebx,[eax+VARDAT_ARRLBOUND]	; Check bounds
			jb	E59
			cmp	ebx,[eax+VARDAT_ARRUBOUND]
			ja	E59
			push	ecx
			mov	ecx,[eax+VARDAT_TYPE]
			call	[TypeLenTable+ecx*4]
			add	ebx,[eax+VARDAT_DATASPTR]	; Get datas
			pop	ecx
			pop	eax
			test	eax,eax
			jnz	E27				; Negative address ? too weird
			ret
; --- Literal FP datas
			align	16
GetFPCOMP:		inc	edx
			fld	qword ptr [edx]
			add	edx,8
			call	PushOperStackDoubleCOMP
			pop	ecx
			test	ecx,ecx
			jz	FinalizeFP
			fchs
FinalizeFP:		ret

; --- Literal Integer datas
			align	16
GetIntegerCOMP:		inc	edx
			mov	ebx,[edx]
			add	edx,4
			call	PushOperStackIntCOMP
			pop	ecx
			test	ecx,ecx
			jz	FinalizeInt
			neg	ebx
FinalizeInt:		ret

; --- Literal String datas
			align	16
GetStringCOMP:		inc	edx
			mov	ebx,[edx]
			add	edx,4
			PUSHOPERSTACKSTRCOMP
			pop	ecx
			test	ecx,ecx
			jnz	E27				; Can't negate a string
			ret

; Retrieve Array index
			align	16
GetArrayArgs:		mov	al,[edx]
			cmp	al,WRAP_OPENBRACKET
			jne	E30
			inc	edx
			call	EvalExprCOMP
			PUSHOPERSTACKCOMP
			mov	al,[edx]
			cmp	al,WRAP_CLOSEBRACKET
			jne	E40
			inc	edx
			ret

;-----------------------------------------------------------------------------------------------
; Sub expressions
			align	16
GetFNCLastArgs:		mov	ExprFinalResult,VAR_NOFNCARG
			jmp	ContFncArg
			align	16
GetFNCArgs:		mov	ExprFinalResult,VAR_NOFNCARG
			mov	al,[edx]			; load char if coming from a function
			cmp	al,WRAP_OPENBRACKET		; (
			jne	GetNextFncExpr
			inc	edx				; Avoid some recursive problems
ContFncArg:		mov	al,[edx]			; Empty function argument ?
			cmp	al,WRAP_CLOSEBRACKET		; )
			je	GetNextFncExpr
			call	EvalExprCOMP
			PUSHOPERSTACKCOMP
GetNextFncExpr:		mov	al,[edx]
			cmp	al,WRAP_CLOSEBRACKET		; )
			jne	FinalizeBrackExprCOMP
			inc	edx
FinalizeBrackExprCOMP:	ret
; From expression...
			align	16
GetFNCArgsFromExpr:	cmp	al,WRAP_OPENBRACKET		; (
			jne	GetNextExpr
			inc	edx
			call	EvalExprCOMP
			PUSHOPERSTACKCOMP
GetNextExpr:		mov	al,[edx]
			cmp	al,WRAP_CLOSEBRACKET		; )
			jne	FinalizeFncCOMP
			inc	edx
; Finalize operands
FinalizeFncCOMP:	pop	eax
			test	eax,eax
			jz	NoNegFncCOMP
			PEEKOPERSTACKCOMP			; Retrieve type
			cmp	eax,VAR_DOUBLE
			jne	NegIntDblFncCOMP
			fchs					; FP
			ret
			align	16
NegIntDblFncCOMP:	cmp	eax,VAR_STRING			; Can't negate strings
			je	E27
			neg	ebx				; Integer
NoNegFncCOMP:		ret
			align	16
E40:			mov	edi,offset Err40		; Error: <Invalid index reference>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
; Retrieve single variable/array address
; (used to speed up various commands)
; Return real variable in eax and datas address in ebx
			align	16
GetVarRealAddress:	mov	al,[edx]
			inc	edx
			cmp	al,WRAP_VARADDRESS
			jne	GetArrayRealAddress
			mov	eax,[edx]			; ebx has already been multiplied because variables
			add	eax,VarSymb			; are fixed in memory
			add	edx,4
			mov	ebx,[eax+VARDAT_DATASPTR]
			ret
; Array address
			align	16
GetArrayRealAddress:	cmp	al,WRAP_ARRAYADDRESS
			jne	E8
			push	dword ptr [edx]
			add	edx,4
			call	GetArrayArgs			; We need to calculate array offset here
			cmp	ExprFinalResult,VAR_INTEGER
			jne	E28
			test	ebx,ebx
			js	E40
			pop	eax
			cmp	ebx,[eax+VARDAT_ARRLBOUND]	; Check bounds
			jb	E59
			cmp	ebx,[eax+VARDAT_ARRUBOUND]
			ja	E59
			push	ecx
			mov	ecx,[eax+VARDAT_TYPE]
			call	[TypeLenTable+ecx*4]
			add	ebx,[eax+VARDAT_DATASPTR]	; Get datas
			pop	ecx
			ret
			align	16
E8:			mov	edi,offset Err8			; Error: <Unexpected variable type>
			jmp	DispError			; (shouldn't happend)

; Array datas (Used with LBOUND/UBOUND)
; Return array's lbound in eax and ubound in ebx
			align	16
GetArrayBounds:		mov	ExprFinalResult,VAR_NOFNCARG
			mov	al,[edx]
			inc	edx
			cmp	al,WRAP_OPENBRACKET		; (
			jne	E30
			mov	al,[edx]
			inc	edx
			cmp	al,WRAP_ARRAY
			jne	E62
			push	dword ptr [edx]
			add	edx,4
			mov	al,[edx]			; Correct sequence
			cmp	al,WRAP_OPENBRACKET
			jne	E30
			inc	edx
			mov	al,[edx]
			cmp	al,WRAP_CLOSEBRACKET
			jne	E40
			inc	edx
			mov	al,[edx]
			cmp	al,WRAP_EXPREND
			jne	E27
			inc	edx
			call	PushOperStackIntCOMP
			pop	eax
			mov	ebx,[eax+VARDAT_ARRUBOUND]
			mov	eax,[eax+VARDAT_ARRLBOUND]
			ret
			align	16
E62:			mov	edi,offset Err62		; Error: <Array expected>
			jmp	DispError

;-----------------------------------------------------------------------------------------------
end start
